<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page info="seller home page" session="true" %>
<%@ page import="java.util.*" %>
<%@ page import="java.math.*" %>
<%@ page import="com.avinamart.Utility.*" %>
<%@ page import="com.avinamart.Utility.Exception.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.Constant.*" %>
<%@ page import="com.avinamart.BusinessLogic.Key.*" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.*" %>
<%@ page import="com.avinamart.Struct.*" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.ApplicationServices.*" %>
<%@ page import="com.avinamart.WebInterface.CurrencyContainer"%>
<%@ page import="com.emptoris.framework.attribute.common.constant.AttributeDefDataType" %>
<%@ page import="com.emptoris.framework.translation.util.TranslationUtility" %>
<%@ page import="com.avinamart.Utility.EPASSQPrettyBase" %>
<%@ page import="com.emptoris.framework.ui.controller.internal.ESPUiSecurityHelper" %>


<%--	$Archive: /epass/epass_5,01_sp2_269_wl/com/avinamart/WebInterface/public_html/en/detail_simple_bid.jsp $
		$Revision: 1 $ $Date: 9/22/04 3:07p $ --%>

<%@ include file="include/head.inc" %>

<%
    // true if called from the Place bid button, that brings up the bid tabs
    boolean isFromBidTab = EPASSUiBiddingServices.isCalledFromBidRouter(ref);
	EPASSUiSimpleBidHelpServices simpleBidPageProcessor = new EPASSUiSimpleBidHelpServices( ref );
	final String formName = "formBid";
	String title 	= null;

    simpleBidPageProcessor.init();
	boolean bIsBiddingSide = simpleBidPageProcessor.isBiddingSide();
    
    //----------------------------------------------------------------------------------------------

	// Get the FRAME_BASED parameter that indicates page is in a frame
	if( simpleBidPageProcessor.isPageInFrame() )
	{
		popupImage = "img/title/rfqs/rfx_view_simple_bid.gif";
	}
	else
	{
		popupImage = "img/title/rfqs/rfx_create_manual_awards.gif";
	}

    simpleBidPageProcessor.setShowSellerOrg( !bIsBiddingSide );

  
	//***************************************************************************************
	//	Bid Detail Action Block
	//***************************************************************************************
	
	switch( ref.getAction().intValue() )
	{
		//------------------------------------------------------------------------------//
		//------------------  Saving a bid ---------------------------------------------//
		//------------------------------------------------------------------------------//
		case EPASSJSPActions.SAVE_NEW:
			simpleBidPageProcessor.doSaveAction();

            // This code prevent page against being submitet if user hit F5 key in browser.
            // In this code just right after data is saved the page reloads itself with EDIT
            // action
			if( simpleBidPageProcessor.getCurrentBid() != null
            /*
				&&
                simpleBidPageProcessor.getCurrentBid().getId() != null
*/
				&&
				!simpleBidPageProcessor.isError()
			)
			{

				//When first bid is put on an item, the list_item page should also be updated (to display bid indicators)
				String contexes = null;
				if( simpleBidPageProcessor.getCurrentNumberOfBidsForItem() == 0 )
				{
					contexes = ContextCodes.BID+","+ContextCodes.REQ_ITM;
				}
				else
				{
					contexes = ContextCodes.BID;
				}

            	out.println( "<SCRIPT>" );
				out.println( NavSupport.notifyOfUpdate( contexes, simpleBidPageProcessor.isNotifyOfUpdate() ) );

				//ver 3.6
				if( simpleBidPageProcessor.isNotifyOfUpdate() )
				{
			    	Integer parentBidID = simpleBidPageProcessor.getCurrentBid().getParentBid();

			    	if( parentBidID != null )
			    	{
						BidStruct parentBid = EPASSUiBiddingServices.getBid( ref, parentBidID );

						if( parentBid.getBidType().equals( BidType.BUNDLE_BID ) )
						{
							out.println( "NAV_FireEvent( top, '" + EPASSUiBundleBidHelpServices.SUB_BID_UPDATED_EVENT + "', '" + parentBidID + "' );" );
						}
					}
				}
    			//ver 3.6

				//If a new bid was saved successfully and the draft bid feature is enabled, send a message to the
				//top window so it can update the draft button image
				if( simpleBidPageProcessor.isNewBidSaved() && ref.isDraftBidEnabled() )
				{
					out.println( "NAV_FireEvent( top, '" + EPASSUiBiddingServices.DRAFTBID_CREATED_MESSAGE + "', '' );" );
				}

                EPASSLink resultLink = new EPASSLink( ref.getUserPath() + JSP.DETAIL_SIMPLE_BID,
                                                         ref
                                                       );

                if (getIsSaveAndNextItem(ref))// true, if user clicks save bid and go to next item
                {
                    setNextItem(ref);// this gets the next item id from request, and sets it in the userdatacontext
                    resultLink.setParameter( EPASSJSPActions.ACTION, ""+EPASSJSPActions.CREATE_VIEW );
                    resultLink.setParameter(EPASSUiRFQServices.ITEM_ID_PARAM, ref.userDataContext.getRfqItemId() );
                    resultLink.setParameter(EPASSUiBiddingServices.BID_ROUTER_INDICATOR_PARAM, "true" );

                    // notify the bidding tab page to refresh with new id. Otherwise it uses the original request
                    out.println( "NAV_FireEvent( top, 'item_change', '" + ref.userDataContext.getRfqItemId() + "' );" );
                } else {
                    resultLink.setParameter( EPASSJSPActions.CURRENT_ID, simpleBidPageProcessor.getCurrentBid().getId().toString() );
                    resultLink.setParameter( EPASSJSPActions.ACTION, ""+EPASSJSPActions.EDIT_VIEW );
                    resultLink.setParameter( EPASSUiSimpleBidHelpServices.SAVE_MESSAGE, "true" );
                    if (isFromBidTab)
                    {
                        resultLink.setParameter(EPASSUiBiddingServices.BID_ROUTER_INDICATOR_PARAM, "true" );
                    }
                }
                resultLink.setParameter(EPASSUiSimpleBidHelpServices.ITEM_VIEW_MODE, simpleBidPageProcessor.getItemViewMode());
                out.println( "document.location.replace('" + resultLink.toURL() + "');" );
                out.println( "</SCRIPT>" );

   				out.flush();

                return;
			}
            //------------------------------------------------------------------------------------

			// Only suppliers may "revise" a supplier bid.  Buyers may change the cost adjustment amount.
			if (bIsBiddingSide)
			{
				popupImage = "img/title/quotes/revise_bid.gif";
				title 	   = "form.detailSimpleBid.title.update_bid";
			}
			else
			{
				popupImage = "img/title/rfqs/rfx_view_simple_bid.gif";
				title 	   = "form.detailSimpleBid.title.view_bid";
			}
		break;

		case EPASSJSPActions.DELETE:
			if( simpleBidPageProcessor.getCurrentBid() != null ) {
				simpleBidPageProcessor.cancelBid();
				String	contexes = ContextCodes.BID+","+ContextCodes.REQ_ITM;
            	out.println( "<SCRIPT>" );
				out.println( NavSupport.notifyOfUpdate( contexes, simpleBidPageProcessor.isNotifyOfUpdate() ) );
				out.println( "top.window.close()" );
                out.println( "</SCRIPT>" );
   				out.flush();
                return;
			}
		break;
		//------------------------------------------------------------------------------//
		//------------------  Editing a bid --------------------------------------------//
		//------------------------------------------------------------------------------//
	 	case EPASSJSPActions.EDIT_VIEW:
	 		// - edit view is used when an existing Bid is to be udpated.
			simpleBidPageProcessor.doEditAction();

            if( ref.isReadOnly() == true )
            {
               //We can just view the bid so show appropriate gif
    			popupImage = "img/title/rfqs/rfx_view_simple_bid.gif";
 				title 	   = "form.detailSimpleBid.title.update_bid";
           }
            else
            {
			    // Only suppliers may "revise" a supplier bid.  Buyers may change the cost adjustment amount.
			    if (bIsBiddingSide)
			    {
				    popupImage = "img/title/quotes/revise_bid.gif";
				    title 	   = "form.detailSimpleBid.title.update_bid";
			    }
			    else
			    {
				    popupImage = "img/title/rfqs/rfx_view_simple_bid.gif";
				    title 	   = "form.detailSimpleBid.title.view_bid";
			    }

            }

		break;
		//------------------------------------------------------------------------------//
		//------------------  Viewing a bid --------------------------------------------//
		//------------------------------------------------------------------------------//
		case EPASSJSPActions.DEFAULT_VIEW:
	 	case EPASSJSPActions.READ_VIEW:
			popupImage = "img/title/rfqs/rfx_view_simple_bid.gif";
			title 	   = "form.detailSimpleBid.title.view_bid";
		break;
		//------------------------------------------------------------------------------//
		//------------------  Creating a bid --------------------------------------------//
		//------------------------------------------------------------------------------//
	 	case EPASSJSPActions.CREATE_VIEW:
				popupImage = "img/title/quotes/place_bid.gif";
				title 	   = "form.detailSimpleBid.title.create_new_bid";
				setStartItemId(ref);
		break;

	 	default:
		// TODO: MESSAGE HANDLER FOR NO/UNKNOWN ACTION
			throw new EPassUIException("Invalid parameters: missing jspAction: " +
				request.getRequestURI() + "?" +
				ref.getQueryString());
	}

	//****************** END ACTION CONTROL BLOCK********************************************
	//***************************************************************************************

    simpleBidPageProcessor.loadFieldValues();

//***************************************************************************************
//  					Build Form Table Starts
//***************************************************************************************
	EPASSHTMLForm editForm = new EPASSHTMLForm( ref, formName, EPASSHTMLForm.POST,
												ref.getUserPath() + JSP.DETAIL_SIMPLE_BID, true );
    editForm.addHidden(BidStruct.BID_REQUEST_TIME, "");
    editForm.addHidden(EPASSUiSimpleBidHelpServices.ITEM_VIEW_MODE, simpleBidPageProcessor.getItemViewMode());

	//editForm.setEditMode( !ref.isReadOnly() && ref.getAction().intValue() != EPASSJSPActions.CREATE_VIEW );
	//Santosh - XSS fix for UBS
    editForm.setFieldsMonitored( true, EPASSQPrettyBase.escapeForXSS(ref.req.getParameter( "strDirty" )) );

    // TODO: Heinz customization had the following code; see if this is necessary.
    // editForm.setPleaseWait(true);

//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
// Hidden fields --------------------------
//vvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvvv
	editForm.addSeparator( ref.convertLiteral(title) );

    BidStruct currBid =  simpleBidPageProcessor.getCurrentBid();

///////////////////////////////

    simpleBidPageProcessor.setupForm( editForm );

    // PR 21777 (start)

    // if the user has permission to create/change the RFQ

    boolean canChangeRfq = false;
    if (null != ref.userDataContext.getRfqItemId())
    {
        canChangeRfq = EPASSUiRFQServices.getAuctionUiBusinessRules().canUpdateItem(ref, new ItemKeyImpl(ref.userDataContext.getRfqItemId()));
    }
   
	//PR 23788 condtion added to show the from in read only mode for buyers.
    if (! canChangeRfq && ref.isUserBuyer())
    {
   		editForm.setReadOnly(true);
    }
    if(currBid!= null && ref.isUserBuyer() && currBid.isDraftBid()){  
    	/*
         * Introduced as a fix for ESP-53705 "..It shows draft bids and responses to buyer user with direct URL"
         * Didn't add this check in BiddingRulesService since impact is very high. BiddingRulesService.canReadBid()
         * extensively used common api. Also, (as per requirement) we still need to show draft bid though we don't 
         * show value for all fields. So we can't add general authorization check in BiddingRulesService.
         */
    	ESPUiSecurityHelper.logInvalidRequest(request, "Access Denied: Unauthorised/Illegal access attempt to ESP");
		throw new SecurityException("Access Denied: Unauthorised/Illegal access attempt to ESP");
	}

    // PR 21777 (end)


	//////////////////////////////////////////////////////////////////////////////////////////
   // After saving it was showing up the save button again.
   // Here we are checking for save action.
   // If it is save then we will disply  only cancel button.
    if( simpleBidPageProcessor.isSendTnC() )
    {
		editForm.addSaveClose();
	}
	else
	{
		if( ref.getAction().intValue() == EPASSJSPActions.READ_VIEW )
		{
			if( !simpleBidPageProcessor.isPageInFrame() )
			{
				if( simpleBidPageProcessor.isCostAdderEnabled() )
				{
					editForm.addSaveClose();
				}
				else if( ref.isMessage() )
				{
					editForm.addSaveClose();
				}
				else
				{
					editForm.addCloseButton( ref.isReadOnly() );
				}
			}

			editForm.setRequiredFieldFootnote( true );
		}
		else
		{
			if( simpleBidPageProcessor.isCostAdderEnabled() )
			{
				editForm.addSaveClose();
			}
			else if( ref.isReadOnly() && !simpleBidPageProcessor.isPageInFrame() )
			{
				editForm.addCloseButton( ref.isReadOnly() ); // true = "close"; false = "cancel"
			}
			else
			{
				editForm.addSaveClose();
			}

			editForm.setRequiredFieldFootnote( true );
		}
	}
    AuctionStruct auctionStruct = simpleBidPageProcessor.getRfq();
    if(auctionStruct.isAllowSingleValidBidPerItem() && EPASSJSPActions.EDIT_VIEW == ref.getAction().intValue()){
        EPASSInputControl ic =
        new EPASSInputButton("button", "cancelBidId", ref.convertLiteral("form.listBidReverse.tooltip.cancel_bid"),
            ( ref.isSupplierPreviewMode()? "doSupplierPreviewMode()" : "cancelBid()" ) ) ;
        editForm.addButton(ic );
    }
    if (isFromBidTab)
    {
        Integer nextId = getNextItemId(ref);
        if (isThereANextItem(ref, nextId))
        {
            //PR 15891, 15727 - Do validation before saving
            EPASSInputControl ic =
            new EPASSInputButton("button", "save_goto_item", ref.convertLiteral("form.detailSimpleBid.button.save_next_item"),
                ( ref.isSupplierPreviewMode()? "doSupplierPreviewMode()" : "saveBidNextItem()" ) ) ;
           // ic.setAttribute("onclick", "if(validate(this.form)) this.form.submit()");
            editForm.addButton(ic );
        }
        editForm.addHidden(EPASSUiBiddingServices.BID_ROUTER_INDICATOR_PARAM, "true");
        editForm.addHidden("next_item_id", nextId+"");
        editForm.addHidden(EPASSUiRFQServices.ITEM_ID_PARAM, ref.userDataContext.getRfqItemId());
        editForm.addHidden("save_goto_next_item", "");
        editForm.addHidden("nextBidCheck", "");
    }
%>
<%!
	private void setStartItemId(EPASSReferences ref){
		if (!StringUtility.isEmpty(ref.req.getParameter("isStart")))
    	{
			Integer itemId = Integer.parseInt(ref.req.getParameter(EPASSUiRFQServices.ITEM_ID_PARAM));
			ref.sessionTracker.setValue(ref.req, ref.userDataContext.getRfqId() + "_startItemId", itemId);
    	}
	}

%>
<%--Begin HTML--%>
<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<HEAD>
<%--Include Stylesheet includes and JavaScript includes here--%>
<TITLE><esapi:html><%=  ref.convertLiteral("epass.title")%></esapi:html></TITLE>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>

<%-- Add Custom Bid Detail Page JavaScript for detail--%>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%=  ref.getUserPath() + Dir.JS + "functionEvaluator.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%=  ref.getUserPath() + Dir.JS + "supportedFunctions.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_TEXT %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_SELECT %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass_tree_util.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>

<SCRIPT>

$(function(){
 $("input[type='text']").each(function(i){
	if($(this).attr('max__length')!= null && $(this).attr('max__length') == 255){	
		$(this).attr('maxlength','256')
		$(this).keyup(function (){
			if($(this).val().length > 255)
			{
				showError(this,'<%=ref.convertLiteral("form.detailUda.message.max_char_exceeded")%>');
			}else
			{
				clearError(this);
			}
		});
			
	}
})
});

//
//
function NAV_HandleEvent( var1, var2 )
{

	if( var1 == 'updateAttachmentsNumber' )
	{
		onCheckDirty();

		if( <%= !ref.isReadOnly()%> )
		{
			document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = <%= EPASSJSPActions.EDIT_VIEW%>;
		}
		else
		{
			document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = <%= EPASSJSPActions.READ_VIEW%>;
		}

        document.<%= formName%>.submit();
	}
}


function saveBidNextItem()
{
    document.<%= formName%>.save_goto_next_item.value = 'true';
    if (validate(document.<%=  formName%>))
    {
        hideSelectLists();
        displayWaitScreenCSSDefault();
        document.<%= formName %>.<%=  BidStruct.BID_REQUEST_TIME%>.value = NAV_getServerTime().getTime();
        document.<%=  formName%>.submit();
    }
    if(document.<%= formName%>.nextBidCheck.value != 'true')
    document.<%= formName%>.save_goto_next_item.value = '';
}

function cancelBid(){
	 if(confirm("<esapi:js><%= ref.convertLiteral ( "form.listBid.message.delete_confirm" )%></esapi:js>")){
		 document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = <%= EPASSJSPActions.DELETE%>;
		 document.<%= formName%>.submit();
	 }
}



function setItemViewMode() {
    var currImage = document.getElementById( "expand_collapse_img" );
    if( currImage.src.indexOf( 'img/arrow_expanded_icon.gif' ) > 0 ) {
        document.<%= formName%>.<%= EPASSUiSimpleBidHelpServices.ITEM_VIEW_MODE%>.value = "1";
    } else {
        document.<%= formName%>.<%= EPASSUiSimpleBidHelpServices.ITEM_VIEW_MODE%>.value = "0";
    }
}


var NAV_LIST = '';
var NAV_DEP  = '';

</SCRIPT>

<SCRIPT>
//--------------------------------------------------------------------------------------
function validate2(frm, useConfirm)
{
	// confirm dialog was called even if validation error message was present on the page.
	if(isErrorField()){
			return false;
		}
        frm.<%= BidStruct.BID_REQUEST_TIME%>.value = NAV_getServerTime().getTime();
<%
	if( !simpleBidPageProcessor.isCostAdderEnabled() )
	{
%>
//-->
	if( !validateMinMax() || !validateDueDate () )
	{
		return false;
	}
//<--
<%
		//If draft bid feature is disabled, confirm before submission
		if( !ref.isDraftBidEnabled() )
		{
%>
//-->
    if (!confirm( "<esapi:js><%= ref.convertLiteral("form.detailSimpleBid.message.submit_bid")%></esapi:js>" ))
    {
        return false;
    }
//<--
<%
		}
	}
	if( simpleBidPageProcessor.isCostAdderEnabled() )
	{
%>
//<--
	if( !confirm( "<esapi:js><%= ref.convertLiteral("form.detailSimpleBid.message.submit_bid_with_cost_adder")%></esapi:js>" ) )
	{
		return false;
	}
//-->
<%
	}
%>

<%
    
    
    boolean bwarning = false;
    boolean bwarningConfig = false;

    bwarningConfig = EPASSConfig.getInstance().getBooleanParameter(EPASSConfig.BID_USED_FOR_BUNDLING_WARNING_ENABLED);
    if (currBid != null)
    {
        bwarning = currBid.isBidUsedForBundling();
        bwarning = bwarning &&  bwarningConfig;
    }

    if (bwarning)
    {
%>
	if( !confirm( "<esapi:js><%= ref.convertLiteral("form.detailBidUpdateVerify.sealed.warning_update_sourcebid")%></esapi:js>" ) )
	{
          return false;
	}
<%
    }
%>
		if(frm.nextBidCheck)frm.nextBidCheck.value = 'true'
        hideSelectLists();
        displayWaitScreenCSSDefault();

	return true;
}// end validate2

	//--------------------------------------------------------------------------------------------
	function validateDueDate ()
	{
		var bRetVal = true;

		if( <%= simpleBidPageProcessor.isEnforceDatePolicy()%> && <%= simpleBidPageProcessor.isUseDeliveryDate()%>
			&& typeof(document.<%= formName%>.<%= EPASSFieldName.addPrefix( BidStruct.DELIVERYDATE )%>) != 'undefined')
		{
			var dtDueDate = i18n.textToDate( document.<%= formName%>.<%= EPASSFieldName.addPrefix( BidStruct.DELIVERYDATE )%>.value );
			var dtNow 	  = new Date ();
			
			if(dtDueDate == undefined){
				showError(document.<%= formName%>.<%= EPASSFieldName.addPrefix( BidStruct.DELIVERYDATE )%>, "<%=  ref.convertLiteral ("form.detailItem.message.due_date_must_be_future" )%>" );
				bRetVal = false;
			}

			else if( !isNaN ( dtDueDate ) && dtDueDate < dtNow )
			{
				//alert ( '<%=  ref.convertLiteral ( "form.detailItem.message.due_date_must_be_future" )%>' );
				showError(document.<%= formName%>.<%= EPASSFieldName.addPrefix( BidStruct.DELIVERYDATE )%>,"<%=  ref.convertLiteral ( "form.detailItem.message.due_date_must_be_future" )%>" );
				bRetVal = false;
			}
		}

		return bRetVal;
	}

	//---------------------------------------------------------------------------------------------
 function validateMinMax()
     {
         // validate Min less than max
         var minField = document.<%= formName%>.<%= EPASSFieldName.addPrefix( BidStruct.MINCAPACITY)%>;
         var maxField = document.<%= formName%>.<%= EPASSFieldName.addPrefix( BidStruct.MAXCAPACITY)%>;

         if(typeof(minField) != 'undefined' && typeof(maxField) != 'undefined'){
             var minVal = minField.value;
             var maxVal = maxField.value;

             if( (minVal.length != 0 ) && ( maxVal.length != 0 ) ) {
                 if( i18n.textToNumber(minVal) > i18n.textToNumber(maxVal) ){


                     //alert('<%= ref.convertLiteral("form.detailSimpleBid.message.min_max")%>');
                     showError(minField,"<%= ref.convertLiteral("form.detailSimpleBid.message.min_max")%>"); 
                     return false;
                 }
             }
         }

         return true;
     }

//----------------------------------------------------------------------------------------------
</SCRIPT>
<style type="text/css">
#optBoxIframe{
 max-height:100px !important;
}
</style>
</Head>
<Body>
<%-- include file="top.html" --%>
<%
	String popupColor = EPassArea.getAreaInstance(EPassArea.RFQ, ref).getBGColor();
	String popupTitle = ref.convertLiteral(title);
if (!isFromBidTab) {
%>
<%@ include file="include/inc_popup_top.inc" %>
<%}%>

<%--Display Message/Error if it exists--%>
<%if ( ref.isMessage() ) {
		out.println( ref.getMessage() );
}%>

<table class="CONTENT" cellpadding=0 cellspacing=0 border=0 width="100%" >
<%--Display Bid Detail Form Table--%>
<%
if( simpleBidPageProcessor.getMessage() != null )
{
%>
    <tr class='POPFORMHIGH'>
        <td colspan=3>
            <p class='ERRORMSG'><esapi:html><%= simpleBidPageProcessor.getMessage() %></esapi:html></p>
        </td>
    </tr>
<%
}
%>
    <%
        Integer itemForInfoID = simpleBidPageProcessor.getCurrentItem().getId();       
        String itemValue = EPASSUiRFQServices.getItem(ref, new ItemKeyImpl(itemForInfoID)).getName() + "";
        if (TranslationUtility.isTranslationKey(itemValue)) {
        	itemValue = ref.convertLiteral(itemValue);
        }
        String item = ref.convertLiteral("form.detailSimpleBid.link.item_info")
                        + ": "
                        + EPASSQPrettyBase.escapeForXSS(itemValue)
                        + "  ";
        boolean isCollapsed = simpleBidPageProcessor.getItemViewMode().equals(EPASSUiSimpleBidHelpServices.ITEM_VIEW_MODE_HIDDEN);
        final String style = isCollapsed? "{display:'none'}" : "{display:''}";
        String collapsedIconTooltip = ref.convertLiteral("form.detailSimpleBid.link.item_detail");
        String expandedIconTooltip = ref.convertLiteral("form.detailSimpleBid.link.hide_item_detail");
        String tooltip = isCollapsed? collapsedIconTooltip : expandedIconTooltip;

    %>
    <%=  EPASSUiJSPServices.createHidingRowHeader(ref,
                                                isCollapsed,
                                                "showOrHideFrame('item_detail','" + collapsedIconTooltip + "','" + expandedIconTooltip + "'); setItemViewMode();",
                                                tooltip,
                                                item, "POPFORMTITLE")%>
    <tr id="item_detail" style="<%=style%>" class="POPFORMBODY" valign=top>
        <td valign=top> <%-- Begin Item Table --%>
        <%@ include file="include/inc_item_info.inc"%>
        </td> <%-- End Item Table --%>
    </tr>
    <tr><td>&nbsp;</td></tr>
    <tr>
        <td>
<%
  	editForm.setFieldsMonitored( false );

	out.println( editForm );

	//Santosh - XSS fix for UBS
   	editForm.setFieldsMonitored( true, EPASSQPrettyBase.escapeForXSS(ref.req.getParameter( "strDirty" )) );
%>
        </td>
    </tr>
</table>

<%if (!isFromBidTab) {
%>
<%@ include file="include/inc_popup_bottom.inc" %>
<%}%>

<%@ include file="include/bottom.inc" %>

<script>

function initMonitorFields() {
<%= editForm.getInitMonitorJS()%>
}
</script>

</body>
</html>

<script>
	//setTimeout("calculateAllFormulas('skipMessage')",200);
	setTimeout("initMonitorFields()",500);
</script>

<%
	boolean isSendTnC = simpleBidPageProcessor.isSendTnC();
%>
<%@ include file="include/inc_nda_popup_call.inc" %>


<%@ include file="include/tail.inc" %>

<%!

    // This is called after saving the bid
    public void setNextItem(EPASSReferences ref)
    {
        if (!StringUtility.isEmpty(ref.req.getParameter("next_item_id")))
        {
            Integer ret = new Integer (ref.req.getParameter("next_item_id"));
            ref.userDataContext.setRfqItemId(ret);
        }
    }

    public boolean isThereANextItem(EPASSReferences ref, Integer nextId)
    {
        boolean ret = false;
        if (EPASSUiBiddingServices.isCalledFromBidRouter(ref))
        {
            if (null != nextId && null != ref.userDataContext.getRfqItemId())
            {
            	
            	Integer startItemId = (Integer) ref.sessionTracker.getValue(ref.req, ref.userDataContext.getRfqId() + "_startItemId");
            	
                ret = !(nextId.equals(ref.userDataContext.getRfqItemId()));
                
                ret = ret && (startItemId == null || !startItemId.equals(nextId));
                
            }
        }
        return ret;
    }

    // This is called and passed as a hidden parameter, Retrieved later by setnext_item_id()
    public Integer getNextItemId(EPASSReferences ref)
        throws EPASSApplicationException, java.rmi.RemoteException
    {
        Integer ret = null;
        if (EPASSUiBiddingServices.isCalledFromBidRouter(ref))
        {
            // The item id was passed in as EPASSUiRFQServices.ITEM_ID_PARAM.
            //      When constructing the tabs, the EPASSUiBiddingServices.setItemIdFromBidButton() was called and set this context.
            Integer currItem = ref.userDataContext.getRfqItemId();
            // default the return to current item
            ret = currItem;

            // Get all the items for the auction
            ItemStruct[] items = EPASSUiRFQServices.getAllRfqItems(ref, ref.userDataContext.getRfqId());

            // Iterate through the items, and return the one after the current item
            if (null != items
                && null != currItem)
            {
                //StructComparator comp = new StructComparator(ItemStruct.NAME, true);
                StructComparator comp = new StructComparator(ItemStruct.REQUISITIONSEQNO);
                comp.add(ItemStruct.SEQUENCENUMBER);
                Arrays.sort(items, comp);

                boolean isCurrentFound = false;
				boolean isLastItem = false;
                // Go through the items and add the good ones. No sub set or current item
                for (int i = 0; i < items.length; i++)
                {
                    if (!ItemType.SUBSTITUTION.equals(items[i].getItemType()))
                    {
                        if (!isAllorNoneChild(ref, items[i]))
                        {
                        	if (isLastItem)
                        	{
	                        	ret = items[i].getId();
                                break;
                        	}
                            // Its not a sub set, check to see if it is the current item. If so, move on
                            if (isCurrentFound)
                            {
                                // its not the current item, return this id
                                ret = items[i].getId();
                                break;
                            } else if (currItem.equals(items[i].getId())){// this is the current item AND not the last item. Return the next item in array
                                isCurrentFound = true;// the current is found, select the next id, if not substitution set
                                if ((i + 1) == items.length)// What if this is the last id? Send back the first one, and break out.
                                {
	                                isLastItem = true;
	                                i=-1; // i will be incremented to 0 in the next iteration
	                                continue;
                                }
                            } else if ((i + 1) == items.length){ // this is not a sub set, but its the current item. We need to check if its the last item in list. If so return the first item
                                isLastItem = true;
                                i=-1; // i will be incremented to 0 in the next iteration
                                continue;
                            }
                        }
                    }
                }

            }
        }
        return ret;
    }

    public boolean getIsSaveAndNextItem(EPASSReferences ref)
    {
        boolean ret = false;

        debug("debug: in savd before...");
        if (!StringUtility.isEmpty(ref.req.getParameter("save_goto_next_item")))
        {
            debug("debug: in savd ....savd goto true00");
            ret = true;
        }
        return ret;
    }

    public boolean isAllorNoneChild(EPASSReferences ref,
                                       ItemStruct item)
        throws EPASSApplicationException, java.rmi.RemoteException
    {
        boolean ret = false;

        if (null != item.getParentItem())
        {
            ItemStruct parent = EPASSUiRFQServices.getItem(ref, new ItemKeyImpl(item.getParentItem()));
            if (ItemType.ALL_OR_NONE.equals(parent.getItemType()))
            {
                ret = true;
            }
        }

        return ret;
    }

%>



