<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">

<%@ page import="java.util.*,
                 com.avinamart.WebInterface.Constants.Dir,
                 com.avinamart.WebInterface.Constants.Javascript,
                 com.emptoris.framework.attribute.common.constant.IATypes" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.BusinessLogic.Helper.formulahelpers.FormulaHelper" %>
<%@ page import="com.avinamart.WebInterface.forms.ia.detailuda.*" %>
<%@ page import="com.avinamart.WebInterface.forms.ia.detailuda.managers.*" %>
<%@ page import="com.avinamart.Utility.EPASSConfig" %>
<%@ page import="com.avinamart.Utility.EPASSQPrettyBase" %>
<%@ page import="com.emptoris.framework.translation.util.TranslationUtility" %>

<%@ include file="include/head.inc" %>

<%
	StringBuffer popupTitle = new StringBuffer();
	String popupColor = ref.getArea().getAttribute(EPassArea.AREA_BGCOLOR);
	boolean saveEnabled = true;

//The IA type corresponds to the owner type that comes with the request.
	int owner = Integer.parseInt(ref.req.getParameter(Misc.OWNER_TYPE));
int iaType = DetailUDAManager.getIATypeFromMisc(owner);
ref.userDataContext.setIAType(iaType);

//Instantiate a form manager
DetailUDAManager detailUDA = DetailUDAManager.getManager(ref);

// PR 61954 - need to check for reverse auction
AuctionStruct auctionStruct = null;
if ( ref.userDataContext.getRFQKey() != null ) {
	auctionStruct = ref.serviceRef.getAuctionDataService(ref).getAuction( ref.sessionService, ref.userDataContext.getRFQKey() );
    if ( auctionStruct != null ) {
        detailUDA.setReverseAuction( auctionStruct.isReverseAuction() );
        detailUDA.setJapaneseAuction( auctionStruct.isJapaneseAuction() );
    }
}

//ACTION  BLOCK=================================================
switch (ref.getAction().intValue()) {
//Creating new IA------------------------------------------//
case EPASSJSPActions.CREATE_VIEW:
  detailUDA.processCreateAction();
   break;

//Edit an existing IA--------------------------------------//
case EPASSJSPActions.EDIT_VIEW:
  detailUDA.processEditAction();
  break;

//Read an existing IA--------------------------------------//
case EPASSJSPActions.READ_VIEW:
case DetailUDAManager.READ_MATRIX_FIELD :
  detailUDA.processReadAction();
  break;

//Toggle price IA between currency and formula views-------//
case DetailUDAManager.TOGGLE_CONVERTIBLE_FIELD:
  detailUDA.processToggleFormulaConversionAction();
  break;

case EPASSJSPActions.SAVE_NEW:
  try {
    EPASSAttributeDefStruct savedAttr = detailUDA.processSaveAction();
    if (!StringUtility.isEmpty(ref.getMessage())) {
      out.print("<script>alert('");
      out.print(ref.getMessage());
      out.print("</script>\n");
    }
    out.print(detailUDA.getExitOnSaveScript(savedAttr));
    out.flush();
    return;
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
  }
  break;

//*************************** Overridden formula actions *****************************//
//Overriding an RFQ scope formula to an item level---------//
case DetailUDAManager.OVERRIDE_FORMULA_VIEW:
  detailUDA.processOverrideViewAction();
  break;

//Editing an overridden formula----------------------------//
case DetailUDAManager.EDIT_OVERRIDDEN_FORMULA_VIEW:
  detailUDA.processEditOverridenFormulaAction();
  break;

//Saving an overridden formula-----------------------------//
case DetailUDAManager.OVERRIDE_FORMULA_SAVE:
  try {
    EPASSAttributeDefStruct overridden = detailUDA.processSaveOverridenFormulaAction();
    out.print(detailUDA.getExitOnSaveScript(overridden));
    out.flush();
    return;
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
  }
  break;

//*************************** Supplier specific actions ******************************//
 //Toggling between supplier specific and All suppliers options for the attribute default value
case DetailUDAManager.TOGGLE_SUPPLIER_SPECIFICITY:
  detailUDA.processToggleSupplierSpecificityAction();
  break;

//*************************** Matrix related actions **********************************//
//Creating new matrix field---------------------------------//
case DetailUDAManager.CREATE_MATRIX_FIELD:
  // If creating a child field in rfi, instantiate manager as Bid manager
  ref.setAttribute(Misc.OWNER_TYPE, Misc.OWNER_AUCTION_LEVEL_BID);
  detailUDA.processCreateMatrixFieldAction();
  break;

//Edit an existing IA--------------------------------------//
case DetailUDAManager.EDIT_MATRIX_FIELD:
  detailUDA.processEditMatrixFieldAction();
  break;

//Create a new matrix attribute (parent) also between object and library-----//
case DetailUDAManager.SAVE_MATRIX_PARENT_LIBRARY:
case DetailUDAManager.SAVE_MATRIX_PARENT:
  try {
    // Save but do not close the window
    EPASSAttributeDefStruct savedAttr = detailUDA.processSaveMatrixParentAction();
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
    out.print("<script>NAV_Updated(top, '" + ContextCodes.ATTRIBUTE + "');</script>\n");
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
  }
  break;

//Save or a child filed of a matrix attribute----------------//
case DetailUDAManager.SAVE_MATRIX_FIELD:
  try {
    EPASSAttributeDefStruct savedAttr = detailUDA.processSaveMatrixFieldAction();
    out.print( detailUDA.getExitOnSaveScript(savedAttr));
    out.flush();
    return;
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
  }
  break;

//Save or update an IA-------------------------------------//
case DetailUDAManager.SAVE_MATRIX_CELLS:
  try {
    EPASSAttributeDefStruct savedAttr = detailUDA.processSaveMatrixCellsAction();
    out.print( detailUDA.getExitOnSaveScript(savedAttr));
    out.flush();
    return;
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
  }
  break;

//*************************** Attributes library **********************************//
//Loading a library attribute to be saved (can also be modified) to the current object
case DetailUDAManager.CREATE_FROM_LIBRARY:
  detailUDA.processCreateFromLibraryAction();
  break;

//Save or update an IA, also between object and library-----//
case DetailUDAManager.SAVE_NEW_FROMLIBRARY:
  try {
    EPASSAttributeDefStruct savedAttr = detailUDA.processCopyFromLibraryAction();
	out.print("<script>NAV_Updated(top, '" + ContextCodes.ATTRIBUTE + "');</script>\n");
    //out.println(NavSupport.sendUpdateAndClose(ContextCodes.ATTRIBUTE_LIBRARY, ref));
    //out.flush();
    //return;
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
	//If the copy action failes, the form returns as Read Only
    ref.setAction(EPASSJSPActions.READ_VIEW + "");
	saveEnabled = false;
  }
  break;


case EPASSJSPActions.DELETE_VERSION:
  try {
    detailUDA.processDeleteVersionAction();
    if (!StringUtility.isEmpty(ref.getMessage())) {
      out.print("<script>alert('");
      out.print(ref.getMessage());
      out.print("</script>\n");
    }
    out.print(detailUDA.getExitOnSaveScript(null));
    out.flush();
    return;
  }
  catch (EPASSApplicationException ex) {
    ref.setErrorMessage(ex);
    ref.setAction(ref.req.getParameter(DetailUDAManager.CURRENT_ACTION));
  }
  break;
}

// Discount bidding changes: if showing bid uda base price, disable the save button
// by Nesta - Remove the constraint

//Finished processing the request, instantiate the form object.
IABase ia = detailUDA.getFormObject();
ia.setSaveButtonEnabled(saveEnabled);

int defaultDigits = EPASSConfig.getInstance().getIntParameter(EPASSConfig.IBA_REAL_DECIMAL_DIGITS);

//Add category name to the title if there is a category in context.
EPASSLink myLink = null;
StringBuffer tempBuff = new StringBuffer();
if (ref.userDataContext.getCategoryId() != null) {
  // We have a category in context
  EPASSUiCategoryServices.getCategory(ref, null);
  tempBuff.append(ref.structs.categoryStruct.getName());
  tempBuff.toString();
}
popupTitle.append(" : " + tempBuff);

%>

<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<head>
<TITLE><esapi:html><%=  ref.convertLiteral("epass.title")%></esapi:html></TITLE>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
<link type="text/css" href="<%= request.getContextPath()%>/dhtml_lib/css/ext/jquery/jquery-ui-1.7.2.custom.css" rel="stylesheet" />
<link type="text/css" href="<%= request.getContextPath()%>/dhtml_lib/css/feature/emptoris_formula_ide.css" rel="stylesheet" />
<script type="text/javascript" src="<%= request.getContextPath()%>/dhtml_lib/js/ext/jquery/jquery-1.3.2.min.js"></script>
<script type="text/javascript" src="<%= request.getContextPath()%>/dhtml_lib/js/ext/jquery/jquery-ui-1.7.2.custom.min.js"></script>
<script type="text/javascript" src="<%= request.getContextPath()%>/dhtml_lib/js/util/util.js"></script>
<script type="text/javascript" src="<%= request.getContextPath()%>/dhtml_lib/js/util/translation.js"></script>
<script type="text/javascript" src="<%= request.getContextPath()%>/dhtml_lib/js/feature/emptoris_formula_ide.js"></script>

<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath()+Dir.JS+Javascript.EPASS_CHECKBOX %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%= ref.getUserPath()+Dir.JS+Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%= ref.getUserPath()+Dir.JS+Javascript.FUNCTION_EVALUATOR %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC ='<%= ref.getUserPath()+Dir.JS+Javascript.SUPPORTED_FUNCTIONS %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath()+Dir.JS+Javascript.EPASS_TEXT %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath()+Dir.JS+Javascript.EPASS_SELECT %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath()+Dir.JS+Javascript.EPASS %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath()+Dir.JS+Javascript.NAV %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath()+Dir.JS+"matrixMenu.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass_tree_util.js" %>'></SCRIPT>

<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass_slider.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "dragDrop3.js" %>'></SCRIPT>

<script>
var isSearchEnabled = <%= ia.isSearchable() %>;
<%=  NavSupport.notifyOfUpdate(ContextCodes.ATTRIBUTE, false) %>
</script>
<%//JS functions used only by numeric type attributes
if (ia.isText()) {%>
  <%@ include file="include/inc_detail_uda_text_js.inc" %>
 <%-- pr 75542  thiis var is defined in inc_detail_uda_text_js.inc --%>
  <script>maxDefaulChars = <%=  ((IAText)ia).getTextAreaDefaultValueMaxCharCount() %>; 
  //added by Yuxiang in order to fix ESP-57105   
  $(function(){
		if(getControlValue(ia_textFieldType,'value') == 0){
				hideDefaultFieldCounter();
				}
	})

  </script>

<%}
//JS functions used only by numeric type attributes
if (ia.isNumeric()) {%>
  <%@ include file="include/inc_detail_uda_numeric_js.inc" %>
  <script type="text/javascript" src="<%=  ref.getUserPath() + Dir.JS + "inc_detail_uda_numeric.js" %>"></script>
<%}
//JS function used only for the enumeration (list) data type
if (ia.isList()) {%>
  <%@ include file="include/inc_detail_uda_list_js.inc" %>
  <%-- 
  <script type="text/javascript" src="<%=  ref.getUserPath() + Dir.JS + "inc_detail_uda_list.js" %>"></script>
  --%>
<%}
//JS function used only for the matrix (table) data type
if (ia.isMatrix()) {%>
  <%@ include file="include/inc_detail_uda_matrix_js.inc" %>
<%}
//Functions used by the formula (or message) data type.
if (ia.isFormulaOrMessage()) {%>
  <%@ include file="include/inc_detail_uda_formula_js.inc" %>
<%}
//Functions used by the boolean data type.
if (ia.isBoolean()) {%>
  <%@ include file="include/inc_detail_uda_boolean_js.inc" %>
<%}%>

<%// Other JS functions, used for all data types, for all and for specific IA types%>
<%@ include file="include/inc_detail_uda_general_js.inc" %>
<script type="text/javascript" src="<%=  ref.getUserPath() + Dir.JS + "inc_detail_uda_general.js" %>"></script>
<%@ include file="include/inc_detail_uda_iaspecific_js.inc" %>

</head>
<!-- dyy adding onload='init();' and the function init() -->
<body style="background-color:<esapi:htmlatt><%= popupColor %></esapi:htmlatt>;"
    onload='init();' onresize = "onPageResize()" marginwidth="0" marginheight="0" topmargin="0" leftmargin="0">
<script>
function init(){

	// RTC-24836
	if(document.getElementsByName('_uda_precision')[2] !== undefined && document.getElementsByName('_uda_precision')[2].checked == true){
		document.getElementsByName('_uda_required')[0].disabled = true;
	 }
	 
	var localeIDs = <%= TranslationUtility.getInstance().getJSONAvailableLocaleIDs(false) %>;
	var availableLocales = <%= TranslationUtility.getInstance().getJSONAvailableLocales(ref) %>;
	var translations = <%= TranslationUtility.getInstance().getJSONTranslations(detailUDA.getTranslatableStructs(ref.structs.udaStruct)) %>;
	
	//do not display translation button in kpi module
	var translationEnabled = <%= TranslationUtility.getInstance().isTranslationEnabled() %> && <%= !detailUDA.isReadOnly() %> ;
	var translationButtonEnabled = <%= TranslationUtility.getInstance().isTranslationEnabled() %>;		
	var currentLocale = '<%= ref.getLocale().getLanguage()%>';
	
	//modified by dyy: only selection nedd translationDialogWidget
	<%if(ia.isList()) %>
		TranslationDialogWidget.init(localeIDs, availableLocales, ia_udaForm);
	if(typeof ia_items != 'undefined' && ia_items){
		TranslationDialogWidget.initField(ia_items, translations, translationEnabled, currentLocale);
	}
	
	
	// do not show name for Questions
	<% if(iaType != IATypes.RFI){ %>
		//modified by dyy:
		new TranslationWidget(ia_nameField, localeIDs, availableLocales, translations, translationEnabled, translationButtonEnabled, currentLocale, "<%=ref.structs.udaStruct.getName()%>",
				"<%=ref.convertLiteral("form.translateButton.tooltip.translate") %>", "<%=ref.convertLiteral("form.translateButton.tooltip.hide_translate") %>");
		//new TranslationWidget(ia_nameField, localeIDs, availableLocales, translations, translationEnabled, translationButtonEnabled, currentLocale);
	<% } else if (detailUDA.getIsLibraryConsole()) {%>
	
	    new TranslationWidget(ia_nameField, localeIDs, availableLocales, translations, false, false, currentLocale, "<%=ref.structs.udaStruct.getName()%>",
	    		"<%=ref.convertLiteral("form.translateButton.tooltip.translate") %>", "<%=ref.convertLiteral("form.translateButton.tooltip.hide_translate") %>");
	<% }else {%> //by dyy for ESP 54527		
		//add a uda_name_xx value for question name
		setDefaultValueForQuestionNameField(ia_nameField, localeIDs, availableLocales, translations, "<%=ref.structs.udaStruct.getName()%>");
	<%}	%>	
	
	if(getControlValue(ia_dataTypeField,'value') != 12){
		<% 	String descKey  = ref.structs.udaStruct.getDescription();
			if (!TranslationUtility.isTranslationKey(descKey) ){
				if (!ref.structs.udaStruct.isPredefined()) {
					descKey = "";
				}
			}
		%>
		new TranslationWidget(ia_descriptionField, localeIDs, availableLocales, translations, translationEnabled, translationButtonEnabled, currentLocale, "<%=descKey%>",
				"<%=ref.convertLiteral("form.translateButton.tooltip.translate") %>", "<%=ref.convertLiteral("form.translateButton.tooltip.hide_translate") %>");
	}
	
	// show translation for String IAs
	if(typeof ia_defaultField != 'undefined' && ia_defaultField != null && 
			(getControlValue(ia_dataTypeField,'value') == 1
				|| getControlValue(ia_dataTypeField,'value') == 12)){
		<% 	String defaultKey  = ref.structs.udaStruct.getDefaultValue();//by dyy for #ESP 54098
			if (!TranslationUtility.isTranslationKey(defaultKey)){
				if (!ref.structs.udaStruct.isPredefined()) {
					if(!ia.isList() || !TranslationUtility.isMultiTranslationKey(defaultKey) ){
						defaultKey = "";
					}	
				}
				
			}
		%>
		new TranslationWidget(ia_defaultField, localeIDs, availableLocales, translations, translationEnabled, translationButtonEnabled, currentLocale,"<%=defaultKey%>",
				"<%=ref.convertLiteral("form.translateButton.tooltip.translate") %>", "<%=ref.convertLiteral("form.translateButton.tooltip.hide_translate") %>");
		
		}
	//disable the multiline test ia search 
	<% if (ia.isText()) {%>
		if(!isSearchEnabled){
			enableOrDisableSearchElement();
		}
	<%} %>
}

function dataTypeFieldOnChange(elem, jspAction){
	 clearError(elem);
	 var beforeChangeValue = elem.getAttribute("beforechangevalue");
	 if(!isErrorField()){
		 if(beforeChangeValue){
		 	beforeChangeValue = elem.value;
		 }
		 elem.form.jspAction.value = jspAction;
		 elem.form.submit();
	 }else{
		 if(beforeChangeValue){
		 	elem.value = beforeChangeValue;
		 }
		 showError(elem, "<%=ref.convertLiteral("form.detail_uda.data_field_type.validation_error") %>");
	 }
}
</script>
<%@ include file="include/top.inc"%>
<%popupImage = detailUDA.getUdaFormTitleImage();%>
<%@ include file="include/inc_popup_top.inc" %>
<%=  ia.renderIAForm() %>
<%@ include file="include/inc_popup_bottom.inc" %>
<%@ include file="include/bottom.inc"%>

<script>
//added by dyy
//ESP 54392
var buttonId = "<%= IAList.TRANSLATE_BUTTONNAME %>";
if(document.getElementById(buttonId) != null){
	_handleTooltip(document.getElementById(buttonId), document.getElementById(buttonId), "<%=ref.convertLiteral("form.translateButton.tooltip.translate_selections") %>");
}
</script>

<%if (ia.isMatrix()) {%>
<div id = 'columnMenu' class = 'MATRIXMENU' onmouseover = "this.style.visibility='visible'" onmouseout = "this.style.visibility='hidden'">
<div onmouseover = "style.backgroundColor='DDE2F7';style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" onclick= "editColumn(event)">
<image src = 'img/btns/up/btn_edit_small_up.gif'  > <%= ref.convertLiteral("form.detailUda.matrix.edit") %>  </div>
<div onmouseover = "this.style.backgroundColor='DDE2F7';this.style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" >
<image src = 'img/btns/up/btn_arrow_down_small_up.gif' onclick= "insertColumn(event) " > <%= ref.convertLiteral("form.detailUda.matrix.insert") %> </div>
<div onmouseover = "this.style.backgroundColor='DDE2F7';this.style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" >
<image src = 'img/btns/up/btn_delete_small_up.gif' onclick= "delColumn()" >  <%= ref.convertLiteral("form.detailUda.matrix.delete") %> </div>
</div>


<div id = 'rowMenu' class = 'MATRIXMENU' onmouseover = "this.style.visibility='visible'" onmouseout = "this.style.visibility='hidden'">
<div onmouseover = "style.backgroundColor='DDE2F7';style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" onclick= "editRow(event)">
<image src = 'img/btns/up/btn_edit_small_up.gif'  > <%= ref.convertLiteral("form.detailUda.matrix.edit") %>  </div>
<div onmouseover = "this.style.backgroundColor='DDE2F7';this.style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" >
<image src = 'img/btns/up/btn_arrow_down_small_up.gif' onclick= "insertRow(event) " > <%= ref.convertLiteral("form.detailUda.matrix.insert") %> </div>
<div onmouseover = "this.style.backgroundColor='DDE2F7';this.style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" >
<image src = 'img/btns/up/btn_delete_small_up.gif' onclick= "delRow()" >  <%= ref.convertLiteral("form.detailUda.matrix.delete") %> </div>
</div>

<div id = 'addColumnMenu' class = 'MATRIXMENU'  onmouseover = "this.style.visibility='visible'" onmouseout = "this.style.visibility='hidden'">
<div onmouseover = "style.backgroundColor='DDE2F7';style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" onclick= "insertColumn(event)">
<image src = 'img/btns/up/btn_edit_small_up.gif'  ><%= ref.convertLiteral("form.detailUda.library.tooltip.create_new")%></div>
</div>

<div id = 'addRowMenu' class = 'MATRIXMENU'  onmouseover = "this.style.visibility='visible'" onmouseout = "this.style.visibility='hidden'">
<div onmouseover = "style.backgroundColor='DDE2F7';style.color='black'" onmouseout = "this.style.backgroundColor='';this.style.color=''" onclick= "insertRow(event)">
<image src = 'img/btns/up/btn_edit_small_up.gif'  > <%= ref.convertLiteral("form.detailUda.library.tooltip.create_new")%></div>
</div>

<%} %>


<%=EPASSUiJSPServices.getHelpDiv("IAInstructions") %>


</body>
</html>

<%=  ia.declareJSVariables() %>
<%=  ia.initializeJSVariables() %>
<%//Make sure that if there is a default value, the Required field is checked and disabled
//as required by the specifications (this also depends on the setting of the applyDefaultRequiredRule flag
//defined in inc_detail_uda_general_js.inc) %>
<script>
if (typeof ia_defaultField != 'undefined'
&&  typeof ia_requiredField != 'undefined'
&&  !_isEmpty(ia_defaultField)
&& applyDefaultRequiredRule) {
  ia_requiredField.checked = true;
  ia_requiredField.disabled = true;
}

<%//Set the focus on the Name field (or the Description field, in RFI questions) %>
if (typeof ia_nameField != 'undefined' && ia_nameField.type != 'hidden' && ia_nameField.value == ''){
  ia_nameField.focus();
}
else if (ia_descriptionField.type != 'hidden'){
  ia_descriptionField.focus();
}

<%//IA's that require specifi tasks to be performed when the page is loaded should put those calls in
//inc_detail_uda_iaspecific_js.inc, inside this function%>
 IASpecificOnLoad();
</script>
<%@ include file="include/tail.inc" %>




