<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%-- +---------------------------------------------------------------------------
   Frame to be used on the top of epass frames
---------------------------------------------------------------------------+ --%>
<%@ page import="java.util.*" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.Utility.*" %>
<%@ page import="com.avinamart.Utility.Exception.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.Struct.*" %>
<%@ page import="com.avinamart.WebInterface.NavSupport" %>
<%@ page import="org.owasp.esapi.ESAPI" %>
<%@ page import="com.emptoris.framework.configuration.configclient.BrandingPropertiesReader" %>

<%@ include file="include/head.inc" %>
<%
	String ssmPublicURL1 = EPASSConfig.getInstance().getStringParameter(EPASSConfig.SSM_PUBLIC_URL) + "/emptoris";
	String logosDeployTime = BrandingPropertiesReader.getInstance().getLogosDeployTime();
%>

<%
	String itemDesc = "";

		itemDesc = "<DIV ID=\"ITEM_DESC\" "
                    + " style=\"position:absolute;top:72;left:30;z-index:100;visibility:hidden; "
                    + " background-color:white; FONT-WEIGHT: bold; FONT-SIZE: 12px; COLOR: #0C209B; "
					+ " FONT-FAMILY: arial, helvetica, sans-serif;\" > "
					+ " </DIV>";

    boolean showPrint = true;
	boolean showNothing = false;
	boolean showHelpIcon = true;

	if ( request.getParameter("NOPRINT") != null){
		showPrint = false;
	}
// Fix for RTC 38444
	popupHelpUrl="HELP_AUTODETECT";

	if ( request.getParameter("IMAGE") != null){
   		popupImage = EPASSQPretty.toUQString(  (String) request.getParameter("IMAGE") );
   		if(! NavSupport.isValidImagePath(popupImage)){ //PR 83654
   			popupImage = "";
   		}
	}

	if ( request.getParameter("SHOW_NOTHING") != null){
   		showNothing = true;
	}

	if ( request.getParameter("NO_HELP_ICON") != null && "X".equals(request.getParameter("NO_HELP_ICON"))){
		showHelpIcon = false;
	}
%>
<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<HEAD>
 <%-- +-- Include Stylesheet includes and JavaScript includes here -------+ --%>
<TITLE><esapi:html><%=  ref.convertLiteral("epass.title")%></esapi:html></TITLE>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<%-- +--Add Custom Organization Detail Page JavaScript for detail --------+ --%>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_TEXT %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS %>'></SCRIPT>
<%-- Navigation utility that supply all frame services --%>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>
<script language="javascript" src="<%=  Dir.JS %>rollover.js"></script>

<script>
function setTopImage( srcName ){
	document.images['TOPIMAGE'].src=srcName;
}

function doprint(){
	// We know we're in a frameset, so get the parent.
	var pWindow = parent;
	// Ok, heres the scoop, a we want to look at frames with indexes 2 and up.
	// if the parent only has 3 frames, print the index 2 frame
	//if (pWindow.frames.length == 3){
		//alert("here");
		//pWindow.frames[2].print();
	//} else {
		var x;
		for (x=2;x<pWindow.frames.length;x++){
			// Lets look for the frame with the NAV_PRINTFRAME variable defined.
			var w;
			w = pWindow.frames[x];
			if (w.NAV_PRINTFRAME){
				// This frame must support being opened in a new window
				if (w.NAV_PRINTLANDSCAPE){
					alert("<esapi:js><%=  ref.convertLiteral("form.general.print.landscape.notice") %></esapi:js>");
				}
				w.focus();
				w.print();
				return;
			}
		}
		print();
	//}
}

var NAV_LIST="";
var NAV_DEP = "";

function NAV_HandleEvent( var1, var2 ) {

    if( var1 == "QB_SHOW_ITEM_DESC" ) {
		var elem  = document.getElementById( "ITEM_DESC" );
        var bshowDescription = true;
        if (parent != null && parent.window != null && parent.window.frames != null && parent.window.frames.length!=null
                && parent.window.frames.length > 0) {
            for (var i=0; i<parent.window.frames.length; i++) {
                var frameName = parent.window.frames[i].name;
                if ( frameName == "detailBundleBid" || frameName == "detailVolumeBid" ) {
                    bshowDescription = false;
                }
            }
        }

		if ( elem != null ) {
            if (bshowDescription) {
                elem.style.visibility = "visible";
                elem.innerHTML = var2;
            } else {
                elem.style.visibility = "";
                elem.innerHTML = "";
            }
		}
	}
}

</SCRIPT>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/banner.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
</HEAD>
<body bgcolor="#FFFFFF" marginwidth="0" marginheight="0" topmargin="0" leftmargin="0">
<%
	String menuSeperator = "<li><a class=\"menu_separator\" href=\"javascript:\">|</a></li>";
%>
<%=  itemDesc  %>

<table width="100%" border="0" cellspacing="0" cellpadding="0">
  <tr>
    <td width="88" class="ibm_top_header_background"></td>
    <td width="100%" class="ibm_top_header_background">
		<table border="0" cellpadding="0" cellspacing="0" width="100%" class="ibm_top_header_background">
			<tr>
				<td width="139" class="ibm_top_header_background">
					<img src="<%= ssmPublicURL1 %>/branding_logos/leftHeaderLogo?_=<%=logosDeployTime%>" width="29" height="38" onerror='this.style.display="none"' />
				</td>
				<td width="100%" class="ibm_top_header_background">
					<span class="ibm-banner-product-name"><esapi:html><%=  ref.convertLiteral("epass.title.trademark") %></esapi:html></span>
				</td>
				<td width="34" rowspan="1" align="right" class="ibm_top_header_background"></td>
          <%
          	if(!showNothing){
          %>
          <td  class="ibm_top_header_background">
          	<div id="ibm-banner-content">
	      		<ul>
	      			<% if(showHelpIcon)	{ %>
	      			<li class="first">
	      				<a href='<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>' onClick="javascript:void NAV_PopupHelp( top, '<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>', false);return false;">
	      				<%=  ref.convertLiteral("form.mainMenu.label.help") %>
	      				</a>
	      			</li>
	      			<%} %>
	      			
	      			<%if (ref.userDataContext.isNetscape() == false && showPrint ){ %>
	      			
	      			<% if(showHelpIcon){ %>
	      				<%=menuSeperator %>
	      			<%} %>
	      			
	      			<li>
	      				<a href="javascript:;" onClick="javascript:self.doprint(); this.blur(); self.focus();">
	      					<%=  ref.convertLiteral("form.mainMenu.label.print") %>
	      				</a>
	      			</li>
	      			<%} %>
          		</ul>
          	</div>
          </td>
          <%} %>	
          <% if (showNothing == false) { %>
          <% } else if (ref.userDataContext.isNetscape() == false && showPrint ){ %>
          	<%--PR# 38037 Changed the print and help icon--%>
			<% if(showHelpIcon)	{ 
				String productName = BrandingPropertiesReader.getInstance().getProductName();
			%>
				<td width="35" height="20" colspan="1" rowspan="1" class="mainmenucell"><a href='<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>' onClick="javascript:void NAV_PopupHelp( top, '<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>', false);return false;" onMouseOver="SwitchImg('document.help', 'document.help','img/help_ovr.gif'); return NAV_Status('<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>');" onMouseOut="RestoreImg(); return NAV_Status();"><img CLASS="HAND" src="img/help_up.gif" border="0" alt="<esapi:htmlatt><%=ref.convertLiteral("form.general.print.general_help", new String[]{productName})%></esapi:htmlatt>" title="<esapi:htmlatt><%=ref.convertLiteral("form.general.print.general_help", new String[]{productName})%></esapi:htmlatt>" name="help"></a></td>
			<% } %>
			<td width="35" height="20" colspan="1" rowspan="1" class="mainmenucell"><a href="javascript:;" onClick="javascript:self.doprint(); this.blur(); self.focus();" onMouseOver="SwitchImg('document.print', 'document.print','img/print_ovr.gif'); return NAV_Status('<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>');" onMouseOut="RestoreImg(); return NAV_Status();"><img CLASS="HAND" src="img/print_up.gif" border="0" alt="<%=  ref.convertLiteral("form.general.print.click_to_print") %>" title="<%=  ref.convertLiteral("form.general.print.click_to_print") %>" name="print"></a></td>
          <% } else { %>
          	<%--PR# 38037 Changed the help icon--%>
			<% if(showHelpIcon)	{ %>
				<td width="35" height="20" colspan="1" rowspan="1" class="mainmenucell"><a href='<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>' onClick="javascript:void NAV_PopupHelp( top, '<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>', false);return false;" onMouseOver="SwitchImg('document.help', 'document.help','img/help_ovr.gif'); return NAV_Status('<esapi:htmlatt><%=  popupHelpUrl  %></esapi:htmlatt>');" onMouseOut="RestoreImg(); return NAV_Status();"><img CLASS="HAND" src="img/help_up.gif" border="0" alt="<%=  ref.convertLiteral("form.mainMenu.label.help") %>" title="<%=  ref.convertLiteral("form.mainMenu.label.help") %>" name="help"></a></td>
          <% } %>
		<% } %>
			<td id="ibm-banner-logo" width="49"><img src="<%= ssmPublicURL1 %>/branding_logos/corporateLogo?_=<%=logosDeployTime%>" width="88" height="38" onerror='this.style.display="none"'/></td>
        </tr>
      </table>

	</td>
  </tr>
</table>
<table width="100%" height="55" cellpadding="0" cellspacing="0" border="0">
  <tr>
    <td height="55" width="100%">
      <table width="100%" border="0" cellspacing="0" cellpadding="0">
        <tr>
          <td height="5" colspan="6" class="POPFORMSEPARATOR"></td>
        </tr>
        <tr>
          <td height="55" width="80"><img src="img/popups/grnlines_left.gif" width="80" height="55"></td>
          <td height="55" width="60%" background="img/popups/grnlines_mid.gif">&nbsp;</td>
          <td height="55" width="60"><img src="img/popups/grnlines_right.gif" width="60" height="55"></td>
          <td valign="top" nowrap>
            <%
			if (popupImage.length() == 0){
				out.print( "<b>&nbsp;</b>" );
			} else {
				out.print( "<IMG NAME='TOPIMAGE' SRC=");
				out.print(ESAPI.encoder().encodeForHTMLAttribute( popupImage ));
				out.print( ">");
			}
			%>
          </td>
          <td width="40%">&nbsp;</td>
          <td>&nbsp;</td>
        </tr>
      </table>
    </td>
  </tr>
</table>

<SCRIPT>
	<%=  "NAV_FireEvent( top, 'GET_ITEM_DESC', '' );" %>
</SCRIPT>


</body>
</html>



<%@ include file="include/tail.inc" %>








