<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page import="com.avinamart.Struct.*,
                 com.avinamart.WebInterface.forms.auction.ItemListPageProcessor,
                 com.emptoris.framework.messaging.webClient.EPASSUiMessageServices" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.BusinessLogic.Key.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.Utility.SystemException" %>
<%@ page import="com.avinamart.Utility.*" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.ItemType" %>

<%@ include file="include/framehead.inc"%>
<%
	boolean isSupplierAccessingCancelledRFq = EPASSUiRFQServices.isSupplierAccessingCancelledRFq(ref);
	if(isSupplierAccessingCancelledRFq){		
	   	String message = ref.getLocalization().convertLiteral("form.list_scenario.message.not_authorized");
		out.print(message);
	   	return;
	}
	
	//56298
	if(ref.isSupplierPreviewMode()){
	out.print(ref.getLocalization().convertLiteral("epass.nav.error.auth"));
	return;
	}
	String query = ref.getQueryString ();
	String popupTitle = ref.convertLiteral ( "sListTitle" );
	String popupColor = ref.getArea ().getAttribute ( EPassArea.AREA_BGCOLOR  );
	popupImage = getPopupImage(ref);
	showPrintButton = true;
%>

<head>
  <TITLE><esapi:html><%= ref.convertLiteral ( "epass.title" )%></esapi:html></TITLE>
</head>

<%@ include file="include/frametop.inc" %>

<frameset rows="10%, 90%" frameborder="1" border="1" marginwidth="5" onResize="ec.HandleResize();">
	<frame frameborder="0" border="0" src='<%= ref.encodeURL ( JSP.HEADER_MESSAGE_POPUP + "?" + query )%>' name='header_message'>
	<frame frameborder="1" border="1"
		src='<%= ref.encodeURL ( JSP.LIST_MESSAGE + "?" + query )%>' name='list_message'>
</frameset>

<%@ include file="include/framebottom.inc" %>

<%@ include file="include/frametail.inc" %>
<%!

public String getPopupImage(EPASSReferences ref)
	throws EPASSApplicationException, java.rmi.RemoteException
{
	String ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_ALL_MESSAGE;
	Integer cxt = EPASSUiMessageServices.getMessageContextParam(ref);
	Integer id = EPASSUiMessageServices.getMessageOwnerParam(ref, cxt.intValue());

    //PR22600 Reterive mode to display the appropriate image based on the current RFP Mode
     int mode = ItemListPageProcessor.getRFPPageMode(ref);
	if (cxt != null && id != null)
	{
		
		switch (cxt.intValue())
		{
			case EPASSUiMessageServices.msg_view_context_organization:
				ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_ALL_MESSAGE;
				break;
			case EPASSUiMessageServices.msg_view_context_auction:
				ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_BY_RFX;
				break;
			case EPASSUiMessageServices.msg_view_context_item:
				ItemStruct item = EPASSUiRFQServices.getItem(ref, new ItemKeyImpl(id));
				if (item != null)
				{
				    //PR#44581 Showing properMesg Image according to ItemType.
					if(item.getItemType().equals(ItemType.QUESTIONNAIRE))
					{
						ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_BY_QUEST;
					}
					else if(item.getItemType().equals(ItemType.SINGLE_ITEM))
					{
						ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_BY_ITEM;
					}
					else if(item.getItemType().equals(ItemType.QUESTION))
					{
						ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_BY_QUESTION;
					}
				}
				break;
			case EPASSUiMessageServices.msg_view_context_bid:
				BidStruct bid = ref.serviceRef.getBiddingService(ref)
								.getBid(ref.sessionService, new BidKeyImpl(id));
				if (bid != null)
				{
					Integer org = bid.getOrganizationId();
					//PR22600  executed either the auction is RFI or if the auction is RFP and mode is Questionairre mode
                    if (EPASSUiRFQServices.isRFI(ref, bid.getAuction()) || (EPASSUiRFQServices.isRFP(ref)&&ItemListPageProcessor.QUESTIONNAIRE_MODE == mode ))
					{
						ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_BY_RESPONSE;
					}

                    else {
						ret = Dir.HOME_IMG_TITLE + Dir.MESSAGES + Image.TITLE_VIEW_BY_BID;
					}
				}
				break;

			case EPASSUiMessageServices.msg_view_context_project:
				ret = Dir.HOME_IMG_TITLE + Dir.PROJECTS + Image.TITLE_VIEW_BY_PROJECT;
				break;

			case EPASSUiMessageServices.msg_view_context_task:
				ret = Dir.HOME_IMG_TITLE + Dir.PROJECTS + Image.TITLE_VIEW_BY_TASK;
				break;
				
		}

	}
	return ret;
}


%>