<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="org.owasp.esapi.ESAPI" %>
<%
/*
   JavaScript functions to support the boolean mode of detail_uda.jsp:

   IMPORTANT!!!
   In order to assure matching of variable names used here and the form's field names, which are
   generated in the Java IA classes, The Java classes in the ia.detailuda package define a method
   that writes variables declarations.The method is named DeclareJSVariables() and is called at
   the end of detail_uda.jsp to declare many of the variables used in this page. All the variables
   in this page which are declared this way are named with an ia_ prefix so they can easily be
   recognized (e.g. ia_codeField ).

   Avoid changing the names of such variables! If it has to be changed, a corresponding name change
   must also be made in the declaring Java method!!!
  */
 %>
 <script>

   //-------------------------------------------------------------------------------------
	<%//The function is called when the auto score checkbox is clicked. %>
<%if(ia.isScoreUsed()){ %>

	function onAutoScore(fld){

		<%//The checkbox field, when disabled, is presented as a gif with a hidden control
		//carrying the value %>
		var isOn = (ia_autoScoredField.type == 'hidden' && ia_autoScoredField.value == 'true') ||
				ia_autoScoredField.checked;
				
		toggleScoreInput(isOn);	
	}
	//-------------------------------------------------------------------------------------------------
	<%//The function is called when the formula field type is changed between Main Field and Sub field
	//(currently used in KPI formulas). Main KPI fields are scorable and score input is required, KPI
	//subfield are non scorable. It also shows'hides the score cutoffs for performance, which are not relevant for
	//the non scored sub fields. %>
	var cachedVisibility = null;
	function onIsSubField(){
	
		if(typeof ia_isSubField == 'undefined') return;
		
		var isOn = getControlValue(ia_isSubField, 'value') == 'false';
		toggleScoreInput(isOn);
		ShowHideKPIPerformance(isOn);
		
		<%//If the visibility field is hidden (can happen in certain SPM configurations) then there is no VISIBILITYSELECT
		//dropdown control field, only a hidden HIDDENTYPE control . Set the visibility there, exposed_readonly for KPI or
		//exposed_hidden for a subfield%>
		if (typeof(ia_visibilitySelect) == 'undefined' || ia_visibilitySelect.type != 'select-one') {
			ia_visibilityField.value = isOn ? '<%= AttributeDefVisibility.EXPOSED %><%= AttributeDefVisibility.READONLY %>' :
											  '<%= AttributeDefVisibility.EXPOSED %><%= AttributeDefVisibility.HIDDEN %>';
      		return;
    	}
		
		<%//User changes back to KPI field. Enable the control and, if a value was cached, set it to the cached value %>
		if(isOn){
			ia_visibilitySelect.disabled = false;
			if(cachedVisibility != null) EPASSSelect.setValue(ia_visibilitySelect,cachedVisibility);
		}
		<%//User changes to a subfield, cache the current visibility value, set it as Buyer Write/supplier hidden and disable it  %>
		else{
			ia_visibilitySelect.disabled = true;
			cachedVisibility = getControlValue(ia_visibilitySelect, 'value');
			var supplierHiddenVisibility = '<%= AttributeDefVisibility.EXPOSED %>' + '<%= AttributeDefVisibility.HIDDEN %>'
			EPASSSelect.setValue(ia_visibilitySelect,supplierHiddenVisibility);
		}
		
		
		setVisibilityField();
	}
	//---------------------------------------------------------------------------------------------------------
	<%//The function toggles the score inputs for a boolean type IA. It shows/hide
	//the row containing the Yes/No score controls. It also sets the control's required
	//status depending on the auto score setting.  %>
	function toggleScoreInput(isOn){
		var header;
		<%//The checkbox field, when disabled, is presented as a gif with a hidden control
		//carrying the value %>
		if(isOn){
				
			header = '<%= ESAPI.encoder().encodeForHTML(ref.convertLiteral("form.detailUda.header.score")) + Header.REQUIRED_FIELD%>';

			document.getElementById('<%=EPASSFieldName.addPrefix(
					EPASSAttributeDefStruct.MINVALUESCORE)%>_H').style.color='black';
			document.getElementById('<%=EPASSFieldName.addPrefix(
					EPASSAttributeDefStruct.MINVALUESCORE)%>_H').innerHTML = header;
			document.getElementById('<%=EPASSFieldName.addPrefix(
					EPASSAttributeDefStruct.MINVALUESCORE)%>_R').style.visibility='visible';
					
			<%//The control may already be in the array (when initialized in Edit action)
			//Need to check. %>
			if(!_isInArray(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
							'<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUESCORE)%>')){
							
				<%//Add the fields to the Required fields arrays %>
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
						"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUESCORE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
						"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MAXVALUESCORE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
						"<%=ref.convertLiteral(IABoolean.YES_SCORE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
						"<%=ref.convertLiteral(IABoolean.NO_SCORE)%>");
						
			}

		}
		else{
			header = "<%= ref.convertLiteral("form.detailUda.header.score")%>" +
					 " (<%= ref.convertLiteral("form.terminology.boolean.none")%>)";

			document.getElementById('<%=EPASSFieldName.addPrefix(
					EPASSAttributeDefStruct.MINVALUESCORE)%>_H').style.color='gray';
			document.getElementById('<%=EPASSFieldName.addPrefix(
					EPASSAttributeDefStruct.MINVALUESCORE)%>_H').innerHTML = header;
			document.getElementById('<%=EPASSFieldName.addPrefix(
					EPASSAttributeDefStruct.MINVALUESCORE)%>_R').style.visibility='hidden';

			<%//Remove the fields from the Required fields arrays %>
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
					"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUESCORE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
					"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MAXVALUESCORE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
					"<%=ref.convertLiteral(IABoolean.YES_SCORE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
					"<%=ref.convertLiteral(IABoolean.NO_SCORE)%>");

		}
		
		<%//Because of Buyer Feedback survey, there is a need for an IA specific processing here.
		//The function is defined in inc_detail_uda_iaspecific.jsp%>
		processIASpecificToggleScoreInput(isOn);
	}
	//--------------------------------------------------------------------------------------------
	function onMinFixedScore(){
		ia_maxScoreField.selectedIndex = ia_minScoreField.selectedIndex == 0 ? 1 : 0;
	}
	//--------------------------------------------------------------------------------------------
	function onMaxFixedScore(){
		ia_minScoreField.selectedIndex = ia_maxScoreField.selectedIndex == 0 ? 1 : 0;
	}
<%}// End of if(ia.isScoreUsed()) %>
	//------------------------------------------------------------------------------------
	<%//This function is called as part of the validate(frm) method in the general js page
	//which is processed when the form is submitted %>
	function onValidateIABoolean(){
		clearError(ia_defaultField);
		<%//With scorable attributes, even if the auto score is not set, there may be input
		//in the hidden score controls that the user entered there before toggling back to
		//non auto scored. Clean those fields before submitting the form %>
		if(ia_isScoreUsed && !isAutoScored()){
			ia_minScoreField.value = '';
			ia_maxScoreField.value = '';
		}
		return true;
	}
	//--------------------------------------------------------------------------------------------------
	<%// This function is called when the display mode option changes between Dropdown, Radio buttons or checkbox.
	//Radio buttons display is%>
	function onBooleanDisplay(ctrl){
		clearError(ia_requiredField);
		var defFieldCode =  '<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.DEFAULTBOOLEANVALUE)%>'; 
		var defFieldName = '<%=ref.convertLiteral("form.detailUda.header.def_value") %>';
		var defHeaderSpan = document.getElementById(defFieldCode + '_H');
					
		if(ctrl.value == <%= EPASSBooleanInput.CHECKBOX %>){
			if(ia_requiredField.checked){
				//alert('<%= ref.convertLiteral("form.detailUda.messsage.boolean_checkbox_display") %>.');
				showError(ia_requiredField,"<%= ref.convertLiteral("form.detailUda.messsage.boolean_checkbox_display") %>.");
			}
			ia_requiredField.checked = false;
			ia_requiredField.disabled = true;
			if(defHeaderSpan != null){
				defHeaderSpan.innerHTML = '';
			}
			_arrayRemoveElementByValue(<%= DetailUDAManager.REQUIREDFIELD_CODES %>, defFieldCode);
			_arrayRemoveElementByValue(<%= DetailUDAManager.REQUIREDFIELD_NAMES %>, defFieldName);
			
		}
		else if(ctrl.value == <%= EPASSBooleanInput.RADIO %>){
			if(defHeaderSpan != null){
				defHeaderSpan.innerHTML = '<%=  Header.REQUIRED_FIELD %>';
			}
			 // RTC-24836
			 ia_requiredField.disabled = false;
			_
			 arrayAddElement(<%= DetailUDAManager.REQUIREDFIELD_CODES %>, defFieldCode);
			_arrayAddElement(<%= DetailUDAManager.REQUIREDFIELD_NAMES %>, defFieldName);
		
		}
		else {
			ia_requiredField.disabled = false;
			if(defHeaderSpan != null){
				defHeaderSpan.innerHTML = '';
			}
			_arrayRemoveElementByValue(<%= DetailUDAManager.REQUIREDFIELD_CODES %>, defFieldCode);
			_arrayRemoveElementByValue(<%= DetailUDAManager.REQUIREDFIELD_NAMES %>, defFieldName);
		}
	
	}

</script>
