<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>

<%@ page import="com.avinamart.BusinessLogic.Constant.*,
                 com.avinamart.WebInterface.forms.ia.FormulaTester,
                 com.avinamart.WebInterface.forms.ia.detailuda.managers.*,
                 com.avinamart.WebInterface.forms.ia.formulahelpers.FormulaUiHelper,
                 com.avinamart.WebInterface.EPASSJSPActions,
                 com.avinamart.WebInterface.Constants.Dir,
                 com.avinamart.WebInterface.Utility.HTML.EPASSFormulaControl,
                 com.emptoris.framework.attribute.common.constant.AttributeDefDataType,
                 com.emptoris.framework.attribute.common.constant.AttributeDefVisibility"%>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.EPASSBooleanInput" %>
<%@ page import="com.avinamart.BusinessLogic.Helper.formulahelpers.FormulaHelper" %>
<%
/*
   JavaScript functions to support the formula mode of detail_uda.jsp:

   IMPORTANT!!!
   In order to assure matching of variable names used here and the form's field names, which are
   generated in the Java IA classes, The Java classes in the ia.detailuda package define a method
   that writes variables declarations.The method is named DeclareJSVariables() and is called at
   the end of detail_uda.jsp to declare many of the variables used in this page. All the variables
   in this page which are declared this way are named with an ia_ prefix so they can easily be
   recognized (e.g. ia_codeField ).

   Avoid changing the names of such variables! If it has to be changed, a corresponding name change
   must also be made in the declaring Java method!!!
  */
 %>
<script>

    //literals used in emptoris_formula_ide.js
    var ide_literals = {
      enterToSelect :  "<%= ref.convertLiteral("formula.ide.enterToSelect")%>",
      variablesTitle :  "<%= ref.convertLiteral("formula.ide.variablesTitle")%>",
      operatorsTitle :  "<%= ref.convertLiteral("formula.ide.operatorsTitle")%>",
      functionsTitle :  "<%= ref.convertLiteral("formula.ide.functionsTitle")%>",
	  dataType :  "<%= ref.convertLiteral("uda.helptip.datatype")%>",
      textType :  "<%= ref.convertLiteral("formula.ide.textType")%>",
	  integerType :  "<%= ref.convertLiteral("formula.ide.integerType")%>",
      numberType :  "<%= ref.convertLiteral("formula.ide.numberType")%>",
      booleanType :  "<%= ref.convertLiteral("formula.ide.booleanType")%>",
      dateType :  "<%= ref.convertLiteral("formula.ide.dateType")%>",
	  textTypeName :  "<%= ref.convertLiteral("form.pluginUda.types.string_type")%>",
      numberTypeName :  "<%= ref.convertLiteral("form.pluginUda.types.real_type")%>",
	  integerTypeName :  "<%= ref.convertLiteral("form.pluginUda.types.integer_type")%>",
      booleanTypeName :  "<%= ref.convertLiteral("form.pluginUda.types.boolean_type")%>",
      dateTypeName :  "<%= ref.convertLiteral("form.pluginUda.types.date_type")%>",
	  currencyTypeName :  "<%= ref.convertLiteral("form.pluginUda.types.currency_type")%>",
      onSetRequiredTitle :  "<%= ref.convertLiteral("formula.ide.onSetRequiredTitle")%>",
      onsetRequiredMessage1 :  "<%= ref.convertLiteral("formula.ide.onsetRequiredMessage1")%>",
      onsetRequiredMessage2 :  "<%= ref.convertLiteral("formula.ide.onsetRequiredMessage2")%>",
      onsetUnRequiredMessage1 :  "<%= ref.convertLiteral("formula.ide.onsetUnRequiredMessage1")%>",
      onsetUnRequiredMessage2 :  "<%= ref.convertLiteral("formula.ide.onsetUnRequiredMessage2")%>",
	  okBtnCaption : "<%= ref.convertLiteral("form.terminology.button.ok")%>",
      keepOption :  "<%= ref.convertLiteral("formula.ide.keepOption")%>",
      removeOption :  "<%= ref.convertLiteral("formula.ide.removeOption")%>",
      reviewOption :  "<%= ref.convertLiteral("formula.ide.reviewOption")%>",
	  removeWrapFrom :  "<%= ref.convertLiteral("formula.ide.removeWrapFrom")%>",
	  undo : "<%= ref.convertLiteral("formula.ide.undo")%>",
	  redo : "<%= ref.convertLiteral("formula.ide.redo")%>",
	  clear : "<%= ref.convertLiteral("formula.ide.clear")%>",
	  required : "<%= ref.convertLiteral("formula.ide.required")%>",
	  clearTooltip : "<%= ref.convertLiteral("formula.ide.clear_tooltip")%>",
	  undoTooltip : "<%= ref.convertLiteral("formula.ide.undo_tooltip")%>",
	  redoTooltip : "<%= ref.convertLiteral("formula.ide.redo_tooltip")%>",
	  arithmetic : "<%= ref.convertLiteral("formula.ide.arithmetic")%>",
	  logical : "<%= ref.convertLiteral("formula.ide.logical")%>",
	  comparison : "<%= ref.convertLiteral("formula.ide.comparison")%>",
	  noVariablesMessage : "<%= ref.convertLiteral("formula.ide.noVariablesMessage")%>",
	  date : "<%= ref.convertLiteral("formula.ide.date")%>",
	  value : "<%= ref.convertLiteral("formula.ide.value")%>",
	  condition : "<%= ref.convertLiteral("formula.ide.condition")%>",
	  expression : "<%= ref.convertLiteral("formula.ide.expression")%>",
	  variable : "<%= ref.convertLiteral("formula.ide.variable")%>",
	  type : "<%= ref.convertLiteral("formula.ide.type")%>",
	  payment : "<%= ref.convertLiteral("formula.ide.payment")%>",
	  periods : "<%= ref.convertLiteral("formula.ide.periods")%>",
	  rate : "<%= ref.convertLiteral("formula.ide.rate")%>",
	  dateFormat :"<esapi:js><%=  I18NFormats.getBasicDateFormatString(ref.getLocale()) %></esapi:js>"
    }

	var fieldIDs = new Array("0000");
	var fieldNames= new Array("Fields");
	var fieldCodes = new Array("Fields");
	var fieldNameDisplays= new Array("Fields");
	var fieldTypes= new Array("-1");
	var fieldPrecisions = new Array("-1");
	var fieldRequired = new Array("-1");
	var fieldLists = new Array("' '");
	var fieldOptionLists = new Array("' '");

	//The language dependent constants that are used for booleans
	var TEXT_TRUE= "<%= ref.convertLiteral(EPASSBooleanInput.TEXT_TRUE_KEY) %>";
	var TEXT_FALSE= "<%= ref.convertLiteral(EPASSBooleanInput.TEXT_FALSE_KEY) %>";


	var fieldsCount;
	var inserted = "";
	var validated = false;
	var displayFormula;
	var translatedFormula;
	var dependentIds;
	var resultType;
	var precision;
	var listWindow;
	var listsBtnOn= '<%= ref.getUserPath() + Dir.IMG_BTNS_UP %>btn_show_list_up.gif';
	var listsBtnOff = '<%= ref.getUserPath() + Dir.IMG %>blank.gif';
	var listBtnAlt = "<%= ref.convertLiteral("form.detailUda.alt.list_select") %>";
	var isFormulaChanged = false;

   var precisionRow;
   //----------------------------------------------------------------------------------------------------------
  //The function is executed on load
  $(function(){
  
  $("input[name='_uda_precision']").attr("value",ia_currencyPrecision);
   $("#_uda_precision_display").text(ia_currencyPrecision);
   
        //Set the precision control row variable (needed to be shown/hiddedn depending on the data type)
        precisionRow = $(ia_precisionField).parents('tr').get(0);
		if(precisionRow){
	      if(ia_subTypeField.value == -1 ||
	        ia_subTypeField.value == <%= AttributeDefDataType.string_type%>){
	             $(precisionRow).hide();
	      }
		}
    });
    //---------------------------------------------------------------------------------------
    //The function is called when the formula data type changes. It sets the formula precision field accordingly.
    //This function is used only in Create mode. In Edit mode the formula type and data type are ReadOnly and
    //cannot be changed
    function onFormulaDataType(){

	clearError(ia_subTypeField);
        var defaultDecimals = <%= EPASSRealInput.defaultDigits%>;

        //Score formula, the type is always number and precision is always 2
        if(getControlValue(ia_formulaTypeFields) == <%= FormulaHelper.SCORES_FORMULA %>){
            ia_precisionField.value = defaultDecimals;
            ia_precisionField.disabled = true;
            ia_precisionField.style.border = '0px';
            $(precisionRow).show();
        }
        //number type, set by default the filed to 2. Enable the field to be editable
         else if(ia_subTypeField.value == <%= AttributeDefDataType.double_type%>){
            ia_precisionField.value = defaultDecimals;
            ia_precisionField.disabled = false;
            ia_precisionField.style.border = '1px solid';;
            $(precisionRow).show();
        }
        //currency. Set to the currency precision, as defined on the page, disable the field
        else if(ia_subTypeField.value == <%= AttributeDefDataType.currency_type%> ){
            ia_precisionField.value = ia_currencyPrecision;
            ia_precisionField.disabled = true;
            ia_precisionField.style.border ='0px';
            $(precisionRow).show();
        }
        //text or Please Select. Precision is not applicable. Set to 0 and hide it
        else{
            ia_precisionField.value = 0;
            $(precisionRow).hide();
         }
    }
    //--------------------------------------------------------------------------------
	function onFormulaChange(){
		clearError(document.getElementById("editor"));
		validated=false;
		ia_validateButton.disabled = (typeof($.formulaEditor.editor) == "undefined" || $.formulaEditor.editor == null || $.trim($.formulaEditor.editor.text()) == '');
		ia_testButton.disabled = true;
		isFormulaChanged=true;
	}
	//Added by Ashok for ESP-59137
	function replacePlaceHolderWithOpe(formulaTxt){
		var operatorArr = ['+','-','*','/','^'];
		var operatorPlaceHolder = ["OpPlUS","OpMiNUS","OpMuLTiPLy","OpDIvIDe","OpPoWEr"];
		formulaTxt = formulaTxt.replace(/OpPlUS/g,'+').replace(/OpMiNUS/g,'-').replace(/OpMuLTiPLy/g,'*').replace(/OpDIvIDe/g,'/').replace(/OpPoWEr/g,'^');
		return formulaTxt;
	}
	//End added by Ashok
	//-------------------------------------------------------------------
	function validateFormula(showValidMessage){

		clearError(document.getElementById('editor'));		
		    var formula = $.formulaEditor.getFormulaText(false);
		    var concatWithValidMessage=false;
		    if(formula.indexOf('/')!=-1 && (showValidMessage!= undefined && showValidMessage!= false)){
		    		//alert('<%= ref.convertLiteral("form.detailUda.message.dividebyzero")%>');
		    		concatWithValidMessage=true;
		    }
		 
		    //PR# ESP-44341 - BEGIN
		    var exp1 = "[-/\\+\\*\\^]\\s*[-/&=><\\+\\*\\!\\|\\^]";
			
			var construct = formula.match(new RegExp(exp1));
			if (construct != null && construct.length > 0) {
				alert('<%= ref.convertLiteral("form.detailUda.message.error_consecutive_operators") %>');
				return false;
			}
			
			var exp2 = "^\\s*[-/&=><\\+\\*\\!\\|\\^]";  
			construct = formula.match(new RegExp(exp2));
			if (construct != null && construct.length > 0) {
				alert('<%= ref.convertLiteral("form.detailUda.message.error_operator_beginning_line") %>');
				return false;
			}
			//PR# ESP-44341 - END
			
		 // pr 42466 ----------------------------------------------------------------------------------
		 formula = replacePlaceHolderWithOpe(formula);

<%
	char specialChar = '\u00b7';
	StringBuilder jsRegExp = new StringBuilder("");
	jsRegExp.append(specialChar);
%>
		 
		    //purpose here is to replace instances of "<%-- jsRegExp.toString() --%>Bid<%-- jsRegExp.toString() --%>" in formula with "Bid.", or
		    //"<%-- jsRegExp.toString() --%>Kpi<%-- jsRegExp.toString() --%>" in formula with "Kpi."
		    //so used this one which actually has chinese characters .  
		    //i.e. iaTypesJsArr has localised names of IATypes
		    // this var iaTypeNamesArr is send from FormulaUiHelper, 
		    //iaTypeNamesArr = {'KPI' , 'BID' , 'ITEM'} or 
		    for(var i = 0; i < iaTypesJsArr.length; i++)
		    {
		    	var iaTypeName = iaTypesJsArr[i];
		    	var iaTypeNameRegex = new RegExp('(<%= jsRegExp.toString() %>'+iaTypeName+'<%= jsRegExp.toString() %>)' ,'g') ;
		    	formula = formula.replace(iaTypeNameRegex, iaTypeName+".");	
		    }
			 // pr 43060 ----------------------------------------------------------------------------------

			if(formula.length == 0){
				return false;
			}
			
		<%if(!ia.isMessage()){ %>
			else if(ia_subTypeField.selectedIndex == 0){
				//alert('<%= ref.convertLiteral("form.detailUda.message.select_formula_type")%>');
				showError(ia_subTypeField,"<esapi:js><%= ref.convertLiteral("form.detailUda.message.select_formula_type")%></esapi:js>");
				return false;
			}
		<%} %>
		if(formula == null || $.trim(formula)==""){
			showError(document.getElementById("editor"),"<esapi:js><%= ref.convertLiteral("form.detailUda.message.required_field_mark")%></esapi:js>");
			return false;
		}

		<%if(ia.isMessage()){ %>
			var messageType = getControlValue(ia_subTypeField,'value');
			resultType = '<%=AttributeDefDataType.STRING_TYPE.toString() %>';
		<%}
		else{%>
			var messageType = '';
			resultType = getControlValue(ia_subTypeField,'value');
		<%} %>
			<%//The evaluator needs to know if this is a score formula (skips type validation) %>
			var isScoresFormula = (getControlValue(ia_formulaTypeFields) == <%= FormulaHelper.SCORES_FORMULA %>);

			<%//Validation of the use of isEmpty function depends whther the formula is set as required or not %>
			var isRequiredAsCheckBox = ia_requiredField.type == 'checkbox' && ia_requiredField.checked;
			var isRequiredAsHidden = ia_requiredField.type == 'hidden' && ia_requiredField.value.toLowerCase() == 'true';
			var isFormulaRequired = isRequiredAsCheckBox || isRequiredAsHidden;


			var result =evaluateFormula(
				ia_udaForm,'validate',formula, isScoresFormula, messageType,resultType,
									'<%= FormulaUiHelper.FORMULA_SEPARATOR %>', isFormulaRequired);


			if(result) {
				var results = result.split('<%= FormulaUiHelper.FORMULA_SEPARATOR %>');
				//An array was returned
				if(results.length > 1){

					var validMessage = results[0];  //"valid Formula";
					//translatedFormula = results[1];
					dependentIds = results[2];
					resultType = results[3];
					precision = results[4];

					displayFormula = $.formulaEditor.editor.text();
                    translatedFormula =  $.formulaEditor.getFormulaTextESP();

					if(translatedFormula.length > 1800){
						//alert('<%= ref.convertLiteral("form.detailUda.message.formula_toolong")%>');
						showError(document.getElementById('editor'),"<%= ref.convertLiteral("form.detailUda.message.formula_toolong")%>");
						return false;
					}

					if(typeof(dependentIds) == 'undefined' || dependentIds.length == 0){
						//alert('<%= ref.convertLiteral("form.detailUda.message.error_nofields") %>');
						showError(document.getElementById('editor'),"<%= ref.convertLiteral("form.detailUda.message.error_nofields") %>");
						return false;
					}

					ia_formulaField.value = translatedFormula;
					ia_dependenciesField.value = dependentIds;
					<%if(ia.isFormula()){ %>
						////ia_subTypeField.value = resultType;
					<%} %>

					//ia_precisionField.value = precision;

					validated = true;
					ia_validateButton.disabled = true;
					ia_testButton.disabled = false;

					if(showValidMessage && concatWithValidMessage){ 
						alert(validMessage + "\n\n"+'<%= ref.convertLiteral("form.detailUda.message.dividebyzero")%>');
					}else if(showValidMessage && !concatWithValidMessage){
						alert(validMessage);
					}
					
				}
				else{
					alert(results[0]);
				}
			}
			else{
				return false;
			}
		//}  //Temporary fix for PR 12146 until back end fix is applier
		return true;
	}
	//------------------------------------------------------------------
	function testFormula(){
	
		if($.formulaEditor.editor.text() == ''){
			 ia_testButton.disabled = true;
			 return;
		}

		<%//Hack for enableing testing in edit view when openning the page,
		//without first validating the formula%>
		if(typeof(displayFormula) == 'undefined'){
			validated = false;
			validateFormula(false);
		}
		var tempDisplayFormula 	  = encodeURIComponent(displayFormula);
		var tempTranslatedFormula 	  = encodeURIComponent(translatedFormula);

		<%//In the case of formula (not message), sub datatype is a hidden field to
		  //be populated here. Also, if the sub data type is currency, set the precision
		//to currency precision, ignoring the precision returned from the validator%>
		var testPrecision = '';
		if(resultType == <%= AttributeDefDataType.double_type %>){
			testPrecision = ia_precisionField.value;
		}
        else if(resultType == <%= AttributeDefDataType.currency_type %>){
			testPrecision = ia_currencyPrecision;
		}

		if(tempDisplayFormula.length > 500) tempDisplayFormula =
			"<%= ref.convertLiteral("form.detailUda.message.see_form") %>";
<%//FIXME, the temporary hack needed in oreder to use formulaHelper. Need API to get type from id %>
	var isScoresFormula = (getControlValue(ia_formulaTypeFields) == <%= FormulaHelper.SCORES_FORMULA %>);
	var added =
		'<%= FormulaTester.FORMULA_IATYPE %>=<%= detailUDA.getIaType() %>&' +
		'<%= FormulaTester.DISPLAY_FORMULA %>=' + tempDisplayFormula + '&'  +
		'<%= FormulaTester.SCORE_FORMULA %>=' + isScoresFormula + '&'  +
		'<%= FormulaUiHelper.FORMULA_TEST_SIDE %>=' + ia_formulaTestSide +'&' +
		'<%= FormulaTester.TRANSLATED_FORMULA %>=' + tempTranslatedFormula +'&' +
		'<%= FormulaTester.DEPENDENT_IDS %>=' + dependentIds + '&' +
		'<%= FormulaTester.IS_MESSAGE %>=<%= ia.isMessage() %>&' +
		'<%= FormulaTester.FORMULA_DATATYPE %>=' + getControlValue(ia_subTypeField,'value') + '&' +
		'<%= FormulaTester.PRECISION %>='	+ testPrecision + '&' +
		'<%= DetailUDAManager.IATYPE_CUSTOM_PARAMETERS %>=' +
			'<%= DetailUDAManager.CALLER_ORIGIN %>' +
		  	'<%= DetailUDAManager.IATYPE_CUSTOM_SEPARATOR %>' +
			'<%= BidUDAManager.CALLER_WIZARD_RFQ %>' +
		    '<%= DetailUDAManager.IATYPE_CUSTOM_SEPARATOR %>' +
			'<%= DetailUDAManager.IS_LIBRARY_CONSOLE %>' +
			'<%= DetailUDAManager.IATYPE_CUSTOM_SEPARATOR %>' +
			'<esapi:js><%= ref.req.getParameter(DetailUDAManager.IS_LIBRARY_CONSOLE)  %></esapi:js>&' +
		'<%= EPASSJSPActions.ACTION %>=<%= FormulaTester.INITIAL_CALL %>';

		var testFormulaURL = ia_testURL + added;
		NAV_Popup( top, 1, testFormulaURL, 480, 640 );

	}

	//----------------------------------------------------------------
	//This is object specific and should be written by a sub class
	function updateFieldsControls(){

	<%if(ia.isFormulaFieldEnabled()){ %>

		<%//Everytime the fields are updated, if there is already a formula in the formula box
		//it may become invalid. A new validation has to be enforced %>
        if($.formulaEditor.editor.val() != ''){
                    validated = false;
            ia_validateButton.disabled = false;
            ia_testButton.disabled = true;
        }
       $.formulaEditor.setAvailableFields(getFormulaFields());
        var invalids = $.formulaEditor.markInvalidEntries();

        if(invalids > 0){
            alert("Some fo the fields in your formula are out of scope as a result of the change you made. Please remove them. ")
        }

	<%}//end if(isFormulaFieldEnabled()) %>
	}
    //----------------------------------------------------------------
	//This is object specific and should be written by a sub class
	function getFormulaFields(){

	    var objTypesMap = new EPASSJSMap()
	    // pr 42466 iaObjectTypes = ['bid.','item.','supplier.'] array in replace with
	    // localised version of array of Ia type names
		for(var i = 0; i < localisedIaObjectTypes.length; i++){
			var typeName = localisedIaObjectTypes[i].substring(0, localisedIaObjectTypes[i].length-1);
			objTypesMap.put(typeName.toLowerCase(), iaObjectTypeSuffixes[i]);
		}

		<%//The available fields depend on three parameters (if they are used) - the visibility of the
		//formula (seen by supplier or not), the scope of the formula (rfq or item) and whether the formula is

		//The getControlValue() function is used here. This function can handle Radio and
		//checkbox controls in both enabled or disabled (rendered as hidden fields) formats.
		//For radio button, the argument 'value' returns the *index* of the slected radio
		//and the argument 'text' returns the *value* property of the selected button>

		//Initialize all as null and then look whether defined%>
		var isSupplierHidden = null;
		var modifiedFormulaScope = null;

		if(typeof ia_visibilitySelect != 'undefined'){
		var vis = parseInt(getControlValue(ia_visibilitySelect,'value') )
		var supVis = vis % 10;
			isSupplierHidden = (supVis == <%= AttributeDefVisibility.HIDDEN%>) ;
		}

		if(typeof <%= FormulaUiHelper.FORMULA_SCOPE_MODIFIER %> != 'undefined'){
			modifiedFormulaScope = <%= FormulaUiHelper.FORMULA_SCOPE_MODIFIER %>;
		}

		<% //Initialize an array for the fields objects%>
		var fields = [] ;
		for(var i = 1; i < allFieldIDs.length; i++){

			<% //If the formula is exposed to supplier, supplier hidden fields cannot be used.
			//All other combos of these two parameters are allowed%>
			var eliminateHidden = false;
			if(isSupplierHidden != null){
				eliminateHidden = !isSupplierHidden && allFieldHiddens[i];
			}

			<%//Similar rule apples for the formula scope and the fields scope%>
			var eliminateScope = false;
			if(modifiedFormulaScope != null){
				eliminateScope = (modifiedFormulaScope & allFieldRfqScopes[i]) != allFieldRfqScopes[i];
			}


			<%//This variable sums the elimination related to formula types (values, scores, subfields, as currently
			//used in KPI formulas). It defaults to false and then calculated, if formula types are used%>
			var eliminateForFormulaTypes = false;

			if(typeof ia_formulaTypeFields != 'undefined'){
				var fType = getControlValue(ia_formulaTypeFields);

				<%//For a values formula (the first radio button is checked) eliminate manual fields and score formula fields%>
				var eliminateIfValues = fType == <%= FormulaHelper.VALUES_FORMULA%> && (allScoreFormulas[i]  || allFieldManuals[i]);
				<%//For a score formula (the second radio button is checked) eliminate sub fields (components)%>
				var eliminateIfScores = fType == <%= FormulaHelper.SCORES_FORMULA%> && allSubFields[i];

				<%//Assign the combined value to eliminateForFormulaTypes%>
				eliminateForFormulaTypes = eliminateIfValues || eliminateIfScores ;
			}

			if(!eliminateHidden && !eliminateScope &&  !eliminateForFormulaTypes){

                //This is needed for the validation
                fieldIDs.push(allFieldIDs[i]);
				fieldNames.push(allFieldNames[i]);
				fieldCodes.push(allFieldCodes[i]);
				fieldTypes.push(allFieldTypes[i]);
				fieldPrecisions.push(allFieldPrecisions[i]);
				fieldRequired.push(allFieldRequired[i]);

                //This is needed for the editor
				var mtchName = allFieldNames[i].match("^([^\\.]+)\\.'([^']+)'$");

                var myList = null;
                if(allFieldLists[i] != ' '){
                    myList = allFieldLists[i].split('|');
                    myList.pop();
                }

                var myScope = mtchName[1];
                var varName = mtchName[2];
                var scopeId = objTypesMap.get(myScope.toLowerCase());

                var fld = {
                             id : allFieldIDs[i],
                             scope : myScope,
                             scopeId :  scopeId,
                             name :varName,
                             code : editorFieldCodes[i] ,
                             dataType : allFieldTypes[i],
                             required : allFieldRequired[i],
                             list : myList
                        };

                fields.push(fld);

            }
        }
        return fields;

	}

    var helpCache = [];
	//----------------------------------------------------------------------------------------------------------
    function getMyHelpText(iaId){

        var helpTxt = helpCache[iaId];
        if(helpTxt){
            return helpTxt;
        }

       var helpUrl = "<%= ref.getUserPath()%>formula_editor_ajax.jsp?IA_ID=" + iaId;
       $.get(helpUrl, function(resp){
           helpTxt = resp.replace(/^\s+|\s+$/g,"");
           helpCache[iaId] = helpTxt;
       });

    }
	//-------------------------------------------------------------------------------------------------------
	<%//This function is called when formula type is changed (currently used only in KPI formulas, where
	//a formula can be of Values, Scores, or sub fields type. %>
	function onFormulaType(){

		<%//The function is also called when the formula page is loaded in editable mode. Ignore it if the subfield
		//is disabled %>
        var fType = getControlValue(ia_formulaTypeFields);
		if(typeof ia_subTypeField == 'undefined' || ia_subTypeField.type == 'hidden') {
            if(fType == <%= FormulaHelper.SCORES_FORMULA %>){
                toggleScoreInput(false);
            }
            return;
        }

		var isFormulaDataTypeEditable = ia_subTypeField.type != 'hidden';

		if(fType == <%= FormulaHelper.SCORES_FORMULA %>){
			<%//Score formula is a Numeric data type. Set the type and disable the data type control %>
			if(isFormulaDataTypeEditable){
				ia_subTypeField.value = '<%= AttributeDefDataType.DOUBLE_TYPE %>';
				ia_subTypeField.disabled = true;
			}

		    <%//Score formula is like a manual KPI, not auto scored. Hide the score fields and set the field type as a KPI.
		    //Disable the field type Radio button beacuase as long as it is a score formula, it cannot be changed to
		    //a sub field(component).%>
			ia_isSubField[0].checked = true;
			ia_isSubField[0].disabled = true;
			ia_isSubField[1].disabled = true;
			toggleScoreInput(false);
		}
		else{
			<%//Values formula can be Numeric or Currency, enable user ability to select data type. %>
			if(isFormulaDataTypeEditable){
				ia_subTypeField.value = '<%= EPASSHTMLSelect.NONE %>';
				ia_subTypeField.disabled = false;
			}
			<%//When set to a values formula, if the field is set as KPI, expose the score fields, If set as sub field,
			//leave them hidden. If the Use in Formula is checked, enable the selection between KPI and sub field %>
			var isUsed = getControlValue(ia_useInFormulaField, 'text') == 'true';
			if(isUsed){
				ia_isSubField[0].disabled = false;
				ia_isSubField[1].disabled = false;
			}
			<%//If the selection is as KPI, expose the score firlds %>
			var isKPI = getControlValue(ia_isSubField, 'value') == 'false';
			if(isKPI){
				toggleScoreInput(true);
			}

		}
		<%//Update the valid formula field to match the selected formula type %>
		updateFieldsControls();
        //Also update the precision field that depends on the formula data type
        onFormulaDataType();
    }


<%if(ia.isScoreUsed()){ %>

	<%//This provides the decimal places for the formula min and max values %>
	//-------------------------------------------------------------------------------------
    function getDecPlaces(){
		return <%= defaultDigits %>;
    }
	function onMin(fld){

		if(!validateMinMaxRange(fld)){
			return false;
		}

		if(!_isEmpty(fld)){
			ia_minInclusiveField.disabled = false;
		}
		else{
			ia_minInclusiveField.checked = false;
			ia_minInclusiveField.disabled = true;
			return true;
		}
	}
	//---------------------------------------------------------------------------
	function onMax(fld){

		if(!validateMinMaxRange(fld)) return false;

		if(!_isEmpty(fld)){
			ia_maxInclusiveField.disabled = false;
		}
		else{
			ia_maxInclusiveField.checked = false;
			ia_maxInclusiveField.disabled = true;

			return true;
		}
	}

	//---------------------------------------------------------------------------------------------
	function validateMinMaxRange(fld){

		var minValue = _isEmpty(ia_minValueField) ?
				Number.NEGATIVE_INFINITY :i18n.textToNumber(ia_minValueField.value);
		var maxValue = _isEmpty(ia_maxValueField) ?
				Number.POSITIVE_INFINITY : i18n.textToNumber(ia_maxValueField.value);

		<%//First, max field must be greater than min field%>
		if(minValue >= maxValue){
			alert("<esapi:js><%= ref.convertLiteral("form.detailUda.message.minmax_validation")%></esapi:js>");
			fld.focus();
			return false;
		}
		return true;
	}
	//-------------------------------------------------------------------------------------------------
	<%//The function is called when the formula field type is changed between Main Field and Sub field
	//(currently used in KPI formulas). Main KPI fields are scorable and score input is required, KPI
	//subfield are non scorable. It also shows'hides the score cutoffs for performance, which are not relevant for
	//the non scored sub fields. %>
	var cachedVisibility = null;
	function onIsSubField(){
		if(typeof ia_isSubField == 'undefined') return;


		var isOn = getControlValue(ia_isSubField, 'value') == 'false';
		toggleScoreInput(isOn);
		ShowHideKPIPerformance(isOn);

		<%//If the visibility field is hidden (can happen in certain SPM configurations) then there is no VISIBILITYSELECT
		//dropdown control field, only a hidden HIDDENTYPE control . Set the visibility there, exposed_readonly for KPI or
		//exposed_hidden for a subfield%>
		if (typeof(ia_visibilitySelect) == 'undefined' || ia_visibilitySelect.type != 'select-one') {
			ia_visibilityField.value = isOn ? '<%= AttributeDefVisibility.EXPOSED %><%= AttributeDefVisibility.READONLY %>' :
											  '<%= AttributeDefVisibility.EXPOSED %><%= AttributeDefVisibility.HIDDEN %>';
      		return;
    	}

		<%//User changes back to KPI field. Enable the control and, if a value was cached, set it to the cached value %>
		if(isOn){
			ia_visibilitySelect.disabled = false;
			if(cachedVisibility != null) EPASSSelect.setValue(ia_visibilitySelect,cachedVisibility);
		}
		<%//User changes to a subfield, cache the current visibility value, set it as Buyer Read/supplier hidden and disable it  %>
		else{
			ia_visibilitySelect.disabled = true;
			cachedVisibility = getControlValue(ia_visibilitySelect, 'value');
			var supplierHiddenVisibility = '<%= AttributeDefVisibility.READONLY %>' + '<%= AttributeDefVisibility.HIDDEN %>'
			EPASSSelect.setValue(ia_visibilitySelect,supplierHiddenVisibility);
		}

		setVisibilityField();

	}
	//-----------------------------------------------------------------------------------------------------------------
	<%//The function toggles between auto scored/ non auto scored status for formula.  This is used currently in KPI formulas
	//When on, score input controls are exposed to  view and are made required. When off, they are hidden from view and
	//are made non required. %>

	function toggleScoreInput(isOn){


		<%//The checkbox field, when disabled, is presented as a gif with a hidden control
		//carrying the value %>
		if(isOn){

			document.getElementById('<%= EPASSAttributeDefStruct.SCORED %>_row').style.display =
													navigator.appName == 'Netscape' ? 'table-row' : 'block';
			document.getElementById('<%= EPASSAttributeDefStruct.SCORED %>_sep').style.display =
													navigator.appName == 'Netscape' ? 'table-row' : 'block';
			document.getElementById('<%= EPASSAttributeDefStruct.MINVALUEDOUBLE %>_row').style.display =
													navigator.appName == 'Netscape' ? 'table-row' : 'block';
			document.getElementById('<%= EPASSAttributeDefStruct.MINVALUEDOUBLE %>_sep').style.display =
													navigator.appName == 'Netscape' ? 'table-row' : 'block';
			document.getElementById('<%= EPASSAttributeDefStruct.MAXVALUEDOUBLE %>_row').style.display =
													navigator.appName == 'Netscape' ? 'table-row' : 'block';
			document.getElementById('<%= EPASSAttributeDefStruct.MAXVALUEDOUBLE%>_sep').style.display =
													navigator.appName == 'Netscape' ? 'table-row' : 'block';

			<%//Set the formula as auto scored by setting the hidden field value %>
			ia_autoScoredField.value = 'true';

			<%//Add the fields to the Required fields arrays.
			//The control may already be in the array (when initialized in Edit action)
			//Need to check. %>
			if(!_isInArray(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
							'<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUESCORE)%>')){

				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
						"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUEDOUBLE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
						"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MAXVALUEDOUBLE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
						"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUESCORE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
						"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MAXVALUESCORE)%>");

				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
												"<%=ref.convertLiteral(IANumeric.MINVALUE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
												"<%=ref.convertLiteral(IANumeric.MAXVALUE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
												"<%=ref.convertLiteral(IANumeric.MINSCORE)%>");
				_arrayAddElement(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
												"<%=ref.convertLiteral(IANumeric.MAXSCORE)%>");

			}
		}
		else{
			document.getElementById('<%= EPASSAttributeDefStruct.SCORED %>_row').style.display  ='none';
			document.getElementById('<%= EPASSAttributeDefStruct.SCORED %>_sep').style.display ='none';
			document.getElementById('<%= EPASSAttributeDefStruct.MINVALUEDOUBLE %>_row').style.display = 'none';
			document.getElementById('<%= EPASSAttributeDefStruct.MINVALUEDOUBLE %>_sep').style.display = 'none';
			document.getElementById('<%= EPASSAttributeDefStruct.MAXVALUEDOUBLE %>_row').style.display = 'none';
			document.getElementById('<%= EPASSAttributeDefStruct.MAXVALUEDOUBLE%>_sep').style.display ='none';

			<%//Set the formula as non auto scored by setting the hidden field value to false %>
			ia_autoScoredField.value = 'false';

			<%//Remove the fields from the Required fields arrays %>
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
					"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUEDOUBLE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
					"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MAXVALUEDOUBLE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
					"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MINVALUESCORE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_CODES %>,
					"<%=EPASSFieldName.addPrefix(EPASSAttributeDefStruct.MAXVALUESCORE)%>");

			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
											"<%=ref.convertLiteral(IANumeric.MINVALUE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
											"<%=ref.convertLiteral(IANumeric.MAXVALUE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
											"<%=ref.convertLiteral(IANumeric.MINSCORE)%>");
			_arrayRemoveElementByValue(<%=DetailUDAManager.REQUIREDFIELD_NAMES %>,
											"<%=ref.convertLiteral(IANumeric.MAXSCORE)%>");

		}

		//In the formula IDE the components side box has to be re positioned also
		$.formulaEditor.setAllComponentsPosition();

	}
//------------------------------------------------------------------------------------
    //This function is added for compatibility for KPI formulas where min and max ranges are defined while there is not default value
    //Otherwise, a javascript error happens on blur from the min/max inclusive checkboxes (PR82587)
    function validateDefaultInRange(){}

<%}//End of  if(ia.isScoreUsed())%>
	</script>
