<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ page import="com.avinamart.WebInterface.Constants.Frames" %>
<%@ page import="com.avinamart.WebInterface.menus.ZissouCommands" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.AuctionStatus" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.AuctionType" %>

<script type="text/javascript" src="<%= request.getContextPath()%>/dhtml_lib/js/feature/zissou.autocomplete.js"></script>
<link rel="stylesheet" type="text/css" href="<%= request.getContextPath()%>/dhtml_lib/css/feature/zissou.autocomplete.css" />
<link rel="stylesheet" type="text/css" href="<%= request.getContextPath()%>/dhtml_lib/css/feature/zissou_new.css">
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>

<script type='text/javascript' src='<%= request.getContextPath()%>/dhtml_lib/js/feature/zissou.js'></script>

<script type="text/javascript">

var ZissouUserPath = "<%=ref.getUserPath()%>";

var ZissouUserType = {
    isBuyer : function(){ return <%=ref.isUserBuyer() %>; },
    isSeller : function(){ return <%=ref.isUserSeller() %>; }
}

var ZissouAuctionType = {
    SEALED : <%= AuctionType.SEALED%>,
    ASCENDING_PRICE : <%= AuctionType.ASCENDING_PRICE%>,
    DESCENDING_PRICE : <%= AuctionType.DESCENDING_PRICE%>,
    RFI : <%= AuctionType.RFI%>,
    DESCENDING_PRICE_ADVANCED : <%= AuctionType.DESCENDING_PRICE_ADVANCED%>,
    BUYER_RFI : <%= AuctionType.BUYER_RFI%>,
    RFP : <%= AuctionType.RFP%>,
    DUTCH_REVERSE_AUCTION : <%= AuctionType.DUTCH_REVERSE_AUCTION%>,
    DUTCH_FORWARD_AUCTION : <%= AuctionType.DUTCH_FORWARD_AUCTION%>,
    JAPANESE_REVERSE_AUCTION : <%= AuctionType.JAPANESE_REVERSE_AUCTION%>,
    JAPANESE_FORWARD_AUCTION : <%= AuctionType.JAPANESE_FORWARD_AUCTION%>
};

var ZissouAuctionStatus = {
    OPEN : <%= AuctionStatus.open %>,
    PAUSED : <%= AuctionStatus.paused %>,
    CLOSED : <%= AuctionStatus.closed %>,
    CREATED : <%= AuctionStatus.created %>,
    PENDING : <%= AuctionStatus.pending %>
};

var ZissouAuctionStatusTextMap = {
    <%=AuctionStatus.PENDING%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Pending") %>",
    <%=AuctionStatus.OPEN%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Open") %>",
    <%=AuctionStatus.CLOSED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Closed") %>",
    <%=AuctionStatus.AWARDED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Awarded") %>",
    <%=AuctionStatus.CANCELED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Canceled") %>",
    <%=AuctionStatus.CREATED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Created") %>",
    <%=AuctionStatus.TEMPLATE%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Template") %>",
    <%=AuctionStatus.PAUSED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.Paused") %>",
    <%=AuctionStatus.PENDING_CLOSED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.PendingClosed") %>",
    <%=AuctionStatus.PENDING_PAUSED%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.PendingPaused") %>",
    <%=AuctionStatus.PENDING_INVITATION%> : "<%=ref.tl("form.EPASSReferences.title.AuctionStatus.PendingInvitation") %>"
}

var ZissouToolbarMap = {
    logoutText : { name: "<%= ref.convertLiteral("form.mainMenu.label.loginout")%>", command: function(val){ top.frames['mainMenu'].NAV_NewWork(top, '/sourcing/en/logout.jsp?_eps_=Y', '0','*'); } },
    messageText : { name: "<%= ref.convertLiteral("form.mainMenu.label.messages")%>", command: function(val){ gotoMessageCenter();} },
    homeText : { name: "<%= ref.convertLiteral("form.mainMenu.label.home")%>", command: function(val){ goToHome(); } },
    portalText : { name: "<%= ref.convertLiteral("form.mainMenu.label.portal")%>", command: function(val){ goToPortal(); } },
    helpText : { name: "<%= ref.convertLiteral("form.mainMenu.label.help")%>", command: function(val){ top.frames['mainMenu'].NAV_PopupHelp( top, 'HELP_AUTODETECT', true); } },
    tutorialText : { name: "<%= ref.convertLiteral("form.mainMenu.label.tutorial")%>", command: function(val){ gotoSupplierTutorial(); } }
};

var ZissouLiterals = {
    Commands : "<%= ref.convertLiteral( "menu.title.commands" ) %>",
    Bids : "<%= ref.convertLiteral( "menu.title.Bid_Center" ) %>",
    RFx : "<%= ref.convertLiteral( "menu.title.RFQ_Center" ) %>",
    Categories : "<%= ref.convertLiteral( "menu.title.Category_Manager" ) %>",
    Suppliers : "<%= ref.convertLiteral( "menu.title.Supplier_Center" ) %>",
    Organization : "<%= ref.convertLiteral( "menu.title.Organization_Mgt" ) %>",
    Binders : "<%= ref.convertLiteral( "menu.title.Events" ) %>",
    Messaging : "<%= ref.convertLiteral( "menu.title.Messaging_Center" ) %>",
    Assessment : "<%= ref.convertLiteral( "menu.title.Assessment" ) %>",
    Utility : "<%= ref.convertLiteral( "menu.title.Utility" ) %>",
    Projects : "<%= ref.convertLiteral( "menu.title.Project_Management_Center" ) %>",
    Organization : "<%= ref.convertLiteral( "menu.title.Organization_Mgt" ) %>",
    Bids : "<%= ref.convertLiteral( "menu.title.seller.Bid_Center" ) %>",
    Messaging : "<%= ref.convertLiteral( "menu.title.seller.Messaging_Center" ) %>",
    Assessment : "<%= ref.convertLiteral( "menu.title.seller.Assessment" ) %>",
    Utility : "<%= ref.convertLiteral( "menu.title.seller.Utility" ) %>",
    Commands : "<%= ref.convertLiteral( "menu.title.seller.commands" ) %>",
    Notices : "<%= ref.convertLiteral( "menu.title.Notice_Center" ) %>"
};

$().ready(function() {
    if ( true ) Zissou.start();
});

</script>

<%-- System.out.println(ZissouCommands.getJSONCommands(ref)); --%>
