<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="com.emptoris.framework.organization.common.struct.OrganizationStruct" %>
<%@ page import="com.avinamart.Struct.*,java.util.ArrayList,
                 java.util.List,
                 com.avinamart.Utility.Exception.EPASSApplicationException,
                 java.text.NumberFormat,
                 com.avinamart.WebInterface.forms.bidding.ListBidSealedPageProcessor,
                 com.avinamart.Utility.EPASSConfig,
                 com.avinamart.WebInterface.forms.auction.ItemListPageProcessor,
                 com.avinamart.WebInterface.forms.scenario.FeedbackScenarioRun,
                 java.util.Date"%>
<%@ page import="java.util.Map" %>
<%@ page import="com.avinamart.BusinessLogic.Key.*" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.*" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.AuctionStatus" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.WebInterface.forms.bidding.BidComparer" %>
<%@ page import="com.emptoris.framework.currency.common.CurrencyCodeConstants" %>
<%@ page import="com.emptoris.framework.attribute.common.struct.EPASSAttributeDefStruct" %>
<%@ page import="com.emptoris.framework.translation.util.TranslationUtility" %>
<%@ page import="com.emptoris.app.bidding.service.extensions.attribute.BiddingIAHelper" %>

<%@ include file="include/head.inc"%>

<%
	boolean doNavUpdate = false;
	String ITEM_DETAIL_MULTI_ROUND_BIDDING = Misc.ITEM_DETAIL_MULTIROUNDBIDDING;
	boolean fromItemDetailMultiRoundBidding = !StringUtility.isEmpty(request.getParameter( ITEM_DETAIL_MULTI_ROUND_BIDDING));
    ListBidSealedPageProcessor lb = new ListBidSealedPageProcessor(ref);
	//Get the item id and the related RFx, either from cur_id and if not there, from context
	AuctionStruct rfq = null;
	Integer itemId = null;
	String sItemName = "";
	String curIdStr = request.getParameter( ServletBase.CURRENT_ID );
    String itemIdParam = StringUtility.isEmpty(ref.req.getParameter(EPASSUiRFQServices.ITEM_ID_PARAM))?
                        "" : ref.req.getParameter(EPASSUiRFQServices.ITEM_ID_PARAM);

    Integer rfqID = null;
    if (!StringUtility.isEmpty( curIdStr ) ) {
		itemId = new Integer( curIdStr );
		ItemStruct item = EPASSUiRFQServices.getCurrentRFQItem(ref, new ItemKeyImpl(itemId));
		rfqID = (Integer) item.getAttribute(ItemStruct.AUCTIONID);
		sItemName = item.getName();
		if (sItemName != null && TranslationUtility.isTranslationKey(sItemName)) {
		    sItemName = ref.convertLiteral(sItemName);
		}
	    //PR 28014
        sItemName = EPASSQPretty.makeJavascriptSafe(sItemName);
		rfq = EPASSUiRFQServices.getCurrentRFQ(ref, rfqID);
        if (EPASSUiRFQServices.isPageCalledFromListButton(ref)){
            // set the session context, for the item
            ref.userDataContext.setRfqItemId(itemId);
        }
	} else {
		itemId = ref.userDataContext.getRfqItemId();
		rfqID = ref.userDataContext.getRfqId();
		rfq = EPASSUiRFQServices.getCurrentRFQ(ref, rfqID);
	}

    boolean showFeedback =  rfq != null
                            && rfq.getType() != null
                            && (rfq.isSealedAuction() || rfq.isRFP())
                            && Boolean.TRUE.equals(rfq.isAllowOptimizationFeedback());


     //Assign auction into ref for use later in buildTableModelTreeArray
    ref.structs.auctionStruct = rfq;

	// Get the list of optional currencies on the auction, to determine, if we need to have the user choose one, when
	//		creating a vdb bid.
	String[] optCurrency = getCurrencyCodes(ref, rfq);

	boolean canCreateBid = false;
	boolean canCreateVolumeBid = false;
	boolean canCancelBid = false;
	boolean showButtons = false;
	boolean canInvalidateBid = false;
	boolean canUpdateBids = false;
    boolean isDraftsEnabled = EPASSConfig.getInstance().getBooleanParameter(EPASSConfig.CREATE_DRAFT_BIDS);
    		                 
    
    boolean isUserHost = false;
    if (rfq != null ){
        isUserHost = EPASSUiRFQServices.isHost( ref, new AuctionKeyImpl( rfq.getId() ) );
    }
    // now available to suppliers for sealed bids
	boolean canCompareBids = EPASSUiBiddingServices.getBiddingUiBusinessRules().canCompareBids(ref, rfq);
	boolean canShowBids = true;


	if ( itemId != null ) {
		canCreateBid = EPASSUiBiddingServices.canCreateBidNow( ref, itemId );
		canCreateVolumeBid = EPASSUiBiddingServices.canCreateVolumeBidNow(ref, itemId);

		// determine if the user is a host or bidder or admin. Admin and host can invalidate
		// 		bidder can cancel. This determined what button and method to use, based on the user
        canCancelBid = EPASSUiBiddingServices.getBiddingUiBusinessRules().canPerformCancelBid(ref, new ItemKeyImpl(itemId));
        canInvalidateBid = EPASSUiBiddingServices.getBiddingUiBusinessRules().canPerformInvalidateBid(ref, new ItemKeyImpl(itemId));
        canUpdateBids = canCreateBid;
		// Bids comparison enabled for all users
		showButtons = true;
	}
	//Display locked when it is locked 
	if (rfq != null){
		//This check if RFx is locked or is in two envelope bidding mode
		canShowBids = EPASSUiRFQServices.getAuctionUiBusinessRules().canShowItemBids(ref,rfq);
		
	}
	// HTML output strings
	final String formName = "bid_list";


	String message = null;
	if (itemId != null){
		ItemStruct tmpItem = EPASSUiRFQServices.getCurrentRFQItem(ref, new ItemKeyImpl(itemId));
		if ( tmpItem != null ) {
			if ( ItemType.SUBSTITUTION.equals( tmpItem.getItemType() ) ) {
					message = "<BR><P CLASS =\"STATUS_MESSAGE\">"
						+ ref.convertLiteral("form.listBid.message.cannot_bid_on_substitution_parent_items") + "</P>";
                   ref.setErrorMessage(message);
            } else if ( tmpItem.getParentItem() != null ) {
					ItemStruct pItem = EPASSUiRFQServices.getCurrentRFQItem(ref, new ItemKeyImpl( tmpItem.getParentItem() ));
					if (ItemType.ALL_OR_NONE.equals( pItem.getItemType() ) ) {
						message = "<BR><P CLASS =\"STATUS_MESSAGE\">"
							+ ref.convertLiteral("form.listBid.message.cannot_bid_on_all_or_none_child_items") + "</P>";
                        ref.setErrorMessage(message);
                    }
			}
		}
	}

	final String fieldNameSTATUS = EPASSFieldName.addPrefix(BidStruct.STATUS);

	ArrayList arrStatus = new ArrayList();
	arrStatus.add( new EPASSAttribute( ref.convertServicesLiteral( BidStatusType.getDisplayCode(BidStatusType.all) ),
						BidStatusType.ALL) );
	arrStatus.add( new EPASSAttribute( ref.convertServicesLiteral(BidStatusType.getDisplayCode(BidStatusType.normal) ),
						BidStatusType.NORMAL) );
	arrStatus.add( new EPASSAttribute( ref.convertServicesLiteral(BidStatusType.getDisplayCode(BidStatusType.cancelled) ),
						BidStatusType.CANCELLED) );
	arrStatus.add( new EPASSAttribute( ref.convertServicesLiteral(BidStatusType.getDisplayCode(BidStatusType.invalid) ),
						BidStatusType.INVALID) );

    Integer defaultStatusForFilter = BidStatusType.NORMAL;
     if (isDraftsEnabled)
     {
     	arrStatus.add( new EPASSAttribute( ref.convertServicesLiteral(BidStatusType.getDisplayCode(BidStatusType.draft) ),
                 BidStatusType.DRAFT) );
         arrStatus.add(new EPASSAttribute(ref.convertServicesLiteral(BidStatusType.DRAFT_OR_NORMAL_KEY),
                 BidStatusType.DRAFT_OR_NORMAL));
         defaultStatusForFilter = BidStatusType.DRAFT_OR_NORMAL;
     }


	EPASSHTMLFilterSelect filterSelectBid = null;
	// If list bid page is launched from detail item multi round bidding popup, don't create the filter
	if (!fromItemDetailMultiRoundBidding) {
        EPASSLink link = getFilterLink(ref, curIdStr, fromItemDetailMultiRoundBidding);
		filterSelectBid = new EPASSHTMLFilterSelect( request, Misc.ACTION_BAR_FORM, fieldNameSTATUS, arrStatus,
							defaultStatusForFilter, link.toString(),
							"frames_list_bid_sealed.jsp", ref.getCollator(), true );
	}


	if (itemId != null) {

	   //--------------------------------------------------------------------------------------//
	   //----------------------------------     INVALIDATE ------------------------------------//
	   //--------------------------------------------------------------------------------------//
	  	switch( ref.getAction().intValue() ) {
		 case EPASSJSPActions.INVALIDATE_BID:
              String[] invalidArray = request.getParameterValues( Misc.SELECTED_OBJECT );
              lb.invalidateBids( ref, rfq, invalidArray );

			doNavUpdate = true;
		 	break;
	   //--------------------------------------------------------------------------------------//
	   //----------------------------------     DELETE ------------------------------------//
	   //--------------------------------------------------------------------------------------//
		 case EPASSJSPActions.DELETE: // Deletes the auctions from the database

			if (rfq != null)
			{
				if (rfq.getStatus().equals(AuctionStatus.AWARDED))
				{
					out.println("<script>alert('"
								+ ref.convertLiteral("form.listBid.message.bid_closed")
								+ "')</script>");
				} else {
					String[] deletionArray = request.getParameterValues( Misc.SELECTED_OBJECT );
					int cancelledBids = 0; 
					for( int i = 0; i < deletionArray.length; i++ )
					{
						int id = Integer.parseInt( deletionArray[i] );
						try
						{
							// TRY AND DELETE OR INVALIDATE
							BidKeyImpl bidKey = new BidKeyImpl(id);
							if (EPASSUiBiddingServices.canDeleteBid(ref,bidKey))
							{
								EPASSUiBiddingServices.cancelBid(ref, bidKey,rfq, itemId);
								cancelledBids++;
							}
							/*
							Commented for PR 81096
							else {
								out.println("<script>alert('" +
								 ref.convertLiteral("form.listBid.message.bid_not_deleted") +
								  "')</script>");
							}*/
						} catch (EPASSApplicationException e){
							ref.setErrorMessage(e);
							break; //loop
						}
					}
					if(cancelledBids == 0)//If none of selected bid is deleted then show error message(PR 80916)
					{
						out.println("<script>alert('" +
								 ref.convertLiteral("form.listBid.message.bids_not_deleted") +
								  "')</script>");
					}
				}// end if rfq is closed or awarded
			} // if rfq is null
			doNavUpdate = true;
			break;

                  // remove alternate bid status
                  case EPASSJSPActions.DEMOTE:
                        String strHeadBidId = ref.req.getParameter( "bidClickedToDemote" );
                        if ( EPASSUiJSPServices.stringNotEmpty ( strHeadBidId ) )
                        {
                            Integer intHeadBidId = new Integer ( strHeadBidId );
                            BidStruct bidHead = EPASSUiBiddingServices.getBid ( ref, intHeadBidId );
                            bidHead.setAlternative ( Boolean.FALSE );
                            List lstSubBids = EPASSUiBundleBidHelpServices.getBidSetBids ( ref, new BidKeyImpl ( intHeadBidId ), false );
                            ref.serviceRef.getBiddingService ( ref ).updateBundleBid ( ref.sessionService
                                                                                       , bidHead
                                                                                       , lstSubBids );
                        }
                        break;
		 default:
		 	break;
		}
	}

	// END ACTION CONTROL BLOCK-------------------------------------------------
%>


<%-- +---------------------------------------------------------------------------
	Displaying the status on the title bar
---------------------------------------------------------------------------+ --%>
<%
	//Integer status = new Integer(-1);
	//By default the status should be valid bids
	Integer status = BidStatusType.NORMAL;
	int st = -1;
	StringBuffer listTitle = new StringBuffer();

	String bid = ref.convertLiteral("form.listBid.title.list_bid");
	if (!fromItemDetailMultiRoundBidding) {
		status = filterSelectBid.getFilterValue();
		st = status.intValue();
        switch(st){
            case BidStatusType.all:
                listTitle.append(ref.convertLiteral("form.listBid.title.list_all_bid"));
                break;
            case BidStatusType.cancelled:
                listTitle.append(ref.convertLiteral("form.listBid.title.list_cancelled_bid"));
                break;
            case BidStatusType.invalid:
                listTitle.append(ref.convertLiteral("form.listBid.title.list_invalid_bid"));
                break;
            case BidStatusType.normal:
                listTitle.append(ref.convertLiteral("form.listBid.title.list_valid_bid"));
                break;
            case BidStatusType.draft:
                listTitle.append(ref.convertLiteral("form.listBid.title.list_draft_bid"));
                break;
            case BidStatusType.draftOrNormal:
                listTitle.append(ref.convertLiteral("form.listBid.title.list_valid_and_draft_bid"));
                break;

            default:
                break;
        }


		if(showButtons){
			toolbarItems.addControl( filterSelectBid+"");
		}

	} else {
		listTitle.append(ref.convertServicesLiteral(BidStatusType.getDisplayCode( status ))+ " " + bid);

	}

	StringBuilder validBidIds = new StringBuilder();
	// Get auction data based on the context information. It may gets all auctions
    // as well as filtered or found according to the context block information
    // all this functionality encapsulated in the getAuctions method of the
    // EPASSUiRFQServices
	NumberFormat nf = I18NFormats.getNumberFormat( ref.getLocale() );
	nf.setMaximumFractionDigits(2);
	nf.setMinimumFractionDigits(2);
	nf.setGroupingUsed(true);

	int nValidBids = 0;			//Needed for 'smart' update of the items page
	BidStruct[] bidStructs = null;
	if (itemId != null) {
		try {
			if (showFeedback){
                	// ListBidSealedPageProcessor lb = new ListBidSealedPageProcessor(ref);
            	bidStructs = lb.getAllItemBidsWithAwardQuantities(itemId, status);
            } else {
			  	bidStructs = EPASSUiBiddingServices.getAllItemBids( ref, itemId );
            }
			
		} catch (EPASSApplicationException e) {
			;
		}
		if ( bidStructs != null ) {

				for (int x=0;x<bidStructs.length;x++){
					bidStructs[x] = (BidStruct)bidStructs[x].getLocalVersion();
					bidStructs[x].setAttribute( "."+BidStruct.FIXEDCOST ,
						bidStructs[x].getAttribute(BidStruct.FIXEDCOST));
					bidStructs[x].setAttribute( "."+BidStruct.VARIABLECOST ,
						bidStructs[x].getAttribute(BidStruct.VARIABLECOST));
                    if(rfq.transformPrice()){
                        bidStructs[x].setAttribute( "."+BidStruct.BASEVARIABLECOST ,
						    bidStructs[x].getAttribute(BidStruct.BASEVARIABLECOST));
                    }
				// Don't show checkbox for child bids (e.g. volume sets )
					if ( bidStructs[x].getParentBid() != null ) {
						bidStructs[x].setAttribute( EPASSTableModel.IS_INDIVIDUAL_CHECK_BOX_DISABLED,
								new Boolean(true) );
					}
				}

				//this condition is added by dyy: esp 44136
				//in supplier preview mode, draft cannot be seen
				if(isDraftsEnabled && ref.isSupplierPreviewMode()){ //this condition is added by dyy: in supplier preview mode, draft bids cannot be count
					if (status.equals(BidStatusType.DRAFT) ) {
						bidStructs = new BidStruct[0];
					}else if(status.equals(BidStatusType.DRAFT_OR_NORMAL)){
						bidStructs = EPASSUiBiddingServices.filterBidStatus(ref, bidStructs, BidStatusType.NORMAL);
					}else if(status.equals(BidStatusType.ALL)){
						bidStructs = EPASSUiBiddingServices.filterBidStatusExcludeDraft(ref, bidStructs);
					}else if (status != null) {
						bidStructs = EPASSUiBiddingServices.filterBidStatus(ref, bidStructs, status);
					}
				}else if (ref.isSupplierPreviewMode()){
					if(status.equals(BidStatusType.ALL)){
						bidStructs = EPASSUiBiddingServices.filterBidStatusExcludeDraft(ref, bidStructs);
					}else if ((status != null) && !(status.equals(BidStatusType.ALL) ) ) {
						bidStructs = EPASSUiBiddingServices.filterBidStatus(ref, bidStructs, status);
					}
				}else{ //end of dyy adding 
					if ((status != null) && !(status.equals(BidStatusType.ALL) ) ) {
						bidStructs = EPASSUiBiddingServices.filterBidStatus(ref, bidStructs, status);
					}
				}
			//We need the number of valid bids (for the 'smart' update of the items page)
			//If this is not the current status, we get it here
			if(status.equals(BidStatusType.NORMAL)){
				nValidBids = bidStructs.length;
			}else{
				BidStruct[] validBids = EPASSUiBiddingServices.filterBidStatus(ref, bidStructs, BidStatusType.NORMAL);
				nValidBids = validBids.length;
			}

			// can't operate if no data, also hide bids if RFx locked and user is a buyer
			if (bidStructs.length > 0  && canShowBids ) {
				bidStructs = EPASSUiJSPServices.buildTableModelTreeArray(ref, bidStructs);

			}
			
			// Insert/Replace struct references
			Integer bidderOrgId = null;
			String orgName = null;

            // HOTSPOT performance fix - retrieve userOrgs in bulk
            Map userOrgs = EPASSUiJSPServices.getUserOrganizations(ref, bidStructs);
			boolean isUserBidder = ref.isUserBidder( ref, rfq);
			for ( int i = 0; i < bidStructs.length; i++) {
				Integer userId = (Integer) bidStructs[i].getAttribute( bidStructs[i].BIDDERID );
				Integer bidType = (Integer) bidStructs[i].getAttribute( bidStructs[i].BIDTYPE );
				//PR 77063-Start
				StringBuilder bidNameLink = new StringBuilder();				
				if(BidType.BUNDLE_BID.equals(bidType))
				{
					String name = bidStructs[i].getName();
					if(isUserBidder && EPASSUiBiddingServices.getBiddingUiBusinessRules().canUpdateBid(ref, bidStructs[i].getKey()))
					{
						bidNameLink.append("<a href=\"javascript:void 0\" onclick=\"editBundleName('")
						   .append(bidStructs[i].getId())
						   .append("')\">")
						   .append(name)
						   .append("</a>");
					}
					else
					{
						bidNameLink.append(name);
					}
				}		
				
				bidStructs[i].setAttribute("BID_NAME",bidNameLink.toString());
				//PR 77063-End
                Boolean isStep = Boolean.FALSE;
    			if(BidStatusType.NORMAL.equals(bidStructs[i].getStatus()))
    				validBidIds.append(bidStructs[i].getId()).append(",");
                if (bidType.equals(BidType.VOLUME_BID)){
                    //PR 63850 - As such there should not be any max capacity specified on Parent Volume bid, but we do save default of 1.0 while saving Volume bid
                    //Taking this out could cause repercussions in other areas, so just take it out while displaying
                    bidStructs[i].setMaxCapacity(null);
                    isStep = bidStructs[i].isStepVolumeDiscount();
                    if (isStep == null) {
                        isStep = Boolean.FALSE;
                    }
                }
                
                                
                
				// Check if any manual award exists
				Boolean isManualAwardPresent = bidStructs[i].isManualAwardPresent();
				if (Boolean.TRUE.equals(isManualAwardPresent) ) {

					bidStructs[i].setAttribute( Misc.MANUAL_AWARD_IMAGE,
						/* hrefImage  */
						"<img src='"+ ref.getUserPath() + Dir.IMG + "detail_dollar_sign.gif' border='0'>"
					);
				}
				else {
		    		bidStructs[i].setAttribute( Misc.MANUAL_AWARD_IMAGE, "&nbsp;" );
				}

				if(bidType.equals(BidType.VOLUME_BID)){
					bidStructs[i] = (BidStruct) WrapperObjectStruct.makeCopy(bidStructs[i]);
					bidStructs[i].setAttribute(BidStruct.MINCAPACITY ,"");
				}

                if ( EPASSConfig.getInstance().getBooleanParameter ( "epass.sealed.enable_alternative_bids", true ) )
                {
                    addAlternativeBidIcon ( ref, bidStructs [ i ], bidType );
                }

                if ( userId != null) {
 					BusinessUserKeyImpl userKey = new BusinessUserKeyImpl( userId );
 					BusinessUserStruct user = ref.serviceRef.getOrganizationService(ref)
 										.getBusinessUser(service, userKey );
 					bidderOrgId = user.getOrganization();
                     orgName = ((OrganizationStruct) userOrgs.get(userKey)).getName();
 					bidStructs[i].setAttribute("ORG_NAME", orgName);
 					bidStructs[i].setAttribute("PARTNER_NAME", user.getAttribute(user.FIRSTNAME) + " "
 						+ user.getAttribute(user.LASTNAME)  );
                     
 				}
                
          			String timeBid = EPASSQPretty.toUQString( bidStructs[i].getSubmitDate(), ref.getLocale(), ref.getTimeZone());
                     bidStructs[i].setAttribute("TIME_BID", timeBid);
                		
                	//this part is moved inside of this condition by dyy
                	// to set bid type
                     String sBidTypeName;
                     if (isStep.booleanValue()){
                         sBidTypeName = ref.convertLiteral("BidType.StepVolumeBid");
                     }
                     else {
     				    sBidTypeName = ref.convertLiteral(BidType.getBidTypeResource( bidType ));
                     }
                     if  ((!bidStructs[i].isDraftBid()) || (ref.isUserBidder(ref)))
                     {
                         bidStructs[i].setAttribute("BID_TYPE_NAME", sBidTypeName  );
                     }
     				
     				//end of bid type setting
     				
	     			// moved in by dyy
	     			//Check if bid history exists -
					// pr9869 - tac - do not show bid history for bundled bid. We do not deal with it yet!
					if ( bidStructs[i].getPreviousBidId() != null
						&& !BidType.BUNDLE_BID.equals(bidType)) { // has bid history, decide if view is allowed
						EPASSImageControl imageHistory =
							new EPASSImageControl(ref.getUserPath() + Dir.IMG + "bid_revision_icon.gif",
							"onClickHistory(" + bidStructs[i].getId() + ")",
							ref.convertLiteral("form.listbid.tooltip.view_bid_history"));
						if (ref.isUserBidder(ref)){	// for bidders, check bidder org id against login user
							if ( bidderOrgId != null){
								if (!bidderOrgId.equals(ref.getOrgKey().getID())){// if they are not the same
									bidStructs[i].setAttribute( "HAS_HISTORY", "&nbsp;");
								}
								else{ // bidder can view bid history for bids of their own org
									bidStructs[i].setAttribute( "HAS_HISTORY", imageHistory.toString());
								}
							}
							else{	// bidder org id = null, should never happen
								bidStructs[i].setAttribute( "HAS_HISTORY", "&nbsp;");
							}
						}
						else{	// buyers can view history
							bidStructs[i].setAttribute( "HAS_HISTORY", imageHistory.toString());
						}
					}
					else{	// no bid history
						bidStructs[i].setAttribute( "HAS_HISTORY", "&nbsp;");
					}
	
	                if (showFeedback && bidStructs[i].getAttribute(ListBidSealedPageProcessor.bidAwardThisSupplier) != null) {
	                    Double qty = (Double)bidStructs[i].getAttribute(ListBidSealedPageProcessor.bidAwardThisSupplier);
	                    Integer iQty = new Integer(qty.intValue());
	                    String qtyString = colorCodeText(ref,iQty.intValue(),iQty.toString());
	                    bidStructs[i].setAttribute(QtyWinning,qtyString);
	                }
	
	                if (BidType.BUNDLE_BID.equals(bidType)) {
	                    bidStructs[i] = getBundleBidInfo(ref, bidStructs[i], itemId, isUserHost, isDraftsEnabled);
	                }
     				
                		
             //   }else{
             //   	 bidStructs[i].setMaxCapacity(null);
             //   	 bidStructs[i].setMinCapacity(null);
             //   	 bidStructs[i].setAttribute( "."+BidStruct.VARIABLECOST ,null);//price per unit
             //  }

				

			}

            // don't filter if auction owner
			if ( !isUserHost ) {
				// filter other organizations
				bidStructs = EPASSUiJSPServices.filterBidders(ref, ref.getOrgKey() , bidStructs );
			}


            if ( ref.isUserBidder( ref, rfq) ) {
                // add revise bid or view bid button
                bidStructs = createBiddingButtons(ref, bidStructs);
            }
		}
	} // if itemid != null

  	// Get the table model
    ArrayList bidTableModel = new ArrayList();
    if (rfq != null) {
   	    bidTableModel = createBidTableModel(ref, rfq, showFeedback);
    }


    ref.setAttribute(EPASSTableModel.IS_DHTML, Boolean.TRUE);
    // retrieve the counts for smart icons
	bidStructs = (BidStruct[])EPASSUiJSPServices.getCountsForIcons(ref, bidStructs);

	// HACK - EPASSTableViewControl generates table regardless value set in setShowData.
	// Temp fix before table control is fixed
	if( !canShowBids ){ // show message only (no data) if bids are locked and user is buyer
		bidStructs = null;
	}
	// end HACK


    // Build the table according to the model and data.
    EPASSTableViewControl bidTable =
            new EPASSTableViewControl(
                    ref,
                    null,                                             // form name not used in the current version
                    ref.getUserPath() + "bid_list.jsp",             // current JSP name
                    ref.getUserPath() + "detail_bid_router.jsp",     // popup detail/edit JSP
                    false,                                             //ref.isReadOnly(), // indicate if table is read only
                    bidTableModel,                                 // table model data
                    bidStructs,                                     // table data
                    "BID_VIEW_CONTEXT",                             // key for the saving current
                    // table view context in to the SessionTracker
                    null,                                            // with buttons (create/delete)
                    BidStruct.SUBMITDATE,                             // default column for sort
                    ref.getCollator(),                         // no collator for sorting
                    false,                                             // ascending sort order
                    true,                                             // late building
                    true,                                             // without scroller
                    true,                                             // headers are clickable
                    true                                            // tree support
            );
    bidTable.setTreeParentKey(BidStruct.PARENTBID);
    bidTable.setTreeIdKey(BidStruct.ID);
    bidTable.setDisplayNullRows(true);
    if (!canShowBids) { // show message only (no data) if bids are locked and user is buyer
        bidTable.setShowData(false);
        bidTable.setCustomDataMessage(ref.convertLiteral("form.listBid.locked"));
    } else if (message == null) {
        bidTable.setParentContext(ContextCodes.REQ_ITM);
    } else {
        bidTable.setParentContext(message);
    }

    bidTable.setROModeForDetailLink(!canUpdateBids);
    String additionalParameters = buildAdditionalParameters(ref, curIdStr, itemIdParam);
    bidTable.setExtraTreeParameters(additionalParameters);

    //For the additional table customized columns, add only the user defined attributes
    EPASSAttributeDefStruct[] attrs = EPASSUiAttributeDefServices.getAllRFQBidAttributeDefs(ref,rfqID,null);
    EPASSAttributeDefStruct leadDays = null;
	for (int i = 0; i<attrs.length; i++){
		if (BidStruct.LEADDAYS.equals(attrs[i].getCode())){
			leadDays = attrs[i];
			break;
		}
	}
    List<EPASSAttributeDefStruct> attrsList = WrapperObjectStruct.filterRemoveAttributes(attrs, EPASSAttributeDefStruct.PREDEFINED, Boolean.TRUE);
    // RTC - 58227
    if(leadDays != null){
		attrsList.add(leadDays);
	}
    attrs = attrsList.toArray(new EPASSAttributeDefStruct[0]);
    //Set a version for the buyer view, the customization does not apply to supplier view and customization button is disabled
    //The version must be event specific because different bid IAs apply to each
    if(ref.isUserSeller()){
        bidTable.setViewVersion(rfq.getId().toString());
       toolbarItems.setTableConfigButtonEnabled(false);
        //Set freeze position after the revision button name
        bidTable.setFreezePosition(3);
       bidTable.setFitToPage(false);
    }
    else{
        bidTable.setViewVersion("0");
        //Set freeze position after the organization name
        bidTable.setFreezePosition(3);
    }
    //No split view
     toolbarItems.setSplitPageButtonEnabled(false);

    bidTable.setAavailableIAs(attrs);

    // Construct table. It performs all operations like scroller and button pad
    // creation.
    bidTable.constructTable();


    // Show bid count in title bar
	// for some reason, when bids locked, the EPASSUiBiddingServices.bidsCount(bidStructs,true,false) returns 0, so using the "if" below
	int bidCount = 0;
	if( bidStructs != null ){
		bidCount =  canShowBids ? EPASSUiBiddingServices.bidsCount(bidStructs,true,false) : bidStructs.length;
	}

	String actionBarTitle = listTitle + " (" + bidCount + ")";
   	Object actionBarButtons = toolbarItems;
%>

<%-- +---------------------------------------------------------------------------
 	StyleSheets and Javascript
---------------------------------------------------------------------------+ --%>
<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<head>
<title><esapi:html><%=  ref.convertLiteral("epass.title")%></esapi:html></title>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
<%-- Navigation utility that supply all frame services --%>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.ACTIONBAR %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS +Javascript.EPASSTREEUTIL  %>'></SCRIPT>

<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass_dtable.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "dragDrop3.js" %>'></SCRIPT>
<SCRIPT>
	<%
		boolean doItemUpdate = doNavUpdate;
		String updateCodes = "";
		//The items page is updated only if a bid was cancelled, deleted or awarded and the number
		//of valid bids reduced to 0
        if (doItemUpdate || showFeedback){
            updateCodes = ContextCodes.REQ_ITM+","+ContextCodes.BID;
		} else if (doNavUpdate){
			updateCodes = ContextCodes.BID;
		}
	%>
	<%=   NavSupport.notifyOfUpdate(updateCodes,doNavUpdate) %>

    var NAV_LIST='<%=  ContextCodes.BID + ","+ ContextCodes.ATTACHMENT + "," + ContextCodes.MESSAGE%>';	// I am dependent on items
    <%//On buyer side, the page depends on the item in context
        if (!EPASSUiRFQServices.isPageCalledFromListButton(ref)){ %>
	    var NAV_DEP='<%=  ContextCodes.REQ_ITM%>';	// I am dependent on items
    <% }
    //On supplier side it is always the same item, no dependency needed
    else { %>
        var NAV_DEP='';	// I am dependent on nothing
    <% } %>

 	var NAV_VOLATILE=0;

<%if(showButtons ){

	if (canCreateBid){
	%>
		function createBid() {
			var bidUrl = "<%=  ref.encodeURLwUP("detail_simple_bid.jsp?") %>" + "&" +
			 "<%=  EPASSJSPActions.ACTION %>" + "=" + "<%=  EPASSJSPActions.CREATE_VIEW %>" + "&" +
			 "numberOfBids=" + "<%= nValidBids %>";
			NAV_Popup( top, -1, bidUrl, 370 , 500);
		}
	<%
	}

	if (canCreateVolumeBid  ){

		// Javascript handler for volume/bid
		//The link also passes to the create page the number of current bids on the item. This is
		//needed in order to create 'smart' update of the list_item page (which have to be updated
		//in order to display bid indicators)
	  %>
		function doCreateVolumeBid() {
	   		var bidUrl = "<%=  ref.encodeURLwUP(JSP.FRAMES_DETAIL_VOLUME_BID+"?") %>";
			var _width = 750;
			var _height = 550;

			// If there is no currency choice (one currency), then do not ask user to choose. Go directly to vdb form
			<% if (EPASSConfig.getInstance().getBooleanParameter( CurrencyCodeConstants.EPASS_MULTIPLE_CURRENCY_ENABLE )
					&& null != optCurrency && optCurrency.length > 1)
			{%>
				bidUrl = "<%=  ref.encodeURLwUP("detail_vdb_currency_choice.jsp?") %>";
				_width = 450;
				_height = 275;
			<%}%>

			bidUrl = bidUrl + "&" +
			 "<%=  EPASSJSPActions.ACTION %>" + "=" + "<%=  EPASSJSPActions.CREATE_VIEW %>" + "&" +
			 "numberOfBids=" + "<%= nValidBids %>";

			NAV_Popup( top, -1, bidUrl, _height, _width );
		}
<%  }

	if ( canCompareBids ) {
		toolbarItems.addControl( EPASSButtonDivControl.getSingleTaskTextButton( ref
			         			, "compareBidId"
			         			, ref.convertLiteral("form.listBid.button.compare_bids")
			         			, "doCompareBids()"
			         			, ref.convertLiteral("form.listBid.tooltip.compare_bids") ).toString() );



%>
	function doCompareBids() {

		var errMsg = "<%=  ref.convertLiteral("form.listBid.message.select_bid_for_compare")%>";
	    if(!EPASSCheckbox.checkRequired(document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,errMsg)){
			return false;
		}

		var selList = document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>;
		//In case thre was only one bid in the list page
		if(typeof(selList.length) == 'undefined') selList = new Array(selList)

		var compareUrl = "<%=  ref.encodeURLwUP(JSP.BIDS_COMPARE_PAGE + "?") %>";
		for (var i=0; i < selList.length;i++) {
			if(selList[i].checked){
				var bidId = selList[i].value;
				compareUrl += ("&<%= BidComparer.REQUEST_BID_IDS %>" + "=" + bidId);
			}
		}
		compareUrl += "&<%= ServletBase.CURRENT_ID %>" + "=" + <%= itemId %>;
		NAV_Popup( top, -1, compareUrl, 550 , 750);
	}

<%	}//end if ( canCompareBids )



	if ( canInvalidateBid ) {

		toolbarItems.addControl( EPASSButtonDivControl.getSingleTaskImageButton( ref
			         			, "invalidateBidId"
			         			, ref.getUserPath() + Dir.IMG_BTNS_UP + Image.DELETE_ITEM_UP_BUTTON
			         			, "doInvalidateBid()"
			         			, ref.convertLiteral("form.listBid.message.invalidate_bids") ).toString() );

%>
	//---------------------------------------------------------------------------------
	function doInvalidateBid(){
        if( EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
				"<%=  ref.convertLiteral ( "form.listBid.message.select_bid" )%>" ) ) {
           var msg = "<%=  ref.convertLiteral ( "form.listBid.message.invalidate_bid" )%>";
//         PR 60517 - begin
           <% if (rfq != null && rfq.getType() != null
                    && (rfq.isSealedAuction() || rfq.isRFP())
                    && rfq.getStatus().equals(AuctionStatus.CLOSED)) {
            %>
                msg += "\n\n" + "<%= ref.convertLiteral("form.listBid.message.stale_data_notice")%>";
           <% } %>
//         PR 60517 - end
		   if( confirm( msg )){
				document.<%=  formName%>.<%=  EPASSJSPActions.ACTION%>.value =
													 <%=  EPASSJSPActions.INVALIDATE_BID%>;
				document.<%=  formName%>.submit();
			}
		}
		return false;
	}
<%
	}//end ( canInvalidateBid )

	if ( ref.isSupplierPreviewMode() || canCancelBid ) {
		String cancelBidJsFuncName = "doCancelBid()";		
//		toolbarItems.addControl( EPASSUiJSPServices.makeButton( ref, cancelBidJsFuncName, false,
//		 ref.getUserPath()+Dir.IMG_BTNS_UP+Image.DELETE_ITEM_UP_BUTTON,
//		 ref.convertLiteral("form.listBid.label.cancel_bid") ) );
		toolbarItems.addControl( EPASSButtonDivControl.getSingleTaskImageButton( ref
			         			, "cancelBidId"
			         			, ref.getUserPath()+Dir.IMG_BTNS_UP+Image.DELETE_ITEM_UP_BUTTON
			         			, ref.isSupplierPreviewMode()? "doSupplierPreviewMode()" : cancelBidJsFuncName
			         			, ref.convertLiteral("form.listBid.label.cancel_bid") ).toString() );

%>
		function <%=  cancelBidJsFuncName %>	{
			if ( checkDeletion() ){
				var validBidIds = '<%=validBidIds.toString()%>';
				var selectedIds = EPASSCheckbox.getValues(document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>);
				var selectedValidCount = 0;
				for(var i=0;i<selectedIds.length;i++)
				{
					var selectedId = selectedIds[i];					
					if(validBidIds.indexOf(selectedId)>-1)
					{
						selectedValidCount++;						
					}
				}
				var canSubmitForm = false;
				if(selectedValidCount == 0)//User does not selected valid bids.
				{
					alert("<esapi:js><%= ref.convertLiteral("form.listBid.message.bids_not_deleted")%></esapi:js>");
				}
				else if (selectedValidCount == selectedIds.length)//User selected all valid bids.
				{
					canSubmitForm = confirm("<esapi:js><%= ref.convertLiteral ( "form.listBid.message.delete_confirm" )%></esapi:js>"); 
				}
				else //User selected some valid and some not valid bids.
				{
					canSubmitForm = confirm("<esapi:js><%= ref.convertLiteral ( "form.listBid.message.only_valid_delete_confirm" )%></esapi:js>");
				}
				
				if(canSubmitForm)
				{
					document.<%=  formName%>.<%=  EPASSJSPActions.ACTION%>.value =
																		 <%=  EPASSJSPActions.DELETE%>;
					document.<%=  formName%>.submit();
				}				
			}
		}

		function checkDeletion() {
			if( EPASSCheckbox.checkRequired(
		     document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
		     "<%=  ref.convertLiteral ( "form.listBid.message.delete_select" )%>" ) ) {
	 	   		return true;
			} else {
		   		return false;
			}
		}

<%	}//end if ( canCancelBid )

}    //end if(showButtons)
%>
	function onClickHistory(bidId) {
		var historyUrl;
		historyUrl = "<%=  ref.encodeURLwUP(JSP.BID_HISTORY_PAGE + "?") %>" + "&BID_ID=" + bidId;
		NAV_Popup( top, -1, historyUrl, 650 , 800);
	}

	function removeAlternateStatus ( bidId )
    {
	   if ( confirm ( "<esapi:js><%=  ref.convertLiteral ( "form.detailItemManualAward.confirm.remove_alternative_status" ) %></esapi:js>" ) )
       {
			document.<%=  formName%>.bidClickedToDemote.value = bidId;
			document.<%=  formName%>.<%=  EPASSJSPActions.ACTION%>.value =
													 <%=  EPASSJSPActions.DEMOTE%>;
			document.<%=  formName%>.submit ();
            return false;
		}
	}

    function reviseBid(bidId) {
        var url;
        url = "<%=  ref.encodeURLwUP(JSP.BID_ROUTER_PAGE+ "?") %>" +
            "&<%= EPASSJSPActions.ACTION %>" + "=" + <%= EPASSJSPActions.EDIT_VIEW %> +
            "&<%= ServletBase.CURRENT_ID %>" + "=" + bidId;
        NAV_Popup( top, -1, url, 650 , 800);
    }
    
    function editBundleName(bidId)
    {
    	 var url;
        url = "<%=  ref.encodeURLwUP(JSP.BID_ROUTER_PAGE+ "?") %>" +
            "&<%= EPASSJSPActions.ACTION %>" + "=" + <%= EPASSJSPActions.EDIT_BUNDLE_NAME %> +
            "&<%= ServletBase.CURRENT_ID %>" + "=" + bidId;
        NAV_Popup( top, -1, url, 650 , 800);
    }

    function viewBid(bidId) {
        var url;
        url = "<%=  ref.encodeURLwUP(JSP.BID_ROUTER_PAGE+ "?") %>" +
            "&<%= EPASSJSPActions.ACTION %>" + "=" + <%= EPASSJSPActions.READ_VIEW %> +
            "&<%= ServletBase.CURRENT_ID %>" + "=" + bidId;
        NAV_Popup( top, -1, url, 650 , 800);
    }

</script>

</head>

<script>
/*
<%-- NavSupport.getContextClearJavascript(ref, ContextCodes.BID)--%>
*/
</script>

<%-- +---------------------------------------------------------------------------
 	HTML BODY
---------------------------------------------------------------------------+ --%>

<body onload="startTable();" marginleft="0" marginheight="0" marginwidth="1" rightmargin="2" topmargin="0" leftmargin="0">

<%@ include file="include/top.inc" %>


<%@ include file="include/inc_actionbar_spacer.inc" %>


<FORM name="<%=  formName%>" METHOD="POST" ACTION="list_bid_sealed.jsp" >

<%=  EPASSHTMLForm.getSessionHiddenField( ref ) %>
<input type="hidden" name=<%=  EPASSJSPActions.ACTION%> value='' >
<input type="hidden" name='bidClickedForViewHistory' value='' >
<input type="hidden" name='bidClickedToDemote' value='' >
<INPUT type="HIDDEN" name="<%=  ItemListPageProcessor.PAGE_MODE%>" value="<%=  ItemListPageProcessor.ITEM_MODE%>" >

<% if (fromItemDetailMultiRoundBidding){%>
    <input type="hidden" name=<%= ITEM_DETAIL_MULTI_ROUND_BIDDING %> value='<esapi:htmlatt><%=  request.getParameter( ITEM_DETAIL_MULTI_ROUND_BIDDING) %></esapi:htmlatt>' >
<%}%>

<% if (EPASSUiRFQServices.isPageCalledFromListButton(ref)){%>
    <INPUT type="HIDDEN" name="<%=  EPASSUiRFQServices.ITEM_ID_PARAM%>" value="<%=  ref.userDataContext.getRfqItemId()%>" >
<%}%>

<% if (!StringUtility.isEmpty(curIdStr)){%>
    <INPUT type="HIDDEN" name="<%= ServletBase.CURRENT_ID%>" value="<esapi:htmlatt><%= curIdStr%></esapi:htmlatt>" >
<%}%>


<%
 if (EPASSUiRFQServices.isPageCalledFromListButton(ref)){%>

	<%bidTable.stream(out);%>
    <DIV id = 'tableBottomSection' style = 'font-size: 0'>
		<TABLE width = '100%'>
			<TR align = 'center'><TD >
			<input type="button"
                value="<%= ref.convertLiteral("form.pluginAttachment.button.close")%>"
                onclick="javascript: parent.close()" >
            </TD></TR>
		</TABLE>
     </DIV>

<%}
 else{%>
	<%bidTable.stream(out);%>
<%} %>
</FORM>


<% // Polling support - For feedback scenario run
    if (rfq != null && rfq.isSealedAuction() && rfq.isAllowOptimizationFeedback().booleanValue() ) {
        String keys[] = new String[]{ PollCache.FEEDBACK_SCENARIO_RUN };
        String values[] = new String[]{ "NEW" };
        out.println( Poll.getPollScripts( pageStartTime, formName, keys, values, 10000) );

        // set up the initial time to compare for polling
        Date initialTime = new Date();
        ref.sessionTracker.setValue( ref.req, FeedbackScenarioRun.LAST_SCENARIO_CHECK_TIME_BID_LIST, initialTime );
    }

	//PR#83647# Two envelope bidding -adds polling support for pricing envelope
	if(lb.canAddPollingSupport(rfq)){
	    String keys[] = new String[]{PollCache.RFQ};
	    String values[] = new String[]{ref.userDataContext.getRfqId().toString()};
	    out.println(Poll.getPollScripts(pageStartTime, JSP.LIST_BID, keys, values, 0));
	} 
%>

<%@ include file="include/inc_action_bar.inc" %>

<SCRIPT>
<% if (EPASSUiRFQServices.isPageCalledFromListButton(ref)
        || "true".equalsIgnoreCase( ref.req.getParameter( "QB_SHOW_ITEM_DESC" ) ) ) {
ref.userDataContext.setRfqItemId(itemId);
%>
	<%=  "NAV_FireEvent( top, 'QB_SHOW_ITEM_DESC', '"
			+ ref.convertLiteral( "epass.list_quick_bid..bidhistory.bids_on_item")
			+ " "
			+ sItemName + "' );" %>

function NAV_HandleEvent( var1, var2 ) {
	if( var1 == "GET_ITEM_DESC" ) {
		<%=  "NAV_FireEvent( top, 'QB_SHOW_ITEM_DESC', '"
			+ ref.convertLiteral( "epass.list_quick_bid..bidhistory.bids_on_item")
			+ " "
			+ sItemName + "' );" %>
	}
	else if(var1 == "refreshPage")//PR 77063
	{		
		NAV_Reload(this);		
	}
}
<% } %>
</SCRIPT>

<%@ include file="include/bottom.inc" %>
</body>
<%
// scroll to the proper position on table
%>
<%=  bidTable.getSelectedRowScript()%>

</html>
<%@ include file="include/tail.inc" %>


<%-- *********************************************************************************** --%>
<%-- Local functions --%>
<%-- *********************************************************************************** --%>

<%!

public static final String optFeedback = AuctionStruct.ALLOWOPTIMIZATIONFEEDBACK;
public static final String QtyWinning = "QTYWINNING";

BidStruct[] createBiddingButtons(EPASSReferences ref, BidStruct[] bidStructs)
                            throws java.rmi.RemoteException, EPASSApplicationException{

    if (bidStructs != null && bidStructs.length > 0) {
        for (int i = 0; i < bidStructs.length; i++) {
            //addition for pr22695 fix so as not to display button if node has a parent starts here
            if(bidStructs[i].getParentBid()==null){
                //addtion for pr22695 fix so as not to display button if node has a parent ends here
                //String button = "";
                EPASSButtonDivControl button = null;
                if (EPASSUiBiddingServices.getBiddingUiBusinessRules().canUpdateBid(ref, bidStructs[i].getKey())) {

                    button = EPASSButtonDivControl.getSingleTaskTextButton( ref
                                , "reviseBidId"
                                , ref.convertLiteral("form.listBidSealed.button.revise_bid")
                                , "javascript:reviseBid('" + bidStructs[i].getId() + "')"
                                , ref.convertLiteral("form.listBidSealed.tooltip.revise_bid") );

                    button.setAttributes("class", "buttonListLgGreenUp");
                    button.setAttributes("Onmouseover", "this.className='buttonListLgGreenOver'");
                    button.setAttributes("Onmouseout", "this.className='buttonListLgGreenUp'");
					
                } else {

                    	button = EPASSButtonDivControl.getSingleTaskTextButton( ref
                                , "viewBidId"
                                , ref.convertLiteral("form.listBidSealed.button.view_bid")
                                , "javascript:viewBid('" + bidStructs[i].getId() + "')"
                                , ref.convertLiteral("form.listBidSealed.tooltip.view_bid") );

                   		button.setAttributes("class", "buttonListLgGreenUp");
                   	 	button.setAttributes("Onmouseover", "this.className='buttonListLgGreenOver'");
                    	button.setAttributes("Onmouseout", "this.className='buttonListLgGreenUp'");
                
                
                }
                bidStructs[i].setAttribute(EPASSUiRFQServices.BID_BUTTON, button.toString());
            }

        }
    }
    return bidStructs;
}
//--------------------------------------------------------------------------------------------------------------------
String buildAdditionalParameters(EPASSReferences ref, String curIdStr, String itemIdParam)
          throws EPASSApplicationException, java.rmi.RemoteException
{
    StringBuffer additionalParameters = new StringBuffer("");

    if ( !StringUtility.isEmpty(curIdStr) )
    {
        additionalParameters.append("&")
                    .append(ServletBase.CURRENT_ID)
                    .append("=")
                    .append(curIdStr);
    }

    if ( !StringUtility.isEmpty(itemIdParam) )
    {
        additionalParameters.append("&")
                    .append(EPASSUiRFQServices.ITEM_ID_PARAM)
                    .append("=")
                    .append(itemIdParam);
    }
    return additionalParameters.toString();
}
//------------------------------------------------------------------------------------------------------------------
 public static String colorCodeText(EPASSReferences ref, int quantity, String text)
        throws java.rmi.RemoteException, EPASSApplicationException
{
    NumberFormat f = null; // NumberFormat.getNumberInstance(locale);
                f = I18NFormats.getNumberFormat(ref.getLocale());
    f.setMaximumFractionDigits(0);

    text = f.format(new Double(text));

  String ret = "";
  if (quantity > 0){
      ret = "<font class=\"WINNING_QTY\">" + text + "</font>";
  } else {
      ret = "<font class=\"LOSING_QTY\">" + text + "</font>";
  }

  return ret;
}

//-----------------------------------------------------------------------------
// This static method builds table model for the current table view
//
ArrayList createBidTableModel( EPASSReferences ref,
                               AuctionStruct rfq,
                               boolean showFeedback)
          throws EPASSApplicationException, java.rmi.RemoteException
{
      ArrayList result               = new ArrayList();
      EPASSTableColumnModel column   = null;
      EPASSTableColumnModel columnID = null;
      EPASSTableColumnIconAttachments  columnIcon = null;
      EPASSTableColumnIconMessages  columnMsgIcon = null;
      Integer auctionId = rfq.getId();
      EPASSAttributeDefStruct ppuStruct = BiddingIAHelper.getBidAttributeDef(auctionId, BidStruct.BASEVARIABLECOST);

      // Checkbox column. Used for multiple selection for deleting and/or moving records.
      // As far as we want to put this checkbox as last column ib the table we don't add it to result list here.
      columnID = new EPASSTableColumnModel( Nav.SPACE, EPASSTableColumnModel.CHECK_BOX,
                                            BidStruct.ID );
      columnID.setLabel(ref.convertLiteral("form.terminology.column.headers.checkbox"));
      columnID.setRequiredColumn(Boolean.TRUE);

       // Tree navigation Images-------------------------
       column = new EPASSTableColumnModel( "&nbsp;&nbsp;&nbsp;",
                                              EPASSTableColumnModel.PLAIN_HTML,
                                               Misc.TREE_LINK );
        column.setWidth("35");
        column.setLabel(ref.convertLiteral("form.terminology.column.headers.tree"));
          result.add( column );
        //-------------------

      // Detail link column (shows details in the popup window). This also has to set
      // the nav context area, like the radio button column.
      if (EPASSUiRFQServices.isPageCalledFromListButton(ref))
      {
          column = new EPASSTableColumnModel( ref.convertLiteral("form.listBid.header.partner_name"), EPASSTableColumnModel.STRING_LABEL,
                                               "PARTNER_NAME" );
          column.setWidth("200");
          result.add( column ); //-----------------

          //Bid revision button -----------------
          column = new EPASSTableColumnModel(ref.convertLiteral("form.listItem.header.bid_revision"),
                                               EPASSTableColumnModel.PLAIN_HTML,
                                               EPASSUiRFQServices.BID_BUTTON);
         column.setWidth("100");
         result.add( column );
      }
      else {
          column = new EPASSTableColumnModel( ref.convertLiteral("form.listBid.header.partner_name"), EPASSTableColumnModel.DETAIL_LINK,
                                               "PARTNER_NAME" );

           // Detail column needs additional data source for ID of row
           column.setDetailLinkIDSource( columnID );
           //Set context block information for the NAV_Ctx function
           column.setContextWindowName( "top" );
           column.setPopupType( new Integer( 1 ) );
           column.setPopupWidth( new Integer( 606 ) );
           column.setPopupHeight( new Integer( 665 ) );
          column.setWidth("200");
          result.add( column ); //-----------------

          column = new EPASSTableColumnModel( ref.convertLiteral("form.listBid.header.org_name"), EPASSTableColumnModel.STRING_LABEL,
                                              "ORG_NAME" );
          column.setWidth("150");
          result.add( column );
      }

      // Bid Submission time
     boolean showBidTimeStamp = EPASSConfig.getInstance().getBooleanParameter(
                                        "showBidTimeStamp");

     if (showBidTimeStamp) {
         column = new EPASSTableColumnModel( ref.convertLiteral("form.listBid.header.submit_date"),
                                        EPASSTableColumnModel.DETAIL_LINK,
                                        BidStruct.SUBMITDATE );

          // Detail column needs additional data source for ID of row
          column.setDetailLinkIDSource( columnID );

          //Set context block information for the NAV_Ctx function
          column.setContextWindowName( "top" );
          column.setPopupType( new Integer( 1 ) );
          column.setPopupWidth( new Integer( 606 ) );
          column.setPopupHeight( new Integer( 665 ) );
          result.add( column ); //-----------------

    }

      column = new EPASSTableColumnModel( ref.convertLiteral("form.listBid.header.bid_type"),
                                            EPASSTableColumnModel.STRING_LABEL,
                                          "BID_TYPE_NAME" );
      result.add( column );
    //-----------------
      column = new EPASSTableColumnModel( ref.convertLiteral("form.listBid.header.bid_name"), EPASSTableColumnModel.PLAIN_HTML, "BID_NAME");

      result.add( column );
    //-----------------
     if (!showFeedback){
        EPASSAttributeDefStruct supplierItemStruct = BiddingIAHelper.getBidAttributeDef(auctionId, BidStruct.PRODUCTCODE);
        column = new EPASSTableColumnModel( ref.convertLiteral(supplierItemStruct.getName()),
                                    EPASSTableColumnModel.STRING_LABEL,
                                    BidStruct.PRODUCTCODE );
        result.add( column );
    }

    //-----------------
    //PR 35606
    boolean isPPUVisible = EPASSUiBiddingServices.isPPUVisibleForAuction(ref,
                        ref.getUserDataContext().getRfqId(),ref.isUserSeller());

    if(isPPUVisible){

        if(rfq.transformPrice() && !ref.isUserSeller()){

             column = new EPASSTableColumnCurrency( ref.convertLiteral(ppuStruct.getName()),
                                                    "."+BidStruct.BASEVARIABLECOST,
                                                    BidStruct.CURRENCYCODE
                                                  );
            column.setAttribute("CLASS", "LIST_CURRENCY_RIGHT");
            column.setFormatCode( "EPASSSmallCurrencyFormat" + rfq.getDecimalPlaces() );
            column.setAttribute("PaddingRightAsNBSP","0");
            column.setLabel(ref.convertLiteral(ppuStruct.getName()));
            result.add( column );

             column = new EPASSTableColumnCurrency( ref.convertLiteral("term.transformedPricePerUnit"),
                                                    "."+BidStruct.VARIABLECOST,
                                                    BidStruct.CURRENCYCODE
                                                  );
             column.setAttribute("CLASS", "LIST_CURRENCY_RIGHT");
             column.setFormatCode( "EPASSSmallCurrencyFormat" + rfq.getDecimalPlaces() );
             column.setAttribute("PaddingRightAsNBSP","0");
             column.setLabel(ref.convertLiteral("term.transformedPricePerUni"));
             result.add( column );

     }
     else{
            column = new EPASSTableColumnCurrency( ref.convertLiteral(ppuStruct.getName()),
                                                "."+BidStruct.VARIABLECOST,
                                                BidStruct.CURRENCYCODE
                                              );
            column.setAttribute("CLASS", "LIST_CURRENCY_RIGHT");
            column.setFormatCode( "EPASSSmallCurrencyFormat" + rfq.getDecimalPlaces() );
            column.setAttribute("PaddingRightAsNBSP","0"); // tells tableDataModel to add blank spaces before data to align numbers
            column.setLabel(ref.convertLiteral(ppuStruct.getName()));
            result.add( column );
       }
    }

    //PR PR 35606
     boolean isOTCVisible = EPASSUiBiddingServices.isOTCVisibleForAuction(ref,
            ref.getUserDataContext().getRfqId(),ref.isUserSeller());
     if(isOTCVisible)
     {
        EPASSAttributeDefStruct otcStruct = BiddingIAHelper.getBidAttributeDef(auctionId, BidStruct.BASEFIXEDCOST);
        column = new EPASSTableColumnCurrency( ref.convertLiteral(otcStruct.getName()),
                                             "."+BidStruct.FIXEDCOST,
                                             BidStruct.CURRENCYCODE
                                           );
        column.setAttribute("CLASS", "LIST_CURRENCY_RIGHT");
        column.setFormatCode( "EPASSSmallCurrencyFormat" + rfq.getDecimalPlaces() );
        column.setAttribute("PaddingRightAsNBSP","0"); // tells tableDataModel to add blank spaces before data to align numbers
        column.setLabel(ref.convertLiteral(otcStruct.getName()));
        result.add( column );
     }

      //-----------------
      Integer intPrecision = null;

      if (showFeedback){
            EPASSAttributeDefStruct minQNStruct = BiddingIAHelper.getBidAttributeDef(auctionId, BidStruct.MINCAPACITY);
            column = new EPASSTableColumnModel( ref.convertLiteral(minQNStruct.getName()),
                EPASSTableColumnModel.STRING_LABEL, BidStruct.MINCAPACITY );
            column.setAllowNBSPName( false );
            intPrecision = new Integer ( EPASSConfig.getInstance().getIntParameter ( EPASSConfig.MIN_BID_QNT_DECIMAL_DIGITS, 0 ) );
            if ( intPrecision.intValue() == 0 )
            {
              column.setFormatCode( "EPASSIntegerFormat" );
            }
            else
            {
              column.setFormatCode( "NUMERIC=" + intPrecision + "." + intPrecision );
            }
            column.setAttribute ( "width", "10%" );
            column.setAttribute("CLASS", "LIST_NUMERIC");
            result.add( column );
      }
       //-----------------
      EPASSAttributeDefStruct maxQNStruct = BiddingIAHelper.getBidAttributeDef(auctionId, BidStruct.MAXCAPACITY);
      column = new EPASSTableColumnModel( ref.convertLiteral(maxQNStruct.getName()),
        EPASSTableColumnModel.STRING_LABEL, BidStruct.MAXCAPACITY );
      column.setAllowNBSPName( false );
      intPrecision = new Integer ( EPASSConfig.getInstance().getIntParameter ( EPASSConfig.MAX_BID_QNT_DECIMAL_DIGITS, 0 ) );
      if ( intPrecision.intValue() == 0 ){
        column.setFormatCode( "EPASSIntegerFormat" );
      }
      else{
        column.setFormatCode( "NUMERIC=" + intPrecision + "." + intPrecision );
      }
      column.setAttribute ( "width", "10%" );
      column.setAttribute("CLASS", "LIST_NUMERIC");
      result.add( column );

     //Winning quantity column, shown if supplier feedback is enabled-----------------
      if (showFeedback){
            column = new EPASSTableColumnModel( "<font class=\"LOSING_QTY\">" +
                    ref.convertLiteral("form.listBid.header.quantity_winning")+
                    "</font>",
                    EPASSTableColumnModel.PLAIN_HTML , QtyWinning );

            column.setAttribute ( "width", "8%" );
            column.setAttribute("CLASS", "LIST_NUMERIC");
            column.setAllowNBSPName(false);
            column.setLabel(ref.convertLiteral("form.listBid.header.quantity_winning"));
            result.add( column );
      }

     //Bid Status-----------------
      column = new EPASSTableColumnModel( ref.convertLiteral("form.detailItemManualAward.header.bid_status"),
        EPASSTableColumnModel.STRING_LABEL, Misc.BID_STATUS_LABEL /*BidStruct.STATUS*/ );
     column.setWidth("80");
      result.add( column );

     //Bid History buttons-----------------
      column = new EPASSTableColumnModel( ref.convertLiteral("form.comparebids.title.bid_history"),
                            EPASSTableColumnModel.PLAIN_HTML,
                            "HAS_HISTORY" );
     column.setWidth("50");
      result.add( column );

     // Alternative Bid icon----------------------------
     if ( EPASSConfig.getInstance().getBooleanParameter ( "epass.sealed.enable_alternative_bids", true ) ){
        column = new EPASSTableColumnModel ( ref.convertLiteral ( "form.detailItemManualAward.header.alt_bid" )
                                             , EPASSTableColumnModel.PLAIN_HTML
                                             , EPASSUiBundleBidHelpServices.ALLOWED_ALTERNATIVE_BIDS );
        result.add ( column );
     }

    // Bid time column-------------------------
     column = new EPASSTableColumnModel( ref.convertLiteral("form.listBidReverse.header.time_bid"),
                    EPASSTableColumnModel.STRING_LABEL, "TIME_BID" );
     column.setColumnToSortOn(BidStruct.SUBMITDATE);
     column.setAttribute("CLASS", "LIST_NUMERIC");
     result.add( column );

     // Add Attachment Icon---------------
    String iconImage = "<img src=\"" + ref.getUserPath() + Dir.IMG + Image.ATTACHMENT_ICON + "\">";
    columnIcon = new EPASSTableColumnIconAttachments( iconImage, EPASSTableColumnModel.ICON, "ATTACHMENT_ICON" );
    columnIcon.setAllowNBSPName( false );
    columnIcon.setDetailLinkIDSource( columnID );
    columnIcon.setPopupWidth( new Integer( 800 ) );
    columnIcon.setPopupHeight( new Integer( 480 ) );

    // Attributes for Icons------------------
    columnIcon.setOwnerType (Misc.OWNER_BID);
    columnIcon.setCountsEnable (true);
    columnIcon.setLabel(ref.convertLiteral("form.terminology.column.headers.attachments"));
    result.add( columnIcon );

    // Add Message Icon--------------------
    iconImage = "<img src=\"" + ref.getUserPath() + Dir.IMG + Image.MESSAGE_ICON + "\">";
    columnMsgIcon = new EPASSTableColumnIconMessages( iconImage, EPASSTableColumnModel.ICON, "MESSAGE_ICON" );
    columnMsgIcon.setAllowNBSPName( false );
    columnMsgIcon.setDetailLinkIDSource( columnID );
    columnMsgIcon.setPopupWidth( new Integer( 800 ) );
    columnMsgIcon.setPopupHeight( new Integer( 480 ) );

    // Attributes for Icons--------------------
    columnMsgIcon.setOwnerType (Misc.OWNER_BID);
    columnMsgIcon.setCountsEnable (true);
    columnMsgIcon.setLabel(ref.convertLiteral("form.terminology.column.headers.messages"));
    result.add( columnMsgIcon );


    //Now add check box column for the table--------------
    result.add( columnID );

     // Manual Award Indicator
    /*if(!ref.isUserBidder(ref)){ //PR# 77742
        column = new EPASSTableColumnModel("<img src='"+ ref.getUserPath() + Dir.IMG + "detail_dollar_sign.gif' border='0'>",
                                EPASSTableColumnModel.PLAIN_HTML,
                                Misc.MANUAL_AWARD_IMAGE );

        column.setLabel(ref.convertLiteral("form.terminology.column.headers.manual_award"));
        column.setWidth("35");
        result.add( column );
     }*/

     return result;
}

//------------------------------------------------------------------------------------------------------------------------
void addAlternativeBidIcon ( EPASSReferences ref, BidStruct bid, Integer intBidType )
{
    String strHtml = "&nbsp;";

    if ( BidType.BUNDLE_BID.equals ( intBidType )
            && Boolean.TRUE.equals( bid.isAlternative() )
            && BidStatusType.NORMAL.equals( bid.getStatus () ) ) {
        try {
            String strCall = ref.isUserSeller() ? "javascript:removeAlternateStatus(" + bid.getId() + ");" : "";
            String strTooltip = ref.isUserSeller() ? ref.convertLiteral( "form.detailItemManualAward.tooltip.remove_alternative_status" ) : "";
            EPASSImageControl img = new EPASSImageControl ( ref.getUserPath() + Dir.IMG + "alternate_bid_icon.gif"
                                                            , strCall
                                                            , strTooltip );
            strHtml = "" + img;
        }
        catch ( Exception e ) {
            error(e.getMessage(),e);
        }

    }
    bid.setAttribute ( EPASSUiBundleBidHelpServices.ALLOWED_ALTERNATIVE_BIDS, strHtml );
}
//------------------------------------------------------------------------------------------------------------------
public String[] getCurrencyCodes(EPASSReferences ref, AuctionStruct rfq)
{
	String[] ret = null;
	if (null != rfq){
		String optCurrencyVal = rfq.getOptionalCurrencies();
		ret = StringUtility.stringToArray(optCurrencyVal,",");
	}

	return ret;
}
//-----------------------------------------------------------------------------------------------------------------------
public EPASSLink getFilterLink(EPASSReferences ref,
                               String curIdStr,
                               boolean fromItemDetailMultiRoundBidding)
{
    EPASSLink ret = new EPASSLink("list_bid_sealed.jsp", ref);

    if (fromItemDetailMultiRoundBidding){
        ret.setParameter(Misc.ITEM_DETAIL_MULTIROUNDBIDDING, ref.req.getParameter(Misc.ITEM_DETAIL_MULTIROUNDBIDDING));
    }

    ret.setParameter(ItemListPageProcessor.PAGE_MODE, new Integer(ItemListPageProcessor.getRFPPageMode(ref)));

    if (EPASSUiRFQServices.isPageCalledFromListButton(ref)){
        ret.setParameter(EPASSUiRFQServices.ITEM_ID_PARAM, curIdStr);
    }

    if (!StringUtility.isEmpty(curIdStr)){
        ret.setParameter(ServletBase.CURRENT_ID, curIdStr);
    }

    return ret;
}
//---------------------------------------------------------------------------------------------------------------------
public BidStruct getBundleBidInfo(EPASSReferences ref, BidStruct bundleBid, Integer itemId, boolean isUserHost, boolean isDraftsEnabled)
            throws java.rmi.RemoteException, EPASSApplicationException
{
    BidKeyImpl bundleBidKey = bundleBid.getKey();
    List listBids = null;
    listBids = ref.serviceRef.getBiddingService(ref).getBidSetBids(ref.sessionService, bundleBidKey, false);
    if (listBids != null && listBids.size() > 0) {
        for (int i = 0; i < listBids.size(); i++) {
            BidStruct bid = (BidStruct) listBids.get(i);

            if (bid != null && bid.getLineItemId() != null && bid.getLineItemId().equals(itemId)) {

                boolean showallInfo = true;

                if (isDraftsEnabled && isUserHost && bid.isDraftBid()) {
                    showallInfo = false;
                }

                if (showallInfo){
                    bundleBid.setAttribute("."+BidStruct.VARIABLECOST, bid.getVariableCost());
                    bundleBid.setAttribute("."+BidStruct.FIXEDCOST, bid.getFixedCost());
                    bundleBid.setMaxCapacity(bid.getMaxCapacity());
                }
            }
        }
    }

    return bundleBid;
}
%>
