<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="com.emptoris.app.scenario.common.constant.ScenarioType" %>
<%@ page import="com.emptoris.app.scenario.common.constant.ScenarioStatusType" %>
<%@ page import="com.emptoris.app.scenario.common.struct.ScenarioStruct" %>
<%@ page import="com.avinamart.WebInterface.forms.scenario.ScenarioListPageProcessor"%>

<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.Utility.Exception.*" %>

<%@ page import="java.util.Map" %>
<%@ page import="java.util.HashMap" %>
<%@ page import="java.util.Set" %>
<%@ page import="com.emptoris.app.awardkernel.common.struct.AwardConfigurationStruct" %>
<%@ page import="com.emptoris.app.awardkernel.common.constant.AwardConstants" %>
<%@ page import="java.util.HashSet" %>
<%@ page import="com.emptoris.app.awardkernel.common.constant.AwardLimits" %>

<%@ include file="include/head.inc" %>

<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<head>
    <%EPASSReferences localRef = ref;%>
    <TITLE><esapi:html><%=  localRef.convertLiteral("epass.title")%></esapi:html></TITLE>
    <link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
    <link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>

    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  localRef.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX %>'></SCRIPT>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  localRef.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  localRef.getUserPath() + Dir.JS + Javascript.EPASS_VALIDATE %>'></SCRIPT>

    <%-- Navigation utility that supply all frame services --%>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  localRef.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  localRef.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  localRef.getUserPath() + Dir.JS + Javascript.ACTIONBAR %>'></SCRIPT>

<script>
// The following javascript variables indicate to the navigation system(Nav.java)
// what the page is listing and what the page is dependent upon. The NAV_DEP variable
// can include several dependencies separated by comma. When a page (detail or list)
// changes one of the dependency types, all pages with this type of dependency will be
// forced to refresh. In this case, the page lists RFQs and depends on no other pages.

   var NAV_LIST='<%=  ContextCodes.SCENARIO%>,<%=  ContextCodes.RFQ%>';
   var NAV_DEP ='<%=  ContextCodes.RFQ%>';
   <%=  NavSupport.createNAV_VOLATILE( localRef ) %>
</script>
<script type="text/javascript">
    // override search results width for this page
    zmResultWidth = 300;
</script>

<%@ include file="include/zissou_mini.inc" %>
<script type="text/javascript">

a_list_or_url = "zissou_mini_find.jsp?scenarioSearch=true&rfq=<%= ref.userDataContext.getRfqId()%>";

ZissouMiniFormatter.getDataAction = function( dataObject ) {
    return {
        execute : function(){
			editScenario(dataObject.id);            
      }
    };
}

<% if ( request.getParameter("debugRulers") != null ) { %>
// fix close button
Util.addEvent(window, "load", function() {
$( "input[value=<%=  ref.txt("form.terminology.button.close") %>]" ).hide();
} );
<% } %>
</script>
</head>

<body onload="init();displayErrorMessage();" onResize="nsResize();" marginleft="0" marginheight="0" marginwidth="1" rightmargin="2" topmargin="0" leftmargin="0">

<%

    boolean isWizardEnabled = false;
    ScenarioListPageProcessor scenarioProcessor = new ScenarioListPageProcessor(localRef, isWizardEnabled);

    boolean doNavUpdate = false;
    // Integer action = EPASSUiScenarioServices.handleAction( request, ref, out );
    Integer action = scenarioProcessor.handleAction(request, localRef, out);
    if ((EPASSJSPActions.RUN == action.intValue()
            || EPASSJSPActions.DELETE == action.intValue()) && scenarioProcessor.getErrorMessage() == null) {
        doNavUpdate = true;
    }

    // Co host of an RFQ (authorized only for some items, cannot see scenarios
    // canCreateScenario verifies this authority
    // boolean canCreateScenario = false;
    boolean canReadScenario = false;
    String viewMsg = null;

    AuctionKeyImpl rfxKey = localRef.userDataContext.getRFQKey();
    if (rfxKey != null) {
        canReadScenario = EPASSUiScenarioServices.getScenarioUiBusinessRules().canReadScenario(localRef, rfxKey);

        // no buttons for rfi type of auctions
        if (EPASSUiRFQServices.isRFI(localRef)) {
            viewMsg = localRef.convertLiteral("form.list_scenario.message.rfi_no_app");

        } else if (canReadScenario == false) {
            viewMsg = localRef.convertLiteral("form.list_scenario.message.not_qualified_host");
        }

    } else {
        viewMsg = EPASSTableViewControl.createNoContextStatusMessage(ContextCodes.RFQ, localRef);
    }
    ScenarioStruct[] scenarioStructs = null;
    EPASSHTMLFilterSelect scenarioFilter = scenarioProcessor.getScenarioFilter();
   	Integer filterValue =  scenarioFilter.getFilterValue();
   	if(filterValue != null && filterValue == EPASSUiScenarioServices.SCENARIO_MY_LIST)
   	{
   		scenarioStructs = EPASSUiScenarioServices.getMyWatchListScenarios(ref,ref.userDataContext.getRFQKey());
   	}
   	else
   	{
   	 	//The view of the table is blocked if there is no RFQ in context or the user is a
   	    //co host who cannot view scenarios,
   	    //  ===== Advanced Optimization Customization - begin =====
   	    scenarioStructs = EPASSUiScenarioServices.getBuyerScenarios( ref );
   		//  ===== Advanced Optimization Customization - end =====		
   	}
   

    String storageKey = AwardConstants.SCENARIOS_FOR_AWARDING + rfxKey.getID().toString() + localRef.getOrgID().toString();
    Map selectedForAwardingMap = (Map) _sessionTracker.getValue(localRef.req, storageKey);
    AwardConfigurationStruct awardingConfig = scenarioProcessor.checkAndSetAwardConfiguration(ref);
    Set<Integer> scenariosForAwarding = new HashSet<Integer>();
    Integer selectedScenarioId = null;
    if (awardingConfig != null) {
        scenariosForAwarding = awardingConfig.getAllScenarioSet();
        selectedScenarioId = awardingConfig.getSelectedScenarioId();
    }
    if (selectedScenarioId != null) {
        localRef.userDataContext.setSelectedScenarioForAwarding(selectedScenarioId);
    }

    if (selectedForAwardingMap == null) selectedForAwardingMap = new HashMap();

    //The lowest cost scenario is the default selected scenario when going to the Awarding tab.
    for (int i = 0; i < scenarioStructs.length; i++) {

        //Another temporary place holder - identify here the lowest cost scenario by its name. Set it on the session as
        //one of the selected and also set it as the one in context
        if (AwardConstants.DEFAULT_SCENARIO_NAME.equals(scenarioStructs[i].getName())) {
            Integer lowestCostId = scenarioStructs[i].getId();
            //Add to the selected scenario
            selectedForAwardingMap.put(lowestCostId, Boolean.TRUE);
        }

        if (scenariosForAwarding.contains(scenarioStructs[i].getId())) {
            scenarioStructs[i].setAttribute(AwardConstants.SELECTED_FOR_AWARDING,
                    "<img src = '" + localRef.getUserPath() + Dir.IMG + Image.CHOOSE_FOR_AWARD_ICON + "' alt = '" +
                            localRef.convertLiteral("form.frames.awarding.alt.selected_for_awarding") + "' title = '" +
                                localRef.convertLiteral("form.frames.awarding.alt.selected_for_awarding") + "'" +">");
        } else {
            scenarioStructs[i].setAttribute(AwardConstants.SELECTED_FOR_AWARDING, "");
        }

        // Design Issue: this doesn't seem to work.
        // Disable the check box on any scenario that has been marked for external approval.
        if (scenarioStructs[i].isScenarioExternalAwardApprovalRequired().booleanValue()) {
            scenarioStructs[i].setAttribute(EPASSTableModel.CHECK_BOX_PRESENTED_DISABLED, Boolean.TRUE);
        }
        scenarioStructs[i].setAttribute(Misc.TREE_LINK ,"");//setting tree_link value to empty string to show select all button
    }

    EPASSTableViewControl scenarioTable = scenarioProcessor.getScenarioTableViewControl(scenarioStructs, canReadScenario);

    // Identify infeasible scenarios.
    StringBuffer sb = new StringBuffer();
    String realtimeFeedbackId = "/ /"; // For JavaScript RegExp space character, which should not be in Misc.SELECTED_OBJECT
    boolean isAuctionFeedback = false;
    for (int i = 0; i < scenarioStructs.length; i++) {
        ScenarioStruct scenarioStruct = scenarioStructs[i];
        if (ScenarioStatusType.INFEASIBLE_STATUS.equals(scenarioStruct.getStatusCode())) {
            if (sb.length() == 0) {
                sb.append(scenarioStructs[i].getId().toString());
            } else {
                sb.append("," + scenarioStructs[i].getId().toString());
            }
        }

        if (scenarioStruct.isRealtimeFeedbackType() || scenarioStruct.isAuctionFeedbackEnabled()) {

            realtimeFeedbackId = "/," + scenarioStruct.getId() + ",/"; // Note comma delimiter is part of search
            isAuctionFeedback = scenarioStruct.isAuctionFeedbackEnabled();
        }
    }

    String infeasibleIds = sb.toString();	
        
    String omniSearchCtrl = "<img class=\"zissou_mini_search_icon\" src=\"" + request.getContextPath() + "/dhtml_lib/img/search.gif\" border=\"0\" />" +
	"<span id=\"zissou_mini_container\" ><img src=\"" + request.getContextPath() + "/dhtml_lib/img/1x1_trans.gif\" width=\"108\" height=\"1\"/></span>";
	toolbarItems.addControl(omniSearchCtrl+"&nbsp;&nbsp;&nbsp;&nbsp;");
	toolbarItems.addControl(scenarioFilter);
    scenarioProcessor.addActionBarButtons(toolbarItems,filterValue);
   
    String scenarioCreateUrl = scenarioProcessor.getCreateScenarioUrl();
    EPASSLink scenarioDetailLink = scenarioProcessor.makeScenarioLink();

    final String formName = "scenario_list";
    String listTitle = localRef.convertLiteral("form.list_scenario.title.scenarios");
    String actionBarTitle = listTitle + " (" + ((scenarioStructs != null) ? scenarioStructs.length : 0) + ")";
    Object actionBarButtons = toolbarItems.toString();
%>

<script>
function displayErrorMessage(){
	<% if(scenarioProcessor.getErrorMessage() != null){ %>
		alert('<%=scenarioProcessor.getErrorMessage()%>');
	<% } %>
}
</script>
<script language='javascript'>
// array of RULER_IMG names
<%= scenarioTable.getJSArrayOfRulerImageNames()%>
// array of contents to place into cells
<%= scenarioTable.getJSArrayOfHeaderContents()%>

<%= NavSupport.notifyOfUpdate( ContextCodes.SCENARIO, doNavUpdate ) %>

</script>


<script type="text/javascript">

function doCreateScenario() {
    <% if (scenarioCreateUrl != null){ // the link may be null if the user can't create a scenario %>
       <%= scenarioCreateUrl%>;
    <% } %>
}

function doLegacyCreateScenario() {
    <% if (scenarioDetailLink != null){ // the link may be null if the user can't create a scenario %>
       NAV_Popup( top, -1, '<esapi:js><%= scenarioDetailLink.toURL() %></esapi:js>', 500, 500 );
    <% } %>
}


function doCreateResidual() {
	document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = '<%= EPASSJSPActions.CREATE_FROM_RESIDUAL%>';
	document.<%= formName%>.submit();
}

function checkSelection( msgConfirm ){
if ( EPASSCheckbox.checkRequired(
                            document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
                            "<%=  localRef.convertLiteral("form.listRfq.message.none_selected" )%>" ) ) {

var conf = confirm( msgConfirm);
return conf;
} else {
return false;
}
}

 function selectForAwarding(){

     var nSelected = EPASSCheckbox.getValues(document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>).length;
     if(nSelected == 0)  {
         alert("<esapi:js><%=  localRef.convertLiteral("form.list_scenario.message.scenario_select" )%></esapi:js>!" );
         return false;

     }

    document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = "<%= EPASSJSPActions.SELECT_SCENARIOS_FOR_AWARDING%>";
    document.<%= formName%>.submit();

  }


function doRunScenario() {
if( checkRun() ) {
        document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = "<%= EPASSJSPActions.RUN%>";
        document.<%= formName%>.submit();
}
}

function doStopScenario( scnId ) {
   alert( "<esapi:js><%=  localRef.convertLiteral( "form.list_scenario.message.stop_alert" )%></esapi:js>" );
   document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = "<%= EPASSJSPActions.STOP%>";
   var checkbox = document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>;

if ( typeof checkbox == "undefined" ) {
alert('undefined checkbox');
return false;
}

// it can be an array or one control
if ( typeof checkbox.length != "undefined" ) {
for ( var i = 0; i < checkbox.length; i++ ) {
    // only one should be checked
    if ( checkbox[i].value == scnId ) {
        checkbox[i].checked = true;
    } else {
        checkbox[i].checked = false;
    }
}
} else {
    if ( checkbox.value == scnId ) {
        checkbox.checked = true;
    }
}
   document.<%= formName%>.submit();
   return false;
}
function doCreateContract( scnId ) {
    var strUrl = "<%=  ref.encodeURLwUP( JSP.FRAMES_CM_PARTNERS + "?" ) %>"
                + "&" + "<%=  EPASSJSPActions.ACTION %>" + "=" + "<%=  EPASSJSPActions.CREATE_VIEW %>"
                + "&" + "<%=  ServletBase.CURRENT_ID %>" + "=" + scnId;
   NAV_Popup( top, -1, strUrl, 480 , 640 );
   }
// View bid summary report
function doViewBSR() {
    <% String viewBSR_URL = localRef.encodeURL( localRef.getUserPath()
        + JSP.BID_SUMMARY_REPORT);
    %>
    NAV_Popup( top, 1, '<esapi:js><%= viewBSR_URL %></esapi:js>', 480, 640 );
   }

   function doViewBVD() {
    <% String viewBVD_URL = localRef.encodeURL( localRef.getUserPath()
        + JSP.WIZ_RFQ_APPROVAL
        + "?"
        + EPASSUiCategoryServices.VIEW_BUSINESS_VOLUME_DISCOUNT_INDICATOR+"=1" );
    %>
    NAV_Popup( top, 1, '<esapi:js><%= viewBVD_URL %></esapi:js>', 480, 640 );
    }

    function submitForm() {
    if( checkDeletion() ) {
      document.<%= formName%>.submit();
    }
    }

    function scheduleScenario( scnId ) {
    if ( checkInfeasible(scnId) ) {
        var scnUrl = "<%=  localRef.encodeURLwUP("wiz_scenario_schedule.jsp?") %>"
                + "&" + "<%=  EPASSJSPActions.ACTION %>" + "="
                +  "<%=  EPASSJSPActions.EDIT_VIEW %>"
                + "&" + "<%=  ServletBase.CURRENT_ID %>="
    + scnId;
    NAV_Popup( top, -1, scnUrl, 370 , 600);
    }
    }

	function showScenarioReport(scnId)
	{
	
		alert('showScenarioReport '+scnId);
		var scnUrl = "<%=  JSP.REPORT_SCENARIO %>"
                + "?_eps_=Y" + "<%=  EPASSJSPActions.ACTION %>" + "="
                +  "<%=  EPASSJSPActions.EDIT_VIEW %>"
                + "&" + "<%=  ServletBase.CURRENT_ID %>="+ scnId;
    	NAV_Popup( top, -1, scnUrl, 600 , 700);
	}
	
	function _T_M2(v){
	  if (v){
	     return NAV_Status('Click for detail');
	  } else {
	     return NAV_Status();
	  }
	 }
	
	function _T_D2(v)
	{
	  var url = "<%=  ref.getUserPath() + JSP.REPORT_SCENARIO %>" + "?_eps_=Y" + "<%=  EPASSJSPActions.ACTION %>" + "="
                +  "<%=  EPASSJSPActions.EDIT_VIEW %>"
                + "&" + "<%=  ServletBase.CURRENT_ID %>="+ v;
	  NAV_Popup( top, 1,url,-1,-1);
	   return false;
	}
		
    function checkInfeasible( scnId ) {
    var msg  = "<esapi:js><%= localRef.convertLiteral( "form.list_scenario.message.run_confirm" )%></esapi:js>";
    var doIt = true;
    var sIDs = document.<%= formName%>.all_infeasible.value;
    var arr  = sIDs.split( ',' );
    var i;
    for ( i = 0; i < arr.length; i = i + 1 ) {
        if ( scnId == arr[i] ) {
            doIt = confirm( msg );
            break;
        }
    }
    return doIt;
    }

    function checkRun() {
    var isOk = EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
                                                       "<%=  localRef.convertLiteral( "form.list_scenario.message.select_run" )%>"
                                                       );
                                                       if ( isOk ) {
        var scnIds = EPASSCheckbox.getValues( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %> );

            for ( var i = 0; i < scnIds.length; i = i + 1 ) {
                var scnId = scnIds[i];
                isOk = checkInfeasible( scnId );
                if ( ! isOk ) {
                    break;
                }
            }
                                                       }

                                                       return isOk;
    }

    function checkDeletion() {
        var scenario_ids = EPASSCheckbox.getValues(<%= formName%>.<%=  Misc.SELECTED_OBJECT %>);
        var search_string = "," + scenario_ids + ",";
        var realtime_feedback_id = <%=  realtimeFeedbackId %>;
        var error_msg = "<%=  localRef.convertLiteral( "form.list_scenario.message.cannot_delete_realtime_feedback" )%>";
        if (<%= isAuctionFeedback %>)
        {
            error_msg = "<%=  localRef.convertLiteral( "form.list_scenario.message.cannot_delete_auction_feedback" )%>";
        }

        if ( search_string.search( realtime_feedback_id ) != -1 ) {
            alert( <esapi:js>error_msg</esapi:js> );
            return false;
        }

        if ( EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
                                          "<%=  localRef.convertLiteral( "form.list_scenario.message.delete_select" )%>" ) ) {

            return confirm( "<esapi:js><%=  localRef.convertLiteral( "form.list_scenario.message.delete_confirm" )%></esapi:js>" );
        } else {
            return false;
        }
    }

    function checkStop() {
    if( EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
                                     "<%=  localRef.convertLiteral( "form.list_scenario.message.stop_select" )%>" ) ) {

        return confirm( "<esapi:js><%=  localRef.convertLiteral( "form.list_scenario.message.stop_confirm" )%></esapi:js>" );
    } else {
    return false;
    }
    }

    function NAV_NotifyOnReload( reason ) {
    NAV_Updated( top, '<%= ContextCodes.SCENARIO_RESULTS%>');
    }
// added by Yash for m1
function refreshWithNewAttributes(){
	document.<%= formName%>.jspAction.value="-1";
    document.<%= formName%>.submit();
}

function NAV_HandleEvent(var1, var2)
{
    if (var1 == "Test") {
        refreshWithNewAttributes();
    }

}
// ends here
// Advance Optimization : Supplier entered constraint
	function doViewSupplierConstraint()
	{
    <% String viewSC_URL = ref.encodeURL( ref.getUserPath()
        + "frames_supplier_bruls.jsp?"
        + "&" + EPASSJSPActions.ACTION +"="+EPASSJSPActions.READ_VIEW);
    %>
    NAV_Popup( top, 1, '<esapi:js><%= viewSC_URL %></esapi:js>', 540, 840 );
	}
	
	function viewAltScenarioSummaryPopup(scenarioId)
	{
		var link = "<%= ref.getUserPath() + JSP.FRAMES_ALTERNATE_SCENARIO_SUMMARY%>?<%= ServletBase.CURRENT_ID%>="+scenarioId;
		NAV_Popup( top, 1, link, 500, 700 );
	}
	
	function addToMyList()
	{
		if ( EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
                                          "<%=  localRef.convertLiteral( "form.list_scenario.message.delete_select" )%>" ) ) 
        {

            var doConfirm = confirm( "<esapi:js><%=  localRef.convertLiteral( "form.list_scenario.message.confirm_addMyList" )%></esapi:js>" );
            if(doConfirm)
            {
             document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = '<%= EPASSJSPActions.ADD_MY_LIST%>';
             document.<%= formName%>.submit();
            }
        }
	
		return false;
	}
	
	function deleteFromMyList()
	{
		if ( EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
                                          "<%=  localRef.convertLiteral( "form.list_scenario.message.delete_select" )%>" ) ) 
        {

            var doConfirm = confirm( "<esapi:js><%=  localRef.convertLiteral( "form.list_scenario.message.confirm_removeMyList" )%></esapi:js>" );
            if(doConfirm)
            {
             document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = '<%= EPASSJSPActions.REMOVE_MY_LIST%>';
             document.<%= formName%>.submit();
            }
        }
	
		return false;
	}
	
function editScenario(scenarioId){	 
    NAV_Popup( top, 1,'<%= ref.getUserPath() + JSP.REPORT_SCENARIO  %>'+'?_eps_=Y&'+'<%=  EPASSJSPActions.ACTION %>' + '='
                +  '<%=  EPASSJSPActions.EDIT_VIEW %>'
                + '&' + '<%=  ServletBase.CURRENT_ID %>=' + scenarioId,-1,-1);
   return false;
 }
</script>

<%@ include file="include/zissou_mini_box.inc" %>

<%@ include file="include/inc_actionbar_spacer.inc" %>

<table width="100%" cellpadding=0 cellspacing=0 border=0 >
<FORM name="<%= formName%>" METHOD="POST" ACTION='<%=  JSP.SCENARIO_LIST_PAGE%>' ONSUBMIT="return checkDeletion();" >
<input type="hidden" name="<%= EPASSJSPActions.ACTION%>" value="<%= EPASSJSPActions.DELETE%>" >
<input type="hidden" name="all_infeasible" value='<%= infeasibleIds %>' >
<%=  EPASSHTMLForm.getSessionHiddenField(  localRef ) %>


<% if (scenarioTable.toString() != null)
{%>
<tr>
   <td colspan=2>
    <%-- Puts HTML representation of the table view --%>
      <%=scenarioTable.toString()%>
   </td>
</tr>
<%}%>
</FORM>
<% if (viewMsg != null)
{%>
<tr>
 <td colspan=2>
  <BR><P CLASS="STATUS_MESSAGE">
   <%= viewMsg%>
   </td>
</tr>
<%}%>
</table>

<%@ include file="include/inc_action_bar.inc" %>


<%@ include file="include/bottom.inc"%>
</body>

<%= scenarioTable.getSelectedRowScript()%>

</html>
<%@ include file="include/tail.inc"%>
