<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="com.avinamart.Utility.Exception.*,
                 java.util.List,
                 java.util.Arrays,
                 java.util.StringTokenizer,
                 java.text.DecimalFormat,
                 com.avinamart.Utility.StringUtility,
                 com.avinamart.ApplicationServices.ServiceManager,
                 com.avinamart.ApplicationServices.RFIServiceIntf,
                 com.emptoris.framework.attribute.common.struct.EPASSAttributeDefStruct" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.*" %>
<%@ page import="java.text.Collator" %>
<%@ page import="com.avinamart.Struct.*" %>
<%@ page import="com.avinamart.BusinessLogic.Key.*" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.AuctionStatus" %>
<%@ page import="com.avinamart.BusinessLogic.Helper.*" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.tree.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.Utility.I18NFormats" %>
<%@ page import="java.util.ArrayList" %>
<%@ page import="com.emptoris.framework.ui.controller.internal.CSRFHelper" %>
<%@ page import="org.owasp.esapi.ESAPI" %>
<%@ include file="include/head.inc" %>


<%-- +---------------------------------------------------------------------------
   Declarations
---------------------------------------------------------------------------+ --%>
<%

    //EPASSReferences ref = null;
    EPASSTableViewControl ranksTable = null;

    final String formName = "questionnaireRanksForm";
	String tableHTML = null;
	boolean isSaved = false;
    boolean isReadOnly = false;
    DecimalFormat df = null;
   try{
      df = (DecimalFormat)I18NFormats.getDecimalFormat( "#0.00", ref.getLocale() );
      df.setMaximumFractionDigits(2);
      df.setMinimumFractionDigits(2);
      df.setGroupingSize(100);
   }catch( Exception ex ){error(ex.getMessage(),ex);}

    //The RFI is the one in context
    Integer rfiID = ref.userDataContext.getRfqId();

     // BEGIN ACTION CONTROL BLOCK-----------------------------------------------
      switch (ref.getAction().intValue()) {
      case EPASSJSPActions.SAVE_UPDATE:
      case EPASSJSPActions.SAVE_NEW:


        //Look for the changed fields
        String changedFields = ref.req.getParameter("DIRTY_CELLS");
        if(!StringUtility.isEmpty(changedFields)){
            String[] idsRanks = StringUtility.stringToArray(changedFields, "@");
            try{
            	// RTC - 65439 - Get questionnaires with description otherwise translations will not be saved properly
            	QuestionnaireStruct[] questionnaireStructs = ServiceManager.getRFIService().getQuestionnairesWithDescription(ref.sessionService, new AuctionKeyImpl(rfiID));
                for(int i = 0; i < idsRanks.length; i +=2){

                    Integer ID = new Integer(idsRanks[i]);

                  //PR23825  Generic parsing code for different Locales
                    //  Double rank = new Double(idsRanks[i+1]);
                    Double rank = I18NFormats.toDouble(idsRanks[i+1], ref.getLocale());
                    QuestionnaireStruct questionnaire = null;
                    for(QuestionnaireStruct questionnaireStruct : questionnaireStructs){
						if(ID.equals(questionnaireStruct.getId())){
							questionnaire = questionnaireStruct;
							break;
						}
					}
                    if(questionnaire == null) {
                    	questionnaire = rfiService.getQuestionnaire(ref.sessionService, new QuestionnaireKeyImpl(ID));
                    }
                    questionnaire.setRank(rank);
                    //AttributeDefHelper.saveAttribute(ref.sessionService,Misc.OWNER_AUCTION_LEVEL_BID,rfiID,questionDef);
                    QuestionnaireKeyImpl questionnaireKey =
                            rfiService.saveQuestionnaire(ref.sessionService, questionnaire);
                }
                isSaved = true;
            }
            catch (EPASSApplicationException e){
                isSaved =false;
                ref.setErrorMessage(e);
            }
        }


        break;

      default:
        break;
      }
    // END ACTION CONTROL BLOCK-------------------------------------------------

    //Get the rfi questionnaires
     QuestionnaireStruct[] questionnaires = rfiService.getQuestionnaires(ref.sessionService, new AuctionKeyImpl(rfiID));
	String ranksJSArray = null;
	String weightsJSArray = null;
    if(questionnaires != null && questionnaires.length > 0){

		//Create a javascript arrays of all the ranks and weights. This will be used for normalization calculations
		double[] ranks = new double[questionnaires.length];
		double[] weights = new double[questionnaires.length];
		double sumRanks = 0;

		StringBuffer sbRanks = new StringBuffer("[");
		for(int i = 0; i < questionnaires.length; i++){
			Double rank = questionnaires[i].getRank();
			if(rank == null) rank = new Double(0);
			sbRanks.append(rank.toString());
			if (i < questionnaires.length - 1) sbRanks.append(",");

			ranks[i] = rank.doubleValue();
			sumRanks += ranks[i];
		}
		sbRanks.append("]");
		ranksJSArray = sbRanks.toString();

		StringBuffer sbWeights = new StringBuffer("[");
		for(int i = 0; i < questionnaires.length; i++){
			//If all ranks are 0 (sum ranks is 0), set equal weights for all.
			if(sumRanks == 0){
				weights[i] = 100.0/questionnaires.length/100;
			}
			else{
				weights[i] = ranks[i]/sumRanks;
			}
			sbWeights.append(String.valueOf(weights[i]));
			if (i < questionnaires.length - 1) sbWeights.append(",");
		}

		sbWeights.append("]");
		weightsJSArray = sbWeights.toString();

		//Authorization is the same for all questionnaires so get it only for the first one
        AuctionStruct rfi = EPASSUiRFQServices.getRFQ(ref,rfiID);
        isReadOnly = !EPASSUiRFIServices.getRFIUiBusinessRules().canUpdateQuestionnaire(ref, rfi, questionnaires[0]);

        for(int i = 0; i < questionnaires.length; i++){

            questionnaires[i].setAttribute("RANK_CONTROL", getRankControl(ref, i, ranks[i],questionnaires[i], df, isReadOnly));
            questionnaires[i].setAttribute("NORMALIZED_WEIGHT", getNormalizedWeightDiv(i,weights[i],df));
            questionnaires[i].setAttribute(QuestionnaireStruct.SEQUENCENUMBER, questionnaires[i].getSequenceNumber());
        }

	}

     // TABLE  ------------------------------------------------------

    ArrayList ranksTableModel = createTableModel(ref);

    ranksTable = new EPASSTableViewControl(
           ref,
           null,                                           // form name not used in the current version
           ref.getUserPath() + "list_weight_qustions.jsp", // current JSP name
           ref.getUserPath() + "list_weight_qustions.jsp",        									// popup detail/edit JSP
           true,                                           // indicate if table is read only
           ranksTableModel,                                  // table model data
           questionnaires,                                           // table data
           "rfi_weights",                            	// key for the saving current table view context in to the SessionTracker
           null,                                           // with buttons (create/delete)
           QuestionnaireStruct.SEQUENCENUMBER,                                  // default column for sort
           null,                                            // collator for case insensetive sorting
           true,                                           // ascending sort order
           true,                                           // late building
           true,                                           // without scroller
           true                                            // headers are clickable
       );

	//Create a post scroll processing callback object and register it with the table
    PostScrollProcessor postScroll =  new PostScrollProcessor();
    //ranksTable.setEPASSTablePostScrollCallback( postScroll );

    // Construct table. It performs all operations like scroller and button pad creation.
    ranksTable.constructTable();
	tableHTML = ranksTable.toString();

	// Modified for bugfix 22517
	tableHTML = StringUtility.replaceAll(tableHTML,"tOtAlS",
               "<span style='font-family:arial;font-size:12px;font-weight:bold;color:black'>"+ref.convertLiteral("form.listWeightQuestions.total")+"</span>");
    // Modified for bugfix 22517

%>
<script language='javascript'>
// array of RULER_IMG names
<%=  ranksTable.getJSArrayOfRulerImageNames() %>
// array of contents to place into cells
<%=  ranksTable.getJSArrayOfHeaderContents() %>
</script>
<%
//} // End if (categoryId != null)

  int nquestions = questionnaires != null ?  questionnaires.length : 0 ;
  String actionBarTitle =  ref.convertLiteral("form.listScoreSheet.header.questionnaires") + " (" + nquestions + ")";
  Object actionBarButtons = toolbarItems;
%>

<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<head>
<title><esapi:html><%=  ref.convertLiteral("epass.title") %></esapi:html></title>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_SELECT %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.ACTIONBAR %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass_tree_util.js" %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass.js"%>' ></SCRIPT>
<script>
// Turn off the maximize and the toggle button button
top.showmaxbtn = "false";
top.showScrollBtn = "false";
var isNavBlocked = false;
var NAV_LIST="";
var NAV_DEP ="<%= ContextCodes.CATEGORY%>";

<%if(ranksJSArray != null){ %>
var ranks = <%= ranksJSArray %>;
var weights = <%= weightsJSArray %>;
<%} %>
//-----------------------------------------------------------------------------
function calculateNormalization(fld, idx){

	if(fld.value == '') fld.value = _fixedDecimals(0,2);

	<%//update the ranks array with the new value put in the field%>
	ranks[idx] = i18n.textToNumber(fld.value);

	var sumRanks = 0;
	for(var i = 0; i < ranks.length; i++){
		sumRanks += ranks[i];
	}

	for(var i = 0; i < ranks.length; i++){
		if(sumRanks == 0){
			weights[i] = 100.0/ranks.length/100;
		}
		else{
			weights[i] = ranks[i]/sumRanks;
		}
	}

	var rankCtrls = document.<%= formName %>.<%= RANKS %>
	for(var i = 0; i < rankCtrls.length ; i++){
		var rowNumber = parseInt(rankCtrls[i].getAttribute('<%= ROW_NUMBER %>'));
		normalizedWeight = _fixedDecimals(weights[rowNumber]*100,2) + '%';
		document.getElementById('<%= NORMALIZED_WEIGHTS %>' + rowNumber).innerHTML = normalizedWeight;
	}


}
//---------------------------------------------------------------------------------------
function NAV_ReloadVeto(){
	if (isFormDirty()){

		if(confirm( "<esapi:js><%= ref.convertLiteral("form.wizConfig.message.save")%></esapi:js>" ) ){
			if(isErrorField()){
			return false;
			}
			document.<%=  formName %>.submit();
			return false;
		}
	}
	return true;
}

//-------------------------------------------------------------------------------
function NAV_HandleEvent(var1, var2){

  if (var1 == "<%=  EPassTree._sNavigationEvent %>") {
    var frm = document.<%=  formName %>;
    var splitted = var2.split( ";" );
    var goToDir = splitted[0];
    var goToParam = (splitted.length == 2) ? splitted[1] : "";

    <%//--------- When the Close button is clicked -------------------------+ --%>
    if (goToDir.indexOf('<%=  EPassTree._sTreeNavCloseCmd%> ') == 0) {
      NAV_ExecuteMenu(top, '<esapi:js><%=  TreeWizUtility.getNavCloseMenuId(ref)  %></esapi:js>');
    }

    <%//--------- When the Reset button is clicked -----------------------------+ --%>
    if (goToDir.indexOf('<%=  EPassTree._sTreeNavResetCmd %>') == 0) {
      if (confirm("<esapi:js><%=  ref.convertLiteral("form.reset") %></esapi:js>")) {
        frm.reset();
      }
    }


    <%//--------- Any other button (next or save) when the form is changed (dirty) --%>
    else if (isFormDirty()){

       if (var2 == "<%= EPassTree._sTreeNavSaveCmd%>" ){
       if(isErrorField()){
       return false;
       }
        frm.submit();
      }
      <% //PR 25821 - Confirm for save if form is dirty and navigation is from Tree
          // Short circuit for Close which is already handled %>
      else if (var2 == "<%= EPassTree._sTreeNavCloseCmd%>"
      ||  confirm( "<esapi:js><%= ref.convertLiteral("form.wizConfig.message.save")%></esapi:js>" ) ){
        frm.<%= TreeWizUtility.NEXT_PAGE_PARAMETER%>.value = var2;
        if(isErrorField()){
        return false;
        }
        	
        frm.submit();
      }
      else {
        document.<%=  formName %>.reset();
        NAV_FireEvent(top, '<%=  EPassTree._sNavigationEvent %>', var2);
      }
    }

    else {
        <%//---------When the Close or Save button is clicked but nothing to save--- %>
       	if ( var2 == "<%= EPassTree._sTreeNavCloseCmd%>" ||
          var2 == "<%= EPassTree._sTreeNavSaveCmd%>" ){

           ;
       	}
       	else if( goToDir.indexOf( '<%= EPassTree._sTreeNavBackCmd%>' ) == 0 ||
           goToDir.indexOf( '<%= EPassTree._sTreeNavNextCmd%>' ) == 0){
           <%= EPassTree.getInstance( ref, ref.userDataContext.getWizTreeName() )
                                           .getReRenderTreeJS( "goToDir", "goToParam" )%>
       	}
       	else{
           <%= EPassTree.getNotificationEventJSFunctionCall(
                EPassTree._sOnNodeExternalySelectedEvent, "goToDir", "goToParam" )%>
      	}
    }
  }

}

//----------------------------------------------------------------------------
function onClickSaveForm() {

  var frm = document.<%=  formName %>;
  if(isErrorField()){
  return false;
  }
  

  frm.submit();
}
//------------------------------------------------------------------------------
function isFormDirty() {

  var dirtied = false;
  var changedRanks = '';

  var frm = document.<%= formName %>;
  var rankCtrls = frm.<%= RANKS%>;
  var questionIdCtrls = frm.<%= QUESTION_IDS%>;
  var initialRankCtrls = frm.<%= INITIAL_RANKS%>;

  <%//If the page is empty , return false (form cannot be dirty without entries)%>
  if(typeof rankCtrls == 'undefined') return false;

  var nRows = typeof rankCtrls.length != 'undefined' ? rankCtrls.length : 1;
  <%//This is needed because if there is only one row,  rankCtrls and
	//questionIdCtrls are created as a single variable and not an array.%>
	var ranks = new Array();
	var questionIds = new Array();
	var initialRanks = new Array();
	if(nRows > 1){
		ranks = rankCtrls;
		questionIds = questionIdCtrls;
		initialRanks = initialRankCtrls;
	}
	else{
		ranks[0] = rankCtrls;
		questionIds[0] = questionIdCtrls;
		initialRanks[0] = initialRankCtrls;
	}

  for(var i = 0; i <ranks.length; i++){
  	if(ranks[i].value != initialRanks[i].value){
		changedRanks += (questionIds[i].value + '@' + ranks[i].value + '@');
		dirtied = true;
	}
  }
  if(dirtied){
  	frm.<%= DIRTY_CELLS%>.value = changedRanks.substring(0,changedRanks.length-1);
  }
  return dirtied;

}
//--------------------------------------------------------------------------------
function reinitializeForm() {
  var frm = document.<%=  formName %>;

}

</script>
</head>

<%-- +---------------------------------------------------------------------------
   HTML BODY
---------------------------------------------------------------------------+ --%>
<body onload="init()" onResize="nsResize();" marginheight="0" marginwidth="1"  topmargin="0" leftmargin="0">
<%@ include file="include/top.inc" %>
<script>
var showmaxbtnlocal    = 'false';   // no maximize button
var showScrollBtnlocal = 'false';   // no toggle scroll button
</script>

<%
  // Everything processed Ok
  if (!ref.isMessage()) {
    String res = TreeWizUtility.getTreeFireEventJs(ref);
    if (!StringUtility.isEmpty(res)) {
      out.write("<script>");
      out.write(res);
      out.write("</script>");
      out.flush();
      return;
    }
  }
%>

<%@ include file="include/inc_actionbar_spacer.inc" %>
<%actionBarButtons = toolbarItems;%>

<table width="100%" cellpadding="0" cellspacing="0" border="0">
<form name="<%=  formName %>" METHOD="POST" ACTION="list_weight_questionnaires.jsp">
<input type = 'hidden' name = '<%= DIRTY_CELLS %>' value = ''>
<tr ><td class="POPFORMBODY"><%= tableHTML %></td></tr>
<input type="hidden" name="<%=  EPASSJSPActions.ACTION %>" value="<%=  EPASSJSPActions.SAVE_UPDATE %>">
<INPUT type="HIDDEN" name="<%= TreeWizUtility.NEXT_PAGE_PARAMETER %>" value="">
<%
	CSRFHelper csrfHelper = CSRFHelper.getInstance();
	String hmaCode = csrfHelper.getHMACode(ref.req); 
%>
<input type="hidden" name="<%= CSRFHelper.HMA_CODE%>" value="<esapi:htmlatt><%= hmaCode %></esapi:htmlatt>" >
</form>
</table>

<%@ include file="include/inc_action_bar.inc" %>

<%@ include file="include/bottom.inc" %>
</body>
</html>
<% if(questionnaires != null && questionnaires.length > 0){ %>
	<script>

		<%
		StringBuffer message = new StringBuffer();
        message.append(ref.convertLiteral("form.listWeightQuestionnaire.help.1"))
               .append("<div align = \"center\" style = \"font-weight:bold;color:blue\">")
               .append(ref.convertLiteral("form.listWeightQuestionnaire.help.2"))
               .append("</div><p>")
               .append(ref.convertLiteral("form.listWeightQuestionnaire.help.3"))
               .append(" <span style = \"font-weight:bold\">")
               .append(ref.convertLiteral("form.listWeightQuestionnaire.normalized"))
			  .append("</span>")
               .append(ref.convertLiteral("form.listWeightQuestionnaire.help.4"))
               .append("<p><div align = \"center\" style = \"font-weight:bold;color:blue\">")
               .append(ref.convertLiteral("form.listWeightQuestionnaire.help.5"))
               .append("</div><p>")
               .append(ref.convertLiteral("form.listWeightQuestionnaire.help.6"));

		OptionalDisplayMessage messageDialog =
				new OptionalDisplayMessage(ref,"questionnaireWeights",message.toString(),true,true);

		messageDialog.setPopupSize(500,530);
		messageDialog.setMessageStyle("font-family:arial;font-size:12;");
		messageDialog.setShowScrollBars(true);
		%>
		 <%//This will prevent showing the message again in the same pass or after saving
        if(ref.getAction().intValue() !=  EPASSJSPActions.SAVE_UPDATE ){%>
		    	<%= messageDialog.InsertOptionalDisplayMessage() %>
        <%}%>



	</script>
<%} %>
<% //This code will remove the Save button when the page is readonly or no questions exist
    boolean hideSaveButton = isReadOnly || questionnaires == null || questionnaires.length == 0;
    out.write(TreeWizUtility.getNavHideSaveButtonJs(hideSaveButton));%>
<%@ include file="include/tail.inc" %>


<%!

final static String RANKS = "RANKS";
final static String NORMALIZED_WEIGHTS = "NORMALIZED_WEIGHTS";
final static String INITIAL_RANKS = "INITIAL_RANKS";
final static String RANK_TOTAL = "RANK_TOTAL";
final static String NORMALIZED_TOTAL = "NORMALIZED_TOTAL";
final static String QUESTION_IDS = "QUESTION_IDS";
final static String DIRTY_CELLS = "DIRTY_CELLS";

final static String ROW_NUMBER = "ROW_NUMBER";

RFIServiceIntf rfiService = ServiceManager.getRFIService();

ArrayList createTableModel(EPASSReferences ref)
        throws EPASSApplicationException, java.rmi.RemoteException {
  ArrayList result = new ArrayList();
  EPASSTableColumnModel column = null;

  // Questionnaire column
  column = new EPASSTableColumnModel(
      ref.convertLiteral("form.listItem.title.questionnaires"),
      EPASSTableColumnModel.STRING_LABEL,
      EPASSAttributeDefStruct.NAME);
 column.setWidth("30%");
  column.setLabelTruncation(50);
    column.setLabelTipLength(100);
  result.add(column);

  // Ranks
  Double dblMin = I18NFormats.toDouble(ref.convertLiteral("form.detailQuestionnaire.message.weight_min"), ref.getLocale());
	Double dblMax = I18NFormats.toDouble(ref.convertLiteral("form.detailQuestionnaire.message.weight_max"), ref.getLocale());
	
	NumberFormat nf = I18NFormats.getNumberFormat( ref.getLocale() );
	nf.setMaximumFractionDigits(2);
	nf.setMinimumFractionDigits(2);
	
	String min = nf.format(dblMin);
	String max = nf.format(dblMax);
	String[] msgParams = {min, max};
	
  String message = ref.formatMessage(ref.convertLiteral( "form.listWeightQuestions.rank"), msgParams);
  
  
  column = new EPASSTableColumnModel(
      message,
      EPASSTableColumnModel.PLAIN_HTML,
      "RANK_CONTROL");
  result.add(column);

  // Normalized weights
  column = new EPASSTableColumnModel(
      ref.convertLiteral("form.listWeightQuestions.weights"),
      EPASSTableColumnModel.PLAIN_HTML,
      "NORMALIZED_WEIGHT");
  result.add(column);

  return result;
}
//-----------------------------------------------------------------------------
String getRankControl(EPASSReferences ref, int index, double rank, QuestionnaireStruct questionnaire, DecimalFormat df,  boolean isReadOnly)
            throws EPASSApplicationException, java.rmi.RemoteException {

  // get the attribute definition
  String  rankStr = df.format(new Double(rank));

  EPASSRealInput rankControl = new EPASSRealInput(ref, RANKS, rankStr);
  rankControl.setSize(5);
  rankControl.setLowInclusive(0.0);
  rankControl.setHighInclusive(10.0);
  rankControl.setAttribute("onchange","calculateNormalization(this," + index + ")");
  rankControl.setEnabled(!isReadOnly);
  rankControl.setAttribute(ROW_NUMBER,"" + index);

  // Add  hidden controls to store the attribute id and the initial value
  StringBuffer sb = new StringBuffer();
  sb.append("<input type = 'hidden'  name = '" +INITIAL_RANKS+ "' value = '")
    .append(rankStr)
    .append("'>")
    .append("<input type = 'hidden'  name = '" + QUESTION_IDS + "' value = '")
    .append(questionnaire.getId())
    .append("'>");

  rankControl.setExtendedText(sb.toString());

  return "<div align = 'center'>" + rankControl.toString() + "</div>";
}
//-----------------------------------------------------------------------------------
String getNormalizedWeightDiv(int index, double weight, DecimalFormat df)
        throws EPASSApplicationException, java.rmi.RemoteException {

   String  weightStr = df.format(new Double(weight*100.0));

  // Add a hidden control by the same name to store the initial value
  StringBuffer sb = new StringBuffer();
  sb.append("<div id = '" + (NORMALIZED_WEIGHTS + index) + "' align = 'center' >" + weightStr + "%</div>");

  return sb.toString() ;
}

//*****************************************************************************************************
//The post scroll processor adds the totals line at the bottom of the page. This is done after the subset
//displayed on the page is already selected.
    public class PostScrollProcessor implements EPASSTablePostScrollCallback{

        public PostScrollProcessor(){

        }

        //--------------------------------------------------------------------------------------
		//The method accepts the subset of questionnaires displayed on the page and append 2 spacers and
		//a totals line at the bottom.

        public WrapperObjectStruct[] postScrollProcess(EPASSReferences ref,
                                                         WrapperObjectStruct[] displayedRows, List tableColumnModel )
                              throws EPASSApplicationException, java.rmi.RemoteException, java.lang.Exception {

			QuestionnaireStruct[] pageQuestionnaires = new QuestionnaireStruct[displayedRows.length+3];
			for(int i = 0; i < displayedRows.length; i++){
				pageQuestionnaires[i] = (QuestionnaireStruct) displayedRows[i];
			}
            //Add a spacer line
	        QuestionnaireStruct spacer = new QuestionnaireStruct();
	        spacer.setDescription("");
	        spacer.setAttribute("RANK_CONTROL","");
	        spacer.setAttribute("NORMALIZED_WEIGHT","");
	        pageQuestionnaires[pageQuestionnaires.length - 3] = spacer;
	        pageQuestionnaires[pageQuestionnaires.length - 2] = spacer;

	        QuestionnaireStruct totals = new QuestionnaireStruct();

	        totals.setName("tOtAlS");

	        totals.setAttribute("RANK_CONTROL","<div id='" + RANK_TOTAL +
							"' align = 'center' style='font-size:12px;color:black;font-weight:bold'></div>");
	        totals.setAttribute("NORMALIZED_WEIGHT","<div id='" + NORMALIZED_TOTAL +
							"' align='center' style='font-size:12px;color:black;font-weight:bold'></div>");
	        pageQuestionnaires[pageQuestionnaires.length - 1] = totals;

			return pageQuestionnaires;

        }// end postScrollProcess
    }// end public class PostScrollProcessor implements EPASSTablePostScrollCallback {
%>
