<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="java.util.*" %>
<%@ page import="com.avinamart.Struct.*" %>
<%@ page import="com.avinamart.BusinessLogic.Key.*" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.WebInterface.forms.search.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.Utility.Exception.*" %>
<%@ page import="java.text.Collator" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.*" %>
<%@ page import="com.avinamart.Utility.Query.*" %>
<%@ page import="com.avinamart.Framework.Reporting.Constants.Parameters" %>
<%@ page import="org.owasp.esapi.ESAPI" %>

<%@ include file="../../include/head.inc"%>


<%@page import="com.avinamart.WebInterface.forms.search.compound.AbstractCompoundSearchProcessor"%>
<%@page import="com.avinamart.WebInterface.forms.search.compound.CpvListCompoundSearchProcessor"%>
<%@page import="com.avinamart.WebInterface.forms.search.compound.VocListCompoundSearchProcessor"%>
<%@page import="com.avinamart.WebInterface.forms.search.compound.NutsListCompoundSearchProcessor"%>
<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<%
	String queryContext = ref.req.getParameter( SearchManager.QUERY_CONTEXT );
   	AbstractCompoundSearchProcessor pageProcessor = new CpvListCompoundSearchProcessor( ref );
	pageProcessor.setTitle( ESAPI.encoder().encodeForHTMLAttribute(ref.convertLiteral("form.listCpv.selected.CPV")));
	//default implementation for basic_cpv_search and additional_cpv_search query contexts
	String alertMessge		= ref.convertLiteral( "form.listCpv.message.remove_from_search_msg" );
	String confirmMessage	= ref.convertLiteral( "form.listCpv.message.remove_from_search_confirm" );
	String selectOneMessage = ref.convertLiteral( "form.listCpv.message.please_select_one" );
	String selectUpperLimitMessage = ref.convertLiteral( "form.listCpv.message.please_select_upper_limit" );
	if( queryContext.endsWith( SearchManager.BASIC_VOC_SEARCH ) || queryContext.endsWith( SearchManager.ADDITIONAL_VOC_SEARCH ))
	{
		pageProcessor = new VocListCompoundSearchProcessor( ref );
		pageProcessor.setTitle("Selected VOC(s) ");
		alertMessge	= ref.convertLiteral( "form.listVoc.message.remove_from_search_msg" );
		confirmMessage	= ref.convertLiteral( "form.listVoc.message.remove_from_search_confirm" );
		selectUpperLimitMessage = ref.convertLiteral( "form.listVoc.message.please_select_upper_limit" );
	}	
	else if( queryContext.endsWith( SearchManager.BASIC_NUTS_SEARCH ))
	{
		pageProcessor = new NutsListCompoundSearchProcessor( ref );
		pageProcessor.setTitle(ESAPI.encoder().encodeForHTMLAttribute(ref.convertLiteral("form.listNuts.header.nuts_selected_search")));		
		alertMessge	= ref.convertLiteral( "form.listNuts.message.remove_from_search_msg" );
		confirmMessage	= ref.convertLiteral( "form.listNuts.message.remove_from_search_confirm" );
		selectOneMessage = ref.convertLiteral( "form.listNuts.message.please_select_one" );
		selectUpperLimitMessage = ref.convertLiteral( "form.listNuts.message.please_select_upper_limit" );
	}	
	pageProcessor.setCompoundListPageName( JSP.SELECTED_SEARCH_LIST_PAGE );
	String customParams = ref.req.getParameter( SearchManager.CUSTOM_PARAMETERS );

	toolbarItems.setPrintable( false );
	final String formName = "compound_selected_search_list";
	pageProcessor.setFormName( formName );
	pageProcessor.setToolBar( toolbarItems );
	pageProcessor.init();
	
	EPASSQuery query = SearchManager.getRequestQuery( ref );
	pageProcessor.setQuery( query );
	
	String plzMakeSelection = ref.convertLiteral("form.treeCompoundSearch.please_select");
%>

<head>
<title><esapi:html><%=  ref.convertLiteral( "epass.title" )%></esapi:html></title>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
<%-- Navigation utility that supply all frame services --%>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.ACTIONBAR %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_LIST_SEARCH%>'></SCRIPT>

<%@ include file="../../include/inc_compound_search_js.inc" %>

<script>
var NAV_LIST='';
var NAV_DEP ='';

var checked_list = 0;
var checked_value;

function submitSelectFromTree(code, id)
{
	//alert('code : '+code);
	document.<%= formName%>.<%= SearchManager.CUSTOM_PARAMETERS %>.value = '<esapi:js><%= customParams %></esapi:js>';
	document.<%= formName%>.<%= SearchForm.ADD_SEARCH_FORM_TREE %>.value = 'true';
	document.<%= formName%>.<%= SearchForm.TREE_SELECTION_OBJECT %>.value = code;
	document.<%= formName%>.submit();
}
function submitSelectedObjects()
{

	var searchListIds = document.<%= formName%>.<%= SearchForm.SEARCH_LIST_CODES %>.value;
	if(searchListIds.length == 0)
	{
		alert('<esapi:js><%=  plzMakeSelection  %></esapi:js>');
		return false;
	}
	//if multiselect is false then form should not get submited
	//if there are more than one rows 
	var multiselect = document.<%= formName%>.<%= SearchManager.MULTISELECT_IN_RESULT_PAGE %>.value;	
	
	if( multiselect == 'false')
	{

		var seperateIds = new Array();
		seperateIds = searchListIds.split(';');		
		if( seperateIds.length > 1)
		{
			alert( '<esapi:js><%=  selectOneMessage  %></esapi:js>' );
			return false;
		}
	}
	
	if( multiselect == 'null')
	{
		var seperateIds = new Array();
		seperateIds = searchListIds.split(';');		
		<% if( queryContext.endsWith( SearchManager.ADDITIONAL_CPV_SEARCH )) { %>
			if( seperateIds.length > 100)
			{
				alert( '<esapi:js><%=  selectUpperLimitMessage  %></esapi:js>' );
				return false;
			}
		<% } else if (queryContext.endsWith( SearchManager.BASIC_VOC_SEARCH ) || queryContext.endsWith( SearchManager.ADDITIONAL_VOC_SEARCH )) { %>
			if( seperateIds.length > 20)
			{
				alert( '<esapi:js><%=  selectUpperLimitMessage  %></esapi:js>' );
				return false;
			}
		
		<% } else if (queryContext.endsWith( SearchManager.BASIC_NUTS_SEARCH )) {%>
			if( seperateIds.length > 20)
			{
				alert( '<esapi:js><%=  selectUpperLimitMessage  %></esapi:js>' );
				return false;
			}
		<% } %>
	}
	
	var queryContext = document.<%= formName%>.<%= SearchManager.QUERY_CONTEXT %>.value;
	var resultList =  
			document.<%= formName%>.<%= SearchForm.SEARCH_LIST_IDS %>.value + ';;' +
			document.<%= formName%>.<%= SearchForm.SEARCH_LIST_CODES %>.value + ';;' +
			document.<%= formName%>.<%= SearchForm.SEARCH_LIST_NAMES %>.value + ';;' + queryContext + ';;' +
			document.<%= formName%>.<%= SearchManager.NUTS_CONTACT_NAME %>.value + ';;' +
			document.<%= formName%>.<%= SearchManager.STATE %>.value; 
	
	NAV_FireEvent ( top, "selectCpvVocNuts", resultList );
	parent.close();
}
function submitSearchForm( selectedItems )
{
	var previousSelection = document.<%= formName%>.<%= SearchForm.SEARCH_LIST_CODES %>.value;
	if( previousSelection.length > 1 )
	{
		document.<%= formName%>.<%= SearchForm.SEARCH_LIST_CODES %>.value = previousSelection +';'+selectedItems;
	}
	else
	{
		document.<%= formName%>.<%= SearchForm.SEARCH_LIST_CODES %>.value = selectedItems;
	}
	
	
	document.<%= formName%>.<%= SearchForm.ADD_SEARCH_FROM_MIDDLE_PANE %>.value = 'true';
	document.<%= formName%>.submit();
	
}

function checkFunc(){ 
 	var oldValue = checked_value;
 	if (this.checked) { 
 		checked_list++;	
 		checked_value = this.value;
 	}else{
 		checked_list--;
 	}
 	if ( checked_list > 1 ) {
 		alert( 'Please select only one record' );
 		this.checked = false;
 		checked_value = oldValue;
 		checked_list--;
 	}
} 
//


function checkDeletion()
{
	 if( EPASSCheckbox.checkRequired( document.<%= formName%>.<%=  Misc.SELECTED_OBJECT %>,
									  '<esapi:js><%=  alertMessge  %></esapi:js>' ) )
	 {
		return confirm( '<esapi:js><%=  confirmMessage %></esapi:js>' );
	 }
	 else
	 {
		return false;
	 }
}

function doRemoveFromSearch(){
	if( checkDeletion() ){
		document.<%= formName%>.<%= SearchManager.CUSTOM_PARAMETERS %>.value = '<esapi:js><%= customParams %></esapi:js>';
		document.<%= formName%>.<%= EPASSJSPActions.ACTION%>.value = <%= EPASSJSPActions.DELETE%>;
		document.<%= formName%>.submit();
   	}
}

//---------------------------------------------------------------------------------
<%//This JS function acts to capture search input whn the page is used to display
//secondary (compound) search results %>
<%
	if( !pageProcessor.inIFrame() ){
		out.print( SearchManager.captureSearchEventFunction( ref, SearchManager.COMPOUND_QUERY,false ) );
	}
%>
</script>
</head>

<%--
 	HTML BODY
--%>
<body onload="init();" onResize="nsResize();"  marginheight="0" marginwidth="1"  topmargin="0" leftmargin="0">
<%@ include file="../../include/top.inc"%>

<%--
 	Action Control Block
--%>
<%
	pageProcessor.doAction();
	pageProcessor.prepareData();
	String treeSelectionObjectList = "";
	
	if( ref.req.getParameter(EPASSTableViewControl.CHECKBOX_ARRAY) != null )
	{
		treeSelectionObjectList = ref.req.getParameter(EPASSTableViewControl.CHECKBOX_ARRAY);
	}
	// END DATA SUPPORT BLOCK ---------------------------------------------------
%>

<%-- +---------------------------------------------------------------------------
 	Display Table Form View
---------------------------------------------------------------------------+ --%>
<%
	String actionBarTitle	= pageProcessor.getTitle();
	Object actionBarButtons = pageProcessor.getToolBar();
%>

<%-- LOCATION of inc_action_bar.jsp for NS --%>
<%-------------------------------------------%>
<%@ include file="../../include/inc_actionbar_spacer.inc" %>
<table width="100%" cellpadding=0 cellspacing=0 border=0 >
<FORM name="<%= formName%>" METHOD="POST" action="<esapi:htmlatt><%= pageProcessor.getCompoundListPageName() %></esapi:htmlatt>" >
 
<input type='hidden' name='<%= SearchManager.MULTISELECT_IN_RESULT_PAGE %>' value='<esapi:htmlatt><%=  ref.req.getParameter( SearchManager.MULTISELECT_IN_RESULT_PAGE)  %></esapi:htmlatt>' >
<input type='hidden' name='<%= SearchManager.QUERY_CONTEXT %>' value='<esapi:htmlatt><%=  ref.req.getParameter( SearchManager.QUERY_CONTEXT)  %></esapi:htmlatt>' >
<input type='hidden' name='<%= SearchManager.NUTS_CONTACT_NAME %>' value='<esapi:htmlatt><%=  ref.req.getParameter( SearchManager.NUTS_CONTACT_NAME)  %></esapi:htmlatt>' >
<input type='hidden' name='<%= SearchManager.STATE %>' value='<esapi:htmlatt><%=  ref.req.getParameter( SearchManager.STATE)  %></esapi:htmlatt>' >
<input type='hidden' name='<%= SearchForm.SUBMIT_BTN_REQD %>' value='<esapi:htmlatt><%=  ref.req.getParameter( SearchForm.SUBMIT_BTN_REQD)  %></esapi:htmlatt>' >
<input type='hidden' name='<%= SearchForm.ADD_SEARCH_FROM_MIDDLE_PANE %>' value='' >

<input type='hidden' name='<%= SearchManager.CUSTOM_PARAMETERS %>' value='' >
<input type='hidden' name='<%=SearchForm.SEARCH_LIST_IDS %>' value='<%=pageProcessor.getSearchListAttributeValues("id") %>' >
<input type='hidden' name='<%=SearchForm.SEARCH_LIST_CODES %>' value='<%=pageProcessor.getSearchListAttributeValues("code") %>' >
<input type='hidden' name='<%=SearchForm.SEARCH_LIST_NAMES %>' value='<%=pageProcessor.getSearchListAttributeValues("name") %>' >
<input type='hidden' name='<%= SearchForm.ADD_SEARCH_FORM_TREE %>' value='' >
<input type='hidden' name='<%= SearchForm.TREE_SELECTION_OBJECT %>' value='' >
<%= pageProcessor.getHiddenFields()%>	
<tr><td><%= pageProcessor.getTableControl()%></td></tr>
</FORM>
</table>

<%-- LOCATION of inc_action_bar.jsp for IE --%>
<script language='javascript'>// array of RULER_IMG names
<%= pageProcessor.getTableControl().getJSArrayOfRulerImageNames()%>
// array of contents to place into cells
<%= pageProcessor.getTableControl().getJSArrayOfHeaderContents()%>

var numberOfItems	= <%=  pageProcessor.getData() != null? pageProcessor.getData().length: 0 %>;
var elementIds		= '<esapi:js><%=pageProcessor.getDataIds()%></esapi:js>';
</script>

<%@ include file="../../include/inc_action_bar.inc" %>
<%-------------------------------------------%>

<%@ include file="../../include/bottom.inc"%>
<%@ include file="../../include/tail.inc"%>
</body>

</html>
