<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.Struct.WrapperObjectStruct" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.Utility.Query.*" %>
<%@ page import="com.avinamart.WebInterface.tree.EPassTree"%>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*"%>
<%@ page import="com.avinamart.Utility.Exception.*"%>
<%@ page import="com.emptoris.app.ojeu.webClient.model.NoticeAnnexbPageBean"%>
<%@ page import="com.avinamart.WebInterface.forms.sequencer.StructsSequencer" %>
<%@ page import="com.emptoris.framework.attribute.common.constant.AttributeDefDataType"%>
<%@ page import="com.emptoris.app.ojeu.common.struct.NoticeLotStruct"%>

<%-- JSP Head --%>
<%@ include file="../../include/simple_head.inc"%>

<%
	String CREATE_LOT_URL = ref.getUserPath()+JSP.NOTICE_DETAIL_LOT  + "?" + EPASSJSPActions.ACTION + "=" + EPASSJSPActions.CREATE_VIEW;
	String FORM_NAME = "annexbForm";
	NoticeAnnexbPageBean bean = (NoticeAnnexbPageBean)
							request.getAttribute(AbstractUIBean.REQUEST_ATTRIBUTE_NAME);
	NoticeLotStruct[] lots = bean.getLots();
	String actionBarTitle = ref.convertLiteral(TITLE);
	if (lots!=null)
		actionBarTitle+="("+lots.length+")";
	EPASSToolbarItems toolbar = new EPASSToolbarItems(ref);
    Object actionBarButtons = getToolBar(ref, toolbar, bean, lots);
    String defaultSortColumn = NoticeLotStruct.SEQUENCE; 
    
    boolean isMultipleOOCs = bean.isMultipleOOCs();
    if (isMultipleOOCs)
    	defaultSortColumn = NoticeLotStruct.CONTRACT_OBJECT_ID;

    EPASSTableViewControl lotTable = new EPASSTableViewControl(ref,
 			   					  FORM_NAME,
 	                              JSP.WIZ_NOTICE_ANNEXB,           // current JSP name
 	                             ref.getUserPath() + JSP.NOTICE_DETAIL_LOT,
 	                              false,
 	                              createTableModel(ref,isMultipleOOCs), // table model data
 	                              lots, // table data
 	                              JSP.WIZ_NOTICE_ANNEXB,// key for the saving current
 	                              null,        // with buttons (create/delete)
 	                              defaultSortColumn, // default column for sort
 	                              ref.getCollator(), // clollator for case insensetive sorting
 	                              true, // ascending sort order
 	                              true, // late building
 	                              true, // without scroller
 	                              true,  // headers are clickable
 	                              false);

    	lotTable.addTieBreaker( NoticeLotStruct.SEQUENCE, null);
    	//lotTable.setEPASSTablePostScrollCallback(new  PostScrollCallback( ref));
    	lotTable.setSortAfterPostScroll(false);	// dont sort again!
 	    lotTable.setDisplayNullRows(true);
 	    lotTable.constructTable();
%>

<%!
final String TITLE = "ojeu.annaxb.title";

 ArrayList createTableModel(EPASSReferences ref, boolean isMultipleOOCs) throws EPASSApplicationException
{
	final ArrayList<EPASSTableColumnModel> tableModelData = new ArrayList<EPASSTableColumnModel>();
	EPASSTableColumnModel columnId = new EPASSTableColumnModel("&nbsp;", EPASSTableColumnModel.CHECK_BOX, NoticeLotStruct.ID);
	columnId.setLabel(ref.convertLiteral("form.terminology.column.headers.checkbox"));
	columnId.setRequiredColumn(Boolean.TRUE);
	columnId.setAttribute("width", "1%");

	EPASSTableColumnModel column = null;
	column = new EPASSTableColumnModel("",
									EPASSTableColumnModel.DETAIL_LINK,
	            						NoticeLotStruct.SEQUENCE);
    column.setAttribute("width", "1%");
    column.setDataType(AttributeDefDataType.INTEGER_TYPE);
    column.setDetailLinkIDSource( columnId );
    column.setPopupType(1 );
    column.setPopupWidth(900);
	column.setPopupHeight(830);
    tableModelData.add(column);
	
    if(isMultipleOOCs)
    {
    	
    	column = new EPASSTableColumnModel("&nbsp;", 
    			EPASSTableColumnModel.STRING_LABEL, 
    			NoticeAnnexbPageBean.CONTRACT_TITLE);
    	column.setHidden( true );
    	tableModelData.add( column );
    	
    	column = new EPASSTableColumnModel(ref.convertLiteral("ojeu.form.lot.label.contract_title"),
    			EPASSTableColumnModel.PLAIN_HTML,
    			NoticeAnnexbPageBean.CONTRACT_LINK);
    	column.setAttribute("width", "3%");	
    	column.setAllowNBSPName( false );
    	column.setCanSortColumn(true);
    	column.setColumnToSortOn(NoticeAnnexbPageBean.CONTRACT_TITLE);
    	tableModelData.add(column);
    }    
    
	/*column = new EPASSTableColumnModel(ref.convertLiteral( "ojeu.form.lot.no.hdr"),
	            						EPASSTableColumnModel.STRING_LABEL,
	            						NoticeLotStruct.NUMBER);
    column.setAttribute("width", "2%");
    column.setDataType(AttributeDefDataType.INTEGER_TYPE);
    tableModelData.add(column);
	
	column = new EPASSTableColumnModel(ref.convertLiteral( "ojeu.form.lot.title"),
										EPASSTableColumnModel.DETAIL_LINK,
										NoticeLotStruct.TITLE);
	 column.setAttribute("width", "10%");
	 column.setDetailLinkIDSource( columnId );
	 column.setPopupType(1 );
	 column.setPopupWidth( 900 );
	 column.setPopupHeight( 600 );
	 column.setAllowNBSPName( false );
	 column.setContextWindowName( "top" );
	 column.setCurrNavContextPrefix( "rit" );
	 column.setClrNavContextPrefixes( new String[]{"bid"} );
	 tableModelData.add(column);*/
	 
	column = new EPASSTableColumnModel(ref.convertLiteral( "ojeu.form.lot.no.hdr"),
	EPASSTableColumnModel.DETAIL_LINK,
	NoticeLotStruct.NUMBER);
	column.setAttribute("width", "5%");
	column.setDetailLinkIDSource( columnId );
	column.setPopupType(1 );
	column.setPopupWidth( 900 );
	column.setPopupHeight( 600 );
	column.setAllowNBSPName( false );
	column.setContextWindowName( "top" );
	column.setCurrNavContextPrefix( "rit" );
	column.setClrNavContextPrefixes( new String[]{"bid"} );
	tableModelData.add(column);
	
	column = new EPASSTableColumnModel(ref.convertLiteral( "ojeu.form.lot.title"),
			EPASSTableColumnModel.STRING_LABEL,
			NoticeLotStruct.TITLE);
	column.setAttribute("width", "10%");
	tableModelData.add(column);
	 
	 
	 if(!ref.isReadOnly())
		 tableModelData.add(columnId);
	return tableModelData;
}        

 EPASSToolbarItems getToolBar(EPASSReferences ref, EPASSToolbarItems toolbar, NoticeAnnexbPageBean bean, NoticeLotStruct[] lots)
	throws EPASSApplicationException
 {
	 if(!ref.isReadOnly())
	 {	
		 if (bean.isCreateButtonVisible()) { 
			 addCreateLotButton(toolbar,ref);
	 	 }
		 if (lots != null && lots.length > 0) {
			addDeleteButton(toolbar,ref);
		 }
	 }
	return toolbar;
 }
 void addCreateLotButton(EPASSToolbarItems toolbar, EPASSReferences ref)
	throws EPASSApplicationException
 {
    String buttonPath = ref.getUserPath()+Dir.IMG_BTNS_UP+Image.ADD_LOT_BUTTON_UP;
    toolbar.addControl( EPASSButtonDivControl.getSingleTaskTextButton( ref
				  , "createLotId"
				  , ref.convertLiteral("form.listLot.button.add_lot")
				  , "doCreateLot()"
				  , ref.convertLiteral("form.listLot.tooltip.add_lot") ).toString() );
 }
 void addDeleteButton(EPASSToolbarItems toolbar, EPASSReferences ref)
	throws EPASSApplicationException
{ 
     String deleteToolTip = ref.convertLiteral("form.listLot.tooltip.delete_lot");
     String buttonPath = ref.getUserPath()+Dir.IMG_BTNS_UP+Image.DELETE_UP_BUTTON;
     toolbar.addControl( EPASSUiJSPServices.makeButton(ref,
                            "doDelete()",
                            false,
                            buttonPath,
                            deleteToolTip
                            ) + ""
                            );
 }

%>


<%
//if(bean.isNotifyOfUpdate())
if( true )
{
	String res = TreeWizUtility.getTreeFireEventJs(ref);
	if( !StringUtility.isEmpty( res ) )
	{
		out.write("<script>");
   		out.write( res );
		out.write("</script>");
		out.flush();

	   	return;
	}
}
%>
<%
	String arrayOfHeaderContent = lotTable.getJSArrayOfHeaderContents();
%>
<%--
    StyleSheets and Javascript
--%>
<%@page import="java.util.Collection"%>
<%@page import="com.emptoris.app.ojeu.common.constant.NoticeType"%>
<%@page import="com.avinamart.Struct.StructComparator"%>
<%@page import="java.util.Arrays"%>
<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<head>
<title><esapi:html><%=  ref.convertLiteral( "epass.title" )%></esapi:html></title>
<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION %>'></SCRIPT>
<%-- Navigation utility that supply all frame services --%>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.ACTIONBAR %>'></SCRIPT>
<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_LIST_SEARCH%>'></SCRIPT>

<script>
var NAV_LIST='<%= ContextCodes.NOTICE%>';
var NAV_DEP ="";
var misc_selected_object = '<%= Misc.SELECTED_OBJECT%>';
//-------------------------------------------------------------------------------
//this is called when the Cancel Search button is clicked
function submitReset ()
{
        <%-- enhancement #25207 --%>
        NAV_FireEvent( top, '_reset_prod_search_', '' );

        var actionField = document.<%= FORM_NAME%>.<%=  EPASSJSPActions.ACTION %>;
        actionField.value = <%= EPASSJSPActions.DEFAULT_VIEW %>;
        document.<%= FORM_NAME%>.submit ();
}

//-------------------------------------------------------------------------------

function NAV_HandleEvent(var1, var2)
{
	if( var1 == "<%= EPassTree._sNavigationEvent%>" )
	{
		<%= EPassTree.getNotificationEventJSFunctionCall( EPassTree._sOnNodeExternalySelectedEvent, "var2", "''" )%>
	}
}

function doCreateLot()
{
	NAV_Popup( top, 1, '<%= ref.encodeURL(CREATE_LOT_URL)%>', 600, 900 );
}



function doDelete()
{
    if( EPASSCheckbox.checkRequired(
        document.<%= FORM_NAME%>.<%=  Misc.SELECTED_OBJECT %>,
        "<%= ref.convertLiteral("form.listLot.select_delete")%>"))
    {
        if(confirm('<%=  ref.convertLiteral("form.annexb_listLot.message.delete_lot_confirm")%>'))
        {
            document.<%= FORM_NAME%>.<%= EPASSJSPActions.ACTION%>.value = <%= EPASSJSPActions.DELETE%>;
            document.<%= FORM_NAME%>.submit();
        }
    }
}

function viewObjectOfContract(contractId)
{
	var contractUrl;
		contractUrl = "<%=  ref.encodeURLwUP(JSP.WIZ_OBJECT_CONTRACT_PIN+"?") %>"
			+ "&"+ "<%= EPASSJSPActions.ACTION %>" + "=" + <%= EPASSJSPActions.READ_VIEW %>
			+ "&" + "<%= ServletBase.CURRENT_ID%>" + "="
			+ contractId;	
		NAV_Popup( top, -1, contractUrl, 700 , 900);
}
top.showmaxbtn = "false";
top.showScrollBtn = "false";
        
</script>

</head>

<%-- HTML BODY --%>
<body onload="init();" onResize="nsResize();" marginleft="0" marginheight="0" marginwidth="1" rightmargin="2" topmargin="0" leftmargin="0">
<%@ include file="../../include/inc_actionbar_spacer.inc" %>
<table width="100%" cellpadding=0 cellspacing=0 border=0 >
<FORM name="<esapi:htmlatt><%= FORM_NAME %></esapi:htmlatt>" METHOD="POST" ACTION="<%= JSP.WIZ_NOTICE_ANNEXB%>" >
<INPUT type="hidden" name=<%= EPASSJSPActions.ACTION%> value="" >
<tr>
<td colspan=2>
<%=lotTable.toString()%>
</td>
</tr>
<input type="hidden" name="<%=  TreeWizUtility.NEXT_PAGE_PARAMETER %>" value="">	
</FORM>

</table>
<%@ include file="../../include/inc_action_bar.inc" %>
<%@ include file="../../include/bottom.inc"%>

</body>

</html>

<%@ include file="../../include/simple_tail.inc"%>
