<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page info="Administrator Organization Management" session="true" %>
<%@ page import="com.avinamart.Struct.BusinessUserStruct,
                 com.avinamart.Utility.EPASSConfig" %>
<%@ page import="com.avinamart.Utility.Exception.EPASSApplicationException" %>
<%@ page import="com.avinamart.Utility.SystemException" %>
<%@ page import="com.avinamart.WebInterface.Constants.ContextCodes" %>
<%@ page import="com.avinamart.WebInterface.Constants.Image" %>
<%@ page import="com.avinamart.WebInterface.Constants.JSP" %>
<%@ page import="com.avinamart.WebInterface.Constants.Javascript" %>
<%@ page import="com.avinamart.WebInterface.Constants.Misc" %>
<%@ page import="com.avinamart.WebInterface.Constants.Nav" %>
<%@ page import="com.avinamart.WebInterface.EPASSJSPActions" %>
<%@ page import="com.avinamart.WebInterface.EPASSReferences" %>
<%@ page import="com.avinamart.WebInterface.EPASSUiAdminServices" %>
<%@ page import="com.avinamart.WebInterface.EPASSUiApprovalHelpServices"%>
<%@ page import="com.avinamart.WebInterface.EPASSUiContractServices"%>
<%@ page import="com.avinamart.WebInterface.EPASSUiJSPServices"%>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.EPASSImageControl"%>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.EPASSTableColumnModel"%>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.EPASSTableViewControl"%>
<%@ page import="com.avinamart.WebInterface.tree.EPassTree"%>
<%@ page import="java.util.ArrayList"%>
<%@ page import="com.emptoris.framework.ui.model.clientInterface.*" %>
<%@ page import="com.emptoris.framework.workflow.common.struct.*" %>
<%@ page import="com.emptoris.framework.workflow.common.key.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.emptoris.framework.authorization.common.constant.InvitationType" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.EPASSDHTMLSelect" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.EPASSInputControlInterface" %>
<%@ page import="org.owasp.esapi.ESAPI" %>
<%@ include file="../../include/simple_head.inc" %>

<%!
    final String strFormName = "notice_team_list"; 
	final String NO_LINK_COLUMN = BusinessUserStruct.LASTNAME + EPASSTableModel.NO_LINK;
%>

<%	
	WizNoticeListTeamBean bean = (WizNoticeListTeamBean)request.getAttribute(AbstractUIBean.REQUEST_ATTRIBUTE_NAME);
	boolean canUpdate = bean.canUpdateNotice();
    BusinessUserStruct[] arrInvitedUsers = bean.getInvitedUsers();
 
    ArrayList<EPASSTableColumnModel> usrTableModel =  new ArrayList<EPASSTableColumnModel>();
    EPASSTableColumnModel column   = null;
    EPASSTableColumnModel columnID = null;
    
    //----------------------------
    // Last name
    columnID = new EPASSTableColumnModel( Nav.SPACE,
                                   EPASSTableColumnModel.CHECK_BOX,
                                   BusinessUserStruct.ID );

    column = new EPASSTableColumnModel( ref.convertLiteral("form.list_usr.header.last_name"),
                                   EPASSTableColumnModel.DETAIL_LINK,
                                   BusinessUserStruct.LASTNAME);
    column.setContextWindowName( Nav.TOP );

    column.setPopupType( new Integer( 1 ) );
    column.setPopupWidth( new Integer( 640 ) );
    column.setPopupHeight( new Integer( 600 ) );
    column.setJSPAction(new Integer(EPASSJSPActions.READ_VIEW));

    column.setDetailLinkIDSource( columnID );
    column.setLabelTruncation(25);
    usrTableModel.add( column );

    //-----------------------------
    // First name

    column = new EPASSTableColumnModel( ref.convertLiteral("form.list_usr.header.first_name"),
                                      EPASSTableColumnModel.STRING_LABEL,
                                      BusinessUserStruct.FIRSTNAME );
    column.setLabelTruncation(25);
    usrTableModel.add( column );

    //-----------------------------
    // User Roles
    column = new EPASSTableColumnModel( ref.convertLiteral("form.list_usr.header.role"),
                                      EPASSTableColumnModel.STRING_LABEL,
                                      "ROLE" );
    column.setLabelTruncation(35);
    usrTableModel.add( column );

    //-----------------------------
    // Operating group
    column = new EPASSTableColumnModel( ref.convertLiteral("form.list_usr.header.business_unit"),
                                      EPASSTableColumnModel.PLAIN_HTML,
                                      BusinessUserStruct.BUSINESSUNIT );
    column.setLabelTruncation(25);
    column.setColumnToSortOn(EPASSUiAdminServices.BUSINESS_UNIT_SORT);
    usrTableModel.add( column );


    //-----------------------------
    // access
    column = new EPASSTableColumnModel( ref.convertLiteral("form.list_usr.header.access"),
                                      EPASSTableColumnModel.STRING_LABEL,
                                      "INVITEACCESS" );
    column.setLabelTruncation(25);
    usrTableModel.add( column );
	if(canUpdate)
    usrTableModel.add ( columnID );
    
    
        // need to check the authorization for each record and set the check box attribute accordingly
    if (arrInvitedUsers != null) {
        for (int i=0; i < arrInvitedUsers.length; i++) {
            Integer invitationType=(Integer)arrInvitedUsers[i].getAttribute(BusinessUserStruct.INVITATIONTYPE);
            String strInviteAccess = ref.convertLiteral("form.list_usr.header.manual");
            if (invitationType != null) {
                if (!InvitationType.isRevokable(invitationType)) {
                    arrInvitedUsers[i].setAttribute( EPASSTableModel.IS_INDIVIDUAL_CHECK_BOX_DISABLED, new Boolean(true) );
                }
                if (InvitationType.isImplicit(invitationType)) {
                    strInviteAccess = ref.convertLiteral("form.list_usr.header.automatic");
                }
            }
            arrInvitedUsers[i].setAttribute("INVITEACCESS", strInviteAccess);
            arrInvitedUsers[i].setAttribute ( "ROLE", EPASSUiAdminServices.findRoleDisplayCode ( ref, arrInvitedUsers [ i ] ) );
            if(arrInvitedUsers[i].getAttribute(NO_LINK_COLUMN)==null){
            	boolean canView = EPASSUiAdminServices.canViewUserProfile(ref, arrInvitedUsers[i].getId());
				if(!canView)
					arrInvitedUsers[i].setAttribute(NO_LINK_COLUMN, EPASSTableModel.NO_LINK);
            }
        }
    }
    
    EPASSTableViewControl usrTable = new EPASSTableViewControl ( ref
                                                                 , null
                                                                 , ref.getUserPath () + "ojeu/jsp/wiz_notice_list_team.jsp"
                                                                 , ref.getUserPath () + JSP.ADMIN_USR_DETAIL_PAGE
                                                                 , !canUpdate
                                                                 , usrTableModel
                                                                 , arrInvitedUsers
                                                                 , "USR_VIEW_CONTEXT"
                                                                 , null
                                                                 , BusinessUserStruct.LASTNAME
                                                                 , ref.getCollator ()
                                                                 , true
                                                                 , true
                                                                 , true
                                                                 , true );
    usrTable.setParentContext ( ContextCodes.ORGANIZATION );
    usrTable.constructTable ();

	EPASSButtonDivControl inputCTRL = null;


	
	

	String displays[] = { ref.convertLiteral ( "form.list_usr.filter.manually_invited" ),
						ref.convertLiteral ( "form.list_usr.filter.auto_invited" ), 
						ref.convertLiteral ( "form.list_usr.filter.all_invited" ) };
	
	String values[] = {bean.INVITE_MANUAL.toString() ,bean.INVITE_AUTO.toString() ,bean.INVITE_ALL.toString() };
 	
	
	                                  		
	EPASSDHTMLSelect filter =   new EPASSDHTMLSelect( ref, "_view_users_filter_",values,displays ,bean.getFilterValue(),
											    			  "NAV_ReloadWithFilter(window , this );");                                   		

	EPASSInputControlInterface icInterface = filter;		                               
			toolbarItems.addControl( icInterface );
			
	
	if(bean.canAddTeamMembers())
	{
		inputCTRL = EPASSButtonDivControl.getSingleTaskTextButton( ref
				  , "AddMemberId"
				  , ref.convertLiteral("form.wiz_notice_list_team.button.add_member")
				  , "void assignTeamMembers()"
				  , ref.convertLiteral("form.wiz_notice_list_team.tooltip.add_member") );

	    toolbarItems.addControl ( inputCTRL );
	
	}
	
	if(bean.canRemoveTeamMembers())
	{
      	inputCTRL = EPASSButtonDivControl.getSingleTaskImageButton( ref 
        			, "DelMemberId"
        			, ref.getUserPath() + Dir.IMG_BTNS_UP   + Image.DELETE_UP_BUTTON
        			, "void removeTeamMember(this)"
        			, ref.convertLiteral("form.wiz_notice_list_team.tooltip.delete_member") );
	
	   toolbarItems.addControl( inputCTRL );
	}
	
    

   String listTitle = ref.convertLiteral ( "form.wiz_notice_list_team.title" );
   if ( arrInvitedUsers != null )
   {
   	listTitle += " (" + arrInvitedUsers.length + ")";
   }

   String actionBarTitle = listTitle;
   Object actionBarButtons = toolbarItems;
%>

<%@page import="com.emptoris.app.ojeu.webClient.model.WizNoticeListTeamBean"%>
<%@page import="com.avinamart.WebInterface.Utility.HTML.EPASSButtonDivControl"%>
<%@page import="com.avinamart.WebInterface.Utility.HTML.EPASSTableModel"%>
<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<HEAD>
	<TITLE><esapi:html><%=  ref.convertLiteral("epass.title")%></esapi:html></TITLE>
	<link rel="stylesheet" href="<%= request.getContextPath()%>/css/epass.css" />
	<link rel="stylesheet" type="text/css" href="<%=ref.getUserPath()%>branding/jsp/branding.jsp"/>
	<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_CHECKBOX%>'></SCRIPT>
	<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.EPASS_FORMVALIDATION%>'></SCRIPT>
	<%-- Navigation utility that supply all frame services --%>
	<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.NAV%>'></SCRIPT>
	<%-- Utilities needed for DHTML and floating action bars --%>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.DHTMLLIB%>'></SCRIPT>
    <SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + Javascript.ACTIONBAR%>'></SCRIPT>
	<SCRIPT LANGUAGE="JavaScript" SRC='<%=  ref.getUserPath() + Dir.JS + "epass_select.js" %>' ></SCRIPT>

	<script language='javascript'>
    var NAV_LIST='<%= ContextCodes.BUSINESSUSER %>';
    var NAV_DEP='';
    top.showmaxbtn = "false";
    top.showScrollBtn = "false";

	// array of RULER_IMG names
	// array of contents to place into cells
	<%= usrTable.getJSArrayOfHeaderContents()%>

	function assignTeamMembers ( btn )
    {
		NAV_Popup ( top, -1, '<%= ref.encodeURLwUP ( "ojeu/jsp/frames_unassigned_members_notice.jsp" )%>', 500, 900 )
	}

	function removeTeamMember ( btn )
    {
        var bRetVal = false;
		if ( EPASSCheckbox.checkRequired ( document.<%= strFormName%>.<%=  Misc.SELECTED_OBJECT %>, '<%=  ESAPI.encoder().encodeForJavaScript(ref.convertLiteral ( "form.list_usr.message.select_delete" )) %>' ) )
        {
           var conf = confirm ( '<%=  ESAPI.encoder().encodeForJavaScript(ref.convertLiteral ( "form.list_usr.message.delete_confirm" )) %>' );
           if ( conf )
           {
	  		  document.<%= strFormName%>.<%= EPASSJSPActions.ACTION%>.value='<%= EPASSJSPActions.DELETE%>';
	  		  document.<%= strFormName%>.action="<%= ref.getUserPath()%>ojeu/jsp/wiz_notice_list_team.jsp";
              document.<%= strFormName%>.submit();
              bRetVal = true;
           }
		}
        return bRetVal;
	}

    function isAllLeadsRemoved ()
    {
        var bRetVal = false;
        alert('All Leads are removed');
        return false; //TODO
    }

    function NAV_HandleEvent(var1, var2)
    {
        if( var1 == "<%= EPassTree._sNavigationEvent%>" ){
            <%= EPassTree.getNotificationEventJSFunctionCall( EPassTree._sOnNodeExternalySelectedEvent, "var2", "''" )%>
        } else  {
            document.<%= strFormName %>.submit();
        }
    }


	function unapprove()
	{
		alert('Unapprove');
	}

	function NAV_HandleQuery_list_notice_team(evName,srchParams)
	{
		var thisPage = PAGE_HREF.split('?')[0];	
		location = thisPage + '?' + srchParams;
	}

    </script>

</HEAD>

<body onload="init();" onResize="nsResize();" marginleft="0" marginheight="0" marginwidth="1" rightmargin="2" topmargin="6" leftmargin="0">
<%@ include file="../../include/inc_action_bar.inc"%>
<%@ include file="../../include/inc_actionbar_spacer.inc" %>

<table width="100%" cellpadding=0 cellspacing=0 border=0 >
<form name="<%= strFormName%>" METHOD="POST"  ACTION="<%= ref.getUserPath()%>ojeu/jsp/wiz_notice_list_team.jsp">
	<tr>
        <td colspan=2>
        <%= usrTable%>
        </td>
    </tr>
	<input type="hidden" name="<%= EPASSJSPActions.ACTION%>" value="<%= EPASSJSPActions.READ_VIEW%>" >    
</form>
</table>


<script>
	function showBUList(userId)
	{

		var url = '<%= ref.getUserPath()%>list_business_unit.jsp?_eps_=Y&jspAction=1&_isRFXWizardParam_=0&control_mode=5&is_popup=true' + '&' + 'cur_id' + '=' + userId ;

		NAV_Popup(top, -1, url, 500, 675);
	}
</script>

</BODY>
</HTML>

<%@ include file="../../include/simple_tail.inc" %>
