<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>

<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%-- +---------------------------------------------------------------------------
	Import EPASS/JAVA Packages
---------------------------------------------------------------------------+ --%>
<%@ page import="java.sql.*" %>
<%@ page import="java.util.*" %>
<%@ page import="com.avinamart.ApplicationServices.*" %>
<%@ page import="com.avinamart.BusinessLogic.Key.*" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.*" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.WebInterface.Constants.*" %>
<%@ page import="com.avinamart.Utility.*" %>
<%@ page import = "com.avinamart.Utility.Exception.*" %>
<%@ page import="com.avinamart.WebInterface.Utility.HTML.*" %>
<%@ page import="com.avinamart.Struct.*" %>
<%@ page import="org.owasp.esapi.ESAPI" %>


<%-- +---------------------------------------------------------------------------
	Include Head
		- This file is used for initalizing an object called EPASSReference
		  which (among other things) holds references to the user data context
		  information and service wrappers used in this page. 
---------------------------------------------------------------------------+ --%>

<%@ include file="include/head2.inc" %>	

<%!

public String cvt(EPASSReferences ref, String key ) throws Exception {
	return ref.convertLiteral( "form.popupCalendarJs.popcal." + key);
}

%>

<html lang="<%= (request.getAttribute("PREFERRED_LANGUAGE_CODE")!=null ? request.getAttribute("PREFERRED_LANGUAGE_CODE") : "EN") %>">
<HEAD>

<SCRIPT LANGUAGE="JavaScript"><!--

// Global Variables
var d = new Date();
var today = d.getDate();  // Determines today's date to be used for calendar color coding

/*******************************************************/
/*  Calendar Config Section                           
*/

//  COLORS
var blankcolor = "<%= cvt(ref, "blankcolor") %>";		// color for background of window
var nodatecolor= "<%= cvt(ref, "nodatecolor") %>";		// color for dates not in current month
var linkcolor  = "<%= cvt(ref, "linkcolor") %>";		// link color for weeklastDayOfMonth
var wlinkcolor = "<%= cvt(ref, "wlinkcolor") %>";		// link color for weekends
var daycolor   = "<%= cvt(ref, "daycolor") %>";			// background color for weeklastDayOfMonth 
var tdaycolor  = "<%= cvt(ref, "tdaycolor") %>";		// background color for today
var calcolor   = "<%= cvt(ref, "calcolor") %>";			// border color of calendar

//  FONTS
var calfont    = "<%= cvt(ref, "calfont") %>";			// types of fonts
var calfontsize= "<%= cvt(ref, "calfontsize") %>";		// default size of calendar font
var headsize   = "<%= cvt(ref, "headsize") %>";			// size of header date
var headcolor  = "<%= cvt(ref, "headcolor") %>";		// color of header date
var tlinkcolor = "<%= cvt(ref, "tlinkcolor") %>";		// color of today link

/* end config */
/********************************************************/


function calendar(Month,Year) {    	
	var output = '';
    
    // Build Root Table and ListBox Table and Month/Year Display 
	output += '<TABLE BGCOLOR="' + blankcolor + '" BORDER=0 WIDTH=250 HEIGHT=254><FORM NAME="Cal"><TR><TD ALIGN=LEFT>';
    output += '<FONT COLOR="' + headcolor + '" FACE="' + calfont + '" SIZE=' + headsize + '>' + namesOfMonth[Month] + ' ' + Year + '<\/FONT><\/TD><TD ALIGN=RIGHT>';
    output += '<SELECT NAME="Month" onChange="updateCalendar();">';

    // Build List Box of Months
	for (month=0; month<12; month++) {
		// alert("doesn: " + month + " = " + Month);
	        if (month == Month){
			output += '<OPTION VALUE="' + month + '" SELECTED>' + namesOfMonth[month] + '<\/OPTION>';
		} else {
			output += '<OPTION VALUE="' + month + '">'          + namesOfMonth[month] + '<\/OPTION>';
		}
	}

    output += '<\/SELECT><SELECT NAME="Year" onChange="updateCalendar();">';

    // Build List Box of Years
	for (year=1900; year<2100; year++) {
        if (year == Year) output += '<OPTION VALUE="' + year + '" SELECTED>' + year + '<\/OPTION>';
        else              output += '<OPTION VALUE="' + year + '">'          + year + '<\/OPTION>';
    }

    output += '<\/SELECT><\/TD><\/TR><TR><TD ALIGN=CENTER COLSPAN=2>';

    firstDay = new Date(Year,Month,1);
    startDay = firstDay.getDay();

    // Handle Leap Year for February
	if (((Year % 4 == 0) && (Year % 100 != 0)) || (Year % 400 == 0))
         lastDayOfMonth[1] = 29; 
    else
         lastDayOfMonth[1] = 28;
		 
	// Build Table wrapper of calendar which creates a border effect 
	output += '<TABLE CELLSPACING=0 CELLPADDING=1 BORDER=0><TR><TD bgcolor="#050e5f">';
 
    // Build actual calendar table
	output += '<TABLE CELLSPACING=1 CELLPADDING=0 BORDER=0><TR bgcolor="#689ED6">';

    // Print Days of Week
	for (i=0; i<7; i++)
        output += '<TD WIDTH=50 ALIGN=CENTER VALIGN=MIDDLE><FONT SIZE=-1 COLOR="#ffffff" FACE="VERDANA,ARIAL,HELVETICA">' + dow[i] +'<\/FONT><\/TD>';

    output += '<\/TR><TR ALIGN=CENTER VALIGN=MIDDLE>';

    // Initialize Days of Month Columns
	var column = 0;
	var thislinkcolor= "";
	var thisdaycolor = "";
    var lastMonth = Month - 1;
    if (lastMonth == -1) lastMonth = 11;

    for (i=0; i<startDay; i++, column++)
        output += '<TD WIDTH=50 HEIGHT=30 BGCOLOR="' + nodatecolor + '"><FONT SIZE=-1 COLOR="#050ef5" FACE="VERDANA,ARIAL,HELVETICA">' + (lastDayOfMonth[lastMonth]-startDay+i+1) + '<\/FONT><\/TD>';

    for (i=1; i<=lastDayOfMonth[Month]; i++, column++) {
	
	if ((column == 0) || (column == 6)){ 
	thislinkcolor = wlinkcolor;
	}else{ 
	thislinkcolor = linkcolor ;
	}
	
	if ( i == today ) {
	thisdaycolor = tdaycolor ;
	} else { 
	thisdaycolor = daycolor ;
	}
		
        output += '<TD WIDTH=50 HEIGHT=30 bgcolor="'+ thisdaycolor + '">' + '<A HREF="#" ONCLICK="javascript:returnDate(' + i + ')"><FONT SIZE=-1 FACE="VERDANA,ARIAL,HELVETICA" COLOR="' + thislinkcolor + '">' + i + '<\/FONT><\/A>' +'<\/TD>';
        
		if (column == 6) {
            output += '<\/TR><TR ALIGN=CENTER VALIGN=MIDDLE>';
            column = -1;
        }
    }

    if (column > 0) {
        for (i=1; column<7; i++, column++)
            output +=  '<TD WIDTH=50 HEIGHT=30 BGCOLOR="' + nodatecolor + '"><FONT SIZE=-1 COLOR="#050ef5" FACE="VERDANA,ARIAL,HELVETICA">' + i + '<\/FONT><\/TD>';
    }

    output += '<\/TR><\/FORM><\/TABLE><\/TD><\/TR><\/TABLE><\/TD><\/TR><\/TABLE>';
	return output;
}

// Return Month to be used in calendar() output method
function getMyMonth() // If no month is supplied in the URl, the 
{
	var myMonth = getValueFromName('month');
	// alert("The month is: " + myMonth + " "  + typeof(myMonth));
	if (""+myMonth != "false")
		myMonth = myMonth;
	else
	{
		// return current month
		// alert("no go!");
		var myDate = new Date();
		myMonth = myDate.getMonth();
	}		
	
	return myMonth;
}

// Return Year to be used in calendar() output method
function getMyYear() // If no year is supplied the systems year will be used
{
	var myYear = getValueFromName('year');
	if (myYear != false)
		myYear = myYear;
	else
	{
		// return current month
		var myDate = new Date();
		myYear = myDate.getYear();
	}		
	
	// Make sure date is 4 digits, not compatible in the year 3000 :)
	if (myYear.length < 4)
		myYear = '20' + myYear.toString();
	
	// Y2K check
	myYear = y2k(myYear);
	
	return myYear;
}

// Return String representation of field value on calling page that will receive date value (it is passed around in the URL)
function getFieldName()
{
	var myField = getValueFromName('callerDateFieldAsString');
	return myField;
}

// Return String representation of field value on calling page that will receive date value (it is passed around in the URL)
function getHoursFieldName()
{
	var myDayField = getFieldName();
	var myHoursField = myDayField.replace("_textDate","_listHourMinute");
	return myHoursField;
}




// Get Value from Name in QueryString
function getValueFromName(name)
{
	var myName = name;
	var myQueryString = location.search;
	var myValue = false;

	// Look for name/value pair
	var xResult = myQueryString.search(myName);
	
	// Find next '&' after name or use end of string
	var xEndAt = myQueryString.indexOf('&',xResult);
	if (xEndAt < 1) {xEndAt = myQueryString.length;}
	
	
	if (xResult > 0)
	{	
		// Query string will look like this, so not gonna use split() since that would require that month and year be passed in particular order
		// ?month=10&year=2001
		myValue = myQueryString.slice(xResult+name.length+1,xEndAt);					
	}	
	// alert("Here: " + name + "@" + xResult + " = " + myValue);
	
	return myValue;
}


<%//Return Selected Date to Calling Page 
//There are two modes of returning the date.
//If the request parameter is name 'openerFunction', the calndar is supposed to call
//that function and pass the return date to it. Otherwise it passes the dates to the
//date time control of the opener page%>

function returnDate(myDay) 
{	

	var myMonth = document.Cal.Month.options[document.Cal.Month.selectedIndex].value;
	var myYear 	= document.Cal.Year.options[document.Cal.Year.selectedIndex].value;
	 var myDate = new Date( myYear.valueOf(), myMonth.valueOf(), myDay.valueOf() );

<%
String strParam = ref.req.getParameter ( "openerFunction" );
boolean bFunctionMode = !StringUtility.isEmpty( strParam );
%> 
	var functionMode = <%= bFunctionMode %>;
	
	if(functionMode){
		returnDateToFunction(myDate);
	}
	else{
		returnDateToControl(myDate) 
	}
}

function returnDateToFunction(myDate){
	var openerFunction = eval('opener.' + '<esapi:js><%=ref.req.getParameter("openerFunction")%></esapi:js>');
	
	openerFunction( myDate);
	setTimeout("closeMe()",500)
	
}

function closeMe(){
	window.close();
}

function returnDateToControl(myDate) 
{	
	
	var oField = eval('opener.' + getFieldName());  // take object name of text box and apply the opening page pointer to it
	var hField = eval('opener.' + getHoursFieldName());
	
	var oEventfuction = opener.dateEventFunction;
	
	// Place date into textBox on calling page
	oField.value = i18n.dateToText( myDate );//stringDate;	
	
	
	if(hField.value == '') hField.value = "0:00";
	
	if (""+opener.EPASSInputControlDate_FixDate == "undefined"){
	} else {
		opener.EPASSInputControlDate_FixDate( getFieldName() );
	}
	
	<% //The event function must be performed AFTER the value is put in the hidden fields
	//by the lines above. Do not change the order!!!%>
	if(	oEventfuction){
		oEventfuction(getFieldName());
	}
	
	var oCalculateAllFormulas = opener.calculateAllFormulas;
	if(	oCalculateAllFormulas){
		oCalculateAllFormulas();
	}
	
	// if calling page has "SET_DURATION" defined then we need to call
	// calling page's calculateDuration to re-calculate the duration
	// when a date is selected in the calendar control
	if (typeof(opener.SET_DURATION) != "undefined"){
		if (""+opener.calculateDuration != "undefined") {
			opener.calculateDuration();
		}
	}
	
    self.close();
}

// Reload with new Month
function updateCalendar() {

    var myMonth = document.Cal.Month.options[document.Cal.Month.selectedIndex].value;
    var myYear = document.Cal.Year.options[document.Cal.Year.selectedIndex].value;

	// Strip of any querystring that me be in the location property
	var sLocation = location.toString();
	var aLocation = sLocation.split('?');
	var myLocation = aLocation[0];
	location.href = myLocation + '?month=' + myMonth + '&year=' + myYear + '&callerDateFieldAsString=' + getFieldName() + '&openerFunction=' + '<esapi:js><%=ref.req.getParameter("openerFunction")%></esapi:js>';


}

// Array Constructor
function makeArray0() {
    for (i = 0; i<makeArray0.arguments.length; i++)
        this[i] = makeArray0.arguments[i];
}

// Y2K for Netscape, not needed in IE
function y2k(number)    { return (number < 1000) ? number + 1900 : number; }

// Make arrrays used in month label, days in each month, and day of week label
var namesOfMonth    = new makeArray0(
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "January")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "February")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "March")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "April")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "May")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "June")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "July")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "August")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "September")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "October")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "November")) %>",
	"<%= ESAPI.encoder().encodeForJavaScript(cvt(ref, "December")) %>");
var lastDayOfMonth  = new makeArray0(31,  28 ,  31 ,  30 ,  31 ,  30 ,  31 ,  31 ,  30 ,  31 ,  30 ,  31 );
var dow       		= new makeArray0(
	"<%= cvt(ref, "Sun") %>",
	"<%= cvt(ref, "Mon") %>",
	"<%= cvt(ref, "Tue") %>",
	"<%= cvt(ref, "Wed") %>",
	"<%= cvt(ref, "Thu") %>",
	"<%= cvt(ref, "Fri") %>",
	"<%= cvt(ref, "Sat") %>");
//--></SCRIPT>

<TITLE><esapi:html><%= ref.convertLiteral("epass.title")%></esapi:html></TITLE>

</HEAD>
<body></body>
<SCRIPT LANGUAGE="JavaScript"><!--
document.write('<esapi:js><BODY BGCOLOR="' + blankcolor + '" TOPMARGIN=0 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0></esapi:js>');
document.write('<div align=center><center>');
document.write(calendar(getMyMonth(),getMyYear()));
document.write('<\/center><\/div>');
document.write('<\/BODY>')


//--></SCRIPT>


<%
//
// tail.jsp used by every page in system. Gives closure and cleanup.
//
%>
<%@ include file="include/tail.inc"%>

</HTML>
