<%--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
--%>
<%@ taglib prefix="esapi" uri="http://www.owasp.org/index.php/Category:OWASP_Enterprise_Security_API" %>
<%@ page language="java" pageEncoding="utf-8" contentType="text/html;charset=utf-8" %>
<%@ page import="com.avinamart.WebInterface.*" %>
<%@ page import="com.avinamart.Utility.EPASSConfig" %>
<%@ page import="com.avinamart.BusinessLogic.Constant.BusinessUserRole" %>
<%@ page import="com.emptoris.framework.organization.service.legacyInterface.OrganizationServiceIntf" %>
<%@ page import="com.avinamart.ApplicationServices.ServiceManager" %>
<%@ page import="com.avinamart.Struct.BusinessUserStruct" %>
<%@ page import="org.owasp.esapi.ESAPI" %>
<%@ include file="include/jsp_logging.inc" %>
<%
    /*
      - Need literal keyword text (e.g auction name or menu name as shown on ui; no db codes etc)
      - show be DATA based or epass COMMAND based
      - need action type
        - optional action url
        - optional action id
        - option javascript command
    */

    //
    // This request should come from an ajax call
    //
    response.setContentType("text/plain; charset=UTF-8");
    request.setCharacterEncoding("UTF-8");

    StringBuffer data = new StringBuffer("");
    if (EPASSConfig.getInstance().getBooleanParameter("epass.zissou.enable", true)) {

        EPASSReferences ref = new EPASSReferences(request, response, ServletBase.getSessionTracker().getSessionService(request));
        if (ref.userDataContext == null) {
            ref.userDataContext = new UserDataContext(null);
        }

        String q = ZissouSearch.replaceAllAsterix(request.getParameter("q"));
        ZissouSearch z = new ZissouSearch(ref, 5 /*max */);

        //if ( q.indexOf("@create") != -1) {
        //    z.setSpecialCommandData(data,q);
        //} else {

        z.setMenuCommandData(data, q);

		if( ref.getBusinessUserRole().equals(BusinessUserRole.spend_user)) {

        } else if ( ref.getBusinessUserRole().equals(BusinessUserRole.FSB)) {
            z.setSuppliersData(data, q);
            z.setMessageData(data, q);
        } else if (ref.isUserSeller()) {
            z.setRFxData(data, q);
            z.setMessageData(data, q);
        } else if ( ref.isUserBuyer() ) {
            z.setRFxStatusData(data, q);
            z.setRFxData(data, q);
            z.setSuppliersData(data, q);
            z.setProjectData(data, q);
            z.setBinderData(data, q);
            z.setMessageData(data, q);
            z.setCategoriesData(data, q);
            z.setNoticeData(data, q);
        } else if ( ref.isUserSystem() ) {
            z.setRFxData(data, q);
            z.setOrganizationData(data, q);
            z.setSuppliersData(data, q);
            z.setProjectData(data, q);
            z.setBinderData(data, q);
            z.setMessageData(data, q);
            z.setCategoriesData(data, q);
            z.setNoticeData(data, q);
        }

        // no results
        if (data.length() == 0) {

            // help
            String helpAlt = ref.convertLiteral("zissou.search.help_alt").replace("{0}", "");
            data.append((q.length() > 2) ? ref.convertLiteral("zissou.search.help_fewer_char") : helpAlt);

            // no results message
            data.append(":no_data").append(ZissouSearch.delimiter).append("{ id : '0', section: '").append(ESAPI.encoder().encodeForHTML(ref.convertLiteral("zissou.search.no_data")))
            	.append("', legend: '<img src=\"").append(request.getContextPath()).append("/dhtml_lib/img/happy_help_icon.gif\" style=\"margin-top:0px;\"align=\"top\" border=\"0\" />', className: 'no_data' }");
        }

    } // config enabled

    out.print(data.toString());
%>
