/** 
 * (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */ 

/*
   JavaScript functions to support detail_uda.jsp:
   IMPORTANT!!!
   In order to assure matching of variable names used here and the form's field names, which are
   generated in the Java IA classes, The Java classes in the ia.detailuda package define a method
   that writes variables declarations.The method is named DeclareJSVariables() and is called at
   the end of detail_uda.jsp to declare many of the variables used in this page. All the variables
   in this page which are declared this way are named with an ia_ prefix so they can easily be
   recognised (e.g. ia_codeField ).
   Avoid changing the names of such variables! If it has to be changed, a corresponding name change
   must also be made in the declaring Java method!!!
*/
//-----------------------------------------------------------------------------------------------
//The function is used to suppress peculiar browser action. Browsers submit forms automatically
//when there is only on Text type field on the form. This happens when the form is in the Controller
//mode, showing just the Name (TEXT) field, the description (TEXTAREA) and the data type (SELECT)
//fields. An event handler for onkeypress is added to the name fired to trap the ENTER key.


function supressSubmitOnEnter(evt) {
    var characterCode = navigator.appName == 'Netscape' ? evt.which : event.keyCode;
    return characterCode != 13; // 13 is the ENTER key, return false if pressed
}

// ---------------------------------------------------------------------------------------
// This function validates the name and makes sure that the reserved characters
// - $ " ' \ are not included in the name.


function onNameField(fld) {
    clearError(fld);
	if (_isEmpty(fld)) {
        return true;
    }

    var nameValue = fld.value;

    // Single quotes are replaced to an equivalent thast does not break
    // javascript strings
    var apostrRegex = new RegExp("'", "g");
    nameValue = nameValue.replace(apostrRegex, "\u2019");
    for (var i = 0; i < reservedChars.length; i++) {
        if (nameValue.indexOf(reservedChars[i]) > -1) {
        	showError(fld,reservedChars[i] + ' ~~form.detailUda.message.reserved_charcters~~');
            return false;
        }
    }
    fld.value = __trim(nameValue);
    // Whenever the name field changes, the code field is cleared. Code is
    // created anew from the name in processSaveAction() whenever there is no code in
    // the submitted form.
    //Update by Owen, we clear the code value only when the name filed value is changed.
    if(fld.defaultValue && fld.value!= fld.defaultValue){
        ia_codeField.value = '';
    }
    return true;
}

// ---------------------------------------------------------------------------
// This function makes any uda a required field when a default value is
// enterd.
// If default is deleted, ask for confirmation before removing the require
// demand

function checkRequiredField(fld) {

	clearError(fld);
    if (!applyDefaultRequiredRule) return;

    if (typeof ia_requiredField != 'undefined') {
        if (!_isEmpty(fld)) {
            ia_requiredField.checked = true;
            ia_requiredField.disabled = true;
        } else {
            ia_requiredField.disabled = false;
            alert('~~form.detailUda.message.uncheck_required~~');
        }
    }
}

// --------------------------------------------------------------------------
// Method to show/hide the input control for the ShowStopper cutoff score.


function setShowStopperCutoff() {
    var cutoffSpan = document.getElementById('showStopperCutoff');
    var hiddVarLowerRangeInclusive = document.getElementById('_uda_lowerRangeInclusive ');
    if (ia_isShowStopperField.checked) {
        cutoffSpan.style.display = "table-row";
        if(hiddVarLowerRangeInclusive){
        	hiddVarLowerRangeInclusive.value = 'true';
        }
    } else {
        cutoffSpan.style.display = "none";
        ia_showStopperCutoffField.value = '';
        if(hiddVarLowerRangeInclusive){
        	hiddVarLowerRangeInclusive.value = '';
        }
    }
}
// -----------------------------------------------------------------------------------
// The function sets the visibility description array


function setVisibilityDescriptions(descriptions) {
    ia_visibilityDescriptions = new Array();
    var args = setVisibilityDescriptions.arguments;
    for (var i = 0; i < args.length; i++) {
        ia_visibilityDescriptions[i] = args[i];
    }
}
// -----------------------------------------------------------------------------------
// The function sets the hidden visibility field, and updates
// the visibiilty description whenever the visibility setting changes


function setVisibilityField() {
    if (typeof (ia_visibilitySelect) == 'undefined' || ia_visibilitySelect.type != 'select-one') {
        return;
    }
    ia_visibilityField.value = getControlValue(ia_visibilitySelect, 'value');
    var sel = ia_visibilitySelect.selectedIndex;
    if (ia_VisibilityHelpDiv != null) {
        ia_VisibilityHelpDiv.innerHTML = ia_visibilityDescriptions[sel];
    }
    // Some IAs have additional tasks to perform when the visibility field
    // changes 
    onIASpecificVisibilityField();
}


// -----------------------------------------------------------------------------------------
// This function is needed only for List types but is rendered as general to
// avoid js error in other data types
function onUseInSearch() {
    ia_lastUseInSearchValue = ia_useInSearchField.checked;
}


// -----------------------------------------------------------------------------------------
// This function is needed only for List types but is rendered as general to
// avoid js error in other data types 
function onShowInTable() {
    ia_lastShowInTableValue = ia_showInTableField.checked;
}

// -----------------------------------------------------------------------------------------
// Date specific function (needed in order to get the event when the
// date is set by using the date time control (which does not trigger a CHANGE event in the
// control)


function dateEventFunction() {
    if (typeof ia_requiredField != 'undefined' && applyDefaultRequiredRule) {
        ia_requiredField.checked = true;
        ia_requiredField.disabled = true;
    }
}

// --------------------------------------------------------------------------------------
// --------------------------------------------------------------------------
// Return whether IntelligentAttribute is autoScored or not, handle read-only
// checkbox 


function isAutoScored() {
    var typ = getControlType(ia_autoScoredField);
    return (typ == 'hidden' && ia_autoScoredField.value == 'true') || (typ == 'checkbox' && ia_autoScoredField.checked);
}
