<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
  version="2.0" xmlns:saxon="http://saxon.sf.net/" 
  xmlns:localeHelper = "java:com.emptoris.framework.importExport.LocaleHelper"
	xmlns:xsltContext="java:com.emptoris.framework.importExport.service.clientInterface.EPASSXMLBasedXSLTContext"
	xmlns:ss="http://www.emptoris.com"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"		
	xmlns:xl="http://www.emptoris.com/if/spreadsheet/saxon/com.emptoris.framework.importExport.service.internal.translate.SpreadSheetXSLTExtensionClassFactory"
	exclude-result-prefixes="localeHelper xsltContext xl ss" extension-element-prefixes="saxon">
	
	<xsl:import href="ePASS2gXML_error_standalone.xsl" />
	<xsl:import href="ePASS2gXML/Common.xsl" />
	<xsl:import href="ePASS2gXML_Bid_RFI_new.xsl" />
	<xsl:import href="ePASS2gXML_Bid_RFQ_new.xsl" />
	<xsl:import href="ePASS2gXML_Bid_Auction_new.xsl" />
	
	<xsl:variable name="supplierItemCode" select="localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidSellerProductCode')" />
	<xsl:variable name="notAppValue" select="localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.NotApplicable')" />
	<xsl:variable name="simpleBidValue" select="localeHelper:getValue( $localeHelper,  'integration.BidType.SimpleBid')" />
	<xsl:variable name="forcedBidValue" select="localeHelper:getValue( $localeHelper,  'integration.BidType.ForcedLotBid')" />
	<xsl:variable name="integer" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.integer')" />

	<xsl:variable name="rfx" select="/ePASSResponse/RFxResponse/RFx" />
	<xsl:variable name="rfxcurrencycodes" select="$rfx/@RFxCurrencyCodes" />
	<xsl:variable name="rfxPrimaryCurrency" select="$rfx/@RFxDefaultCurrencyCode" />
	<xsl:variable name="supplierPrefferedCurrency" select="$rfx/@SupplierPrefferedCurrency" />
	<xsl:variable name="options" select="/ePASSResponse/Options" />
	<xsl:variable name="isBidTemplate" select="$options/Option[@OptionKey='bidtemplate']" />
	<xsl:variable name="validationLimit" saxon:assignable="yes" select="0" />
	<xsl:variable name="bid.Type.Simple" select="localeHelper:getValue( $localeHelper,  'excelmap.bid.simple')" />
	<xsl:variable name="bid.Type.Bundle" select="localeHelper:getValue( $localeHelper, 'excelmap.bids.bundlebids')" />
	<xsl:variable name="bid.Status.Valid" select="localeHelper:getValue( $localeHelper,  'excelmap.bid.valid')" />

	<xsl:variable name="rfq.surrogate" select="$options/Option[@OptionKey='bidtemplate']/@OptionValue='buyer'" />
	<xsl:variable name="bidDomainName" select="localeHelper:getValue( $localeHelper, 'integration.DomainScope.bid')" />
	<!-- xsl:key name="bidXACodesKey" use="." match="/ePASSResponse/RFxResponse/RFx/ExtendedAttributeDefinition[@XADDomain=$bidDomainName]/@XADName" /-->
	<xsl:variable name="bidXAs" select="$rfx/ExtendedAttributeDefinition[@XADDomain = $bidDomainName]" />	
	<xsl:variable name="showDeliveryDate" select="count($rfx/ExtendedAttributeDefinition[$bidDomainName = @XADDomain and @XADCode = 'deliveryDate']/@XADObjectLink) > 0" />
	<xsl:variable name="showLeadDays" select="count($rfx/ExtendedAttributeDefinition[$bidDomainName = @XADDomain and @XADCode = 'leadDays']/@XADObjectLink) > 0" />
	<xsl:variable name="XADName.UniqueId" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.line_items.UniqueId')" />
	<xsl:variable name="XADName.UnitOfMeasure" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.line_items.UnitOfMeasure')" />
	<xsl:variable name="XADName.Specification" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.Specification')" />
	<xsl:variable name="XADName.Description" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.xad.Description')" />
	<xsl:variable name="XADName.SpecificationURL" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.line_items.SpecificationURL')" />
	<xsl:variable name="XADName.StartPrice" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.line_items.StartPrice')" />
	<xsl:variable name="XADName.MinDesiredQuantity" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LineItemMinDesiredQuantity')"/>
	<xsl:variable name="XADName.MaxDesiredQuantity" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.MaximumDesiredQuantity')"/>
	<xsl:variable name="AttributeDefScope.BidItem" select="localeHelper:getValue($localeHelper, 'integration.AttributeDefScope.BidStruct.bid_item')" />
	<xsl:variable name="XADScope.Category" select="localeHelper:getValue( $localeHelper, 'integration.DomainScope.category')" />
	<xsl:variable name="XADScope.LineItem" select="localeHelper:getValue( $localeHelper, 'integration.DomainScope.line_item')" />
	<xsl:variable name="comment" select="''" saxon:assignable="yes"/>
	<xsl:variable name="minvalue" select="''"  saxon:assignable="yes"/>
	<xsl:variable name="maxvalue" select="''"  saxon:assignable="yes"/>
	<xsl:variable name="minvalueinc" select="''"  saxon:assignable="yes"/>
	<xsl:variable name="maxvalueinc" select="''"  saxon:assignable="yes"/>
	<xsl:variable name="itemOrCategoryDomainNames" select="($XADScope.Category,$XADScope.LineItem)" saxon:assignable="yes" />
	<xsl:variable name="noBid" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.no_bid')" />
	
	<xsl:variable name="bidXAsVisible" 
			select="for $bidXA in $bidXAs return if(($bidXA/@XADCode != 'deliveryDate' or $showDeliveryDate ) 
			and ($bidXA/@XADCode != 'leadDays' or $showLeadDays)
			and ($bidXA/@XADScope !='item' or $bidXA/@XADObjectLink != '')) then $bidXA else () " />
	<xsl:variable name="bidXACodesExcludedInRFQ"
		select=" (
		localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidSellerProductCode'),
		localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidMinimum'),
		localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidMaximum'),
		localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidPricePerUnit'),
		localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidOneTimeCharge'),
		localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidDeliveryDate'),
		localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidLeadDays'),
		localeHelper:getValue( $localeHelper,  'term.iba.cost_adder_amount'),
		localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidQuantity')
	)" />
	<xsl:variable name="rfq.bidXAs" select="for $bidXA in $bidXAs return if( every $XA in $bidXACodesExcludedInRFQ satisfies $bidXA/@XADName != $XA ) then $bidXA else ()" />
	
	<xsl:variable name="bidXACodesExcludedInBidHistory"
		select="( 
	    localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidOneTimeCharge'),
	    localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidPricePerUnit'),
	    localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.MinimumQuantity'),
	    localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidQuantity'),
	    localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.MaximumQuantity'),
	    substring(localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BidPricePerUnit'),2)
     )" />
	<xsl:variable name="BidHistoryXACodes" select="for $bidXA in $bidXAs return if( every $XA in $bidXACodesExcludedInBidHistory satisfies $bidXA/@XADName != $XA ) then $bidXA else ()" />
	<xsl:variable name="itemXACodes"
		select="//ExtendedAttributeDefinition
		[some $x in $itemOrCategoryDomainNames satisfies @XADDomain = $x ]
		"/>
	<xsl:variable name="userDefinedItemIACount" select="count($itemXACodes[not(@XADIsPredefined=$trueConstant)])"/>
	<xsl:variable name="includeItemDefs" select="$options/Option[@OptionKey='IncludeItemDefs']/@OptionValue='true'"/>
	<xsl:variable name="itemXACount" select="count($itemXACodes)"/>   
	<xsl:variable name="itemSetEnabled" select="$rfx/GeneralRFxBiddingRules/@RFxUseItemSet"/>
	<xsl:variable name="uniqueIdColumnPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain )and @XADName = $XADName.UniqueId ])" />
	<xsl:variable name="UOMColumnPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain ) and @XADCode = 'unitOfMeasure' ])" />
	<xsl:variable name="specificationPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain ) and @XADName = $XADName.Specification ])" />
	<xsl:variable name="descriptionPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain ) and @XADName = $XADName.Description ])" />
	<xsl:variable name="specificationURLPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain ) and @XADName = $XADName.SpecificationURL ])" />
	<xsl:variable name="startPricePresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain ) and @XADName = $XADName.StartPrice ])" />
	<xsl:variable name="maxDesiredQuantityPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$XADScope.Category or $XADScope.LineItem = @XADDomain ) and @XADName = $XADName.MaxDesiredQuantity ])" />
	<xsl:variable name="visibleItemIACount" select="0" saxon:assignable="yes"/>
						
	<xsl:variable name="instructionsSheetName" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions')" />		    
	<xsl:template match="/">
		<xl:book doctype="RFxResponse" language="{$language}" workbook="{Options/Option[@OptionKey='WorkbookBase']/@OptionValue}" rowColumnNumbersMode="mixed">
			<xl:sheet>
				<xsl:attribute name="name"><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions')" /></xsl:attribute>
				<xsl:attribute name="type"><xsl:value-of select="'INSTRUCTIONS'" /></xsl:attribute>
				<xl:cell font="cautionFont">
					<xsl:attribute name="writeContentToCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions'),',3,1')" />
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.sheet.instructions.caution')"/>
				</xl:cell>
				<xsl:if test="$bid.rfxtype='buyer_rfi' or $bid.rfxtype='rfi' or $bid.rfxtype='rfp'">
					<xl:linkToSheet horizontalAlignment="right">
						<xsl:attribute name="writeContentToCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions'),',12,1')" />
						<xsl:attribute name="targetCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.questionresponse'),',6,1')" />
						<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.questionresponse')" />
					</xl:linkToSheet>
					<xsl:choose>
						<xsl:when test="count(/ePASSResponse/RFxResponse/RFx/Questionnaire/Question[@QuestionResponseType=$XADDataType.Matrix]) > 0">
							<xl:linkToSheet horizontalAlignment="right">
								<xsl:attribute name="writeContentToCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions'),',14,1')" />
								<xsl:attribute name="targetCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.tableresponse'),',1,1')" />
								<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.tableresponse')" />
							</xl:linkToSheet>
						</xsl:when>
						<xsl:otherwise>
							<xl:cell font="templateinstructions">
								<xsl:attribute name="writeContentToCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions'),',14,1')" />
								<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.tableresponse'),':')"/>
							</xl:cell>
						</xsl:otherwise>
					</xsl:choose>
					<xsl:if test="$bid.rfxtype='rfp'">
						<xl:linkToSheet horizontalAlignment="right">
							<xsl:attribute name="writeContentToCellByPosition" select="concat($instructionsSheetName,',17,1')" />
							<xsl:attribute name="targetCellByPosition" select="concat($rfpSheetName,',1,1')" />
							<xsl:value-of select="$rfpSheetName" />
						</xl:linkToSheet>
					</xsl:if>
				</xsl:if>
				<xsl:if test="$bid.rfxtype='sealed'">
					<xl:linkToSheet horizontalAlignment="right">
						<xsl:attribute name="writeContentToCellByPosition" select="concat($instructionsSheetName,',12,1')" />
						<xsl:attribute name="targetCellByPosition" select="concat($rfqSheetName,',1,1')" />
						<xsl:value-of select="$rfqSheetName" />
					</xl:linkToSheet>
				</xsl:if>
				
				<xsl:if test="$bid.rfxtype='reverse'">
					<xl:linkToSheet horizontalAlignment="right">
						<xsl:attribute name="writeContentToCellByPosition" select="concat($instructionsSheetName,',12,1')" />
						<xsl:attribute name="targetCellByPosition" select="concat($reverseAuctionSheetName,',1,1')" />
						<xsl:value-of select="$reverseAuctionSheetName" />
					</xl:linkToSheet>
				</xsl:if>
				<xsl:if test="$bid.rfxtype='forward'">
					<xl:linkToSheet horizontalAlignment="right">
						<xsl:attribute name="writeContentToCellByPosition" select="concat($instructionsSheetName,',12,1')" />
						<xsl:attribute name="targetCellByPosition" select="concat($reverseAuctionSheetName,',1,1')" />
						<xsl:value-of select="$reverseAuctionSheetName" />
					</xl:linkToSheet>
				</xsl:if>
				
			</xl:sheet>
			
			<xsl:choose>
				<xsl:when test="$bid.rfxtype='buyer_rfi' or $bid.rfxtype='rfi'" >
					<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx" mode="RFI" />
				</xsl:when>
				<xsl:when test="$bid.rfxtype='sealed'" >
					<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx" mode="RFQ" />
				</xsl:when>
				<xsl:when test="$bid.rfxtype='rfp'" >
					<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx" mode="RFI" />
					<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx" mode="RFQ" />
				</xsl:when>
				<xsl:when test="$bid.rfxtype='reverse' or $bid.rfxtype='forward'" >
					<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx" mode="Auction" />
				</xsl:when>
			</xsl:choose>
			<xsl:apply-templates select="Logs" mode="standalone" />
		</xl:book>
	</xsl:template>
				    
	<!--
		*********************************Process RFx
		information***********************************
	-->
	<xsl:template name="RFxInformation">
		<xl:row header="true" font="rfxinfo">
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.headers.section')" />
			</xl:cell>
			<xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/>
		</xl:row>
		<xl:row header="true" font="rfxinfo">
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.OrganizationCode'), ' : ' , @OrganizationCode)" />
			</xl:cell>
			<xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/><xl:cell/>
		</xl:row>
		<xl:row header="true" font="rfxinfo">
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.RFxName'),' : ' , @RFxName)" />
			</xl:cell>
			<xl:cell />
			<xl:cell />
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.RFxType'),' : ' ,@RFxType)" />
			</xl:cell>
			<xl:cell />
			<xl:cell />
			<xsl:variable name="varOpenDateTimeZone">
				<xsl:if test="@RFxOpenDateTime">
					<xsl:value-of select="concat(@RFxOpenDateTime, ' ' , /ePASSResponse/@timezone)" />
				</xsl:if>
			</xsl:variable>
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.RFxOpenDateTime'),' : ', $varOpenDateTimeZone)" />
			</xl:cell>
			<xl:cell/><xl:cell/><xl:cell/><xl:cell/>
		</xl:row>
		<xl:row header="true" font="rfxinfo">
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.RFxUniqueID'),' : ' , @RFxCode)" />
			</xl:cell>
			<xl:cell />
			<xl:cell />
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.RFxRoundName'),' : ',@RFxRoundName)" />
			</xl:cell>
			<xsl:variable name="varCloseDateTimeZone">
				<xsl:if test="@RFxCloseDateTime">
					<xsl:value-of select="concat(@RFxCloseDateTime, ' ' , /ePASSResponse/@timezone)" />
				</xsl:if>
			</xsl:variable>
			<xl:cell />
			<xl:cell />
			<xl:cell>
				<xsl:value-of select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfx.RFxCloseDateTime'),' : ',$varCloseDateTimeZone)" />
			</xl:cell>
			<xl:cell/><xl:cell/><xl:cell/><xl:cell/>
		</xl:row>
	</xsl:template>
	
	<xsl:template name="CurrencyExchangeRates">
		<xsl:param name="currExchangeNodes"/>
		<xsl:variable name="supPrefCurrencyInRFx" select="$currExchangeNodes[@CurrencyCode2= $supplierPrefferedCurrency]"/>
		
		<xsl:choose>
			<xsl:when test="$supPrefCurrencyInRFx">
				<xsl:variable name="currExchangeNodesWOSupPrefCurrency" select="$currExchangeNodes[@CurrencyCode2 != $supplierPrefferedCurrency]"/>
				<xl:row>
					<xl:cell font="currencySection">
						<xsl:value-of select="concat(localeHelper:getValue($localeHelper, 'excelmap.rfx.rfx.RFxDefaultCurrencyCode'),': ',$rfxPrimaryCurrency)"/>
					</xl:cell>
					
					<xsl:for-each select="$currExchangeNodesWOSupPrefCurrency">
						<xsl:if test="position() mod 3 = 2">
							<xl:cell font="plain">
								<xsl:value-of select="concat('1',./@CurrencyCode2,'=',./@Rate1To2)"/>
							</xl:cell>
						</xsl:if>
					</xsl:for-each>
				</xl:row>
				<xl:row>
					<xl:cell font="plain">
						<xsl:value-of select="concat('1',$supplierPrefferedCurrency,'=', $supPrefCurrencyInRFx/@Rate1To2)"/>
					</xl:cell>
					<xsl:for-each select="$currExchangeNodesWOSupPrefCurrency">
						<xsl:if test="position() mod 3 = 0">
							<xl:cell font="plain">
								<xsl:value-of select="concat('1',./@CurrencyCode2,'=',./@Rate1To2)"/>
							</xl:cell>
						</xsl:if>
					</xsl:for-each>
				</xl:row>
				<xl:row>
					<xsl:for-each select="$currExchangeNodesWOSupPrefCurrency">
						<xsl:if test="position() mod 3 = 1">
							<xl:cell font="plain">
								<xsl:value-of select="concat('1',./@CurrencyCode2,'=',./@Rate1To2)"/>
							</xl:cell>
						</xsl:if>
					</xsl:for-each>
				</xl:row>
			</xsl:when>
			<xsl:otherwise>
				<xl:row>
					<xl:cell font="currencySection">
						<xsl:value-of select="concat(localeHelper:getValue($localeHelper, 'excelmap.rfx.rfx.RFxDefaultCurrencyCode'),': ',$rfxPrimaryCurrency)"/>
					</xl:cell>
					<xsl:for-each select="$currExchangeNodes">
						<xsl:if test="position() mod 3 = 0">
							<xl:cell font="plain">
								<xsl:value-of select="concat('1',./@CurrencyCode2,'=',./@Rate1To2)"/>
							</xl:cell>
						</xsl:if>
					</xsl:for-each>
				</xl:row>
				<xl:row>
					<xsl:for-each select="$currExchangeNodes">
						<xsl:if test="position() mod 3 = 1">
							<xl:cell font="plain">
								<xsl:value-of select="concat('1',./@CurrencyCode2,'=',./@Rate1To2)"/>
							</xl:cell>
						</xsl:if>
					</xsl:for-each>
				</xl:row>
				<xl:row>
					<xsl:for-each select="$currExchangeNodes">
						<xsl:if test="position() mod 3 = 2">
							<xl:cell font="plain">
								<xsl:value-of select="concat('1',./@CurrencyCode2,'=',./@Rate1To2)"/>
							</xl:cell>
						</xsl:if>
					</xsl:for-each>
				</xl:row>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	<!-- ********************************Get the tooltip for number data type************************************* -->
	<xsl:template name="GetNumberToolTip">
      <xsl:param name="question" select="()" />
	  <xsl:variable name="xadType" select="$question/@QuestionResponseType" />
      <xsl:if test="not(empty($question))"> 
        <saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />
        <saxon:assign name="minvalue" select="if( empty($question/@QuestionResponseMinValue) ) then '' else $question/@QuestionResponseMinValue" />
        <saxon:assign name="maxvalue" select="if( empty($question/@QuestionResponseMaxValue) ) then '' else $question/@QuestionResponseMaxValue" />           
        <saxon:assign name="minvalueinc" select="
          if (empty($question/@ResponseMinValInc)) then '' 
          else if ( $question/@ResponseMinValInc = $trueValue or $question/@ResponseMinValInc = 'true'  ) then 'true'
          else 'false'" />
        <saxon:assign name="maxvalueinc" select="
          if (empty($question/@ResponseMaxValInc)) then '' 
          else if ( $question/@ResponseMaxValInc = $trueValue or $question/@ResponseMaxValInc = 'true'  ) then 'true'
          else 'false'" />
    
        <saxon:assign name="defaultvalue" select=" if (empty($question/@QuestionDefaultValue)) then '' else $question/@QuestionDefaultValue " />    
        <saxon:assign name="decimalplaces" select="
        	if( some $x in $XADDataType.NumberTypes satisfies $x = $xadType ) then
        		if( $XADDataType.Integer =  $xadType ) then 
        			0
        		else if (empty($question/@QuestionResponseDecimalPlaces)) then 
					$rfx/@RFxDecimalPlaces 
				else 
					$question/@QuestionResponseDecimalPlaces
			else
				0
        	" />
        <saxon:assign name="comment" select="''"/>
		</xsl:if>
		
		<xsl:variable name="minInclValue" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.intege.min.inclusive', $minvalue)"/>
		<xsl:variable name="minExclValue" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.min.exclusive', $minvalue)"/>
				
		<xsl:if test="($minvalue != '') and ($minvalueinc = $trueValue or $minvalueinc = 'true')">
			<saxon:assign name="comment" select="$minInclValue"/>			
		</xsl:if>
		<xsl:if test="($minvalue != '') and ($minvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.false') or $minvalueinc = 'false')">
			<saxon:assign name="comment" select="$minExclValue"/>			
		</xsl:if>
		<xsl:if test="($maxvalue != '') and ($maxvalueinc = $trueValue or $maxvalueinc='true')">
			<saxon:assign name="comment" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.max.inclusive', $maxvalue)"/>
		</xsl:if>	
		<xsl:if test="($maxvalue != '') and ($maxvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.false') or $maxvalueinc='false')">
			<saxon:assign name="comment" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.max.exclusive', $maxvalue)"/>
		</xsl:if>
		<xsl:if test="($minvalue != '') and 
					  ($minvalueinc = $trueValue or $minvalueinc = 'true') and
					  ($maxvalue != '') and
					  ($maxvalueinc = $trueValue or $maxvalueinc = 'true')">
			<saxon:assign name="comment" 
				select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.minmax.inclusive', $minvalue,$maxvalue)"/>
		</xsl:if>
		<xsl:if test="($minvalue != '') and 
					  ($minvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.false') or $minvalueinc = 'false') and
					  ($maxvalue != '') and
					  ($maxvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.false') or $maxvalueinc = 'false')">
			<saxon:assign name="comment" 
				select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.minmax.exclusive', $minvalue,$maxvalue)"/>
		</xsl:if>
		
		<xsl:if test="($minvalue != '') and 
					  ($minvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.true') or $minvalueinc='true' ) and 
					  ($maxvalue != '') and
					  ($maxvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.false') or $maxvalueinc='false' )">
			<saxon:assign name="comment" 
				select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.min.inclusive.max.exclusive', $minvalue,$maxvalue)"/>
		</xsl:if>
		<xsl:if test="($minvalue != '') and 
					  ($minvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.false') or $minvalueinc = 'false') and
					  ($maxvalue != '') and
					  ($maxvalueinc = localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.true') or $maxvalueinc = 'true')">
			<saxon:assign name="comment" 
				select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.min.exclusive.max.inclusive', $minvalue,$maxvalue)"/>
		</xsl:if>
	</xsl:template>
				    
				    
    <!--  Variables that capture the various XAD Data types -->
	<xsl:template name="XADHeaderComment">
		<xsl:param name="XANode" />
		
		<xsl:variable name="varXAType" select="$XANode/@XADDataType" /> <!--get datatype of bid IA-->
		<xsl:variable name="varXADescription" select="concat(replace($XANode/@XADDescription,'&amp;#xa;', '&#xA;'), '&#xa;')" /> <!--get description of bid IA-->
		<xsl:variable name="varXARequired"><!--get required status of bid IA-->
			<xsl:if test="$XANode/@XADIsRequired = $trueValue">
				<xsl:value-of select="concat( '(', localeHelper:getValue( $localeHelper,  'EPASSAttributeDefStruct.required') ,')')" />
			</xsl:if>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="$varXAType =  $XADDataType.SimpleText">
				<xsl:variable name="varXAValidation" select="$XANode/@XADValidation" /> <!--get validation set for bid IA such as ZIP,DUNS, E-mail etc-->
				<xsl:variable name="varValidationText"><!--for Text_Single, add the validation rule in comment, if set-->
					<xsl:choose>
						<xsl:when test="$varXAValidation = $XADValidationType.DUNS">
							<xsl:value-of select="concat( $XADValidationType.DUNS.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.EMAIL">
							<xsl:value-of select="concat( $XADValidationType.EMAIL.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.URL">
							<xsl:value-of select="concat( $XADValidationType.URL.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.US_PHONE">
							<xsl:value-of select="concat( $XADValidationType.US_PHONE.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.ZIPCODE">
							<xsl:value-of select="concat( $XADValidationType.ZIPCODE.ValidationComment, '&#xa;')" />
						</xsl:when>
					</xsl:choose>
				</xsl:variable>
				<xsl:attribute name="tooltip"> <!--  To indent the text, blank spaces are set & '&#xa;' is new line character of MS Excel-->
                    <xsl:variable name="commentVar">
                        <xsl:choose>
                            <xsl:when test="$XANode/@XADName = $supplierItemCode or $XANode/@XADDomain = $matrixScope"><!--Exceptional: same type but max length is 80 chars-->
                                <xsl:value-of select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.datalimited','80')" />
                            </xsl:when>
                            <xsl:otherwise>
                                <xsl:value-of select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.datalimited','255')" />
                            </xsl:otherwise>
                        </xsl:choose>
                    </xsl:variable>
                    <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.textsingle'), '  ' , $varXARequired, '&#xa;', $varXADescription, $varValidationText, $commentVar)" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.String">
				<xsl:attribute name="tooltip">
                    <xsl:value-of
					select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.textmulti'), '  ' , $varXARequired, '&#xa;', $varXADescription
                                , '&#xa;' , localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.datalimited','2000'))" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.Enumeration">
				<xsl:variable name="varXASelectionList" select="$XANode/@XADSelectionList" /> <!--get selection list of bid IA-->
				<xsl:attribute name="tooltip">
                   <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.singleselect'), '  ' , $varXARequired, '&#xa;',$varXADescription, $varXASelectionList)" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.EnumerationMulti"><!--for multi select show selection list-->
				<xsl:variable name="varXASelectionList" select="$XANode/@XADSelectionList" /> <!--get selection list of bid IA-->
				<xsl:attribute name="tooltip">
                   <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.multiselect'), '  ' , $varXARequired, '&#xa;',$varXADescription, $varXASelectionList)" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.Calculated"> <!--for formula type show formula in comments-->
				<xsl:variable name="varXAFormulaSubType" select="$XANode/@XADSubDataType" /> <!--get formula result type-->
				<xsl:variable name="varXAFormula" select="$XANode/@Formula" /> <!--get formula-->
				<xsl:attribute name="tooltip">
                    <xsl:choose>
                        <xsl:when test="$XANode/@XADFormulaShowSupp = $trueValue">
                            <xsl:value-of select="concat($varXAType,' : ',$varXAFormulaSubType, '  ' , $varXARequired, '&#xa;', $varXADescription, $XADDataType.Calculated, ' : ', $varXAFormula)" />
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of select="concat($varXAType,' : ',$varXAFormulaSubType, '  ' , $varXARequired, '&#xa;', $varXADescription)" />
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="some $x in $XADDataType.NumberTypes satisfies $x = $varXAType">
				<xsl:variable name="varXAMinMessage">
					<xsl:variable name="varXAMinValue" select="$XANode/@XADMinimumValue" />
					<xsl:if test="$varXAMinValue != ''">
						<xsl:if test="$XANode/@XADMinInc = $trueValue">
							<xsl:value-of select="concat('X &gt;= ',$varXAMinValue )" />
						</xsl:if>
						<xsl:if test="$XANode/@XADMinInc != $trueValue">
							<xsl:value-of select="concat('X &gt; ',$varXAMinValue )" />
						</xsl:if>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="varXAMaxMessage">
					<xsl:variable name="varXAMaxValue" select="$XANode/@XADMaximumValue" />
					<xsl:if test="$varXAMaxValue != ''">
						<xsl:if test="$XANode/@XADMaxInc = $trueValue">
							<xsl:value-of select="concat('X &lt;= ',$varXAMaxValue )" />
						</xsl:if>
						<xsl:if test="$XANode/@XADMaxInc != $trueValue">
							<xsl:value-of select="concat('X &lt; ',$varXAMaxValue )" />
						</xsl:if>
					</xsl:if>
				</xsl:variable>
				<xsl:attribute name="tooltip">
                    <xsl:choose>
                        <xsl:when test="$varXAType = $XADDataType.Currency">
                            <xsl:value-of select="concat($varXAType,'  - ', $rfxPrimaryCurrency, ' ',$varXARequired, '&#xa;', $varXADescription, $varXAMinMessage, '  ', $varXAMaxMessage)" />
                        </xsl:when>
                        <xsl:otherwise>
                             <xsl:value-of select="concat($varXAType, ' ', $varXARequired, '&#xa;', $varXADescription, $varXAMinMessage, '  ', $varXAMaxMessage)" />
                        </xsl:otherwise>
                    </xsl:choose>
                  </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.Date">
				<xsl:attribute name="tooltip">
                    <xsl:value-of select="concat($varXAType, $varXARequired, '&#xa;', localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.datetype.tooltip'), '&#xa;', $varXADescription)" />
                </xsl:attribute> 
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="tooltip">
                   <xsl:value-of select="concat($varXAType, $varXARequired, '&#xa;', $varXADescription)" />
                </xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- FIXME: This should be called 'ProcessBid' as it processes ONLY one bid. -->
	<xsl:variable name="XADName.BidOneTimeCharge" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidOneTimeCharge')" />
	<xsl:variable name="XADName.BidPricePerUnit" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidPricePerUnit')" />
	<xsl:variable name="bidPPUDiscountType.None" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidPPUPercentDiscountType.none')" />
	<xsl:variable name="XADName.BidDeliveryDate" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidDeliveryDate')" />
	<xsl:variable name="XADName.BidSellerProductCode" select="localeHelper:getValue($localeHelper, 'excelmap.bids.simple.BidSellerProductCode')" />
	<xsl:variable name="XADName.BidLeadDays" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidLeadDays')" />	
	<xsl:variable name="XADName.BidMinimum" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidMinimum')" />
	<xsl:variable name="XADName.BidMaximum" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidMaximum')" />
	<xsl:variable name="XADName.BidDiscountCode" select="localeHelper:getValue( $localeHelper,  'excelmap.bidfield.discount.code')" /> <!--PPU Discount Amount in %-->
	<xsl:variable name="XADName.BidDiscountValue" select="localeHelper:getValue( $localeHelper,  'excelmap.bidfield.discount.value')" />
	<xsl:variable name="ForcedLotValue" select="localeHelper:getValue($localeHelper, 'integration.BidType.ForcedLotBid.value')"/>
	<xsl:variable name="ForcedLotCode" select="localeHelper:getValue($localeHelper, 'integration.BidType.ForcedLotBid.code')"/>
	<xsl:variable name="XAD.Visibility.Exposed.Slash" select="concat($XAD.Visibility.Exposed, '/')" />
	<xsl:variable name="XAD.Visibility.Slash.Exposed" select="concat('/',$XAD.Visibility.Exposed)" />
	<xsl:variable name="XAD.Visibility.ReadOnly.Slash" select="concat($XAD.Visibility.ReadOnly, '/')" />
	
	<xsl:template name="ProcessBid">
		<xsl:param name="lineitem"/>
		<xsl:param name="isForced"/>
		<xsl:param name="bidNode"/>
		
		<xsl:variable name="item" select="string($lineitem/@LineItemCode)"/>
		<xsl:variable name="minBidQuantity" select="$lineitem/@LineItemMinimumBidQuantity"/>
		<xsl:variable name="maxBidQuantity" select="$lineitem/@LineItemMaximumBidQuantity"/>
		<xsl:variable name="ppu">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidPricePerUnit"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidSellerProductCode">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidSellerProductCode"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidMinimum">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidMinimum"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidMaximum">
			<xsl:if test="not($isForced=$trueValue) and boolean($bidNode)">
				<xsl:value-of select="
							if($bidNode/@BidQuantity != '')
								then $bidNode/@BidQuantity
							else if($bidNode/@BidMaximum != '')
								then $bidNode/@BidMaximum
							else ''"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidPricePerUnit">
			<xsl:if test="boolean($bidNode)">
				<xsl:choose>
					<xsl:when test="($lineitem/@LineItemMinBidChangeType) and not($bidNode/@BidPricePerUnit)">
						<xsl:value-of select="''"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$bidNode/@BidPricePerUnit"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidDiscount">
			<xsl:if test="boolean($bidNode)">
				<xsl:choose>
					<xsl:when test="($lineitem/@LineItemMinBidChangeType) or ($bidNode/@BidDiscount)">
						<xsl:value-of select="$bidNode/@BidDiscount"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="''"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidOneTimeCharge">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidOneTimeCharge"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidDeliveryDate">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidDeliveryDate"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidLeadDays">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidLeadDays"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidCurrencyCode">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidCurrencyCode"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="BidPPUPercentDiscount">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@PPUPercentDiscount"/>
			</xsl:if>
		</xsl:variable>
		
		<xsl:variable name="BidPPUPercentDiscountType">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/@BidPPUDiscountType"/>
			</xsl:if>
		
		</xsl:variable>	
		<xsl:variable name="ExtendedAttributeCode">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/ExtendedAttribute/@ExtendedAttributeCode"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="ExtendedAttributeValue">
			<xsl:if test="boolean($bidNode)">
				<xsl:value-of select="$bidNode/ExtendedAttribute/@ExtendedAttributeValue"/>
			</xsl:if>
		</xsl:variable>
		<xsl:variable name="LineItemEnableDiscountBidding" select="$lineitem/@LineItemEnableDiscountBidding"/>
		<xsl:variable name="item" select="string($lineitem/@LineItemCode)"/>
	
		<xsl:for-each select="$bidXAsVisible">
			<xsl:variable name="xaName" select="@XADName"/>
			<xsl:variable name="xaCode" select="@XADCode"/>
			<xsl:variable name="varXADNode" select="." />
			<xsl:variable name="varXadType" select="$varXADNode/@XADDataType"/>
			<xsl:variable name="varXadSubType" select="$varXADNode/@XADSubDataType"/>
			<xsl:variable name="isItemSpecific">
			 	<xsl:choose>
					<xsl:when test="$AttributeDefScope.BidItem = $varXADNode/@XADScope">
						<xsl:variable name="links" select="string($varXADNode/@XADObjectLink)"/>
						<xsl:variable name="span" select="string-length($links)"/>
						<xsl:variable name="len" select="string-length($item)"/>
						
						<xsl:value-of select="
								if($links = $item or (($span &gt; $len)
										and (substring($links, $span - $len) = concat('|', $item)
											or contains($links, concat('|', $item, '|'))
											or substring($links, 1, $len + 1) = concat($item, '|'))))
									then 'true'
								else 'false'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'false'"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			
			<xsl:variable name="xaValue">
				<xsl:choose>
					<xsl:when test="boolean($bidNode)">
						<xsl:choose>
							<xsl:when test="$xaCode = 'productCode'">
								<xsl:value-of select="$BidSellerProductCode"/>									
							</xsl:when>
							<xsl:when test="$xaCode = 'minCapacity'">
								<xsl:value-of select="$BidMinimum"/>									
							</xsl:when>
							<xsl:when test="$xaCode = 'maxCapacity'">
								<xsl:value-of select="$BidMaximum"/>									
							</xsl:when>
							<xsl:when test="$xaCode = 'baseVariableCost'">
								<xsl:choose>
									<xsl:when test="empty($BidPPUPercentDiscount) or
													$BidPPUPercentDiscountType = $bidPPUDiscountType.None or
													$LineItemEnableDiscountBidding = $falseConstant">
										<xsl:value-of select="$BidPricePerUnit"/>
									</xsl:when>
									<xsl:when test="empty($LineItemEnableDiscountBidding)">
										<xsl:value-of select="$BidPricePerUnit"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="''"/>
									</xsl:otherwise>
								</xsl:choose>		
							</xsl:when>
							<xsl:when test="$xaCode = 'variableCostDiscountValue'">
								<xsl:choose>
									<xsl:when test="empty($LineItemEnableDiscountBidding) or
												$LineItemEnableDiscountBidding = $falseConstant">
											<xsl:value-of select="''"/>
									</xsl:when>
									<xsl:otherwise>																	
										<xsl:value-of select="$BidPPUPercentDiscount"/>										
									</xsl:otherwise>
								</xsl:choose>															
							</xsl:when>
							<xsl:when test="$xaCode = 'baseFixedCost'">
								<xsl:value-of select="$BidOneTimeCharge"/>
							</xsl:when>
							<xsl:when test="$xaCode = 'deliveryDate'">
								<xsl:value-of select="$BidDeliveryDate"/>
							</xsl:when>
							<xsl:when test="$xaCode = 'leadDays'">
								<xsl:value-of select="$BidLeadDays"/>
							</xsl:when>							
							<xsl:otherwise>
								<xsl:value-of select="$bidNode/ExtendedAttribute[@ExtendedAttributeCode=$xaName]/@ExtendedAttributeValue"/>												
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:when test = "$xaCode = 'baseFixedCost'">
						<xsl:value-of select="$varXADNode/@XADDefaultValue"/>
					</xsl:when>
				</xsl:choose>
			</xsl:variable>

		
		 	<xsl:variable name="readOnly" select="
		 		if(contains($varXADNode/@XADVisibility, $XAD.Visibility.Slash.Exposed)) then 'false'
		 		else if (contains($varXADNode/@XADVisibility, $XAD.Visibility.ReadOnly.Slash)) then 'true'
		 		else if (contains($varXADNode/@XADVisibility, $XAD.Visibility.Exposed.Slash)) then 'true'
		 		else 'false'" /> 
			<xsl:variable name="xadPrecision" select="$varXADNode/@XADPrecision"/>
			<xsl:variable name="unLocalizedDatatype">
				<xsl:value-of select="ss:func_dataTypeReverseLocal($varXadType)" />
			</xsl:variable>
			<xsl:variable name="unLocalizedSubDatatype">
				<xsl:if test="$varXadSubType != '' ">
					<xsl:value-of select="ss:func_dataTypeReverseLocal($varXadSubType)" />
				</xsl:if>
			</xsl:variable>
			<xsl:choose>
				<xsl:when test="$xaCode = 'minCapacity' or $xaCode = 'maxCapacity'"> <!-- only applicable to Bid Minimum and BidMaximum IA  -->
					<saxon:assign name="minvalue" select="$minBidQuantity"/>
					<saxon:assign name="maxvalue" select="$maxBidQuantity"/>
					<saxon:assign name="minvalueinc" select="'true'"/>
					<saxon:assign name="maxvalueinc" select="'true'"/>
				</xsl:when>
				<xsl:otherwise>
					<saxon:assign name="minvalue" select="$varXADNode/@XADMinimumValue"/>
					<saxon:assign name="maxvalue" select="$varXADNode/@XADMaximumValue"/>
					<saxon:assign name="minvalueinc" select="$varXADNode/@XADMinInc"/>
					<saxon:assign name="maxvalueinc" select="$varXADNode/@XADMaxInc"/>
				</xsl:otherwise>
			</xsl:choose>
			
			<xsl:variable name="tooltip">
				<xsl:if test="not($isForced=$trueValue) and ($xaCode = 'minCapacity' or $xaCode = 'maxCapacity')">
					<xsl:choose>
						<xsl:when test="$minBidQuantity != '' and $maxBidQuantity != '' ">
							<xsl:value-of select="concat($minBidQuantity, '&lt;= X &lt;= ',$maxBidQuantity )"/>
						</xsl:when>
						<xsl:when test="$minBidQuantity = '' and $maxBidQuantity != '' ">
							<xsl:value-of select="concat('0 &lt;= X &lt;=', $maxBidQuantity)"/>
						</xsl:when>
						<xsl:when test="$minBidQuantity != '' and $maxBidQuantity = '' ">
							<xsl:value-of select="concat($minBidQuantity, '&lt;= X &lt;=0')"/>
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="'X &gt;= 0'"/>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:if>
			</xsl:variable>
			<xsl:variable name="unLocalizedMinvalueInc">
				<xsl:choose>
					<xsl:when test="$minvalueinc = $trueValue or $minvalueinc = 'true' ">
						<xsl:value-of select="'true'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'false'"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="unLocalizedMaxvalueInc">
				<xsl:choose>
					<xsl:when test="$maxvalueinc = $trueValue or $maxvalueinc = 'true' ">
						<xsl:value-of select="'true'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'false'"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="textLength">
				<xsl:choose>
					<xsl:when test="$xaCode = 'productCode'">
						<xsl:value-of select="$charLen80"/>
					</xsl:when>
					<xsl:when test="$varXadType = $XADDataType.SimpleText">
						<xsl:value-of select="$charLen255"/>
					</xsl:when>
					<xsl:when test="$varXadType = $XADDataType.String">
						<xsl:value-of select="$charLen2000"/>
					</xsl:when>
					<xsl:when test="$varXadType = $XADDataType.Calculated ">
						<xsl:value-of select="'0'"/>
					</xsl:when>
				</xsl:choose>
			</xsl:variable>
			<xsl:variable name="selectionList">
			 	<xsl:value-of select="
			 		if($varXadType = $XADDataType.Boolean or $varXadType = $XADDataType.Boolean_RadioButton
      					or $varXadType = $XADDataType.Boolean_CheckBox)
			 			then concat($pleaseSelectValue,'|', $yesValue ,'|', $noValue)
			 		else if($varXadType = $XADDataType.Enumeration)
			 			then concat($pleaseSelectValue,'|', $varXADNode/@XADSelectionList)
			 		else ''
			 	"/>
			 </xsl:variable>
			 <xsl:variable name="defaultSelected">
			 	<xsl:choose>
				 	<xsl:when test="$AttributeDefScope.BidItem = $varXADNode/@XADScope">
						<xsl:if test="$isItemSpecific ='true'">
							<xsl:value-of select="$varXADNode/@XADDefaultValue"/>
						</xsl:if>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="$xaCode = 'variableCostDiscountValue'">
								<xsl:choose>
									<xsl:when test="empty($LineItemEnableDiscountBidding) or
													$LineItemEnableDiscountBidding = $falseConstant">
												<xsl:value-of select="''"/>
									</xsl:when>
									<xsl:otherwise>
										<xsl:value-of select="$varXADNode/@XADDefaultValue"/>
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:when test="$varXadType=$XADDataType.Spacer">
								<xsl:value-of select="$varXADNode/@XADDescription"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="$varXADNode/@XADDefaultValue"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
             <xsl:variable name="isEditable">
				<xsl:choose>
					<xsl:when test="$varXadType=$XADDataType.Calculated or $varXadType=$XADDataType.Spacer or $readOnly='true'
								or ($xaCode = 'baseVariableCost'
	                                                        and $lineitem/@LineItemEnableDiscountBidding = $trueValue and $discountBidding = $trueValue)
	                                        or ($xaCode = 'variableCostDiscountValue'
	                                                    and $lineitem/@LineItemEnableDiscountBidding =$falseValue)
	                                        or (($xaCode = 'minCapacity' or $xaCode = 'maxCapacity')
	                                        		and $isForced =$trueValue)">
	                                <xsl:value-of select="'false'"/>
					</xsl:when>
					<xsl:when test="$AttributeDefScope.BidItem = $varXADNode/@XADScope">
						<xsl:if test="$isItemSpecific='true' and $readOnly='false'">
							<xsl:value-of select="'true'"/>											
	                    </xsl:if>
					</xsl:when>
					<xsl:when test="$discountBidding = $trueValue and $lineitem/@LineItemEnableDiscountBidding = $trueValue  
															and $ppuFormula != '' and localeHelper:containsInPPUFormula($localeHelper, $ppuFormula,$xaName)">
						<xsl:value-of select="'false'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'true'"/>
					</xsl:otherwise>
				</xsl:choose>						
			</xsl:variable>
						
			<xl:cell>
				<xsl:attribute name="datatype" select="$unLocalizedDatatype"/>
				<xsl:attribute name="editable" select="$isEditable"/>
				<xsl:if test="$unLocalizedSubDatatype!=''">
					<xsl:attribute name="subdatatype" select="$unLocalizedSubDatatype"/>
				</xsl:if>
				<xsl:if test="$xadPrecision!=''">
					<xsl:attribute name="attrDecimalPlaces" select="$xadPrecision"/>
				</xsl:if>
				<xsl:if test="$minvalue!=''">
					<xsl:attribute name="minvalue" select="$minvalue"/>
				</xsl:if>
				<xsl:if test="$maxvalue!=''">
					<xsl:attribute name="maxvalue" select="$maxvalue"/>
				</xsl:if>
				<xsl:if test="$unLocalizedMinvalueInc!=''">
					<xsl:attribute name="minvalueinc" select="$unLocalizedMinvalueInc"/>
				</xsl:if>
				<xsl:if test="$unLocalizedMaxvalueInc!=''">
					<xsl:attribute name="maxvalueinc" select="$unLocalizedMaxvalueInc"/>
				</xsl:if>
				<xsl:if test="$xaCode = 'minCapacity' or $xaCode = 'maxCapacity'">
					<xsl:attribute name="differentValidationForEachRow" select="'true'"/>
				</xsl:if>
				<xsl:if test="$tooltip!=''">
					<xsl:attribute name="tooltip" select="$tooltip"/>
				</xsl:if>
				<xsl:if test="$textLength!=''">
					<xsl:attribute name="textlength" select="$textLength"/>
				</xsl:if>
				<xsl:if test="$selectionList!=''">
					<xsl:attribute name="selectionlist" select="$selectionList"/>
				</xsl:if>
				<xsl:choose>
					<xsl:when test="$defaultSelected!=''">
						<xsl:attribute name="defaultvalue" select="$defaultSelected"/>
					</xsl:when>
					<xsl:when test="
						$varXadType = $XADDataType.Boolean or $varXadType = $XADDataType.Boolean_RadioButton
      						or $varXadType = $XADDataType.Boolean_CheckBox 
      						or $varXadType = $XADDataType.Enumeration">
      					<xsl:attribute name="defaultvalue" select="$pleaseSelectValue"/>
      				</xsl:when>
      			</xsl:choose>
				<xsl:value-of select="$xaValue"/>
			</xl:cell>
		</xsl:for-each>
	
	</xsl:template>
	
	<xsl:function name="ss:func_dataTypeReverseLocal" as="xs:string">
		<xsl:param name="dataType" as="xs:string" />
		<xsl:sequence select="
			if( $dataType = $XADDataType.Double ) then 'Decimal'
			else if( $dataType = $XADDataType.Currency ) then 'Currency'
			else if( $dataType = $XADDataType.Integer ) then 'Integer'
			else if( $dataType = $XADDataType.Date ) then 'Date'
			else if( $dataType = $XADDataType.SimpleText) then 'SingleText'
			else if( $dataType = $XADDataType.String ) then 'Text'
			else if( $dataType = $XADDataType.Calculated ) then 'Formula'
			else if( $dataType = $XADDataType.EnumerationMulti ) then 'SelectionMulti'
			else $dataType 
			" />
	</xsl:function>

	<xsl:template name="ItemIAsHeader">
		<xsl:for-each select="$itemXACodes[not(@XADIsPredefined=$trueConstant)]">
			<xl:cell>
				<xsl:attribute name="tooltip">
					<xsl:value-of select="replace(@XADDescription,'&amp;#xa;', '&#xA;')"/>
				</xsl:attribute>
				<xsl:choose>
					<xsl:when test="./@XADIsRequired= $trueValue
							or translate(@XADIsRequired, 'truefals', 'TRUEFALS')='TRUE'">
						<xsl:choose>
							<xsl:when test="./@XADCode = 'variableCostDiscountValue'">
								<xsl:value-of select="concat('*', localeHelper:getValue($localeHelper, 'excelmap.bidfield.discount.value'))"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="concat('*',@XADName)"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="@XADCode = 'variableCostDiscountValue'">
								<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bidfield.discount.value')"/>
							</xsl:when>
							<xsl:when test="(@XADCode = 'minCapacity') and
											(/ePASSResponse/RFxResponse/RFx/RFQBiddingRules/@RFxAllowOptimizationFeedback = $trueValue)">
								<xsl:value-of select="concat('*',@XADName)"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="@XADName"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
   			</xl:cell>
   		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="ItemIAValues">
		<xsl:param name="extendedattribute"/>
			
		<xsl:for-each select="$itemXACodes[not(@XADIsPredefined=$trueConstant)]">
            <xsl:variable name="varXaName" select="@XADName"/>
            <xsl:variable name="varXADNode" select="."/>
      		<xl:cell>
				<xsl:variable name="varXadType" select="$varXADNode/@XADDataType"/>
				<xsl:attribute name="editable"><xsl:value-of select="'false'"/></xsl:attribute>
				<xsl:attribute name="datatype">
					<xsl:call-template name="DataTypeReverseLocal">
						<xsl:with-param name="dataType" select="$varXadType"/>
					</xsl:call-template>
				</xsl:attribute>
				<xsl:attribute name="attrDecimalPlaces" select="$varXADNode/@XADPrecision"/>
				<xsl:choose>
					<xsl:when test="$varXadType=$XADDataType.Spacer">				
						<xsl:value-of select="$varXADNode/@XADDescription"/>					
					</xsl:when>		
					<xsl:otherwise>
						<xsl:for-each select="$extendedattribute">
							<xsl:variable name="extendedattrname" select="@ExtendedAttributeCode"/>
							<xsl:variable name="extendedattrvalue" select="@ExtendedAttributeValue"/>
						    <xsl:if test="$extendedattrname = $varXaName">
								<xsl:value-of select="$extendedattrvalue"/>
							</xsl:if>
						</xsl:for-each>
					</xsl:otherwise>
				</xsl:choose>
		    </xl:cell>
        </xsl:for-each>
	
	</xsl:template>
    
	
	<xsl:template name="DataTypeReverseLocal">
		<xsl:param name="dataType" />
		<xsl:choose>
			<xsl:when test="$dataType = $XADDataType.Double">
				<xsl:value-of select="'Decimal'" />
			</xsl:when>
			<xsl:when test="$dataType = $XADDataType.Currency">
				<xsl:value-of select="'Currency'" />
			</xsl:when>
			<xsl:when test="$dataType = $XADDataType.Integer">
				<xsl:value-of select="'Integer'" />
			</xsl:when>
			<xsl:when test="$dataType = $XADDataType.Date">
				<xsl:value-of select="'Date'" />
			</xsl:when>
			<xsl:when test="$dataType = $XADDataType.SimpleText or $dataType = $XADDataType.String">
				<xsl:value-of select="'Text'" />
			</xsl:when>
			<xsl:when test="$dataType = $XADDataType.EnumerationMulti">
				<xsl:value-of select="'SelectionMulti'" />
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$dataType" />
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
