<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<!--
$Archive: /epass/epass5.0.1/com/avinamart/WebInterface/public_html/Integration/xsl/ePASS2gXML/ePASS2gXML_Bid.xsl $
$Revision: 2 $ $Date: 10/14/04 3:45p $
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0"
        xmlns:saxon="http://saxon.sf.net/"
        xmlns:java="java:com.avinamart.Utility.EPASSIFHelper"
        exclude-result-prefixes="saxon java" extension-element-prefixes="saxon">

    <!-- ************************************************************** -->
	<!-- code added for new bid templates -->
	<!-- ************************************************************** -->
    <!--For new excel template seperate xslt file is created for each type of RFx so include them -->
    <xsl:include href="ePASS2gXML_Bid_Auction.xsl"/>
    <xsl:include href="ePASS2gXML_Bid_RFI.xsl"/>
    <xsl:include href="ePASS2gXML_Bid_RFQ.xsl"/>
	<xsl:include href="ePASS2gXML_Bid_RFP.xsl"/>
	    
    <!--Global variables for storing XA datatypes-->
    <xsl:variable name="xadDecimalDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.DOUBLE_TYPE')"/>
    <xsl:variable name="xadIntegerDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.INTEGER_TYPE')"/>
    <xsl:variable name="xadDateDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.DATE_TYPE')"/>
    <xsl:variable name="xadCurrencyDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.CURRENCY_TYPE')"/>
    <xsl:variable name="xadBooleanDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.BOOLEAN_TYPE')"/>
    <xsl:variable name="xadBooleanDatatype_RadioBtn" select="java:getValue($language, 'integration.AttributeDefDataType.BOOLEAN_TYPE_RADIO_BUTTON')"/>
    <xsl:variable name="xadBooleanDatatype_CheckBox" select="java:getValue($language, 'integration.AttributeDefDataType.BOOLEAN_TYPE_CHECK_BOX')"/>
	<xsl:variable name="xadTextSingleDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.SIMPLE_TEXT_FIELD')"/>
    <xsl:variable name="xadTextMultiDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.STRING_TYPE')"/>
    <xsl:variable name="xadSpacerDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.SPACER_TYPE')"/>
    <xsl:variable name="xadFormulaDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.CALCULATED_TYPE')"/>
    <xsl:variable name="xadSelectionSingleDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.ENUMERATION_TYPE')"/>
    <xsl:variable name="xadSelectionMultiDatatype" select="java:getValue($language, 'integration.AttributeDefDataType.ENUMERATION_TYPE_MULTI')"/>
    <xsl:variable name="categoryScope" select="java:getValue($language, 'integration.DomainScope.category')" />
   	<xsl:variable name="lineItemScope" select="java:getValue($language, 'integration.DomainScope.line_item')" />
   	<xsl:variable name="itemDescription" select="java:getValue($language, 'excelmap.bids.line_items.xad.Description')" />
   	<xsl:variable name="itemDescriptionPresent" select="exists($rfx/ExtendedAttributeDefinition[(@XADDomain=$categoryScope or $lineItemScope = @XADDomain ) and @XADCode = 'description' ])" />
    <xsl:variable name="pleaseSelectValue" select="java:getValue($language,'form.terminology.select.no_selection_please_select')"/>
    <xsl:variable name="yesValue" select="java:getValue($language,'form.terminology.boolean.yes')"/>
    <xsl:variable name="noValue" select="java:getValue($language,'form.terminology.boolean.no')"/>



    <!--variables for text length validation For JXL API adding one to it. If we set 80 then it will allow max. 79-->
    <xsl:variable name="charLen80"><xsl:value-of select="'80'"/></xsl:variable>
    <xsl:variable name="charLen255"><xsl:value-of select="'255'"/></xsl:variable>
    <xsl:variable name="charLen4096"><xsl:value-of select="'4096'"/></xsl:variable>
    <xsl:variable name="charLen2000"><xsl:value-of select="'2000'"/></xsl:variable>

    <!--Global variables required in all templates-->
    <xsl:variable name="comment" select="''" saxon:assignable="yes"/>
    <xsl:variable name="formula" select="''" saxon:assignable="yes"/>
    <xsl:variable name="number" select="0" saxon:assignable="yes"/>
    <xsl:variable name="allowcomments" select="''" saxon:assignable="yes"/>
    <xsl:variable name="defaultvalue" select="''" saxon:assignable="yes"/>
    <xsl:variable name="minvalue" select="''" saxon:assignable="yes"/>
    <xsl:variable name="minvalueinc" select="''" saxon:assignable="yes"/>
    <xsl:variable name="maxvalue" select="''" saxon:assignable="yes"/>
    <xsl:variable name="maxvalueinc" select="''" saxon:assignable="yes"/>
    <xsl:variable name="SheetName" select="''" saxon:assignable="yes"/>
    <xsl:variable name="integer" select="java:getValue($language, 'excelmap.bids.rfi.response.datatype.integer')"/>

    <xsl:variable name="SubstitutionSet" select="java:getValue($language, 'integration.ItemType.Substitution')"/>
	<xsl:variable name="TableResponse" select="java:getValue($language, 'integration.MatrixTableResponse')"/>

	<!--org.side is used decide whether it is surrogate bidding or supplier bidding --> 
    <xsl:variable name="org.side" select="//Option[@OptionKey='bidtemplate']/@OptionValue='buyer'"/>

    <xsl:variable name="rowNum" select="0"/>
	<xsl:variable name="rfx" select="//RFx[1]"/>
	<xsl:variable name="bid.rfxtype" select="java:getName($language, $rfx/@RFxType, 'integration.AuctionType.')"/>
	<xsl:variable name="isSurvey" select="$bid.rfxtype='buyer_rfi'"/>
	<xsl:variable name="isAdvanced" select="$bid.rfxtype='descending_price_advanced'"/>
	<xsl:variable name="isStandard" select="$bid.rfxtype='reverse'"/>
	<xsl:variable name="bid.isRFI" select="$bid.rfxtype='rfi' or $bid.rfxtype='buyer_rfi'"/>
	<xsl:variable name="bid.questionCount" select="count($rfx/Questionnaire/Question)"/>
	
	<xsl:variable name="includeItemDefs" select="//Option[@OptionKey='IncludeItemDefs']/@OptionValue='true'"/>
	<xsl:variable name="itemSetEnabled" select="$rfx/GeneralRFxBiddingRules/@RFxUseItemSet"/>
	<xsl:variable name="bundleBidEnabled">
		<xsl:value-of select="$rfx/GeneralRFxBiddingRules/@RFxUseBundleBid"/>
	</xsl:variable>
	<xsl:variable name="volumeBidEnabled">
		<xsl:value-of select="$rfx/RFQBiddingRules/@RFxUseVolumeBid"/>
	</xsl:variable>
	
	<xsl:key name="bidIACodesKey" use="."
		match="//ExtendedAttributeDefinition[java:getName($language, @XADDomain, 'integration.DomainScope.')='bid']/@XADCode"/>
	<xsl:variable name="bidIACodes"
    	select="//ExtendedAttributeDefinition[java:getName($language, @XADDomain, 'integration.DomainScope.')='bid']/@XADCode"/>
    
	<xsl:variable name="RowMap" select="java:createMap('RowMap')"/>
	<xsl:variable name="QuestionRowMap" select="java:createMap('QuestionRowMap')"/>
	<xsl:variable name="itemOrCategoryDomainNames" select="(java:getValue($language,'integration.DomainScope.category')
						,java:getValue($language, 'integration.DomainScope.line_item'))" saxon:assignable="yes" />
	<xsl:variable name="itemXAUserDefined"
		select="//ExtendedAttributeDefinition
		[some $x in $itemOrCategoryDomainNames satisfies @XADDomain = $x and @XADIsPredefined=$falseValue]
		"/>
	<!-- PR-21468,9: restore surrogate bidding for all rfx types (except survey)-->
	<!-- PR#44760 : added buyer survey check -->
	<xsl:variable name="surrogate" select="$org.side and not($isSurvey)"/> 
	<xsl:variable name="userDefinedItemIACount">
		<xsl:value-of select="if($surrogate)
			    				then 0
				    			else count($itemXAUserDefined)
		 	"/>
	</xsl:variable>
	<xsl:variable name="org.response.offset">
		<xsl:choose>
			<xsl:when test="not($surrogate)">
				<xsl:value-of select="12"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="15"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="org.matrix.offset" select="number($org.response.offset) - 1"/>


    <xsl:variable name="columnPosition">
		<xsl:choose> <!-- PR 60818 RFx Type localization removed -->
			<xsl:when test="not($surrogate) and
							not($bid.rfxtype = 'reverse') and 
							not($bid.rfxtype = 'forward')">				
				<xsl:value-of select="12"/>
			</xsl:when>		
			<xsl:when test="($surrogate) and
							not($bid.rfxtype = 'reverse') and
							not($bid.rfxtype = 'forward')">				
				<xsl:value-of select="11"/>
			</xsl:when>	
			<!-- PR 63089 global variable used for true and false values -->
			<xsl:when test="not($surrogate) and
							($bid.rfxtype = 'reverse') and
							((//RFx/AuctionRules/@AllowDiscountBidding = $falseValue) or
							 (empty(//RFx/AuctionRules/@AllowDiscountBidding)))">				
				<xsl:value-of select="12"/>
			</xsl:when>
			<xsl:when test="($surrogate) and
							($bid.rfxtype = 'reverse') and
							((//RFx/AuctionRules/@AllowDiscountBidding = $falseValue) or
							 (empty(//RFx/AuctionRules/@AllowDiscountBidding)))">				
				<xsl:value-of select="13"/>
			</xsl:when>
			<xsl:when test="not($surrogate) and
							($bid.rfxtype = 'reverse') and
							(//RFx/AuctionRules/@AllowDiscountBidding = $trueValue)">				
				<xsl:value-of select="15"/>
			</xsl:when>			
			<xsl:when test="($surrogate) and 			
							($bid.rfxtype = 'reverse') and
							(//RFx/AuctionRules/@AllowDiscountBidding = $trueValue)">				
				<xsl:value-of select="16"/>
			</xsl:when>			
			<xsl:when test="not($surrogate) and
							($bid.rfxtype = 'forward')">				
				<xsl:value-of select="9"/>
			</xsl:when>
			<xsl:when test="($surrogate) and
							($bid.rfxtype = 'forward')">				
				<xsl:value-of select="13"/>
			</xsl:when>						
			<xsl:otherwise>
				<xsl:value-of select="15"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>

	<xsl:variable name="org.bid.offset">
		<xsl:choose>
			<xsl:when test="$itemDescriptionPresent">
				<xsl:value-of select="$columnPosition"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$columnPosition - 1"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>

    <xsl:variable name="matrixRowCount"
            select="count($rfx/Questionnaire/Question[@QuestionResponseType=$matrixType]) * 2
                    + count($rfx/Questionnaire/Question[@QuestionResponseType=$matrixType]
                            /ExtendedAttributeDefinition[@XADSubDataType=$matrixField])"/>
    <xsl:variable name="bid.lineItemCount"
            select="count($rfx/Requisition/LineItem[@LineItemType!=$SubstitutionSet])
                  + count($rfx/Requisition/LineItem[@LineItemType=$SubstitutionSet]/LineItem)"/>
    <xsl:variable name="bid.ItemBidCount"
		select="count($rfx/Bid[@BidType=java:getValue($language, 'excelmap.bid.simplebid') and @Status=java:getValue($language, 'excelmap.bid.valid')])" />
                  
	<!-- body.row is one less since position() is added -->
	<xsl:variable name="response.header.row">
		<xsl:choose>
			<xsl:when test="$surrogate">
				<xsl:value-of select="11"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="10"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="roundCount" select="number(//RFx/@RFxRoundCount)"/>
	
	<xsl:variable name="response.body.row" select="$response.header.row + 2" />
	<xsl:variable name="bid.responsescount" select="count(//RFx/Response)"/>
	<xsl:variable name="matrix.row" saxon:assignable="yes">
		<xsl:choose>
			<xsl:when test="$bid.responsescount &gt; $bid.questionCount">
				<xsl:value-of select="$response.body.row + $bid.responsescount"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$response.body.row + $bid.questionCount + 2"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="question.end.row" select="$matrix.row" saxon:assignable="yes"/>
	<xsl:variable name="bundled.end.row" select="0" saxon:assignable="yes"/>
	<xsl:variable name="volume.end.row" select="0" saxon:assignable="yes"/>
	<xsl:variable name="singlebid.end.row" select="0" saxon:assignable="yes"/>
	<xsl:variable name="IACount" select="0" saxon:assignable="yes"/>
	<xsl:variable name="substitution_row_num" select="0" saxon:assignable="yes"/>
	<xsl:variable name="columnNumber" select="1" saxon:assignable="yes"/>	
	<xsl:variable name="xaValue" select="''" saxon:assignable="yes"/>	
	<xsl:variable name="bid.header.row">
		<xsl:choose>
			<xsl:when test="$isRFI"/>
			<xsl:when test="$bid.rfxtype='rfp'">
				<xsl:choose>
					<xsl:when test="$bid.responsescount &gt;= $bid.questionCount">
						<xsl:value-of
							select="$response.body.row + $bid.responsescount + $matrixRowCount + 3" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of
							select="$response.body.row + $bid.questionCount + $matrixRowCount + 3" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:when test="$surrogate">
				<xsl:value-of select="11"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="10"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>
	<xsl:variable name="bid.body.row" select="$bid.header.row + 5"/>
	<xsl:variable name="instr.row">
		<xsl:choose>
			<xsl:when test="$bid.rfxtype='sealed'">
				<xsl:value-of select="$singlebid.end.row + count(/ePASSResponse/RFxResponse/RFx/Bid[@BidType = java:getValue($language, 'excelmap.bids.bundlebids')]/Bid) + 3"/>
			</xsl:when>
            <xsl:when test="$bid.rfxtype='rfp'">
                <xsl:choose>
                    <xsl:when test="count(//LineItem) = 0">
                        <xsl:value-of select="$bid.body.row + 3"/>    
                    </xsl:when>
                    <xsl:otherwise>
                        <xsl:value-of select="$singlebid.end.row + $bid.questionCount + count(/ePASSResponse/RFxResponse/RFx/Bid[@BidType = java:getValue($language, 'excelmap.bids.bundlebids')]/Bid) + 3"/>
                    </xsl:otherwise>
                </xsl:choose>
            </xsl:when>
			<xsl:when test="$isRFI">
				<xsl:value-of
					select="$question.end.row + 3" />					
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of
					select="$singlebid.end.row + 5" />							
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>

	<xsl:variable name="BidSellerProductCode" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidMinimum" select="0" saxon:assignable="yes"/>
	<xsl:variable name="BidMaximum" select="0" saxon:assignable="yes"/><!-- PR#59742 : change attribute name-->
	<xsl:variable name="BidPricePerUnit" select="0" saxon:assignable="yes"/>
	<xsl:variable name="BidOneTimeCharge" select="0" saxon:assignable="yes"/>
	<xsl:variable name="BidDeliveryDate" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidLeadDays" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidCurrencyCode" select="''" saxon:assignable="yes"/>
	<xsl:variable name="SupplierOrgCode" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidderLoginName" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidSubmitterLoginName" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidPPUPercentDiscount" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidPPUPercentDiscountType" select="''" saxon:assignable="yes"/>
	<xsl:variable name="BidIsPreliminary" select="''" saxon:assignable="yes"/>
	<xsl:variable name="LineItemEnableDiscountBidding" select="''" saxon:assignable="yes"/>
	<xsl:variable name="item" select="''" saxon:assignable="yes"/>	
	<xsl:variable name="actionvalue" select="''" saxon:assignable="yes"/>
	 <xsl:variable name="xadType" select="''" saxon:assignable="yes"/>
	<xsl:variable name="readOnly" select="''" saxon:assignable="yes"/>
	<xsl:variable name="links" select="''" saxon:assignable="yes"/>
	<xsl:variable name="span" select="''" saxon:assignable="yes"/>
	<xsl:variable name="len" select="''" saxon:assignable="yes"/>	

	<xsl:variable name="deliveryDate" select="''" saxon:assignable="yes"/>
	<xsl:variable name="leadDays" select="''" saxon:assignable="yes"/>
	<xsl:variable name="xaName" select="''" saxon:assignable="yes"/>
	<xsl:variable name="buyerFieldColumn" select="0" saxon:assignable="yes"/>
	<xsl:variable name="lineitemcode" select="''" saxon:assignable="yes"/>
	<xsl:variable name="lineitemtype" select="''" saxon:assignable="yes"/>
	<xsl:variable name="bidcount" select="0" saxon:assignable="yes"/>		
	<xsl:variable name="lineitem" select="." saxon:assignable="yes"/>
	<xsl:variable name="extendedattrname" select="''" saxon:assignable="yes"/>
	<xsl:variable name="extendedattrvalue" select="''" saxon:assignable="yes"/>
	<xsl:variable name="rowNumber" select="0" saxon:assignable="yes"/>

	<xsl:variable name="BidDiscountCodeStr" select="java:getValue($language, 'excelmap.bidfield.discount.code')"/>
	<xsl:variable name="BidSellerProductCodeStr" select="java:getValue($language, 'excelmap.bids.simple.BidSellerProductCode')"/>
	<xsl:variable name="BidMinimumStr" select="java:getValue($language, 'excelmap.bids.simple.BidMinimum')"/>
	<xsl:variable name="BidMaximumStr" select="java:getValue($language, 'excelmap.bids.simple.BidMaximum')"/>
	<xsl:variable name="BidPricePerUnitStr" select="java:getValue($language, 'excelmap.bids.simple.BidPricePerUnit')"/>
	<xsl:variable name="BidOneTimeChargeStr" select="java:getValue($language, 'excelmap.bids.simple.BidOneTimeCharge')"/>
	<xsl:variable name="BidDeliveryDateStr" select="java:getValue($language, 'excelmap.bids.simple.BidDeliveryDate')"/>
	<xsl:variable name="BidLeadDaysStr" select="java:getValue($language, 'excelmap.bids.simple.BidLeadDays')"/>
	<xsl:variable name="AttributeDefVisibilityExposed" select="java:getValue($language,'integration.AttributeDefVisibility.EXPOSED')"/>
	<xsl:variable name="AttributeDefVisibilityReadOnly" select="java:getValue($language,'integration.AttributeDefVisibility.READONLY')"/>

	<xsl:key name="SimpleBidKey" match="//RFx[1]/Bid[@BidType=java:getValue($language, 'excelmap.bid.simple') and @Status=java:getValue($language, 'excelmap.bid.valid')]" use="@BidLineItemCode"/> 
	<xsl:variable name="ActionUpdate" select="java:getValue($language, 'excelmap.bids.simple.update')"/>
	<xsl:variable name="ActionNew" select="java:getValue($language, 'excelmap.bids.simple.new')"/>
	<xsl:variable name="ActionNoBid" select="java:getValue($language, 'excelmap.bids.simple.no_bid')"/>
	<xsl:variable name="csvExport" select="//Option[@OptionKey='CSVExport']/@OptionValue='true'"/>
	<xsl:variable name="listPageExport" select="//Option[@OptionKey='ListPageExport']/@OptionValue='true'"/>

	<!-- ************************************************************** -->
	<!-- RFx section specific for converting from ePASS RFxResponse XML -->
	<!-- ************************************************************** -->
	<xsl:template match="RFxResponse" mode="bidtemplate">
		<!--<xsl:apply-templates select="RFx[1]" mode="bidtemplate"/>-->
		<xsl:choose>
			<xsl:when test="$surrogate or $csvExport or $listPageExport or not(java:exportAdvancedBidTemplates())">
				<sheet>
                    <range>
						<xsl:apply-templates select="RFx[1]" mode="bidtemplate"/>
				    </range>
                </sheet>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="$bid.rfxtype='rfi' or $bid.rfxtype='buyer_rfi'">
						<xsl:apply-templates select="." mode="bid_RFI_template"/>
					</xsl:when>
					<xsl:when test="$bid.rfxtype='sealed'">
						<xsl:apply-templates select="." mode="bid_RFQ_template"/>
                    </xsl:when>
					<xsl:when test="$bid.rfxtype='reverse' or $bid.rfxtype='forward'">
						<xsl:apply-templates select="." mode="bid_Auction_template"/>   
					</xsl:when>
					 <xsl:when test="$bid.rfxtype='rfp'">
						<xsl:apply-templates select="." mode="bid_RFP_template"/>
					</xsl:when>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	   
	</xsl:template>

	<!-- ***************************** -->
	<!-- Handle the RFx Header section -->
	<!-- ***************************** -->
	<xsl:template match="RFx" mode="bidtemplate">
		<row header="true" row="1">
			<cell column="1"><xsl:value-of select="java:getValue($language, 'excelmap.bids.rfx.OrganizationCode')"/></cell>
            <cell column="2"><xsl:value-of select="@OrganizationCode"/></cell>
		</row>
		<row header="true" row="2">
            <cell column="1"><xsl:value-of select="java:getValue($language, 'excelmap.bids.rfx.RFxName')"/></cell>
            <cell column="2"><xsl:value-of select="@RFxName"/></cell>
		</row>
		<row header="true" row="3">
            <cell column="1"><xsl:value-of select="java:getValue($language, 'excelmap.bids.rfx.RFxCode')"/></cell>
            <cell column="2"><xsl:value-of select="@RFxCode"/></cell>
		</row>
		<row header="true" row="4">
            <cell column="1"><xsl:value-of select="java:getValue($language, 'excelmap.bids.rfx.RFxType')"/></cell>
            <cell column="2"><xsl:value-of select="@RFxType"/></cell>
		</row>
		<row header="true" row="5">
			<cell column="1">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.rfx.RFxRoundName')" />
			</cell>
			<cell column="2">
				<xsl:value-of select="@RFxRoundName"/>
			</cell>
		</row>
		<xsl:choose>
			<xsl:when test="$surrogate">
				<row header="true" row="6">
					<cell column="1">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.rfx.RFxRoundDescription')" />
					</cell>
					<cell column="2">
						<xsl:value-of select="@RFxRoundDescription"/>
					</cell>
				</row>
				<row header="true" row="7">
					<cell column="1">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.rfx.RFxOpenDateTime')" />
					</cell>
					<cell column="2">
                        <xsl:variable name="varOpenDateTimeZone">
                            <xsl:if test="@RFxOpenDateTime">
                                <xsl:value-of select="concat(@RFxOpenDateTime, ' ' , /ePASSResponse/@timezone)"/>
                            </xsl:if>
                        </xsl:variable>
                        <xsl:value-of select="$varOpenDateTimeZone"/>
                    </cell>
				</row>
				<row header="true" row="8">
					<cell column="1">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.rfx.RFxCloseDateTime')" />
					</cell>
					<cell column="2">
                        <xsl:variable name="varCloseDateTimeZone">
                            <xsl:if test="@RFxCloseDateTime">
                                <xsl:value-of select="concat(@RFxCloseDateTime, ' ' , /ePASSResponse/@timezone)"/>
                            </xsl:if>
                        </xsl:variable>
                        <xsl:value-of select="$varCloseDateTimeZone"/>
                    </cell>
				</row>
			</xsl:when>
			<xsl:otherwise>
				<row header="true" row="6">
					<cell column="1">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.rfx.RFxOpenDateTime')" />
					</cell>
					<cell column="2">
						<xsl:value-of select="@RFxOpenDateTime"/>
					</cell>
				</row>
				<row header="true" row="7">
					<cell column="1">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.rfx.RFxCloseDateTime')" />
					</cell>
					<cell column="2">
						<xsl:value-of select="@RFxCloseDateTime"/>
					</cell>
				</row>
			</xsl:otherwise>
		</xsl:choose>

		<!-- Response Template -->
		<xsl:if test="$bid.isRFI or $bid.rfxtype='rfp'">
			<!-- set up the headers section -->
			<xsl:call-template name="response.headers">
				<xsl:with-param name="row" select="$response.header.row"/>
			</xsl:call-template>
			<!-- set up the bids section-->
			<xsl:apply-templates select="//RFx[1]/Questionnaire[1]" mode="ResponseTemplate">
				<xsl:with-param name="row" select="$response.body.row + 1"/>
				<xsl:with-param name="questionno" select="1"/>
				<xsl:with-param name="questionaireno" select="1"/>
			</xsl:apply-templates>
			<!-- export area for each matrix section -->
			<xsl:choose>
				<xsl:when test="$surrogate">
					<xsl:apply-templates select="Questionnaire/Question[@QuestionResponseType=$matrixType]" mode="SurrogateMatrix"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:apply-templates select="Questionnaire/Question[@QuestionResponseType=$matrixType]" mode="matrix"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
		<!-- Bidding Template -->
		<xsl:if test="not($bid.isRFI)">
			<!-- set up the headers section -->
			<xsl:call-template name="bid.headers">
				<xsl:with-param name="row" select="$bid.header.row"/>
			</xsl:call-template>
			<!-- set up the bids section-->
			<!--xsl:apply-templates select="//RFx[1]/Requisition[1]" mode="bidtemplate">
				<xsl:with-param name="rowstart" select="$bid.body.row + 1"/>
				<xsl:with-param name="itemno" select="1"/>
			</xsl:apply-templates-->			
			<saxon:assign name="rowNumber" select="$bid.body.row + 1"/>
			<!-- PR 63675 --> 
			<xsl:apply-templates select="//LineItem[not(parent::node()/@LineItemType= java:getValue($language, 'excelmap.lineitem.type.substitution'))]" mode="bidtemplate"/>

			<xsl:if test="not($bid.rfxtype = 'reverse')">				
				<!-- Bundle Bids -->
				<xsl:if test="/ePASSResponse/RFxResponse/RFx/Bid[@BidType = java:getValue($language, 'excelmap.bids.bundlebids')]">
					<xsl:call-template name="bid.bundle">
						<xsl:with-param name="row" select="$singlebid.end.row"/>
						<xsl:with-param name="bundlebids" select="/ePASSResponse/RFxResponse/RFx/Bid[@BidType = java:getValue($language, 'excelmap.bids.bundlebids')]"/>
					</xsl:call-template>
				</xsl:if>
			</xsl:if>
		</xsl:if>
		
		<!-- set up the bid instruction section -->
		<xsl:call-template name="bid.instr.section">
			<xsl:with-param name="row" select="$instr.row"/>
			<xsl:with-param name="rfxType" select="$bid.rfxtype"/>
		</xsl:call-template>
	</xsl:template>

	<!-- *************************** -->
	<!-- Create the response headers -->
	<!-- *************************** -->
	<xsl:template name="response.headers">
		<xsl:param name="row"/>
		<xsl:call-template name="response.header1">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="response.header2">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="response.header3">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
	</xsl:template>

	<!-- ******************** -->
	<!-- response grouping(s) -->
	<!-- ******************** -->
	<xsl:template name="response.header1">
		<xsl:param name="row"/>
		<row header="true" row="{$row}">
            <cell column="1"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.question.info')"/></cell>
			<xsl:if test="$surrogate">
                <cell column="12"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.responder.info')"/></cell>
			</xsl:if>
            <cell column="{$org.response.offset}"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.response.info')"/></cell>
		</row>
	</xsl:template>


	<!-- ********* -->
	<!-- empty row -->
	<!-- ********* -->
	<xsl:template name="response.header2">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 1}"/>
	</xsl:template>

	<!-- ************ -->
	<!-- column names -->
	<!-- ************ -->
	<xsl:template name="response.header3">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 2}">
			<cell column="1">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.ResponseQuestionnaire')" />
			</cell>
			<cell column="2">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionnaireCategoryCode')" />
			</cell>
			<cell column="3">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.ResponseQuestion')" />
			</cell>
			<cell column="4">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseType')" />
			</cell>
			<cell column="5">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseDecimalPlaces')" />
			</cell>
			<cell column="6">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionIsResponseRequired')" />
			</cell>
			<cell column="7">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseMinValue')" />
			</cell>
			<cell column="8">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseMaxValue')" />
			</cell>
			<cell column="9">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseSelectionValues')" />
			</cell>
			<cell column="10">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.rfx.question.QuestionResponseValidation')" />
			</cell>
			<cell column="11">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionDefaultValue')" />
			</cell>
			<xsl:if test="$surrogate">
				<cell column="12">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.response.ResponderOrganizationCode')" />
				</cell>
				<cell column="13">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.response.ResponderLoginName')" />
				</cell>
				<cell column="14">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.response.ResponseSubmitterLoginName')" />
				</cell>
			</xsl:if>
            <cell column="{$org.response.offset}"><xsl:value-of select="java:getValue($language, 'excelmap.bids.response.ResponseValue')"/></cell>
			<cell column="{$org.response.offset + 1}">
				<xsl:value-of select="java:getValue($language, 'excelmap.bids.response.ResponseComments')"/>
			</cell>
		</row>
	</xsl:template>

	<!-- ************ -->
	<!-- Process Questionnaires -->
	<!-- ************ -->
	<xsl:template match="Questionnaire" mode="ResponseTemplate">
		<xsl:param name="row"/>
		<xsl:param name="questionno"/>
		<xsl:param name="questionaireno"/>
		<xsl:apply-templates select="./Question[$questionno]" mode="bidtemplate">
			<xsl:with-param name="row" select="$row"/>
		</xsl:apply-templates>
		<xsl:variable name="responsecnt" select="count(//RFx[1]/Response[@ResponseQuestion = //RFx[1]/Questionnaire[$questionaireno]/Question[$questionno]/@QuestionText])"/>
		<xsl:variable name="questioncnt">
			<xsl:value-of select="count(./Question)"/>
		</xsl:variable>
		<xsl:choose>
			<xsl:when test="(following-sibling::*[1])">
				<xsl:apply-templates select="following-sibling::*[1]" mode="ResponseTemplate">
					<!-- xsl:with-param name="row" select="java:getRowForQuestion($QuestionRowMap)"/-->
					<xsl:with-param name="row" select="$question.end.row"/>
					<xsl:with-param name="questionno" select="1"/>
					<xsl:with-param name="questionaireno" select="$questionaireno + 1"/>
				</xsl:apply-templates>
			</xsl:when>
		</xsl:choose>
	</xsl:template>

	<!-- ************************************************ -->
	<!-- Create the question section of the response area -->
	<!-- ************************************************ -->
	<xsl:template match="Question" mode="bidtemplate">
		<xsl:param name="row"/>
		<xsl:variable name="questiontext" select="@QuestionText"/>
		<xsl:variable name="responsecount" select="count(/ePASSResponse/RFxResponse/RFx/Response[@ResponseQuestion=$questiontext])"/>
		<xsl:variable name="question" select="."/>
		<xsl:if test="$question[@QuestionResponseType != 'Table']">
			<xsl:call-template name="QuestionResponse">
				<xsl:with-param name="row" select="$row"/>
				<xsl:with-param name="question" select="$question"/>
				<xsl:with-param name="responses" select="/ePASSResponse/RFxResponse/RFx/Response[@ResponseQuestion=$questiontext]"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="$responsecount &lt; 2">
				<!-- xsl:value-of select="java:addRowForQuestion($QuestionRowMap, $row + 1, $questiontext)"/-->
				<saxon:assign name="question.end.row" select="$row + 1"/>
			</xsl:when>
			<xsl:otherwise>
				<!-- xsl:value-of select="java:addRowForQuestion($QuestionRowMap, $row + $responsecount, $questiontext)"/-->
				<saxon:assign name="question.end.row" select="$row + $responsecount"/>
			</xsl:otherwise>
		</xsl:choose>
		<xsl:choose>
			<xsl:when test="following-sibling::*[1]">
				<xsl:choose>
					<xsl:when test="$responsecount &lt; 2">
						<xsl:apply-templates select="following-sibling::*[1]" mode="bidtemplate">
							<xsl:with-param name="row" select="$row + 1"/>
						</xsl:apply-templates>
					</xsl:when>
					<xsl:otherwise>
						<xsl:apply-templates select="following-sibling::*[1]" mode="bidtemplate">
							<xsl:with-param name="row" select="$row + $responsecount"/>
						</xsl:apply-templates>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
		</xsl:choose>
	</xsl:template>
	
	<!-- ************************************************ -->
	<!-- Create the question section of the response area -->
	<!-- ************************************************ -->
	<xsl:template name="QuestionResponse">
		<xsl:param name="row"/>
		<xsl:param name="question"/>
		<xsl:param name="responses"/>
		<xsl:if test="count($responses) &lt; 1">
			<row row="{$row + 1}">
				<xsl:apply-templates select="$question" mode="Query">
					<xsl:with-param name="row" select="$row + 1"/>
				</xsl:apply-templates>
				<!-- row row="{$row + 1}"-->
				<xsl:choose>
					<xsl:when test="$surrogate">
						<cell header="false" column="12">
							<xsl:value-of select="$responses/@ResponderOrganizationCode"/>
						</cell>
						<cell header="false" column="13">
							<xsl:value-of select="$responses/@ResponderLoginName"/>
						</cell>
						<cell header="false" column="14">
							<xsl:value-of select="$responses/@ResponseSubmitterLoginName"/>
						</cell>
					</xsl:when>
				</xsl:choose>
            <xsl:variable name="xadType"
                    select="java:getName($language, @QuestionResponseType, 'integration.AttributeDefDataType.')"/>
				<xsl:choose>
					<xsl:when test="$xadType='MATRIX_TYPE'">
					<cell header="false"
						column="{$org.response.offset}">
							<xsl:value-of select="$TableResponse"/>
						</cell>
					</xsl:when>
				<xsl:when
					test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'">
					<cell header="true"
						column="{$org.response.offset}">
							<xsl:value-of select="'XXXXX'"/>
						</cell>
					</xsl:when>
					<xsl:otherwise>
					<cell header="false"
						column="{$org.response.offset}">
							<xsl:value-of select="$responses/@ResponseValue"/>
						</cell>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
				<xsl:when
					test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'
        	            or not($question/@QuestionAllowComments= $trueValue
            	           or translate($question/@QuestionAllowComments, 'truefals', 'TRUEFALS')='TRUE')">
					<cell header="true"
						column="{$org.response.offset + 1}">
							<xsl:value-of select="'XXXXX'"/>
						</cell>
					</xsl:when>
					<xsl:otherwise>
					<cell header="false"
						column="{$org.response.offset + 1}">
							<xsl:value-of select="$responses/@ResponseComments"/>
						</cell>
					</xsl:otherwise>
				</xsl:choose>
			</row>
			<saxon:assign name="question.end.row" select="$row + 1"/>
		</xsl:if>
		
		<xsl:for-each select="$responses">
			<row row="{$row + position()}">
				<xsl:apply-templates select="$question" mode="Query">
					<xsl:with-param name="row" select="$row + position()"/>
				</xsl:apply-templates>
				<!-- row row="{$row + position()}"-->
				<saxon:assign name="question.end.row" select="$row + position()"/>
				<xsl:choose>
					<xsl:when test="$surrogate">
						<cell header="false" column="12">
							<xsl:value-of select="./@ResponderOrganizationCode"/>
						</cell>
						<cell header="false" column="13">
							<xsl:value-of select="./@ResponderLoginName"/>
						</cell>
						<cell header="false" column="14">
							<xsl:value-of select="./@ResponseSubmitterLoginName"/>
						</cell>
					</xsl:when>
				</xsl:choose>
		            <xsl:variable name="xadType"
		                    select="java:getName($language, @QuestionResponseType, 'integration.AttributeDefDataType.')"/>
				<xsl:choose>
					<xsl:when test="$xadType='MATRIX_TYPE'">
							<cell header="false"
								column="{$org.response.offset}">
							<xsl:value-of select="$TableResponse"/>
						</cell>
					</xsl:when>
						<xsl:when
							test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'">
							<cell header="true"
								column="{$org.response.offset}">
							<xsl:value-of select="'XXXXX'"/>
						</cell>
					</xsl:when>
					<xsl:otherwise>
							<cell header="false"
								column="{$org.response.offset}">
							<xsl:value-of select="./@ResponseValue"/>
						</cell>
					</xsl:otherwise>
				</xsl:choose>
				<xsl:choose>
						<xsl:when
							test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'
		        	            or not($question/@QuestionAllowComments= $trueValue
		            	           or translate($question/@QuestionAllowComments, 'truefals', 'TRUEFALS')='TRUE')">
							<cell header="true"
								column="{$org.response.offset + 1}">
							<xsl:value-of select="'XXXXX'"/>
						</cell>
					</xsl:when>
					<xsl:otherwise>
							<cell header="false"
								column="{$org.response.offset + 1}">
							<xsl:value-of select="./@ResponseComments"/>
						</cell>
					</xsl:otherwise>
				</xsl:choose>
			</row>
		</xsl:for-each>
	</xsl:template>
    
	<!-- ************ -->
	<!-- Process Questions Responses -->
	<!-- ************ -->
	<xsl:template match="Question" mode="Query">
		<xsl:param name="row"/>
		<!-- row row="{$row}"-->
		<cell header="true" column="1">
			<xsl:value-of select="../@QuestionnaireName"/>
		</cell>
		<cell header="true" column="2">
			<xsl:value-of select="../@QuestionnaireCategoryCode"/>
		</cell>
		<cell header="true" column="3">
			<xsl:value-of select="@QuestionText"/>
		</cell>
		<cell header="true" column="4">
			<xsl:value-of select="@QuestionResponseType"/>
		</cell>
		<cell header="true" column="5">
			<xsl:value-of select="@QuestionResponseDecimalPlaces"/>
		</cell>
		<cell header="true" column="6">
			<xsl:value-of select="@QuestionIsResponseRequired"/>
		</cell>
		<cell header="true" column="7">
			<xsl:value-of select="@QuestionResponseMinValue"/>
		</cell>
		<cell header="true" column="8">
			<xsl:value-of select="@QuestionResponseMaxValue"/>
		</cell>
		<cell header="true" column="9">
			<xsl:value-of select="@QuestionResponseSelectionValues"/>
		</cell>
		<cell header="true" column="10">
			<xsl:value-of select="@QuestionResponseValidation"/>
		</cell>
		<cell header="true" column="11">
			<xsl:value-of select="@QuestionDefaultValue"/>
		</cell>
		<saxon:assign name="question.end.row" select="$row"/>
		<!-- /row-->
	</xsl:template>

	<!-- ************ -->
	<!-- Process Questions headers-->
	<!-- ************ -->
	<xsl:template match="Question" mode="matrix">
		<xsl:variable name="question" select="."/>
		<xsl:variable name="questionnaireName"
			select="../@QuestionnaireName" />
		<xsl:variable name="records"
			select="ExtendedAttributeDefinition[@XADSubDataType=$matrixRecord]" />
		<xsl:variable name="fields"
			select="ExtendedAttributeDefinition[@XADSubDataType=$matrixField]" />
		<row header="true" row="{$matrix.row}">
			<cell column="1">
				<xsl:value-of select="$TableResponse"/>
			</cell>
			<cell column="2">
				<xsl:value-of select="$questionnaireName"/>
			</cell>
			<cell column="3">
				<xsl:value-of select="$question/@QuestionText"/>
			</cell>
			<cell column="4">
				<xsl:value-of
					select="java:getValue($language, 'integration.MatrixFieldLabel')" />
			</cell>
			<cell column="5">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseType')" />
			</cell>
			<cell column="6">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseDecimalPlaces')" />
			</cell>
			<cell column="7">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseMinValue')" />
			</cell>
			<cell column="8">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseMaxValue')" />
			</cell>
			<cell column="9">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseSelectionValues')" />
			</cell>
			<cell column="10">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.rfx.question.QuestionResponseValidation')" />
			</cell>
			<!-- PR60427 start -->
			<cell column="11">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionDefaultValue')" />
			</cell>
			<!-- PR60427 end -->
			<xsl:if test="$surrogate">
				<cell column="12">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.response.ResponderOrganizationCode')" />
				</cell>
				<cell column="13">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.response.ResponderLoginName')" />
				</cell>
				<cell column="14">
                	<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.response.ResponseSubmitterLoginName')" />
				</cell>
			</xsl:if>
			<xsl:for-each select="$records">
				<cell column="{$org.matrix.offset + position()}">
					<xsl:value-of select="@XADName"/>
				</cell>
			</xsl:for-each>
			<cell column="{$org.matrix.offset + count($records) + 1}">
					<xsl:value-of select="java:getValue($language, 'excelmap.bids.response.ResponseComments')"/>
			</cell>
		</row>
		<xsl:for-each select="$fields">
			<xsl:variable name="rowpos" select="position()"/>
			<xsl:variable name="fldcode"
				select="java:nameToCode(@XADName)" />	
			<xsl:variable name="fldname"
				select="@XADName" />					
			<row row="{$matrix.row + $rowpos}">
				<cell header="true" column="1"/>
				<cell header="true" column="2">
					<xsl:value-of select="$questionnaireName"/>
				</cell>
				<cell header="true" column="3">
					<xsl:value-of select="$question/@QuestionText"/>
				</cell>
				<cell header="true" column="4">
					<xsl:value-of select="@XADDescription"/>
				</cell>
				<cell header="true" column="5">
					<xsl:value-of select="@XADDataType"/>
				</cell>
				<cell header="true" column="6">
					<xsl:value-of select="@XADPrecision"/>
				</cell>
				<cell header="true" column="7">
					<xsl:value-of select="@XADMinimumValue"/>
				</cell>
				<cell header="true" column="8">
					<xsl:value-of select="@XADMaximumValue"/>
				</cell>
				<cell header="true" column="9">
					<xsl:value-of select="@XADSelectionList"/>
				</cell>
				<cell header="true" column="10">
					<xsl:value-of select="@XADValidation"/>
				</cell>
				<!-- PR60427 start -->
				<cell header="true" column="11">
					<xsl:value-of select="@XADDefaultValue"/>
				</cell>
				<!-- PR60427 end -->
				<xsl:for-each select="$records">
					<xsl:variable name="colpos" select="position()"/>
					<xsl:variable name="reccode" select="java:nameToCode(@XADName,'false')"/>
					<xsl:variable name="cellname" select="concat($fldcode, $reccode)"/>
					<xsl:variable name="recordname" select="@XADName"/>
					<xsl:variable name="response" select="//Response/TableValue/Record[@name=$recordname]/Field[@name=$fldname]/@value"/>
					<!--<xsl:if test="$question/ExtendedAttributeDefinition[@XADName=$fldname]
                    			[@XADIsActive='false']">-->
                    <!-- PR#44761 : check for cell visibility-->
                    <xsl:variable name="cellVisibility"
                    		select="$question/ExtendedAttributeDefinition[@XADName = $cellname]/@XADSubDataType"/>                    
                    <!-- PR#44764 : changed if test -->
                    <xsl:if test="$question/ExtendedAttributeDefinition[@XADName=$fldname]">  
                    	<xsl:choose>
                    		<xsl:when test="empty($cellVisibility) or string-length($cellVisibility) &lt;= 0 or 
                    						not($cellVisibility = 'cell')">
						<cell header="false" column="{$org.matrix.offset + $colpos}">
							<xsl:value-of select="$response"/>
						</cell>
                    		</xsl:when>
                    		<xsl:otherwise>
                    			<cell header="true" column="{$org.matrix.offset + $colpos}">
									<xsl:value-of select="'XXXXX'"/>
								</cell>
                    		</xsl:otherwise>
                    	</xsl:choose>						
						<xsl:variable name="responsecomments" select="//Response[@ResponseQuestionnaire=$questionnaireName]
                        										[@ResponseQuestion=$question/@QuestionText]/@ResponseComments"/>
                        <xsl:variable name="allowComments" select="$question/@QuestionAllowComments"/>
							<xsl:choose>
                        	<xsl:when test="empty($allowComments) or 
                        					$allowComments = 'false'">
                        			<cell header="true" column="{$org.matrix.offset + $colpos + 1}">
									<xsl:value-of select="'XXXXX'"/>
                        			</cell>
								</xsl:when>
								<xsl:otherwise>
                        			<cell header="false" column="{$org.matrix.offset + $colpos + 1}">
									<xsl:value-of select="$responsecomments"/>
                        			</cell>
								</xsl:otherwise>
							</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</row>
		</xsl:for-each>
		<saxon:assign name="matrix.row" select="number($matrix.row) + count($fields) + 2"/>
		<saxon:assign name="question.end.row" select="number($matrix.row)"/>
	</xsl:template>
    
	<!-- ********************** -->
	<!-- Process questions and their responses when surrogate -->
	<!-- ********************** -->
	<xsl:template match="Question" mode="SurrogateMatrix">
		<xsl:variable name="question" select="."/>
		<xsl:variable name="questiontxt" select="$question/@QuestionText"/>
		<xsl:variable name="questionnaireName"
			select="../@QuestionnaireName" />
		<xsl:variable name="responses" select="//Response[@ResponseQuestionnaire=$questionnaireName][@ResponseQuestion=$questiontxt][@ResponseValue='Table Response']"/>
		<xsl:variable name="responsecount" select="count($responses)"/>
		<xsl:if test="$responsecount &lt; 1">
			<xsl:apply-templates select="$question" mode="matrix"/>
		</xsl:if>
		<xsl:for-each select="$responses">
			<xsl:apply-templates select="$question" mode="SurrogateResponse">
				<xsl:with-param name="response" select="."/>
			</xsl:apply-templates>
		</xsl:for-each>
	</xsl:template>
    
	<!-- ************ -->
	<!-- Process Questions headers-->
	<!-- ************ -->
	<xsl:template match="Question" mode="SurrogateResponse">
		<xsl:param name="response"/>
		<xsl:variable name="question" select="."/>
		<xsl:variable name="questionnaireName"
			select="../@QuestionnaireName" />
		<xsl:variable name="records"
			select="ExtendedAttributeDefinition[@XADSubDataType=$matrixRecord]" />
		<xsl:variable name="fields"
			select="ExtendedAttributeDefinition[@XADSubDataType=$matrixField]" />
		<row header="true" row="{$matrix.row}">
			<cell column="1">
				<xsl:value-of select="$TableResponse"/>
			</cell>
			<cell column="2">
				<xsl:value-of select="$questionnaireName"/>
			</cell>
			<cell column="3">
				<xsl:value-of select="$question/@QuestionText"/>
			</cell>
			<cell column="4">
				<xsl:value-of
					select="java:getValue($language, 'integration.MatrixFieldLabel')" />
			</cell>
			<cell column="5">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseType')" />
			</cell>
			<cell column="6">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseDecimalPlaces')" />
			</cell>
			<cell column="7">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseMinValue')" />
			</cell>
			<cell column="8">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseMaxValue')" />
			</cell>
			<cell column="9">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionResponseSelectionValues')" />
			</cell>
			<cell column="10">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.rfx.question.QuestionResponseValidation')" />
			</cell>
			<!-- PR60427 start -->
			<cell column="11">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.questions.QuestionDefaultValue')" />
			</cell>     
			<!-- PR60427 end -->       
			<cell column="12">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.response.ResponderOrganizationCode')" />
			</cell>
			<cell column="13">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.response.ResponderLoginName')" />
			</cell>
			<cell column="14">
            	<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.response.ResponseSubmitterLoginName')" />
			</cell>
            
			<xsl:for-each select="$records">
				<cell column="{$org.matrix.offset + position()}">
					<xsl:value-of select="@XADName"/>
				</cell>
			</xsl:for-each>
			<cell column="{$org.matrix.offset + count($records) + 1}">
					<xsl:value-of select="java:getValue($language, 'excelmap.bids.response.ResponseComments')"/>
			</cell>
		</row>
		<xsl:for-each select="$fields">
			<xsl:variable name="rowpos" select="position()"/>
			<xsl:variable name="fldcode"
				select="java:nameToCode(@XADName)" />	
			<xsl:variable name="fldname"
				select="@XADName" />					
			<row row="{$matrix.row + $rowpos}">
				<cell header="true" column="1"/>
				<cell header="true" column="2">
					<xsl:value-of select="$questionnaireName"/>
				</cell>
				<cell header="true" column="3">
					<xsl:value-of select="$question/@QuestionText"/>
				</cell>
				<cell header="true" column="4">
					<xsl:value-of select="@XADDescription"/>
				</cell>
				<cell header="true" column="5">
					<xsl:value-of select="@XADDataType"/>
				</cell>
				<cell header="true" column="6">
					<xsl:value-of select="@XADPrecision"/>
				</cell>
				<cell header="true" column="7">
					<xsl:value-of select="@XADMinimumValue"/>
				</cell>
				<cell header="true" column="8">
					<xsl:value-of select="@XADMaximumValue"/>
				</cell>
				<cell header="true" column="9">
					<xsl:value-of select="@XADSelectionList"/>
				</cell>
				<cell header="true" column="10">
					<xsl:value-of select="@XADValidation"/>
				</cell>
				<!-- PR60427 start -->
				<cell header="true" column="11">
					<xsl:value-of select="@XADDefaultValue"/>
				</cell>
				<!-- PR60427 end -->
				<xsl:for-each select="$records">
					<xsl:variable name="colpos" select="position()"/>
					<xsl:variable name="reccode" select="java:nameToCode(@XADName)"/>
					<xsl:variable name="cellname" select="concat($fldcode, $reccode)"/>
					<xsl:variable name="recordname" select="@XADName"/>
					<xsl:variable name="answer" select="$response/TableValue/Record[@name=$recordname]/Field[@name=$fldname]/@value"/>
					<!--<xsl:if test="$question/ExtendedAttributeDefinition[@XADName=$fldname]
                    			[@XADIsActive='false']">-->
                    	<!-- PR#44761 : check for cell visibility-->
                    <xsl:variable name="cellVisibility"
                    		select="$question/ExtendedAttributeDefinition[@XADName = $cellname]/@XADSubDataType"/>                    
                    <!-- PR#44764 : changed if test -->
                    <xsl:if test="$question/ExtendedAttributeDefinition[@XADName=$fldname]">
						<cell header="true" column="12">
							<xsl:value-of select="$response/@ResponderOrganizationCode"/>
						</cell>
						<cell header="true" column="13">
							<xsl:value-of select="$response/@ResponderLoginName"/>
						</cell>
						<cell header="true" column="14">
							<xsl:value-of select="$response/@ResponseSubmitterLoginName"/>
						</cell>
						<xsl:choose>
                    		<xsl:when test="empty($cellVisibility) or string-length($cellVisibility) &lt;= 0 or 
                    						not($cellVisibility = 'cell')">
						<cell header="false" column="{$org.matrix.offset + $colpos}">
							<xsl:value-of select="$answer"/>
						</cell>
                    		</xsl:when>
                    		<xsl:otherwise>
                    			<cell header="true" column="{$org.matrix.offset + $colpos}">
									<xsl:value-of select="'XXXXX'"/>
								</cell>
                    		</xsl:otherwise>
                    	</xsl:choose>
						<xsl:variable name="responsecomments" select="//Response[@ResponseQuestionnaire=$questionnaireName]
                        										[@ResponseQuestion=$question/@QuestionText]/@ResponseComments"/>
                        <xsl:variable name="allowComments" select="$question/@QuestionAllowComments"/>
							<xsl:choose>
                        	<xsl:when test="empty($allowComments) or 
                        					$allowComments = 'false'">
                        			<cell header="true" column="{$org.matrix.offset + $colpos + 1}">
									<xsl:value-of select="'XXXXX'"/>
                        			</cell>
								</xsl:when>
								<xsl:otherwise>
                        			<cell header="false" column="{$org.matrix.offset + $colpos + 1}">
                        				<xsl:value-of select="$responsecomments"/>
                        			</cell>
								</xsl:otherwise>
							</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</row>
		</xsl:for-each>
		<saxon:assign name="matrix.row" select="number($matrix.row) + count($fields) + 2"/>
		<saxon:assign name="question.end.row" select="number($matrix.row)"/>
	</xsl:template>

	<!-- ********************** -->
	<!-- Create the bid headers -->
	<!-- ********************** -->
	<xsl:template name="bid.headers">
		<xsl:param name="row"/>
		<saxon:assign name="IACount" select="count($bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])])"/>
		<xsl:call-template name="bid.header0">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="bid.header1">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="bid.header2">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="bid.header3">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="bid.header4">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="bid.header5">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		<xsl:call-template name="bid.header6">
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
		
	</xsl:template>
		
	<!-- *************** -->
	<!-- Bid Section: Simple Bids -->
	<!-- *************** -->
	<xsl:template name="bid.header0">
		<xsl:param name="row"/>
		<row sectionHeader="true" row="{$row}">
			<cell column="{$org.bid.offset + $userDefinedItemIACount}">
				<xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.section.simplebids')"/>
			</cell>
			<xsl:if test="$bid.rfxtype = 'rfp' or $bid.rfxtype='sealed'">
				<xsl:if test="$bundleBidEnabled=$trueValue">
					<xsl:call-template name="bid.header9"/>
				</xsl:if>				
				<xsl:if test="$volumeBidEnabled=$trueValue">
					<xsl:call-template name="bid.header7"/>					
				</xsl:if>
			</xsl:if>
		</row>
	</xsl:template>

	<!-- *************** -->
	<!-- bid grouping(s) -->
	<!-- *************** -->
	<xsl:template name="bid.header1">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 1}">
            <cell column="1"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.item.info')"/></cell>
            <xsl:if test="$surrogate">
                <xsl:choose>
                    <xsl:when test="($bid.rfxtype = 'reverse') or ($bid.rfxtype = 'forward')">
                         <cell column="{$org.bid.offset - 4}"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.buyer.info')"/></cell>
                    </xsl:when>
                    <xsl:when test="not($bid.rfxtype = 'reverse' or $bid.rfxtype = 'forward')">
                        <cell column="{$org.bid.offset - 3}"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.buyer.info')"/></cell>
                    </xsl:when>
                </xsl:choose>
            </xsl:if>
            <cell column="{$org.bid.offset + $userDefinedItemIACount}"><xsl:value-of select="java:getValue($language, 'excelmap.bids.headers.bid.info')"/></cell>
		</row>
	</xsl:template>


	<!-- ********* -->
	<!-- empty row -->
	<!-- ********* -->
	<xsl:template name="bid.header2">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 2}"/>
	</xsl:template>

	<!-- ************ -->
	<!-- column names -->
	<!-- ************ -->
	<xsl:template name="bid.header3">
		<xsl:param name="row"/>
		<saxon:assign name="columnNumber" select="1"/>
		<row header="true" row="{$row + 3}">
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getPredefinedItemIATranslationValue($language, 'name', @OrganizationCode, @RFxCode)" />
			</cell>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getPredefinedItemIATranslationValue($language, 'code', @OrganizationCode, @RFxCode)" />
			</cell>
			<xsl:if test="$itemDescriptionPresent">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of
						select="java:getPredefinedItemIATranslationValue($language, 'description', @OrganizationCode, @RFxCode)" />
				</cell>
			</xsl:if>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getPredefinedItemIATranslationValue($language, 'minQuantity', @OrganizationCode, @RFxCode)" />
			</cell>
			<xsl:if test="$includeItemDefs">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'specification', @OrganizationCode, @RFxCode)" />
				</cell>
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'specificationURL', @OrganizationCode, @RFxCode)" />
				</cell>
			</xsl:if>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getPredefinedItemIATranslationValue($language, 'unitOfMeasure', @OrganizationCode, @RFxCode)" />
			</cell>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.line_items.LineItemCategory')" />
			</cell>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.line_items.LineItemLotName')" />
			</cell>
			<xsl:if test="$bid.rfxtype = 'reverse' or $bid.rfxtype = 'forward'">
                <saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.line_items.ForcedLot')" />				
				</cell>
				<xsl:if test="//RFx/AuctionRules/@AllowDiscountBidding = $trueValue">
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.line_items.LineItemBasePrice')" />					
					</cell>
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
						<xsl:value-of
							select="java:getValue($language, 'excelmap.bids.line_items.LineItemDiscountType')" />				
					</cell>
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
						<xsl:value-of
							select="java:getValue($language, 'excelmap.bids.line_items.LineItemMinimumChange')" />				
					</cell>
					<!--saxon:assign name="columnNumber" select="3"/-->
				</xsl:if>				
				<!--xsl:choose>
					<xsl:when test="$columnNumber = 3">
						<saxon:assign name="columnNumber" select="5"/>
					</xsl:when>
					<xsl:otherwise>
						<saxon:assign name="columnNumber" select="2"/>
					</xsl:otherwise>
				</xsl:choose-->
			</xsl:if>
			<xsl:if test="$includeItemDefs">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of select="java:getValue($language, 'excelmap.bids.line_items.ItemType')" />
				</cell>
				<xsl:if test="$itemSetEnabled=$trueValue">
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
						<xsl:value-of select="java:getValue($language, 'excelmap.bids.line_items.ParentItemUniqueID')" />
					</cell>
				</xsl:if>
				<xsl:if test="$bid.rfxtype = 'sealed' or $bid.rfxtype = 'rfp'">
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'maxQuantity', @OrganizationCode, @RFxCode)" />
					</cell>
				</xsl:if>
			
				<xsl:if test="$showDeliveryDate">
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
						<xsl:value-of select="java:getPredefinedBidIATranslationValue($language, 'deliveryDate', @OrganizationCode, @RFxCode)" />
					</cell>
				</xsl:if>
				<xsl:if test="$showLeadDays">
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
						<xsl:value-of select="java:getPredefinedBidIATranslationValue($language, 'leadDays', @OrganizationCode, @RFxCode)" />
					</cell>
				</xsl:if>
				<xsl:call-template name="ItemIAsHeader"/>
			</xsl:if>
						
						
			<xsl:if test="$surrogate">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.bids.BidderOrganizationCode')" />
				</cell>
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.bids.BidderLoginName')" />
				</cell>
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell column="{$columnNumber}">
					<xsl:value-of
						select="java:getValue($language, 'excelmap.bids.bids.BidSubmitterLoginName')" />
				</cell>					
				<xsl:if test="$bid.rfxtype = 'reverse' or 
							$bid.rfxtype = 'forward'">
					<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
					<cell column="{$columnNumber}">
						<xsl:value-of
							select="java:getValue($language, 'excelmap.bids.bids.BidPreliminary')" />
					</cell>
				</xsl:if>
			</xsl:if>
			
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.bids.BidAction')" />
			</cell>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell column="{$columnNumber}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.bids.BidCurrencyCode')" />
			</cell>
		
			<!-- iterate over extended attributes to get codes -->
			<xsl:for-each
				select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">
				<cell column="{$columnNumber + position()}">					
					<xsl:choose>
						<xsl:when test="../@XADIsRequired= $trueValue
                                or translate(../@XADIsRequired, 'truefals', 'TRUEFALS')='TRUE'">
                            <xsl:choose>
                            	<xsl:when test=". = $BidDiscountCodeStr">
                            		<xsl:value-of select="concat('*', java:getValue($language, 'excelmap.bidfield.discount.value'))"/>
	                            </xsl:when>	
	                            <xsl:otherwise>
	                            	<xsl:value-of select="concat('*',.)"/>
	                            </xsl:otherwise>
                            </xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<xsl:choose>
                            	<xsl:when test=". = $BidDiscountCodeStr">
                            		<xsl:value-of select="java:getValue($language, 'excelmap.bidfield.discount.value')"/>
	                            </xsl:when>	
	                            <xsl:when test="(. = $BidMinimumStr) and
	                            				(//RFx/RFQBiddingRules/@RFxAllowOptimizationFeedback = $trueValue)">
                            		<xsl:value-of select="concat('*',.)"/><!-- PR#60526 -->
	                            </xsl:when>	
	                            <xsl:otherwise>
	                            	<xsl:value-of select="."/>
	                            </xsl:otherwise>
                            </xsl:choose>							
						</xsl:otherwise>
					</xsl:choose>
				</cell>
			</xsl:for-each>
			<xsl:if test="$bid.rfxtype = 'rfp' or $bid.rfxtype='sealed'">
				<xsl:if test="$bundleBidEnabled=$trueValue">
					<xsl:call-template name="bid.header10"/>
				</xsl:if>
				<xsl:if test="$volumeBidEnabled=$trueValue">
					<xsl:call-template name="bid.header8"/>					
				</xsl:if>
			</xsl:if>
		</row>
	</xsl:template>

	<!-- ****************** -->
	<!-- xad description(s) -->
	<!-- ****************** -->
	<xsl:template name="bid.header4">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 4}">
			<!-- iterate over extended attributes to get codes -->
			<xsl:for-each
				select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">
				<cell column="{$columnNumber + $userDefinedItemIACount + position()}">
					<xsl:value-of select="../@XADDescription"/>
				</cell>
			</xsl:for-each>
		</row>
	</xsl:template>

	<!-- *********** -->
	<!-- xad type(s) -->
	<!-- *********** -->
	<xsl:template name="bid.header5">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 5}">
			<!-- iterate over extended attributes to get codes -->
			<xsl:for-each
				select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">
				<cell column="{$columnNumber + $userDefinedItemIACount + position()}">
					<xsl:value-of select="../@XADDataType"/>
				</cell>
			</xsl:for-each>
		</row>
	</xsl:template>

	<!-- ********************************* -->
	<!-- xad info (selection/defval/etc(s) -->
	<!-- ********************************* -->
	<xsl:template name="bid.header6">
		<xsl:param name="row"/>
		<row header="true" row="{$row + 6}">
			<cell column="{$columnNumber + $userDefinedItemIACount}">
				<xsl:value-of select="//RFx/@RFxCurrencyCodes"/> <!-- For PR 61110 changed attribute from RFxDefaultCurrencyCode to RFxCurrencyCodes-->
			</cell>
			<!-- iterate over extended attributes to get codes -->
			<xsl:for-each
				select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">
				<xsl:variable name="range">
					<xsl:choose>
						<xsl:when test="../@XADSelectionList">
							<xsl:value-of select="../@XADSelectionList"/>
						</xsl:when>
						<xsl:when
							test="../@XADMinimumValue and ../@XADMaximumValue">
							<xsl:value-of
								select="concat('X &gt;= ', ../@XADMinimumValue,
                                    '; X &lt;= ', ../@XADMaximumValue)"/>
						</xsl:when>
						<xsl:when test="../@XADMinimumValue">
							<xsl:value-of
								select="concat('X &gt;= ', ../@XADMinimumValue)" />
						</xsl:when>
						<xsl:when test="../@XADMaximumValue">
							<xsl:value-of
								select="concat('X &lt;= ', ../@XADMaximumValue)" />
						</xsl:when>
						<xsl:when test="../@XADValidation">
							<xsl:value-of select="../@XADValidation"/>
						</xsl:when>
					</xsl:choose>
				</xsl:variable>
				<cell column="{$columnNumber + $userDefinedItemIACount + position() }">
					<xsl:value-of select="$range"/>
				</cell>
			</xsl:for-each>
		</row>
	</xsl:template>

	<xsl:variable name="volumeOffSet">
		<xsl:choose>
			<xsl:when test="$bundleBidEnabled=$trueValue">
				<xsl:value-of select="3"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="0"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:variable>

	<!-- *************** -->
	<!-- Bid Section: Volume Discount Bids Section start - Main header-->
	<!-- *************** -->
	<xsl:template name="bid.header7">
		<cell column="{$org.bid.offset + $userDefinedItemIACount + $IACount + $volumeOffSet +2}">
			<xsl:value-of
				select="java:getValue($language, 'excelmap.bids.headers.section.volumediscountbids')" />
		</cell>
	</xsl:template>
	
	<!-- *************** -->
	<!-- Bid Section: Volume Discount Bids Headings -->
	<!-- *************** -->
	<xsl:template name="bid.header8">
			<xsl:variable name="column">
				<xsl:choose>
					<xsl:when test="$surrogate">
						<xsl:value-of select="3"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="0"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<cell column="{$org.bid.offset + $IACount + $volumeOffSet+2}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.headers.section.stepvolumediscount')" />
			</cell>
			<cell column="{$org.bid.offset + $IACount + $volumeOffSet+3}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.volume.minimumquantity')" />
			</cell>
			<cell column="{$org.bid.offset + $IACount + $volumeOffSet +4}">
				<xsl:value-of
					select="java:getValue($language, 'excelmap.bids.volume.maximumquantity')" />
			</cell>
	</xsl:template>
	
	<!-- **************************************************************************************************************** -->
	<!-- process volume bid -->
	<!-- **************************************************************************************************************** -->
	<xsl:template name="bid.volume">
		<xsl:param name="row"/>
		<xsl:param name="volumebids"/>
		<!-- xsl:variable name="start" select="$row + $bid.ItemBidCount + 9 + $bid.lineItemCount"/-->
		<xsl:variable name="start">
			<xsl:choose>
				<xsl:when test="$bid.ItemBidCount &gt; 0 and $bid.ItemBidCount &gt; $bid.lineItemCount and $surrogate">
					<xsl:value-of select="$row + $bid.ItemBidCount + 10"/>
				</xsl:when>
				<xsl:when test="$bid.ItemBidCount &gt; 0 and $bid.ItemBidCount &gt; $bid.lineItemCount">
					<xsl:value-of select="$row + $bid.ItemBidCount + 9"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$row + $bid.lineItemCount + 10"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="column">
			<xsl:choose>
				<xsl:when test="$surrogate">
					<xsl:value-of select="3"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="0"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:for-each select="$volumebids/Bid">
			<row row="{$start + position()}">
				<xsl:if test="$surrogate">
					<cell header="false" column="1">
						<xsl:value-of
							select="@BidderOrganizationCode" />
					</cell>
					<cell header="false" column="2">
						<xsl:value-of
							select="@BidderLoginName" />
					</cell>
					<cell header="false" column="3">
						<xsl:value-of
							select="@BidSubmitterLoginName" />
					</cell>
				</xsl:if>
				<cell header="false" column="{$column + $org.bid.offset + $IACount +5}">
					<xsl:value-of
						select="../@VolumeDiscount" />
				</cell>
				<cell header="false" column="{$column + $org.bid.offset + $IACount +6}">
					<xsl:value-of
						select="@BidMinimum" />
				</cell>
				<cell header="false" column="{$column + $org.bid.offset + $IACount +7}">
					<xsl:value-of
						select="@BidMaximum" />
				</cell>
			</row>
		</xsl:for-each>
	</xsl:template>
	
	<!-- *************** -->
	<!-- Bid Section: Bundle Bids main header-->
	<!-- *************** -->
	<xsl:template name="bid.header9">
		<cell column="{$org.bid.offset + $userDefinedItemIACount + $IACount +2}">
			<xsl:value-of select="java:getValue($language, 'excelmap.bids.bundle.bundlebids')"/>
		</cell>
	</xsl:template>
	
	<!-- **************************************************************************************************************** -->
	<!-- bundled bid headings-->
	<!-- **************************************************************************************************************** -->
	<xsl:template name="bid.header10">
			<xsl:variable name="column">
				<xsl:choose>
					<xsl:when test="$surrogate">
						<xsl:value-of select="3"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="0"/>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:variable>
			<cell column="{$org.bid.offset + $IACount +2}">
				<xsl:value-of select="java:getValue($language, 'excelmap.bids.bundle.bundleno')"/>
			</cell>
			<cell column="{$org.bid.offset + $IACount +3 }">
				<xsl:value-of select="java:getValue($language, 'excelmap.bids.bundle.priceperunitpercentdiscount')"/>
			</cell>
			<cell column="{$org.bid.offset + $IACount + 4}">
				<xsl:value-of select="java:getValue($language, 'excelmap.bids.bundle.onetimechargepercentdiscount')"/>
			</cell>
	</xsl:template>
	

	<!-- **************************************************************************************************************** -->
	<!-- process bundled bid -->
	<!-- **************************************************************************************************************** -->
	<xsl:template name="bid.bundle">
		<xsl:param name="row"/>
		<xsl:param name="bundlebids"/>
		<xsl:variable name="rownum">
			<xsl:choose>
				<xsl:when test="$bid.ItemBidCount &gt; 0 and $bid.ItemBidCount &gt; $bid.lineItemCount and $surrogate">
					<xsl:value-of select="$row"/>
				</xsl:when>
				<xsl:when test="$bid.ItemBidCount &gt; 0 and $bid.ItemBidCount &gt; $bid.lineItemCount">
					<xsl:value-of select="$row"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$row"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="start" select="$rownum"/>
		<xsl:variable name="column">
			<xsl:choose>
				<xsl:when test="$surrogate">
					<xsl:value-of select="3"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="0"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:for-each select="$bundlebids/Bid">
				<row row="{$start + position()}">
					<xsl:variable name="code" select="@BidLineItemCode"/>
					<xsl:call-template name="ItemInformation">
						<xsl:with-param name="row" select="$singlebid.end.row" />
						<xsl:with-param name="bidscount" select="1" />
						<xsl:with-param name="lineitem" select="//LineItem[@LineItemCode =$code]"/>
					</xsl:call-template>
					<xsl:call-template name="BidInfo">
						<xsl:with-param name="lineitem" select="//LineItem[@LineItemCode =$code]" />
						<xsl:with-param name="row" select="$singlebid.end.row" />
						<xsl:with-param name="bids" select="." />
					</xsl:call-template>
				<cell header="false" column="{$org.bid.offset + $IACount+ 2}">
					<xsl:value-of select="@BundleName"/>
				</cell>
				<cell header="false" column="{$org.bid.offset + $IACount+3}">
					<xsl:value-of select="@PPUPercentDiscount"/>
				</cell>
				<cell header="false" column="{$org.bid.offset+$IACount+4}">
					<xsl:value-of select="@OTCPercentDiscount"/>
				</cell>
			</row>
			</xsl:for-each>
	</xsl:template>


	<!-- **************************************** -->
	<!-- Process an item and its bids -->
	<!-- **************************************** -->
	<xsl:template name="BidItem">
		<xsl:param name="row"/>
		<xsl:param name="lineitem"/>
		<xsl:param name="bids"/>
		
		<xsl:if test="count($bids) &lt; 1">
			<row row="{$row + 1}">
				<xsl:call-template name="ItemInformation">
					<xsl:with-param name="row" select="$row + 1"/>
					<xsl:with-param name="bidscount" select="0"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
				</xsl:call-template>
				<!-- iterate over the global extended attributes -->
	            <saxon:assign name="item" select="string($lineitem/@LineItemCode)"/>
	            <saxon:assign name="deliveryDate" select="$lineitem/@LineItemDeliveryDateTime"/>
	            <saxon:assign name="leadDays" select="$lineitem/@LineItemLeadDays"/>
	            <xsl:for-each select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">
	                <saxon:assign name="xaName" select="string(.)"/>
	                <saxon:assign name="xaValue">
	                    <xsl:choose>
	                        <xsl:when test="$xaName=java:getValue($language, 'rfx.item.LineItemDeliveryDateTime')">
	                            <xsl:value-of select="$deliveryDate"/>
	                        </xsl:when>
	                        <xsl:when test="$xaName=java:getValue($language, 'rfx.item.LineItemLeadDays')">
	                            <xsl:value-of select="$leadDays"/>
	                        </xsl:when>
	                        <xsl:when test="$xaName = $BidDiscountCodeStr">																
									<!--<xsl:choose>
										<xsl:when test="(//RFx[1]/@RFxType != java:getValue($language, 'excelmap.rfxtype.reverse')) and (//RFx[1]/@RFxType != java:getValue($language, 'excelmap.rfxtype.forward'))">										
											<xsl:value-of select="'XXXXX'"/>
										</xsl:when>
										<xsl:when test="empty($lineitem/@LineItemEnableDiscountBidding) or
														$lineitem/@LineItemEnableDiscountBidding = 'false'">
											<xsl:value-of select="'XXXXX'"/>
										</xsl:when>										
									</xsl:choose>-->									
							</xsl:when>
							<xsl:when test="$xaName = java:getValue($language, 'excelmap.bids.simple.BidPricePerUnit')">
								<!--<xsl:if test="(//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.reverse')) or
											   		(//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.forward'))">	
									
									<xsl:if test="$lineitem/@LineItemEnableDiscountBidding = $trueValue">
										<xsl:value-of select="'XXXXX'"/>
									</xsl:if>
								</xsl:if>-->
							</xsl:when>
							<xsl:when test="$xaName = $BidOneTimeChargeStr">
								<!--<xsl:choose>
									<xsl:when test="(//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.reverse')) or
											   		(//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.forward'))">										
										<xsl:value-of select="'XXXXX'"/>
									</xsl:when>									
								</xsl:choose>-->
							</xsl:when>
	                        <xsl:otherwise>
	                            <xsl:value-of select="../@XADDefaultValue"/>
	                        </xsl:otherwise>
	                    </xsl:choose>
	                </saxon:assign>
	                <xsl:if test="empty($xaValue) or string-length($xaValue) &lt;= 0">
						<saxon:assign name="xaValue">
							<xsl:value-of select="../@XADDefaultValue"/>
						</saxon:assign>
					</xsl:if>
	                <saxon:assign name="readOnly">
	                    <xsl:choose>
	                        <!-- read/write is editable -->
	                        <xsl:when test="contains(../@XADVisibility, concat('/', $AttributeDefVisibilityExposed))">
	                            <xsl:value-of select="'false'"/>
	                        </xsl:when>
	                        <!-- read/read and read/hidden are readOnly -->
	                        <xsl:when test="contains(../@XADVisibility, concat($AttributeDefVisibilityReadOnly, '/'))">
	                            <xsl:value-of select="'true'"/>
	                        </xsl:when>
	                        <!-- write/read (not-surrogate) is readOnly -->
	                        <xsl:when test="not($surrogate) and
	                                contains(../@XADVisibility, concat($AttributeDefVisibilityExposed, '/'))">
	                            <xsl:value-of select="'true'"/>
	                        </xsl:when>
	                        <!-- write/read and write/hidden (surrogate) are editable -->
	                        <xsl:otherwise>
	                            <xsl:value-of select="'false'"/>
	                        </xsl:otherwise>
	                    </xsl:choose>
	                </saxon:assign>
	                <cell column="{$org.bid.offset + position() + 1}">
			   <!-- for PR 61922 changed from saxon:assign to xsl:variable -->
	                    <xsl:variable name="xadType"
	                            select="java:getName($language, ../@XADDataType, 'integration.AttributeDefDataType.')"/>
	                    <xsl:choose>
	                        <xsl:when test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'">
	                            <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
	                            <xsl:value-of select="'XXXXX'"/>
	                        </xsl:when>
	                        <xsl:when test="java:getValue($language, 'integration.AttributeDefScope.BidStruct.bid_item')=../@XADScope">
	                            <saxon:assign name="links" select="string(../@XADObjectLink)"/>
	                            <saxon:assign name="span" select="string-length($links)"/>
	                            <saxon:assign name="len" select="string-length($item)"/>
	                            <xsl:choose>
	                                <xsl:when test="$links = $item or (($span &gt; $len)
	                                        and (substring($links, $span - $len) = concat('|', $item)
	                                                or contains($links, concat('|', $item, '|'))
	                                                or substring($links, 1, $len + 1) = concat($item, '|')))">
	                                    <!-- grey out cell if field is readonly -->
	                                    <xsl:if test="$readOnly='true'">
	                                        <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
	                                    </xsl:if>
	                                    <xsl:value-of select="$xaValue"/>
	                                </xsl:when>
	                                <xsl:otherwise>
	                                    <!-- grey out cell if field is not linked to this item -->
	                                    <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
	                                    <xsl:value-of select="'XXXXX'"/>
	                                </xsl:otherwise>
	                            </xsl:choose>
				    <saxon:assign name="links" select="''"/>
				    <saxon:assign name="span" select="''"/>
				    <saxon:assign name="len" select="''"/>
	                        </xsl:when>
	                        <xsl:otherwise>
	                            <!-- grey out cell if field is readonly -->
	                            <xsl:if test="$readOnly='true'">
	                                <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
	                            </xsl:if>
	                            <xsl:if test="$xaValue='XXXXX'">
	                                <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
	                            </xsl:if>
	                            <xsl:value-of select="$xaValue"/>
	                        </xsl:otherwise>
	                    </xsl:choose>
	                </cell>
			<saxon:assign name="readOnly" select="''"/>
			<saxon:assign name="xaName" select="''"/>
	            </xsl:for-each>
	            <xsl:call-template name="BlankCells">
	            	<xsl:with-param name="colNum" select="count($bidXACodes)"/>
	            </xsl:call-template>
			</row>
			<saxon:assign name="item" select="''"/>
	                <saxon:assign name="deliveryDate" select="''"/>
	               <saxon:assign name="leadDays" select="''"/>
		</xsl:if>
		
		<xsl:choose>
			<xsl:when test="$surrogate">
				<xsl:call-template name="BidsAndItemsSurrogate">
					<xsl:with-param name="row" select="$row"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
					<xsl:with-param name="bids" select="$bids"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="BidsAndItemsSupplier">
					<xsl:with-param name="row" select="$row"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
					<xsl:with-param name="bids" select="$bids"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	
	

	<!-- **************************************** -->
	<!-- Process bids in ascending order of bids submitted-->
	<!-- **************************************** -->

	
	<xsl:template name="BidsAndItemsSupplier">
		<xsl:param name="row"/>
		<xsl:param name="lineitem"/>
		<xsl:param name="bids"/>
		<xsl:for-each select="$bids">
			<xsl:sort select="@BidCode" data-type="number" order="ascending"/>
			
			<saxon:assign name="actionvalue">
				<xsl:choose>
					<xsl:when test="(@BidPricePerUnit) and not($bid.rfxtype = 'reverse') and not($bid.rfxtype = 'forward')">
						<xsl:value-of select="$ActionUpdate"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="$ActionNew"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>
			<saxon:assign name="BidSellerProductCode" select="@BidSellerProductCode"/>
			<saxon:assign name="BidMinimum" select="@BidMinimum"/>
			<saxon:assign name="BidMaximum">
				<xsl:choose>
					<xsl:when test="$bid.rfxtype = 'reverse' or $bid.rfxtype = 'forward'">
						<xsl:value-of select="@BidQuantity"/><!-- PR#59742 : change attribute name-->
					</xsl:when>	
					<xsl:otherwise>
						<xsl:value-of select="@BidMaximum"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>			
			<saxon:assign name="BidPricePerUnit">
				<xsl:choose>
					<xsl:when test="($lineitem/@LineItemMinBidChangeType) and not(@BidPricePerUnit)">
						<xsl:value-of select="'XXXXX'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@BidPricePerUnit"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>			
			<saxon:assign name="BidOneTimeCharge" select="@BidOneTimeCharge"/>
			<saxon:assign name="BidDeliveryDate" select="@BidDeliveryDate"/>
			<saxon:assign name="BidLeadDays" select="@BidLeadDays"/>
			<saxon:assign name="BidCurrencyCode" select="@BidCurrencyCode"/>
			<saxon:assign name="SupplierOrgCode" select="@BidderOrganizationCode"/>
			<saxon:assign name="BidderLoginName" select="@BidderLoginName"/>
			<saxon:assign name="BidSubmitterLoginName" select="@BidSubmitterLoginName"/>
			<saxon:assign name="BidPPUPercentDiscount" select="@PPUPercentDiscount"/>
			<saxon:assign name="BidPPUPercentDiscountType" select="@BidPPUDiscountType"/>
			<saxon:assign name="BidIsPreliminary" select="@BidIsPreliminary"/>
			<saxon:assign name="LineItemEnableDiscountBidding" select="$lineitem/@LineItemEnableDiscountBidding"/>
			<saxon:assign name="item" select="string($lineitem/@LineItemCode)"/>
			<row row="{$row + position()}">
				<xsl:call-template name="ItemInformation">
					<xsl:with-param name="row" select="$row + position()"/>
					<xsl:with-param name="bidscount" select="1"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
				</xsl:call-template>
			 
				<!-- row row="{$row + position()}"-->
				<xsl:choose>
					<xsl:when test="$surrogate">
						<cell header="false" column="12">
							<xsl:value-of select="$SupplierOrgCode"/>
						</cell>
						<cell header="false" column="13">
							<xsl:value-of select="$BidderLoginName"/>
						</cell>
						<cell header="false" column="14">
							<xsl:value-of select="$BidSubmitterLoginName"/>
						</cell>
					</xsl:when>
				</xsl:choose>
				
				<xsl:choose>
					<xsl:when test="$actionvalue='XXXXX'">
						<cell header="true" column="{$org.bid.offset}">
							<xsl:value-of select="$actionvalue"/>
						</cell>
					</xsl:when>
					<xsl:otherwise>
				<cell header="false" column="{$org.bid.offset}">
					<xsl:value-of select="$actionvalue"/>
				</cell>				
					</xsl:otherwise>
				</xsl:choose>
								
				<!-- <xsl:if test="($BidIsPreliminary != 'true') or (empty($BidIsPreliminary))" >  -->
					<cell header="false" column="{$org.bid.offset + 1}">
						<xsl:value-of select="$BidCurrencyCode"/>
					</cell>
					<xsl:for-each
						select="$bidIACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">			
						<xsl:variable name="attributecode" select="string(.)"/>					
						<saxon:assign name="xaValue">					
						<xsl:choose>
							<xsl:when test="$attributecode = 'productCode'">
									<xsl:value-of select="$BidSellerProductCode"/>
									
							</xsl:when>
								<xsl:when test="$attributecode = 'minCapacity'">									
									<xsl:value-of select="$BidMinimum"/>
									
							</xsl:when>
								<xsl:when test="$attributecode = 'maxCapacity'">
									<xsl:value-of select="$BidMaximum"/>
									
							</xsl:when>
							<xsl:when test="$attributecode = 'baseVariableCost'">
									<xsl:choose>
										<xsl:when test="empty($BidPPUPercentDiscount) or
														$BidPPUPercentDiscountType = java:getValue($language, 'excelmap.bids.simple.BidPPUPercentDiscountType.none') or
														$LineItemEnableDiscountBidding = java:getValue($language, 'excelmap.bids.simple.LineItemEnableDiscountBidding.false')">
											<xsl:value-of select="$BidPricePerUnit"/>
										</xsl:when>
										<xsl:when test="empty($LineItemEnableDiscountBidding)">
											<xsl:value-of select="$BidPricePerUnit"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="'XXXXX'"/>
										</xsl:otherwise>
									</xsl:choose>								
									
							</xsl:when>
								<xsl:when test="$attributecode = 'variableCostDiscountValue'">	
										<xsl:if test="$LineItemEnableDiscountBidding = $trueValue">
										<xsl:value-of select="$BidPPUPercentDiscount"/>										
										</xsl:if>										
							</xsl:when>
								<xsl:when test="$attributecode = 'baseFixedCost'">							
									<xsl:value-of select="$BidOneTimeCharge"/>
							</xsl:when>
								<xsl:when test="$attributecode = 'deliveryDate'">							
									<xsl:value-of select="$BidDeliveryDate"/>
							</xsl:when>
								<xsl:when test="$attributecode = 'leadDays'">								
									<xsl:value-of select="$BidLeadDays"/>
								</xsl:when>
							</xsl:choose>
						</saxon:assign>

						<xsl:if test="empty($xaValue) or string-length($xaValue) &lt;= 0">
							<saxon:assign name="xaValue">
								<xsl:choose>
									<xsl:when test="$LineItemEnableDiscountBidding = $falseValue and
													$attributecode = 'variableCostDiscountValue'">
										<xsl:value-of select="'XXXXX'"/>
									</xsl:when>
									<xsl:otherwise>
								<xsl:value-of select="../@XADDefaultValue"/>
									</xsl:otherwise>
								</xsl:choose>								
							</saxon:assign>
						</xsl:if>
						<saxon:assign name="readOnly">
                    		<xsl:choose>
		                        <!-- read/write is editable -->
		                        <xsl:when test="contains(../@XADVisibility, concat('/', $AttributeDefVisibilityExposed))">
		                            <xsl:value-of select="'false'"/>
		                        </xsl:when>
		                        <!-- read/read and read/hidden are readOnly -->
		                        <xsl:when test="contains(../@XADVisibility, concat($AttributeDefVisibilityReadOnly, '/'))">
		                            <xsl:value-of select="'true'"/>
		                        </xsl:when>
		                        <!-- write/read (not-surrogate) is readOnly -->
		                        <xsl:when test="not($surrogate) and
		                                contains(../@XADVisibility, concat($AttributeDefVisibilityExposed, '/'))">
		                            <xsl:value-of select="'true'"/>
		                        </xsl:when>
		                        <!-- write/read and write/hidden (surrogate) are editable -->
		                        <xsl:otherwise>
		                            <xsl:value-of select="'false'"/>
		                        </xsl:otherwise>
                   			 </xsl:choose>
                		</saxon:assign>
                		
                		<cell column="{$org.bid.offset + position() + 1}">
		                    <saxon:assign name="xadType"
		                            select="java:getName($language, ../@XADDataType, 'integration.AttributeDefDataType.')"/>
		                    <xsl:choose>
		                        <xsl:when test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'">
		                            <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            <xsl:value-of select="'XXXXX'"/>
		                        </xsl:when>
		                        <xsl:when test="java:getValue($language, 'integration.AttributeDefScope.BidStruct.bid_item')=../@XADScope">
		                            <saxon:assign name="links" select="string(../@XADObjectLink)"/>
		                            <saxon:assign name="span" select="string-length($links)"/>
		                            <saxon:assign name="len" select="string-length($item)"/>
		                            <xsl:choose>
		                                <xsl:when test="$links = $item or (($span &gt; $len)
		                                        and (substring($links, $span - $len) = concat('|', $item)
		                                                or contains($links, concat('|', $item, '|'))
		                                                or substring($links, 1, $len + 1) = concat($item, '|')))">
		                                    <!-- grey out cell if field is readonly -->
		                                    <xsl:if test="$readOnly='true'">
		                                        <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                                    </xsl:if>
		                                    <xsl:value-of select="$xaValue"/>
		                                </xsl:when>
		                                <xsl:otherwise>
		                                    <!-- grey out cell if field is not linked to this item -->
		                                    <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                                    <xsl:value-of select="'XXXXX'"/>
		                                </xsl:otherwise>
		                            </xsl:choose>
					    <saxon:assign name="links" select="''"/>
					    <saxon:assign name="span" select="''"/>
					    <saxon:assign name="len" select="''"/>
							</xsl:when>
		                        <xsl:otherwise>
		                            <!-- grey out cell if field is readonly -->
		                            <xsl:if test="$readOnly='true'">
		                                <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            </xsl:if>
		                            <xsl:if test="$xaValue = 'XXXXX'">
		                            	<xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            </xsl:if>
		                            <xsl:choose>
		                            	<xsl:when test="string-length($xaValue) &gt;= 1">
		                            <xsl:value-of select="$xaValue"/>
		                            	</xsl:when>
		                            </xsl:choose>		                            
		                        </xsl:otherwise>
						</xsl:choose>
				    <saxon:assign name="xadType" select="''"/>				   
				    <saxon:assign name="readOnly" select="''"/>
                		</cell>
					</xsl:for-each>
					<xsl:call-template name="bidextendedattribute">
						<xsl:with-param name="extendedattribute" select="./ExtendedAttribute"/>
						<xsl:with-param name="lineitem" select="$lineitem"/>
					</xsl:call-template>			
					<xsl:call-template name="BlankCells">
	            		<xsl:with-param name="colNum" select="count($bidXACodes)"/>
					</xsl:call-template>
				<!-- </xsl:if> -->
			</row>

			<saxon:assign name="BidSellerProductCode" select="''"/>
			<saxon:assign name="BidMinimum" select="0" />
			<saxon:assign name="BidMaximum" select="0" />
			<saxon:assign name="BidPricePerUnit" select="0" />
			<saxon:assign name="BidOneTimeCharge" select="0" />
			<saxon:assign name="BidDeliveryDate" select="''" />
			<saxon:assign name="BidLeadDays" select="''" />
			<saxon:assign name="BidCurrencyCode" select="''" />
			<saxon:assign name="SupplierOrgCode" select="''" />
			<saxon:assign name="BidderLoginName" select="''" />
			<saxon:assign name="BidSubmitterLoginName" select="''" />
			<saxon:assign name="BidPPUPercentDiscount" select="''" />
			<saxon:assign name="BidPPUPercentDiscountType" select="''" />
			<saxon:assign name="BidIsPreliminary" select="''" />
			<saxon:assign name="LineItemEnableDiscountBidding" select="''" />
			<saxon:assign name="item" select="''" />	
			<saxon:assign name="actionvalue" select="''" />

		</xsl:for-each>
	</xsl:template>
	
	
	<!-- **************************************** -->
	<!-- Process bids in ascending order of supplier -->
	<!-- **************************************** -->
	<xsl:template name="BidsAndItemsSurrogate">
		<xsl:param name="row"/>
		<xsl:param name="lineitem"/>
		<xsl:param name="bids"/>
		<xsl:for-each select="$bids">
			<xsl:sort select="@BidderOrganizationCode" data-type="text" order="ascending"/>
			<saxon:assign name="actionvalue">
				<xsl:choose>
					<xsl:when test="(@BidPricePerUnit) and 
									not($bid.rfxtype = 'reverse') and
									not($bid.rfxtype = 'forward')">
						<xsl:value-of select="java:getValue($language, 'excelmap.bids.simple.update')"/>
					</xsl:when>
					<xsl:when test="not($bid.rfxtype = 'reverse') and
								    not($bid.rfxtype = 'forward')">
						<xsl:value-of select="java:getValue($language, 'excelmap.bids.simple.new')"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'XXXXX'"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>
			<saxon:assign name="BidSellerProductCode" select="@BidSellerProductCode"/>
			<saxon:assign name="BidMinimum" select="@BidMinimum"/>
			<saxon:assign name="BidMaximum" select="@BidQuantity"/><!-- PR#59742 : change attribute name-->
			<saxon:assign name="BidPricePerUnit">
				<xsl:choose>
					<xsl:when test="($lineitem/@LineItemMinBidChangeType) and not(@BidPricePerUnit)">
						<xsl:value-of select="'XXXXX'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@BidPricePerUnit"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>			
			<saxon:assign name="BidOneTimeCharge" select="@BidOneTimeCharge"/>
			<saxon:assign name="BidDeliveryDate" select="@BidDeliveryDate"/>
			<saxon:assign name="BidLeadDays" select="@BidLeadDays"/>
			<saxon:assign name="BidCurrencyCode" select="@BidCurrencyCode"/>
			<saxon:assign name="SupplierOrgCode" select="@BidderOrganizationCode"/>
			<saxon:assign name="BidderLoginName" select="@BidderLoginName"/>
			<saxon:assign name="BidSubmitterLoginName" select="@BidSubmitterLoginName"/>
			<saxon:assign name="BidPPUPercentDiscount" select="@PPUPercentDiscount"/>
			<saxon:assign name="BidPPUPercentDiscountType" select="@BidPPUDiscountType"/>
			<saxon:assign name="BidIsPreliminary" select="@BidIsPreliminary"/>
			<saxon:assign name="LineItemEnableDiscountBidding" select="$lineitem/@LineItemEnableDiscountBidding"/>
			<saxon:assign name="item" select="string($lineitem/@LineItemCode)"/>
			
			<saxon:assign name="buyerFieldColumn">
				<xsl:choose>
					<xsl:when test="($bid.rfxtype ='reverse') or 
	 	   	     					($bid.rfxtype ='forward')">
	 	   	     		<xsl:value-of select="1"/>
					</xsl:when>
					<xsl:when test="not($bid.rfxtype ='reverse') or 
	 	   	     					not($bid.rfxtype ='forward')">
	 	   	     		<xsl:value-of select="0"/>
					</xsl:when>					
				</xsl:choose>			
	 	   	</saxon:assign>
			
			<row row="{$row + position()}">
				<xsl:call-template name="ItemInformation">
					<xsl:with-param name="row" select="$row + position()"/>
					<xsl:with-param name="bidscount" select="1"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
				</xsl:call-template>
			 
				<!-- row row="{$row + position()}"-->
				<xsl:choose>
					<xsl:when test="$surrogate">
						<cell header="false" column="{$org.bid.offset - ($buyerFieldColumn + 3)}">
							<xsl:value-of select="$SupplierOrgCode"/>
						</cell>
						<cell header="false" column="{$org.bid.offset - ($buyerFieldColumn + 2)}">
							<xsl:value-of select="$BidderLoginName"/>
						</cell>
						<cell header="false" column="{$org.bid.offset - ($buyerFieldColumn + 1)}">
							<xsl:value-of select="$BidSubmitterLoginName"/>
						</cell>
						<saxon:assign name="buyerFieldColumn" select="0"/>
						<xsl:if test="($bid.rfxtype = 'reverse') or 
	 	   	     					  ($bid.rfxtype = 'forward')">
	 	   	     			<cell header="false" column="{$org.bid.offset - 1}">
		 	   	     			<xsl:choose>
		 	   	     				<xsl:when test="empty($BidIsPreliminary)">
		 	   	     					<xsl:value-of select="java:getValue($language, 'excelmap.bids.bids.BidPreliminary.false')"/>
		 	   	     				</xsl:when>
		 	   	     				<xsl:otherwise>
		 	   	     					<xsl:value-of select="$BidIsPreliminary"/>
		 	   	     				</xsl:otherwise>
		 	   	     			</xsl:choose>
		 	   	     		</cell>							
						</xsl:if>
					</xsl:when>
				</xsl:choose>
				
				<xsl:choose>
					<xsl:when test="$actionvalue='XXXXX'">
						<cell header="true" column="{$org.bid.offset}">
							<xsl:value-of select="$actionvalue"/>
						</cell>
					</xsl:when>
					<xsl:otherwise>
				<cell header="false" column="{$org.bid.offset}">
					<xsl:value-of select="$actionvalue"/>
				</cell>
					</xsl:otherwise>
				</xsl:choose>
				
				<!-- <xsl:if test="($BidIsPreliminary != 'true') or (empty($BidIsPreliminary))" > -->
					<cell header="false" column="{$org.bid.offset + 1}">
						<xsl:value-of select="$BidCurrencyCode"/>
					</cell>
					<xsl:for-each
						select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">			
						<xsl:variable name="attributename" select="string(.)"/>
						<saxon:assign name="xaValue">					
						<xsl:choose>
							<xsl:when test="$attributename = java:getValue($language, 'excelmap.bids.simple.BidSellerProductCode')">
									<xsl:value-of select="$BidSellerProductCode"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidMinimumStr">
									<xsl:value-of select="$BidMinimum"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidMaximumStr">
									<xsl:value-of select="$BidMaximum"/>
							</xsl:when>
							<xsl:when test="$attributename = java:getValue($language, 'excelmap.bids.simple.BidPricePerUnit')">								
									<xsl:choose>
										<xsl:when test="empty($BidPPUPercentDiscount) or
														$BidPPUPercentDiscountType = java:getValue($language, 'excelmap.bids.simple.BidPPUPercentDiscountType.none') or
														$LineItemEnableDiscountBidding = java:getValue($language, 'excelmap.bids.simple.LineItemEnableDiscountBidding.false')">
											<xsl:value-of select="$BidPricePerUnit"/>
										</xsl:when>
										<xsl:when test="empty($LineItemEnableDiscountBidding)">
											<xsl:value-of select="$BidPricePerUnit"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="'XXXXX'"/>
										</xsl:otherwise>
									</xsl:choose>
							</xsl:when>
								<xsl:when test="$attributename = $BidDiscountCodeStr">							
										<xsl:if test="$LineItemEnableDiscountBidding = $trueValue">
										<xsl:value-of select="$BidPPUPercentDiscount"/>										
										</xsl:if>										
							</xsl:when>
								<xsl:when test="$attributename = $BidOneTimeChargeStr">
									<xsl:value-of select="$BidOneTimeCharge"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidDeliveryDateStr">
									<xsl:value-of select="$BidDeliveryDate"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidLeadDaysStr">
									<xsl:value-of select="$BidLeadDays"/>
								</xsl:when>
							</xsl:choose>
						</saxon:assign>
						<xsl:if test="empty($xaValue) or string-length($xaValue) &lt;= 0">
							<saxon:assign name="xaValue">
								<xsl:choose>
									<xsl:when test="$LineItemEnableDiscountBidding = $falseValue and
													$attributename = $BidDiscountCodeStr">
										<xsl:value-of select="'XXXXX'"/>
									</xsl:when>
									<xsl:otherwise>
								<xsl:value-of select="../@XADDefaultValue"/>
									</xsl:otherwise>
								</xsl:choose>								
							</saxon:assign>
						</xsl:if>
						
						<saxon:assign name="readOnly">
                    		<xsl:choose>
		                        <!-- read/write is editable -->
		                        <xsl:when test="contains(../@XADVisibility, concat('/', $AttributeDefVisibilityExposed))">
		                            <xsl:value-of select="'false'"/>
		                        </xsl:when>
		                        <!-- read/read and read/hidden are readOnly -->
		                        <xsl:when test="contains(../@XADVisibility, concat($AttributeDefVisibilityReadOnly, '/'))">
		                            <xsl:value-of select="'true'"/>
		                        </xsl:when>
		                        <!-- write/read (not-surrogate) is readOnly -->
		                        <xsl:when test="not($surrogate) and
		                                contains(../@XADVisibility, concat($AttributeDefVisibilityExposed, '/'))">
		                            <xsl:value-of select="'true'"/>
		                        </xsl:when>
		                        <!-- write/read and write/hidden (surrogate) are editable -->
		                        <xsl:otherwise>
		                            <xsl:value-of select="'false'"/>
		                        </xsl:otherwise>
                   			 </xsl:choose>
                		</saxon:assign>
                		
                		<cell column="{$org.bid.offset + position() + 1}">
		                    <saxon:assign name="xadType"
		                            select="java:getName($language, ../@XADDataType, 'integration.AttributeDefDataType.')"/>
		                    <xsl:choose>
		                        <xsl:when test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'">
		                            <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            <xsl:value-of select="'XXXXX'"/>
		                        </xsl:when>
		                        <xsl:when test="java:getValue($language, 'integration.AttributeDefScope.BidStruct.bid_item')=../@XADScope">
		                            <saxon:assign name="links" select="string(../@XADObjectLink)"/>
		                            <saxon:assign name="span" select="string-length($links)"/>
		                            <saxon:assign name="len" select="string-length($item)"/>
		                            <xsl:choose>
		                                <xsl:when test="$links = $item or (($span &gt; $len)
		                                        and (substring($links, $span - $len) = concat('|', $item)
		                                                or contains($links, concat('|', $item, '|'))
		                                                or substring($links, 1, $len + 1) = concat($item, '|')))">
		                                    <!-- grey out cell if field is readonly -->
		                                    <xsl:if test="$readOnly='true'">
		                                        <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                                    </xsl:if>
		                                    <xsl:value-of select="$xaValue"/>
							</xsl:when>
		                                <xsl:otherwise>
		                                    <!-- grey out cell if field is not linked to this item -->
		                                    <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                                    <xsl:value-of select="'XXXXX'"/>
		                                </xsl:otherwise>
						</xsl:choose>
		                        </xsl:when>
		                        <xsl:otherwise>
		                            <!-- grey out cell if field is readonly -->
		                            <xsl:if test="$readOnly='true'">
		                                <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            </xsl:if>
		                            <xsl:if test="$xaValue = 'XXXXX'">
		                            	<xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            </xsl:if>
		                            <xsl:choose>
		                            	<xsl:when test="string-length($xaValue) &gt;= 1">
		                            <xsl:value-of select="$xaValue"/>
		                            	</xsl:when>		                            	
		                            </xsl:choose>
		                        </xsl:otherwise>
		                    </xsl:choose>
				    <saxon:assign name="readOnly" select="''"/>
				    <saxon:assign name="xadType" select="''"/>
                		</cell>
					
					</xsl:for-each>
					<xsl:call-template name="bidextendedattribute">
						<xsl:with-param name="extendedattribute" select="./ExtendedAttribute"/>
						<xsl:with-param name="lineitem" select="$lineitem"/>
					</xsl:call-template>					
					<xsl:call-template name="BlankCells">
	            		<xsl:with-param name="colNum" select="count($bidXACodes)"/>
					</xsl:call-template>
				<!-- </xsl:if> -->
			</row>			
			<saxon:assign name="BidSellerProductCode" select="''"/>
			<saxon:assign name="BidMinimum" select="0" />
			<saxon:assign name="BidMaximum" select="0" />
			<saxon:assign name="BidPricePerUnit" select="0" />
			<saxon:assign name="BidOneTimeCharge" select="0" />
			<saxon:assign name="BidDeliveryDate" select="''" />
			<saxon:assign name="BidLeadDays" select="''" />
			<saxon:assign name="BidCurrencyCode" select="''" />
			<saxon:assign name="SupplierOrgCode" select="''" />
			<saxon:assign name="BidderLoginName" select="''" />
			<saxon:assign name="BidSubmitterLoginName" select="''" />
			<saxon:assign name="BidPPUPercentDiscount" select="''" />
			<saxon:assign name="BidPPUPercentDiscountType" select="''" />
			<saxon:assign name="BidIsPreliminary" select="''" />
			<saxon:assign name="LineItemEnableDiscountBidding" select="''" />
			<saxon:assign name="item" select="''" />	
			<saxon:assign name="actionvalue" select="''" />

		</xsl:for-each>
	</xsl:template>
	
	<!-- **************************************************************************************************************** -->
	<!-- process extended attributes of bid -->
	<!-- **************************************************************************************************************** -->
	<xsl:template name="bidextendedattribute">
		<xsl:param name="extendedattribute"/>
		<xsl:param name="lineitem"/>
		<xsl:variable name="LineItemEnableDiscountBidding" select="$lineitem/@LineItemEnableDiscountBidding"/>
		<xsl:for-each select="$extendedattribute">
			<saxon:assign name="extendedattrname" select="''"/>
			<saxon:assign name="extendedattrvalue" select="''"/>
			<xsl:variable name="extendedattrcode" select="@ExtendedAttributeCode"/>
			<saxon:assign name="extendedattrvalue" select="@ExtendedAttributeValue"/>			
			<xsl:for-each
						select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">			
				
				<xsl:variable name="attributename" select="string(.)"/>
				<!-- PR#60548:start -->
				<saxon:assign name="readOnly" select="''"/>
				<saxon:assign name="readOnly">
				<xsl:choose>
                        <!-- read/write is editable -->
                        <xsl:when test="contains(../@XADVisibility, concat('/', $AttributeDefVisibilityExposed))">
                            <xsl:value-of select="'false'"/>
                        </xsl:when>
                        <!-- read/read and read/hidden are readOnly -->
                        <xsl:when test="contains(../@XADVisibility, concat($AttributeDefVisibilityReadOnly, '/'))">
                            <xsl:value-of select="'true'"/>
                        </xsl:when>
                        <!-- write/read (not-surrogate) is readOnly -->
                        <xsl:when test="not($surrogate) and
                                contains(../@XADVisibility, concat($AttributeDefVisibilityExposed, '/'))">
                            <xsl:value-of select="'true'"/>
                        </xsl:when>
                        <!-- write/read and write/hidden (surrogate) are editable -->
                        <xsl:otherwise>
                            <xsl:value-of select="'false'"/>
                        </xsl:otherwise>
                 	</xsl:choose>
              	</saxon:assign>  
              	<!-- PR#60548:end -->            	
				<xsl:choose>
					<xsl:when test="$extendedattrcode = $attributename">
						<xsl:choose>
							<xsl:when test="$LineItemEnableDiscountBidding = $trueValue and
											$attributename != java:getValue($language, 'excelmap.bids.simple.BidSellerProductCode') and
											$attributename != $BidDiscountCodeStr and
											not($surrogate)">
								<cell header="true" column="{$org.bid.offset + position() + 1}">
									<xsl:value-of select="'XXXXX'"/>
								</cell>
							</xsl:when>
							<!-- PR#60548:start -->
							<xsl:when test="$readOnly='true'"> <!-- PR 63659 -->
								<saxon:assign name="xadType"
		                            select="java:getName($language, ../@XADDataType, 'integration.AttributeDefDataType.')"/>
								<cell header="true" column="{$org.bid.offset + position() + 1}">
									<xsl:choose>
										<xsl:when test="$xadType='CALCULATED_TYPE'">
		                                    <xsl:value-of select="'XXXXX'"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of select="$extendedattrvalue"/>
										</xsl:otherwise>
									</xsl:choose>
								</cell>
							</xsl:when>
							<!-- PR#60548:end -->
							<xsl:otherwise>
						<cell header="false" column="{$org.bid.offset + position() + 1}">
							<xsl:value-of select="$extendedattrvalue"/>
						</cell>
							</xsl:otherwise>
						</xsl:choose>						
					</xsl:when>
				</xsl:choose>
			</xsl:for-each>
		</xsl:for-each>
		<saxon:assign name="readOnly" select="''"/>
	</xsl:template>
	
	<!-- **************************************************************************************************************** -->
	<!-- create a node for an item -->
	<!-- **************************************************************************************************************** -->
	<xsl:template name="ItemInformation">
		<xsl:param name="row"/>
		<xsl:param name="bidscount"/>
		<xsl:param name="lineitem"/>
		<!-- row row="{$row}"-->
		<xsl:variable name="lineitemcode" select="$lineitem/@LineItemCode"/>
		<saxon:assign name="columnNumber" select="1"/>
		<cell header="true" column="{$columnNumber}"> 
			<xsl:value-of select="$lineitem/@LineItemName"/>
		</cell>
		<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
		<cell header="true" column="{$columnNumber}">
			<xsl:value-of select="$lineitem/@LineItemCode"/>
		</cell>
		<xsl:if test="$itemDescriptionPresent">
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell header="true" column="{$columnNumber}">
				<xsl:value-of select="$lineitem/@LineItemDescription"/>
			</cell>
		</xsl:if>
		<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
		<cell header="true" column="{$columnNumber}">
			<xsl:value-of select="$lineitem/@LineItemMinimumDesiredQuantity"/>
		</cell>
		<xsl:if test="$includeItemDefs">
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell header="true" column="{$columnNumber}">
				<xsl:value-of select="$lineitem/ExtendedAttribute[@ExtendedAttributeCode = java:getValue($language, 'excelmap.bids.line_items.Specification')]/@ExtendedAttributeValue"/>
			</cell>
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell header="true" column="{$columnNumber}">
				<xsl:value-of select="$lineitem/ExtendedAttribute[@ExtendedAttributeCode = java:getValue($language, 'excelmap.bids.line_items.SpecificationURL')]/@ExtendedAttributeValue"/>
			</cell>
		</xsl:if>
		<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
		<cell header="true" column="{$columnNumber}">
			<xsl:value-of select="$lineitem/@LineItemUnitOfMeasure"/>
		</cell>
		<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
		<cell header="true" column="{$columnNumber}">
			<xsl:value-of select="$lineitem/@LineItemCategoryCode"/>
		</cell>
		<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
		<cell header="true" column="{$columnNumber}">
			<xsl:value-of select="$lineitem/@LineItemLotName"/>
		</cell>
		<xsl:if test="$bid.rfxtype = 'reverse' or 
                          $bid.rfxtype = 'forward'">
            <saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell header="true" column="{$columnNumber}">
				<xsl:choose>
					<xsl:when test="empty($lineitem/../@RequisitionIsForced)">
						<xsl:value-of select="'XXXXX'"/>
					</xsl:when>
					<xsl:otherwise>
							<xsl:value-of select="$lineitem/../@RequisitionIsForced"/>
					</xsl:otherwise>
				</xsl:choose>
			</cell>
			<xsl:if test="(//RFx/AuctionRules/@AllowDiscountBidding = $trueValue)">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell header="true" column="{$columnNumber}">
					<xsl:value-of select="//Bid[@BidLineItemCode=$lineitemcode and @BidType='simple']/@BidPricePerUnit"/>
				</cell>
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell header="true" column="{$columnNumber}">
					<!-- PR#59944:added choose -->
					<xsl:choose>
						<xsl:when test="$lineitem/@LineItemEnableDiscountBidding = $trueValue">
							<xsl:value-of select="$lineitem/@LineItemMinBidChangeType"/><!-- PR#45124 -->
						</xsl:when>
						<xsl:otherwise>
									<xsl:value-of select="''"/>
						</xsl:otherwise>
					</xsl:choose>
				</cell>
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell header="true" column="{$columnNumber}">
					<!-- PR#59944:added choose -->
					<xsl:choose>
						<xsl:when test="$lineitem/@LineItemEnableDiscountBidding = $trueValue">
							<xsl:value-of select="$lineitem/@LineItemMinBidChangeValue"/><!-- PR#45124 -->
						</xsl:when>
						<xsl:otherwise>
							<xsl:value-of select="''"/>
						</xsl:otherwise>
					</xsl:choose>					
				</cell>
			</xsl:if>			
		</xsl:if>
		
		<xsl:if test="$includeItemDefs">
			<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell header="true" column="{$columnNumber}">
				<xsl:value-of select="$lineitem/@LineItemType"/>
			</cell>
			<xsl:if test="$itemSetEnabled=$trueValue">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
			<cell header="true" column="{$columnNumber}">
					<xsl:value-of select="$lineitem/@LineItemParentID"/>
				</cell>
			</xsl:if>
			<xsl:if test="$bid.rfxtype = 'rfp' or $bid.rfxtype = 'sealed'">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell header="true" column="{$columnNumber}">
					<xsl:value-of select="$lineitem/@LineItemMaximumDesiredQuantity"/>
				</cell>
			</xsl:if>
			<xsl:if test="$showDeliveryDate">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell header="true" column="{$columnNumber}">
					<xsl:value-of select="$lineitem/@LineItemDeliveryDateTime"/>
				</cell>
			</xsl:if>
			<xsl:if test="$showLeadDays">
				<saxon:assign name="columnNumber" select="$columnNumber + 1"/>
				<cell header="true" column="{$columnNumber}">
						<xsl:value-of select="$lineitem/@LineItemLeadDays"/>
				</cell>
			</xsl:if>
			 <xsl:call-template name="ItemIAValues">
				<xsl:with-param name="extendedattribute" select="$lineitem/ExtendedAttribute"/>
			 </xsl:call-template>
		</xsl:if>
		
		<!-- PR#44954 : cell overwrite not possible in csv format-->
		<xsl:if test="$bidscount = 0">
		<xsl:variable name="actionvalue">
			<xsl:value-of select="$ActionNew"/>
		</xsl:variable>
			<!-- PR#44457:start -->
			<xsl:if test="$surrogate">
				<xsl:if test="($bid.rfxtype = 'reverse') or
							   ($bid.rfxtype = 'forward')">
					<cell header="false" column="{$org.bid.offset - 4}">
						<xsl:value-of select="''"/>
					</cell>
				</xsl:if>				
				<cell header="false" column="{$org.bid.offset - 3}">
					<xsl:value-of select="''"/>
				</cell>
				<cell header="false" column="{$org.bid.offset - 2 }">
					<xsl:value-of select="''"/>
				</cell>
				<cell header="false" column="{$org.bid.offset - 1}">
					<xsl:value-of select="''"/>
				</cell>
			</xsl:if>			
			<!-- PR#44457:end -->
		<xsl:choose>
			<xsl:when test="$actionvalue='XXXXX'">
				<cell header="true" column="{$org.bid.offset}">
					<xsl:value-of select="$actionvalue"/>
				</cell>
			</xsl:when>
			<xsl:otherwise>
		<cell header="false" column="{$org.bid.offset}">
			<xsl:value-of select="$actionvalue"/>
		</cell>
			</xsl:otherwise>
		</xsl:choose>		
			<cell header="false" column="{$org.bid.offset + 1}">
				<xsl:value-of select="''"/>
			</cell>	
		</xsl:if>
		<!-- /row-->
	</xsl:template>
	
	<!-- **************************************************************************************************************** -->
	<!-- process bid node for an item -->
	<!-- **************************************************************************************************************** -->
	<xsl:template name="BidInfo">
		<xsl:param name="row"/>
		<xsl:param name="lineitem"/>
		<xsl:param name="bids"/>
		<xsl:for-each select="$bids">
			<xsl:sort select="@BidCode" data-type="number" order="ascending"/>
			<saxon:assign name="actionvalue">
				<xsl:choose>
					<xsl:when test="(@BidPricePerUnit) and not($bid.rfxtype = 'reverse')">
						<xsl:value-of select="$ActionUpdate"/>
					</xsl:when>
					<xsl:when test="not($bid.rfxtype = 'reverse')">
						<xsl:value-of select="$ActionNew"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="'XXXXX'"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>
			<saxon:assign name="BidSellerProductCode" select="@BidSellerProductCode"/>
			<saxon:assign name="BidMinimum" select="@BidMinimum"/>
			<saxon:assign name="BidMaximum" select="@BidMaximum"/>
			<saxon:assign name="BidPricePerUnit">
				<xsl:choose>
					<xsl:when test="($lineitem/@LineItemMinBidChangeType) and not(@BidPricePerUnit)">
						<xsl:value-of select="'XXXXX'"/>
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="@BidPricePerUnit"/>
					</xsl:otherwise>
				</xsl:choose>
			</saxon:assign>			
			<saxon:assign name="BidOneTimeCharge" select="@BidOneTimeCharge"/>
			<saxon:assign name="BidDeliveryDate" select="@BidDeliveryDate"/>
			<saxon:assign name="BidLeadDays" select="@BidLeadDays"/>
			<saxon:assign name="BidCurrencyCode" select="@BidCurrencyCode"/>
			<saxon:assign name="SupplierOrgCode" select="@BidderOrganizationCode"/>
			<saxon:assign name="BidderLoginName" select="@BidderLoginName"/>
			<saxon:assign name="BidSubmitterLoginName" select="@BidSubmitterLoginName"/>
			<saxon:assign name="BidPPUPercentDiscount" select="@PPUPercentDiscount"/>
			<saxon:assign name="BidPPUPercentDiscountType" select="@BidPPUDiscountType"/>
			<saxon:assign name="BidIsPreliminary" select="@BidIsPreliminary"/>
			<saxon:assign name="LineItemEnableDiscountBidding" select="$lineitem/@LineItemEnableDiscountBidding"/>
			<saxon:assign name="item" select="string($lineitem/@LineItemCode)"/>
				
			<xsl:choose>
					<xsl:when test="$surrogate">
						<cell header="false" column="{$org.bid.offset - 3}">
							<xsl:value-of select="$SupplierOrgCode"/>
						</cell>
						<cell header="false" column="{$org.bid.offset - 2}">
							<xsl:value-of select="$BidderLoginName"/>
						</cell>
						<cell header="false" column="{$org.bid.offset - 1}">
							<xsl:value-of select="$BidSubmitterLoginName"/>
						</cell>
					</xsl:when>
				</xsl:choose>
				<cell header="false" column="{$org.bid.offset}">
					<xsl:value-of select="$actionvalue"/>
				</cell>
				<cell header="false" column="{$org.bid.offset + 1}">
					<xsl:value-of select="$BidCurrencyCode"/>
				</cell>
				<xsl:for-each
						select="$bidXACodes[generate-id()=generate-id(key('bidXACodesKey', .)[1])]">			
						<xsl:variable name="attributename" select="string(.)"/>					
						<saxon:assign name="xaValue">					
						<xsl:choose>
							<xsl:when test="$attributename = java:getValue($language, 'excelmap.bids.simple.BidSellerProductCode')">
									<xsl:value-of select="$BidSellerProductCode"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidMinimumStr">
									<xsl:value-of select="$BidMinimum"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidMaximumStr">
									<xsl:value-of select="$BidMaximum"/>
							</xsl:when>
							<xsl:when test="$attributename = java:getValue($language, 'excelmap.bids.simple.BidPricePerUnit')">
										<xsl:choose>
											<xsl:when test="empty($BidPPUPercentDiscount) or
															$BidPPUPercentDiscountType = java:getValue($language, 'excelmap.bids.simple.BidPPUPercentDiscountType.none') or
															$LineItemEnableDiscountBidding = java:getValue($language, 'excelmap.bids.simple.LineItemEnableDiscountBidding.false')">
												<xsl:value-of select="$BidPricePerUnit"/>
											</xsl:when>
											<xsl:when test="empty($LineItemEnableDiscountBidding)">
									<xsl:value-of select="$BidPricePerUnit"/>																
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="'XXXXX'"/>
											</xsl:otherwise>
										</xsl:choose>								
							</xsl:when>
								<xsl:when test="$attributename = $BidDiscountCodeStr">
									<xsl:if test="$LineItemEnableDiscountBidding = $trueValue">															
										<xsl:value-of select="$BidPPUPercentDiscount"/>										
									</xsl:if>								
							</xsl:when>
								<xsl:when test="$attributename = $BidOneTimeChargeStr">
									<xsl:value-of select="$BidOneTimeCharge"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidDeliveryDateStr">
									<xsl:value-of select="$BidDeliveryDate"/>
							</xsl:when>
								<xsl:when test="$attributename = $BidLeadDaysStr">
									<xsl:value-of select="$BidLeadDays"/>
								</xsl:when>
							</xsl:choose>
						</saxon:assign>
						<xsl:if test="empty($xaValue) or string-length($xaValue) &lt;= 0">
							<saxon:assign name="xaValue">
								<xsl:choose>
									<xsl:when test="$LineItemEnableDiscountBidding = $falseValue and
													$attributename = $BidDiscountCodeStr">
										<xsl:value-of select="'XXXXX'"/>
									</xsl:when>
									<xsl:otherwise>
								<xsl:value-of select="../@XADDefaultValue"/>
									</xsl:otherwise>
								</xsl:choose>								
							</saxon:assign>
						</xsl:if>
						
						<saxon:assign name="readOnly">
                    		<xsl:choose>
		                        <!-- read/write is editable -->
		                        <xsl:when test="contains(../@XADVisibility, concat('/', $AttributeDefVisibilityExposed))">
		                            <xsl:value-of select="'false'"/>
		                        </xsl:when>
		                        <!-- read/read and read/hidden are readOnly -->
		                        <xsl:when test="contains(../@XADVisibility, concat($AttributeDefVisibilityReadOnly, '/'))">
		                            <xsl:value-of select="'true'"/>
		                        </xsl:when>
		                        <!-- write/read (not-surrogate) is readOnly -->
		                        <xsl:when test="not($surrogate) and
		                                contains(../@XADVisibility, concat($AttributeDefVisibilityExposed, '/'))">
		                            <xsl:value-of select="'true'"/>
		                        </xsl:when>
		                        <!-- write/read and write/hidden (surrogate) are editable -->
		                        <xsl:otherwise>
		                            <xsl:value-of select="'false'"/>
		                        </xsl:otherwise>
                   			 </xsl:choose>
                		</saxon:assign>
                		
                		<cell column="{$org.bid.offset + position() + 1}">
		                    <saxon:assign name="xadType"
		                            select="java:getName($language, ../@XADDataType, 'integration.AttributeDefDataType.')"/>
		                    <xsl:choose>
		                        <xsl:when test="$xadType='CALCULATED_TYPE' or $xadType='SPACER_TYPE'">
		                            <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            <xsl:value-of select="'XXXXX'"/>
		                        </xsl:when>
		                        <xsl:when test="java:getValue($language, 'integration.AttributeDefScope.BidStruct.bid_item')=../@XADScope">
		                            <saxon:assign name="links" select="string(../@XADObjectLink)"/>
		                            <saxon:assign name="span" select="string-length($links)"/>
		                            <saxon:assign name="len" select="string-length($item)"/>
		                            <xsl:choose>
		                                <xsl:when test="$links = $item or (($span &gt; $len)
		                                        and (substring($links, $span - $len) = concat('|', $item)
		                                                or contains($links, concat('|', $item, '|'))
		                                                or substring($links, 1, $len + 1) = concat($item, '|')))">
		                                    <!-- grey out cell if field is readonly -->
		                                    <xsl:if test="$readOnly='true'">
		                                        <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                                    </xsl:if>
		                                    <xsl:value-of select="$xaValue"/>
		                                </xsl:when>
		                                <xsl:otherwise>
		                                    <!-- grey out cell if field is not linked to this item -->
		                                    <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                                    <xsl:value-of select="'XXXXX'"/>
		                                </xsl:otherwise>
		                            </xsl:choose>
					     <saxon:assign name="links" select="''"/>
		                            <saxon:assign name="span" select="''"/>
		                            <saxon:assign name="len" select="''"/>
							</xsl:when>
		                        <xsl:otherwise>
		                            <!-- grey out cell if field is readonly -->
		                            <xsl:if test="$readOnly='true'">
		                                <xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            </xsl:if>
		                            <xsl:if test="$xaValue = 'XXXXX'">
		                            	<xsl:attribute name="header"><xsl:value-of select="'true'"/></xsl:attribute>
		                            </xsl:if>
		                            <xsl:choose>
		                            	<xsl:when test="string-length($xaValue) &gt;= 1">
		                            <xsl:value-of select="$xaValue"/>
		                            	</xsl:when>
		                            </xsl:choose>
		                        </xsl:otherwise>
						</xsl:choose>
				    <saxon:assign name="xadType" select="''"/>
				    <saxon:assign name="xaValue" select="''"/>
                		</cell>
					<saxon:assign name="readOnly" select="''"/>					
					</xsl:for-each>
					<xsl:call-template name="bidextendedattribute">
						<xsl:with-param name="extendedattribute" select="./ExtendedAttribute"/>
						<xsl:with-param name="lineitem" select="$lineitem"/>
				</xsl:call-template>
					<saxon:assign name="BidSellerProductCode" select="''"/>
					<saxon:assign name="BidMinimum" select="0" />
					<saxon:assign name="BidMaximum" select="0" />
					<saxon:assign name="BidPricePerUnit" select="0" />
					<saxon:assign name="BidOneTimeCharge" select="0" />
					<saxon:assign name="BidDeliveryDate" select="''" />
					<saxon:assign name="BidLeadDays" select="''" />
					<saxon:assign name="BidCurrencyCode" select="''" />
					<saxon:assign name="SupplierOrgCode" select="''" />
					<saxon:assign name="BidderLoginName" select="''" />
					<saxon:assign name="BidSubmitterLoginName" select="''" />
					<saxon:assign name="BidPPUPercentDiscount" select="''" />
					<saxon:assign name="BidPPUPercentDiscountType" select="''" />
					<saxon:assign name="BidIsPreliminary" select="''" />
					<saxon:assign name="LineItemEnableDiscountBidding" select="''" />
					<saxon:assign name="item" select="''" />	
					<saxon:assign name="actionvalue" select="''" />
			</xsl:for-each>
	</xsl:template>	
	
	<!-- **************************************************************************************************************** -->
	<!-- Process the line items -->
	<!-- **************************************************************************************************************** -->
	<xsl:template match="LineItem" mode="bidtemplate">
		<!--xsl:param name="rowstart"/-->
		
		<saxon:assign name="lineitemcode" select="@LineItemCode"/>
		<saxon:assign name="lineitemtype" select="@LineItemType"/>
		<saxon:assign name="bidcount" select="count(key('SimpleBidKey',$lineitemcode))"/>
		
		<saxon:assign name="lineitem" select="."/>
		<xsl:choose>
			<xsl:when test="(//RFx[1]/@RFxType != java:getValue($language, 'excelmap.rfxtype.reverse')) and (//RFx[1]/@RFxType != java:getValue($language, 'excelmap.rfxtype.forward'))">
				<xsl:choose>
					<xsl:when test="$lineitem/@LineItemType = java:getValue($language, 'excelmap.lineitem.type.substitution')">
						<xsl:variable name="Substitution" select="$lineitem/LineItem"/>
						<saxon:assign name="substitution_row_num" select="$rowNumber"/>
						<xsl:for-each select="$Substitution">
							<xsl:variable name="substi_item" select="."/>
							<xsl:variable name="substi_bids_count" 
									select="count(//RFx[1]/Bid[@BidType=java:getValue($language, 'excelmap.bid.simple') and @BidLineItemCode=$substi_item/@LineItemCode and @Status=java:getValue($language, 'excelmap.bid.valid')])"/>
							<xsl:call-template name="BidItem">
								<xsl:with-param name="row" select="$substitution_row_num"/>
								<xsl:with-param name="lineitem" select="."/>
								<xsl:with-param name="bids" 
									select="//RFx[1]/Bid[@BidType=java:getValue($language, 'excelmap.bid.simple') and @BidLineItemCode=$substi_item/@LineItemCode and @Status=java:getValue($language, 'excelmap.bid.valid')]"/>
							</xsl:call-template>							
							<xsl:choose>
								<xsl:when test="$substi_bids_count &lt; 2">
									<saxon:assign name="substitution_row_num" select="$substitution_row_num + 1"/>
								</xsl:when>
								<xsl:otherwise>
									<saxon:assign name="substitution_row_num" select="$substitution_row_num + $substi_bids_count"/>
								</xsl:otherwise>
							</xsl:choose>							
						</xsl:for-each>
						<saxon:assign name="singlebid.end.row" select="$substitution_row_num"/>
					</xsl:when>
					<xsl:otherwise>
				<xsl:call-template name="BidItem">
								<xsl:with-param name="row" select="$rowNumber"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
						<xsl:with-param name="bids" 
										select="key('SimpleBidKey',$lineitemcode)"/>
				</xsl:call-template>
					</xsl:otherwise>
				</xsl:choose>				
			</xsl:when>
			<xsl:when test="((//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.reverse')) or (//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.forward'))) and ($bidcount &gt;= 1)">
				<xsl:call-template name="BidItem">
					<xsl:with-param name="row" select="$rowNumber"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
						<xsl:with-param name="bids" 
							select="//RFx[1]/Bid[@BidType=java:getValue($language, 'excelmap.bid.simple') and @BidLineItemCode=$lineitemcode and @Status=java:getValue($language, 'excelmap.bid.valid')]"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:when test="((//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.reverse')) or (//RFx[1]/@RFxType = java:getValue($language, 'excelmap.rfxtype.forward'))) and ($bidcount &lt; 1)">
				<xsl:call-template name="BidItem">
					<xsl:with-param name="row" select="$rowNumber"/>
					<xsl:with-param name="lineitem" select="$lineitem"/>
						<xsl:with-param name="bids" 
							select="//RFx[1]/Bid[(@BidType=java:getValue($language, 'integration.BidType.ForcedLotBid.value')) or (@BidType=java:getValue($language, 'integration.BidType.ForcedLotBid'))]/Bid[@BidLineItemCode=$lineitemcode and @Status=java:getValue($language, 'excelmap.bid.valid')]"/>
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
			
		<xsl:choose>
			<xsl:when test="($bidcount &lt; 2) and ($lineitemtype != java:getValue($language, 'excelmap.lineitem.type.substitution'))">
				<!-- xsl:value-of select="java:addRow($RowMap, $rowNumber + 1, $lineitemcode)"/-->
				<saxon:assign name="singlebid.end.row" select="$rowNumber + 1"/>
			</xsl:when>
			<xsl:when test="($bidcount &gt; 1) and ($lineitemtype != java:getValue($language, 'excelmap.lineitem.type.substitution'))">
				<!-- xsl:value-of select="java:addRow($RowMap, $rowNumber + $bidcount, $lineitemcode)"/-->
				<saxon:assign name="singlebid.end.row" select="$rowNumber + $bidcount"/>
			</xsl:when>
		</xsl:choose>
			
				<xsl:choose>
					<xsl:when test="($bidcount &lt; 2) and (($lineitemtype != java:getValue($language, 'excelmap.lineitem.type.substitution')))">
					<saxon:assign name="rowNumber" select="$rowNumber + 1"/>
					</xsl:when>
					<xsl:when test="($bidcount &gt; 1) and (($lineitemtype != java:getValue($language, 'excelmap.lineitem.type.substitution')))">
					<saxon:assign name="rowNumber" select="$rowNumber + $bidcount"/>
					</xsl:when>
					<xsl:when test="($lineitemtype = java:getValue($language, 'excelmap.lineitem.type.substitution'))">
					<saxon:assign name="rowNumber" select="$substitution_row_num"/>
			</xsl:when>
		</xsl:choose>
			
		
		<saxon:assign name="lineitemcode" select="''"/>
		<saxon:assign name="lineitemtype" select="''"/>
		<saxon:assign name="bidcount" select="0"/>		
		<saxon:assign name="lineitem" select="''"/>

	</xsl:template>
	
	<!-- ******************************************* -->
	<!-- Process the requisition(Lot) -->
	<!-- ******************************************* -->
	<!-- xsl:template match="LineItem" mode="bidtemplate" name="LineItemTemplate" -->
	<xsl:template match="Requisition" mode="bidtemplate">
		<xsl:param name="rowstart"/>
		<xsl:param name="itemno"/>
		<xsl:apply-templates select="./LineItem[$itemno]" mode="bidtemplate">
			<xsl:with-param name="rowstart" select="$rowstart"/>
		</xsl:apply-templates>
		<xsl:if test="$singlebid.end.row = 0">
			<saxon:assign name="singlebid.end.row" select="$rowstart"/>
		</xsl:if>	
		<xsl:if test="(following-sibling::*[1])">
			<xsl:apply-templates select="following-sibling::*[1]" mode="bidtemplate">
				<!-- xsl:with-param name="rowstart" select="java:getRow($RowMap)"/-->
				<xsl:with-param name="rowstart" select="$singlebid.end.row"/>
				<xsl:with-param name="itemno" select="1"/>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="ItemIAsHeader">
		<xsl:for-each select="$itemXAUserDefined">
			<cell  column="{$columnNumber + position()}">
			<xsl:choose>
					<xsl:when test="./@XADIsRequired= $trueValue
							or translate(./@XADIsRequired, 'truefals', 'TRUEFALS')='TRUE'">
						<xsl:choose>
							<xsl:when test="@XADName = $BidDiscountCodeStr">
								<xsl:value-of select="concat('*', java:getValue($language, 'excelmap.bidfield.discount.value'))"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="concat('*',@XADName)"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:otherwise>
						<xsl:choose>
							<xsl:when test="@XADName = $BidDiscountCodeStr">
								<xsl:value-of select="java:getValue($language, 'excelmap.bidfield.discount.value')"/>
							</xsl:when>
							<xsl:when test="(@XADName = $BidMinimumStr) and
											(/ePASSResponse/RFxResponse/RFx/RFQBiddingRules/@RFxAllowOptimizationFeedback = $trueValue)">
								<xsl:value-of select="concat('*',@XADName)"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="@XADName"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:otherwise>
				</xsl:choose>
    		</cell>
    	</xsl:for-each>
		
	</xsl:template>
	
	<xsl:template name="ItemIAValues">
		<xsl:param name="extendedattribute"/>
		<xsl:for-each select="$itemXAUserDefined">
            <xsl:variable name="varXaName" select="@XADName"/>
           	<cell  column="{$columnNumber + position()}">
				<xsl:for-each select="$extendedattribute">
					<xsl:variable name="extendedattrname" select="@ExtendedAttributeCode"/>
					<xsl:variable name="extendedattrvalue" select="@ExtendedAttributeValue"/>
				    <xsl:if test="$extendedattrname = $varXaName">
						<xsl:value-of select="$extendedattrvalue"/>
					</xsl:if>
				</xsl:for-each>
		    </cell>
        </xsl:for-each>
	
	</xsl:template>
	
	<!-- ******************************************************************** -->
	<!-- create blank cells : PR#44457 -->
	<!-- ******************************************************************** -->
	<xsl:template name="BlankCells">
		<xsl:param name="colNum"/>
		<cell column="{$org.bid.offset + $colNum + 2}">
			<xsl:value-of select="''"/>
		</cell>
		<cell column="{$org.bid.offset + $colNum + 3}">
			<xsl:value-of select="''"/>
		</cell>
		<cell column="{$org.bid.offset + $colNum + 4}">
			<xsl:value-of select="''"/>
		</cell>
		<cell column="{$org.bid.offset + $colNum + 5}">
			<xsl:value-of select="''"/>
		</cell>
		<cell column="{$org.bid.offset + $colNum + 6}">
			<xsl:value-of select="''"/>
		</cell>
		<cell column="{$org.bid.offset + $colNum + 7}">
			<xsl:value-of select="''"/>
		</cell>
	</xsl:template>
	
	<!-- *************************************** -->
	<!-- Create the bidding instructions section -->
	<!-- *************************************** -->
	<xsl:template name="bid.instr.section">
		<xsl:param name="row"/>
		<xsl:param name="rfxType"/>
		<xsl:variable name="orgOrSup">
			<xsl:choose>
				<xsl:when test="$org.side">
					<xsl:value-of select="'org'"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="'sup'"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="sec1" select="concat('sec1.', $orgOrSup, '.all')"/>
		<xsl:variable name="sec2" select="'sec2.all.all'"/>
		<xsl:variable name="sec3" select="'sec3.all.response'"/>
		<xsl:variable name="sec4" select="'sec4.all.bid'"/>
		<!-- PR 64175 --> 
		<xsl:variable name="sec8" select="'sec8.all.bid'"/>
		<xsl:variable name="sec234">
			<xsl:choose>
				<xsl:when test="$rfxType = 'rfp'">
					<xsl:value-of select="concat($sec2, ',', $sec8, ',', $sec3, ',', $sec4)"/>
				</xsl:when>
				<xsl:when test="$rfxType = 'rfi' or $rfxType = 'buyer_rfi'">
					<xsl:value-of select="concat($sec2, ',', $sec3)"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="concat($sec2, ',', $sec8, ',', $sec4)"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="sec5" select="concat('sec5.', $orgOrSup, '.all')"/>
		<xsl:variable name="sec6" select="'sec6.all.all'"/>
		<xsl:variable name="sec7a" select="'sec7.sup.response'"/>
		<xsl:variable name="sec7b" select="'sec7.sup.bid'"/>
		<xsl:variable name="sec7">
			<xsl:choose>
				<xsl:when test="$org.side">
					<xsl:value-of select="'sec7.org.all'"/>
				</xsl:when>
				<xsl:when test="$rfxType = 'rfp'">
					<xsl:value-of select="concat($sec7a, ',', $sec7b)"/>
				</xsl:when>
				<xsl:when test="$rfxType = 'rfi' or $rfxType = 'buyer_rfi'">
					<xsl:value-of select="$sec7a"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$sec7b"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="sections" select="concat($sec1, ',', $sec234, ',', $sec5, ',', $sec6, ',', $sec7)"/>
		<xsl:call-template name="template_instructions">
			<xsl:with-param name="doc_type" select="'bid'"/>
			<xsl:with-param name="sections" select="$sections"/>
			<xsl:with-param name="row" select="$row"/>
		</xsl:call-template>
	</xsl:template>
</xsl:stylesheet>
<!--
 * $Log: /epass/epass5.0.1/com/avinamart/WebInterface/public_html/Integration/xsl/ePASS2gXML/ePASS2gXML_Bid.xsl $
 *
 * 2     10/14/04 3:45p Djesurum
 * PR-21468,9: restore surrogate bidding for all rfx types (except
 * survey).
 *
 * 19    5/24/04 5:23p Djesurum
 * Use mapDir variable to locate locale specific header map document.
 *
 * 18    4/13/04 6:14p Djesurum
 * PR-21681: Change LineItem bidTemplate to use itemName for bid attribute
 * links instead of itemCode.
 *
 * 17    4/09/04 3:49p Djesurum
 * Change evaluation of readOnly variable in LineItem bidTemplate to
 * handle surrogate bidding.
 *
 * 16    4/07/04 5:03p Djesurum
 * Ignore org.side when evaluating supplierReadOnly variable in LineItem
 * bidTemplate, since surrogate bidders see supplier visibility.
 *
 * 15    4/04/04 10:37p Djesurum
 * Change instructions template to divide instructions into sections, and
 * to search for appropriate sections depending on side (org/sup) and
 * rfxType (bid/response).
 * Change indent template to indent all tabs, not only leading tabs.
 *
 * 14    3/30/04 1:32p Djesurum
 * Correct Question bidtemplate @QuestionAllowComments logic.
 *
 * 13    3/25/04 11:01a Djesurum
 * PR-21185.  Surrogate bidding only applicable for reverse auctions.
 * Preliminary Bid is only for Advanced Auctions.
 *
 * 12    3/19/04 4:25p Djesurum
 * Change LineItem bidTemplate to grey out readOnly cells for supplier.
 *
 * 11    3/18/04 10:26a Djesurum
 * Correct VSS Comments.
 *
 * 10    3/18/04 10:24a Djesurum
 * Add minimum/maximum value range and validation to bid.header6.
 *
 * 9     3/12/04 4:56p Djesurum
 * Add special handling in LineItem bidTemplate to export deliveryDate and
 * leadDays values.
 *
 * 8     3/12/04 9:39a Djesurum
 * Use mapBase to check @RFxType and @XADDomain instead of mapRFx.
 *
 * 7     3/05/04 11:46a Djesurum
 * PR-20656:  Grey-out readonly bid attributes if supplier-side.
 *
 * 6     2/20/04 5:13p Djesurum
 * Correct ResponseQuestionnaire and ResponseQuestion headers.
 *
 * 5     2/18/04 5:56p Djesurum
 * Move sorting of Requisition / LineItems to HelperBase.java.
 * Make SPACER row readonly XXXXX, like CALCULATED fields.
 *
 * 4     2/10/04 5:37p Djesurum
 * Add capability of creating Questionnaire Response section in exported
 * Excel template.
 *
 * 3     1/27/04 12:47p Djesurum
 * Change search for LineItemCode within XADObjectLink to find exact match
 * or beginning "<item>|" or containing "|<item>|" or ending "|<item>".
 *
 * 2     1/27/04 10:35a Djesurum
 * Add row and cell header attributes.
 * Correct instructions template behavior for absent (blank) lines.
 *
 * 1     1/21/04 5:13p Djesurum
 * Initial BidTemplate for ePASS XML to generic XML.
-->
