<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<!--
$Archive: /epass/epass5.0.1/com/avinamart/WebInterface/public_html/Integration/xsl/ePASS2gXML/ePASS2gXML_Bid.xsl $
$Revision: 2 $ $Date: 10/14/04 3:45p $
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0" 
	xmlns:saxon="http://saxon.sf.net/" 
	xmlns:localeHelper = "java:com.emptoris.framework.importExport.LocaleHelper"
	xmlns:xsltContext="java:com.emptoris.framework.importExport.service.clientInterface.EPASSXMLBasedXSLTContext"
	xmlns:java="java:com.avinamart.Utility.EPASSIFHelper"
	xmlns:ss="http://www.emptoris.com"	
	xmlns:xl="http://www.emptoris.com/if/spreadsheet/saxon/com.emptoris.framework.importExport.service.internal.translate.SpreadSheetXSLTExtensionClassFactory"
	exclude-result-prefixes="saxon localeHelper xsltContext xl ss" extension-element-prefixes="saxon">
	
       
	<xsl:variable name="rfxcurrencycodes" select="$rfx/@RFxCurrencyCodes"/>
	<xsl:variable name="VarIndex" select="1" saxon:assignable="yes"/>
	<xsl:variable name="discountBidding" select="$rfx/AuctionRules/@AllowDiscountBidding"/>
	<xsl:variable name="reverseAuctionSheetName" select="localeHelper:getValue( $localeHelper, 'excelmap.bids.reverse_auction.sheet.name.bid')" />
	<xsl:variable name="ppuFormula" select="''" saxon:assignable="yes"/>

	<!-- ***************************** -->
	<!-- Handle the RFx Header section -->
	<!-- ***************************** -->
	<xsl:template match="RFx" mode="Auction">
		<xl:sheet>
			<xsl:attribute name="name" select="$reverseAuctionSheetName"/>
			<xsl:attribute name="type"><xsl:value-of select="'BID_AUCTION'" /></xsl:attribute>
			<xsl:attribute name="rfxDecimalPlaces"><xsl:value-of select="@RFxDecimalPlaces" /></xsl:attribute>
			<xsl:attribute name="validationLimit"><xsl:value-of select="if( $isBidTemplate) then max(($validationLimitBids,$validationLimitItems)) else 0" /></xsl:attribute>
			<xsl:attribute name="rfxCurrencyCodes"><xsl:value-of select="@RFxCurrencyCodes" /></xsl:attribute>
						
			<xsl:call-template name="RFxInformation" />
			<xl:row />
			
			<xsl:variable name="currExchangeNodes" select="$rfx//CurrencyExchange"/>
			<xsl:if test="count($currExchangeNodes) &gt; 0 and java:canBidderViewExchangeRate()">
				<xsl:call-template name="CurrencyExchangeRates">
					<xsl:with-param name="currExchangeNodes" select="$rfx//CurrencyExchange"></xsl:with-param>
				</xsl:call-template>
				<xl:row/>
			</xsl:if>
			
			<!--It creates the column headers-->
			<xsl:call-template name="bid.auction.headers" />
			<saxon:assign name="ppuFormula" select="//ExtendedAttributeDefinition[@XADName= localeHelper:getValue($localeHelper, 'excelmap.bids.simple.BidPricePerUnit')
							and @XADDataType= $XADDataType.Calculated]/@Formula"/>
			<xsl:apply-templates select="$rfx/Requisition" mode="bid_Auction_template"/>
			
		</xl:sheet>
	</xsl:template>
	
	<xsl:template name="bid.auction.headers">
		<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
		<xsl:if test="$UOMColumnPresent">
			<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
		</xsl:if>
		<xsl:if test="$descriptionPresent">
			<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
		</xsl:if>
		<xsl:if test="$includeItemDefs">
			<xsl:if test="$specificationPresent">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
				<xsl:if test="$specificationURLPresent">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
				<xsl:if test="$startPricePresent">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
		</xsl:if>

		<xsl:variable name="discountBidPresent" select="$discountBidding = $trueValue"/>
		<xsl:variable name="numEmptyCells" select="
			if($discountBidPresent) then
				7 + $visibleItemIACount
			else
				5 + $visibleItemIACount
				" />
			<xsl:variable name="itemDefEmptyCells">
	    		<xsl:value-of select="
	    			if($includeItemDefs)
    				then
    					if($itemSetEnabled=$trueValue)
   						then $userDefinedItemIACount + 3
    					else 
    						$userDefinedItemIACount + 2
	    			else 0
	    		"/>
	    	</xsl:variable>
		<xl:row header="true" font="rfxheader">
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfq.headers.itembids.section')" />
			</xl:cell>
			<xl:skip numberOfColumns="{$numEmptyCells+$itemDefEmptyCells}" />
			<xl:cell font="itemheader">
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.section.simplebids')" />
			</xl:cell>
		</xl:row>
		<xl:row header="true" font="itemheader">
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.item.info')" />
			</xl:cell>
	  		<xl:skip numberOfColumns="{$numEmptyCells+$itemDefEmptyCells}" />
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.bid.info')" />
			</xl:cell>
		</xl:row>
		<xl:row header="true" font="itemcolumnheader">
			<xl:cell>
				<xsl:attribute name="tooltip" select="
					$itemXACodes[@XADName=localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.xad.Name')]/@XADDescription"/>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'name', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			<xl:cell>
				<xsl:attribute name="tooltip" select="
					$itemXACodes[@XADName=$XADName.UniqueId]/@XADDescription"/>
				<xsl:if test="not($uniqueIdColumnPresent)">
					<xsl:attribute name="hideColumn" select="'true'"/>
				</xsl:if>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'code', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			<xl:cell>
				<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LotDesc')"/>
				<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LineItemLotName')" />
			</xl:cell>
			<xsl:if test="$descriptionPresent">
				<xl:cell>
					<xsl:attribute name="tooltip" select="
						$itemXACodes[@XADName=localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.xad.Description')]/@XADDescription"/>
					<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'description', @OrganizationCode, @RFxCode)" />
				</xl:cell>
			</xsl:if>
			<xl:cell freezeColumn="true">
				<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.ForcedLotDesc')"/>
				<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.ForcedLot')" />
			</xl:cell>
			<xl:cell>
				<xsl:attribute name="tooltip" select="
					$itemXACodes[@XADName=$XADName.MinDesiredQuantity]/@XADDescription"/>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'minQuantity', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			<xsl:if test="$includeItemDefs">
				<xsl:if test="$specificationPresent">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName= $XADName.Specification]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'specification', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
				<xsl:if test="$specificationURLPresent">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName= $XADName.SpecificationURL]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'specificationURL', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
			</xsl:if>
			<xsl:if test="$UOMColumnPresent">
				<xl:cell>
					<xsl:attribute name="tooltip" select="
						$itemXACodes[@XADCode='unitOfMeasure']/@XADDescription"/>
					<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'unitOfMeasure', @OrganizationCode, @RFxCode)" />
				</xl:cell>
			</xsl:if>
			<xsl:if test="$discountBidding = $trueValue">
				<xl:cell>
					<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.BasePriceDesc')"/>
					<xsl:value-of select="java:getPredefinedBidIATranslationValue($language, 'baseCost', @OrganizationCode, @RFxCode)" />
				</xl:cell>
				<xl:cell>
					<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.DiscountTypeDesc')"/>
					<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LineItemDiscountType')" />
				</xl:cell>
			</xsl:if>
			<xsl:if test="$includeItemDefs">
				<xsl:if test="$startPricePresent">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
											$itemXACodes[@XADName=$XADName.StartPrice]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'startPrice', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
			</xsl:if>
			
			
			<xl:cell>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'minBidChangeAmount', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			
			<xsl:if test="$includeItemDefs">
				<xl:cell>
					<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.CategoryDesc')"/>
					<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LineItemCategory')" />
				</xl:cell>
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.ItemType')" />
				</xl:cell>
				<xsl:if test="$itemSetEnabled=$trueValue">
					<xl:cell>
						<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.ParentItemUniqueID')" />
					</xl:cell>
				</xsl:if>
				
				
				<xsl:call-template name="ItemIAsHeader"/>
			</xsl:if>
			
			<xl:cell>
				<xsl:attribute name="tooltip">
					<xsl:value-of
					select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.singleselect'), '  ' , '(', localeHelper:getValue( $localeHelper,  'EPASSAttributeDefStruct.required'), ')','&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.action.new'),'&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.action.no_bid'))" />
				</xsl:attribute>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bids.BidAction')" />
			</xl:cell>				
			<xl:cell>
				<xsl:attribute name="tooltip" ><!--select="$dropdown"-->
                        <xsl:value-of select="concat(localeHelper:getValue($localeHelper,'excelmap.bid.attribute.singleselect'), '  ' , '(', localeHelper:getValue($localeHelper, 'EPASSAttributeDefStruct.required'), ')','&#xa;',
                                    localeHelper:getValue($localeHelper,'excelmap.bids.comment.currency'),'&#xa;',$rfxcurrencycodes)"/>
                 </xsl:attribute>
				 <xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.bids.BidCurrencyCode')" />
			</xl:cell>
		
			<xsl:for-each select="$bidXAsVisible">
				<xl:cell>
						<xsl:call-template name="XADHeaderComment"><!--it creates the tooltip for bid IA-->
							<xsl:with-param name="XANode" select="." />
						</xsl:call-template>
						<xsl:variable name="isRequired" select="@XADIsRequired = $trueValue or translate(@XADIsRequired, 'truefals', 'TRUEFALS')='TRUE'" />
						<xsl:value-of
							select="
								if( $isRequired ) 
									then if( @XADName = $XADName.BidDiscountCode ) 
											then concat('*', $XADName.BidDiscountValue )
										else concat('*',@XADName)
									else
										if( @XADName = $XADName.BidDiscountCode )
											then concat('*', $XADName.BidDiscountValue)
										else if ( @XADName= $XADName.BidMinimum and $rfx/RFQBiddingRules/@RFXAllowOptimizationFeedback = $trueValue )
											then concat('*',@XADName)
										else
											@XADName 
							" />
					</xl:cell>
			</xsl:for-each>
		</xl:row>
		
	</xsl:template>
	
	
	<!-- ******************************************* -->
	<!-- Process the requisition(Lot) -->
	<!-- ******************************************* -->
	<xsl:template match="Requisition" mode="bid_Auction_template">
		<xsl:variable name="currentNode" select="." />
	
		<xsl:apply-templates select="LineItem" mode="bid_Auction_template">
			<xsl:with-param name="RequisitionIsForced" select="@RequisitionIsForced"/>
			<xsl:with-param name="requisitionNode" select="$currentNode" />
		</xsl:apply-templates>
	</xsl:template>
	
	
	<!-- **************************************************************************************************************** -->
	<!-- create a node for an item -->
	<!-- **************************************************************************************************************** -->
	<xsl:template match="LineItem" mode="bid">
		<xsl:param name="bidscount"/>
	
		<xsl:variable name="lineitemcode" select="@LineItemCode"/>
		<xsl:variable name="isForcedLot" select="../@RequisitionIsForced"/>
		<xl:cell>
			<xsl:value-of select="@LineItemName"/>
		</xl:cell>
		<xl:cell>
			<xsl:if test="not($uniqueIdColumnPresent)">
				<xsl:attribute name="hideColumn" select="'true'"/>
			</xsl:if>	
			<xsl:value-of select="$lineitemcode"/>
		</xl:cell>
		<xl:cell>
			<xsl:value-of select="@LineItemLotName"/>
		</xl:cell>	
		<xsl:if test="$descriptionPresent">
			<xl:cell>
				<xsl:value-of select="@LineItemDescription"/>
			</xl:cell>
		</xsl:if>
		<xl:cell>
			<xsl:value-of select=" if(empty($isForcedLot)) then '' else $isForcedLot"/>
		</xl:cell>	
		<xl:cell datatype="Integer" >
			<xsl:value-of select="@LineItemMinimumDesiredQuantity"/>
		</xl:cell>
		<xsl:if test="$includeItemDefs">
			<xsl:if test="$specificationPresent">
				<xl:cell>
					<xsl:value-of select="ExtendedAttribute[@ExtendedAttributeCode = $XADName.Specification]/@ExtendedAttributeValue"/>
				</xl:cell>
			</xsl:if>
			<xsl:if test="$specificationURLPresent">
				<xl:cell>
					<xsl:value-of select="ExtendedAttribute[@ExtendedAttributeCode = $XADName.SpecificationURL]/@ExtendedAttributeValue"/>
				</xl:cell>
			</xsl:if>
		</xsl:if>
		<xsl:if test="$UOMColumnPresent">
			<xl:cell>
				<xsl:value-of select="@LineItemUnitOfMeasure"/>
			</xl:cell>		
		</xsl:if>
		<xsl:variable name="itemMinBidChangeValue" select="@LineItemMinBidChangeValue"/>
		<!-- TODO pass requestion as parameter -->
		<xsl:variable name="requisitionMinBidChangeValue" select="../@RequisitionMinBidChangeValue"/>
		<xsl:variable name="rfxMinBidChangeValue" select="$rfx/AuctionRules/@RFxMinBidChangeValue"/>
		
		<xsl:variable name="minBidChangeValue">
			<xsl:choose>
				<xsl:when test="$itemMinBidChangeValue != '' "><xsl:value-of select="$itemMinBidChangeValue"/></xsl:when>
				<xsl:when test="$requisitionMinBidChangeValue != '' "><xsl:value-of select="$requisitionMinBidChangeValue"/></xsl:when>
				<xsl:when test="$rfxMinBidChangeValue != '' "><xsl:value-of select="$rfxMinBidChangeValue"/></xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:variable name="minBidChangeType">
			<xsl:choose>
				<xsl:when test="$itemMinBidChangeValue != '' "><xsl:value-of select="./@LineItemPriceChangeType"/></xsl:when>
				<xsl:when test="$requisitionMinBidChangeValue != '' "><xsl:value-of select="../@RequisitionMinBidChangeType"/></xsl:when>
				<xsl:when test="$rfxMinBidChangeValue != '' "><xsl:value-of select="$rfx/AuctionRules/@RFxMinBidChangeType"/></xsl:when>
			</xsl:choose>
		</xsl:variable>
		<xsl:if test="$discountBidding = $trueValue">
			<xl:cell>
				<xsl:if test="./@LineItemEnableDiscountBidding = $trueValue">
					<xsl:value-of select="//Bid[@BidLineItemCode=$lineitemcode and @BidType=$bid.Type.Simple]/@BidPricePerUnit"/>
				</xsl:if>
			</xl:cell>	
			<xl:cell>
				<xsl:if test="./@LineItemEnableDiscountBidding = $trueValue">
					<xsl:value-of select="$minBidChangeType"/>
				</xsl:if>
			</xl:cell>	
		</xsl:if>
		<xsl:if test="$includeItemDefs">
			<xsl:if test="$startPricePresent">
				<xl:cell datatype="Currency">
					<xsl:value-of select="./@LineItemStartPrice"/>
				</xl:cell>
			</xsl:if>
		</xsl:if>
		<xl:cell>
			<xsl:if test="not($isForcedLot=$trueValue and empty($itemMinBidChangeValue))"><!-- PR ESP-45143 -->
				<xsl:value-of select="
					if($minBidChangeType=localeHelper:getValue($localeHelper, 'integration.DiscountType.Percentage') and $minBidChangeValue !='' ) 
						then concat($minBidChangeValue,' %')
					else $minBidChangeValue"/>
			</xsl:if>
		</xl:cell>	
		
			
		<xsl:if test="$includeItemDefs">
			<xl:cell>
				<xsl:value-of select="./@LineItemCategoryCode"/>
			</xl:cell>
			<xl:cell>
				<xsl:value-of select="./@LineItemType"/>
			</xl:cell>
			<xsl:if test="$itemSetEnabled=$trueValue">
				<xl:cell datatype="Integer">
					<xsl:value-of select="./@LineItemParentID"/>
				</xl:cell>
			</xsl:if>
			
			
			 <xsl:call-template name="ItemIAValues">
				<xsl:with-param name="extendedattribute" select="./ExtendedAttribute"/>
			 </xsl:call-template>
		</xsl:if>
		<xl:cell editable="true">
			<xsl:attribute name="defaultvalue" select="$new" />
			<xsl:attribute name="selectionlist" select="concat($new,'|',$noBid,'|')" />
		</xl:cell>
		
		<xsl:variable name="restrictedcurrency">
			<xsl:value-of select="./@LineItemRestrictedCurrency"/>	
		</xsl:variable>			
		
		<xsl:variable name="currencylist">
			<xsl:value-of select="localeHelper:removeRestrictedCurrency($rfxcurrencycodes, $restrictedcurrency )"/>
		</xsl:variable>
			
		<xsl:variable name="multiCurrency" select="substring-after($currencylist,$DefaultStringDelimiter)"/>
		<xsl:variable name="isMultiCurr">
			<xsl:value-of select="
				if($multiCurrency = '' ) 
					then 'false'
				else 'true'"/>
		</xsl:variable>
	
		<xsl:if test="$bidscount = 0"><!-- PR#44954 : cell overwrite not possible in csv format-->
			<xl:cell>
				<xsl:variable name="supplierCurrency" select="$supplierPrefferedCurrency"/>
				<xsl:attribute name="editable">true</xsl:attribute>
				<xsl:attribute name="isCurrencyList">true</xsl:attribute>
				<xsl:attribute name="defaultvalue">
					<xsl:value-of select="
						if($supplierCurrency != '' and contains($currencylist, $supplierCurrency))
							then $supplierCurrency
						else if( contains($currencylist, $rfxPrimaryCurrency) ) 
							then $rfxPrimaryCurrency
						else if($isMultiCurr='true')
							then $pleaseSelectValue
						else $currencylist"/>
				</xsl:attribute>
				
				<xsl:attribute name="selectionlist">
					<xsl:value-of select="$currencylist"/>
				</xsl:attribute>
			</xl:cell>
		</xsl:if>
	</xsl:template>

	<xsl:template name="removeRestrictedCurrencies">
		<xsl:param name="currencies"/>
		<xsl:param name="restrictedcurrency"/>
	
		 <xsl:choose>
			<xsl:when test="contains($restrictedcurrency,'|')">	   
			  <xsl:variable name="currency">
			   <xsl:value-of select="substring-before($restrictedcurrency,'|')"/>
			  </xsl:variable>
			  <xsl:call-template name="removeRestrictedCurrencies">
			<xsl:with-param name="currencies" select="concat(substring-before($currencies,concat($currency,'|')),substring-after($currencies,concat($currency,'|')))"/>
			<xsl:with-param name="restrictedcurrency" select="concat(substring-before($restrictedcurrency,concat($currency,'|')),substring-after($restrictedcurrency,concat($currency,'|')))"/>		
			  </xsl:call-template>	     
			</xsl:when>
			<xsl:otherwise>
			  <xsl:value-of select="concat(localeHelper:getValue($localeHelper, 'form.wizChoiceCurrency.select_currency'),'|',$currencies)"/>
			</xsl:otherwise>
		  </xsl:choose>
	</xsl:template>
	
	<!-- **************************************************************************************************************** -->
	<!-- Process the line items -->
	<!-- **************************************************************************************************************** -->
	<xsl:template match="LineItem" mode="bid_Auction_template">
		<xsl:param name="RequisitionIsForced" />
		<xsl:param name="requisitionNode" />
		
		<xsl:variable name="lineitemcode" select="@LineItemCode"/>
		<xsl:variable name="lineitemtype" select="@LineItemType"/>
		<xsl:variable name="bidcount">
			<xsl:choose>
				<xsl:when test="$RequisitionIsForced = $trueValue">
					<xsl:value-of select="count($rfx/Bid/Bid[@BidType=$bid.Type.Simple and @BidLineItemCode=$lineitemcode and @Status=$bid.Status.Valid])"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="count($rfx/Bid[@BidType=$bid.Type.Simple and @BidLineItemCode=$lineitemcode and @Status=$bid.Status.Valid])"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>

		<xsl:variable name="lineitem" select="."/>
		<xsl:variable name="bids" select="
			if($RequisitionIsForced = $trueValue)
				then $rfx/Bid/Bid[@BidType=$bid.Type.Simple and @BidLineItemCode=$lineitemcode and @Status=$bid.Status.Valid]
			else
				$rfx/Bid[@BidType=$bid.Type.Simple and @BidLineItemCode=$lineitemcode and @Status=$bid.Status.Valid]
		" />
		
		<xsl:choose>
			<xsl:when test="$bidcount &lt; 1">
				<xsl:call-template name="BidAuctionItem">
					<xsl:with-param name="lineitem" select="$lineitem"/>
					<xsl:with-param name="bids" 
						select="$rfx/Bid[(@BidType=$ForcedLotValue) or (@BidType=$ForcedLotCode)]/Bid[@BidLineItemCode=$lineitemcode and @Status=$bid.Status.Valid]"/>					
					<xsl:with-param name="isForced"  select="$RequisitionIsForced"/>
				</xsl:call-template>				
			</xsl:when>
			<xsl:when test="$bidcount &gt;= 1">
				<xsl:call-template name="BidAuctionItem">
					<xsl:with-param name="lineitem" select="$lineitem"/>
					<xsl:with-param name="bids" select="$bids"/>
					<xsl:with-param name="isForced"  select="$RequisitionIsForced"/>
				</xsl:call-template>
			</xsl:when>
		</xsl:choose>
				
	</xsl:template>
		

	<!-- **************************************** -->
	<!-- Process an item and its bids -->
	<!-- **************************************** -->
	<xsl:template name="BidAuctionItem">
		<xsl:param name="lineitem"/>
		<xsl:param name="bids"/>
		<xsl:param name="isForced"/>
	
		<xsl:variable name="bidsCount" select="count($bids)"/>	
		<xsl:choose>
			<xsl:when test="$bidsCount &lt; 1">		
				<xl:row font="iteminfo">
					<xsl:apply-templates select="$lineitem" mode="bid">
						<xsl:with-param name="bidscount" select="0"/>
					</xsl:apply-templates>
				
					<xsl:call-template name="ProcessBid">
						<xsl:with-param name="lineitem" select="$lineitem"/>
						<xsl:with-param name="isForced" select="$isForced"/>
					</xsl:call-template>
				</xl:row>
			</xsl:when>
			<xsl:otherwise>
				<xsl:call-template name="AuctionItemsAndBids">
					<xsl:with-param name="lineitem" select="$lineitem"/>
					<xsl:with-param name="bids" select="$bids"/>
					<xsl:with-param name="isForced" select="$isForced"/>
					<xsl:with-param name="bidsCount" select="$bidsCount"/>
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	

	
	<!-- **************************************** -->
	<!-- Process bids in ascending order of bids submitted-->
	<!-- **************************************** -->
	<xsl:template name="AuctionItemsAndBids">
		<xsl:param name="lineitem"/>
		<xsl:param name="bids"/>
		<xsl:param name="isForced"/>
		<xsl:param name="bidsCount"/>
	
		<xsl:for-each select="$bids">
			<xl:row font="iteminfo">
				<xsl:apply-templates select="$lineitem" mode="bid">
					<xsl:with-param name="bidscount" select="1"/>
				</xsl:apply-templates>
				<xsl:variable name="restrictedcurrency" select="$lineitem/@LineItemRestrictedCurrency"/>	
				<xl:cell>
					<xsl:attribute name="editable" select="'true'"/>
					<xsl:attribute name="isCurrencyList">true</xsl:attribute>
					<xsl:attribute name="defaultvalue" select="@BidCurrencyCode"/>
					<xsl:attribute name="selectionlist" select="localeHelper:removeRestrictedCurrency($rfxcurrencycodes, $restrictedcurrency )"/>
				</xl:cell>
				
				<xsl:call-template name="ProcessBid">
					<xsl:with-param name="lineitem" select="$lineitem"/>
					<xsl:with-param name="isForced" select="$isForced"/>
					<xsl:with-param name="bidNode" select="."/>
				</xsl:call-template>
			</xl:row>
		</xsl:for-each>
	</xsl:template>
		
</xsl:stylesheet>
