<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
	version="2.0"
	xmlns:saxon="http://saxon.sf.net/"
	xmlns:rfi="http://www.emptoris.com/xslt/rfi/saxon"
	xmlns:xs="http://www.w3.org/2001/XMLSchema"
	xmlns:localeHelper = "java:com.emptoris.framework.importExport.LocaleHelper"
	xmlns:rfihelper="java:com.emptoris.framework.importExport.service.internal.translate.RFIHelper"
  xmlns:context="java:com.emptoris.framework.importExport.service.clientInterface.Context"
	xmlns:xsltContext="java:com.emptoris.framework.importExport.service.clientInterface.EPASSXMLBasedXSLTContext"    
	xmlns:questionNameHelper="java:com.emptoris.framework.importExport.service.internal.translate.MatrixQuestionNameHelper"
	xmlns:ss="http://www.emptoris.com"	
	xmlns:xl="http://www.emptoris.com/if/spreadsheet/saxon/com.emptoris.framework.importExport.service.internal.translate.SpreadSheetXSLTExtensionClassFactory"
	exclude-result-prefixes="xs rfi saxon localeHelper rfihelper context xsltContext questionNameHelper xl ss" extension-element-prefixes="saxon">
<!--
	Include these when testing ONLY this template in isolation.
	 	
	<xsl:import href="ePASS2gXML_error_standalone.xsl" />
	<xsl:import href="ePASS2gXML/Common.xsl" />
	<xsl:import href="ePASS2gXML/RFxCommonTemplates.xsl" />
	<xsl:import href="ePASS2gXML/BidCommonTemplates.xsl" />
 -->	
	
	<xsl:function name="rfi:tableResponseCellName" as="xs:string*">
		<xsl:param name="niceName" as="xs:string" />
		<xsl:param name="rowPosition" as="xs:integer" />
		<xsl:param name="lastRow" as="xs:integer" />
		<xsl:param name="columnPosition" as="xs:integer" />
		<xsl:param name="lastColumn" as="xs:integer" />
		<xsl:variable name="comma" select="','" />
		<xsl:sequence select="
			if( $lastRow = 1 and $lastColumn = 1 ) then concat($niceName,'_topLeft',$comma,$niceName,'_bottomRight')
      else if( $lastRow = 1 and $columnPosition = 1 ) then concat($niceName,'_topLeft')                                
      else if( $lastRow = 1 and $columnPosition = $lastColumn ) then concat($niceName,'_bottomRight')
      else if( $rowPosition = 1 and $lastColumn = 1 ) then concat($niceName,'_topLeft')                                
      else if( $rowPosition = $lastRow and $lastColumn = 1 ) then concat($niceName,'_bottomRight')                                
      else if( $rowPosition=1 and $columnPosition=1 ) then concat($niceName,'_topLeft')
      else if( $rowPosition = $lastRow and $columnPosition = $lastColumn ) then concat($niceName,'_bottomRight')                                    
      else ()                                    
		" />
	</xsl:function>
	
	<xsl:variable name="firstResponseStatusCellName" select="'firstQuestionResponseStatus'" />	  
	<xsl:variable name="lastResponseStatusCellName" select="'lastQuestionResponseStatus'" />  
	<xsl:function name="rfi:questionResponseStatusCellName" as="xs:string*">
		<xsl:param name="isFirstQuestion" />
		<xsl:param name="questionNumber" />
		<xsl:param name="numQuestions" />
		
		<xsl:sequence select="
			if( $numQuestions = 1 and $isFirstQuestion = 'true') then concat($firstResponseStatusCellName,',',$lastResponseStatusCellName)
			else if( $questionNumber = 1 and $isFirstQuestion = 'true' ) then $firstResponseStatusCellName
			else if( $questionNumber = $numQuestions ) then $lastResponseStatusCellName			
			else 'questionResponseStatus'" />
	</xsl:function>
		    
	<!--Global variables specific to RFI template-->
	<xsl:variable name="matrixChildCell" select="localeHelper:getValue( $localeHelper,  'integration.MatrixChildType.CELL')"/>
	<xsl:variable name="limitation" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.datalimited','255')"/>
	  
  <!--  If any instances of helper classes are needed, instantiate 'em -->
	<xsl:variable name="rfihelper" select="rfihelper:new($localeHelper)" />
    <xsl:variable name="responseMaxChars" select="rfihelper:getResponseMaxChars($rfihelper)" />
	<xsl:variable name="questionResponseCellName" select="'responseToQuestion'" />
	<xsl:variable name="responseStatusFormula" select="rfihelper:questionResponseStatusFormula($rfihelper,$questionResponseCellName)" />
	<xsl:variable name="totalNumberOfQuestions" select="count(/ePASSResponse/RFxResponse/RFx/Questionnaire[@QuestionnaireCanRespond=$trueValue]/Question[@QuestionResponseType != $XADDataType.Spacer])" />      
	<xsl:variable name="totalRows" select="count(/ePASSResponse/RFxResponse/RFx/Questionnaire)  + count(/ePASSResponse/RFxResponse/RFx/Questionnaire/Question) + 7" /> 
	<xsl:variable name="allQuestionsStatusFormula" select="rfihelper:allQuestionnairesResponseStatusFormula($rfihelper, 7, $totalRows, $totalNumberOfQuestions)" />
	<xsl:variable name="questionNameHelper" select="rfihelper:getQuestionNameHelper($rfihelper)" saxon:assignable="yes"/>   
	<xsl:key name="responseByQuestionnaireAndQuestion" match="/ePASSResponse/RFxResponse/RFx/Response" use="concat(@ResponseQuestionnaire,@ResponseQuestion)" /> 
<!-- 
	use this for testing RFI alone.
	
  <xsl:template match="/">
    <book doctype="RFxResponse" language="{$language}" workbook="{Options/Option[@OptionKey='WorkbookBase']/@OptionValue}" rowColumnNumbersMode="mixed">
			<<xl:sheet>
				<xsl:attribute name="name"><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions')"/></xsl:attribute>			
				<xsl:attribute name="type"><xsl:value-of select="'INSTRUCTIONS'"/></xsl:attribute>

				<xl:linkToSheet horizontalAlignment="right">
				       <xsl:attribute name="writeContentToCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions'),',12,1')" />            
				       <xsl:attribute name="targetCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.questionresponse'),',6,1')" />
				        <xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.questionresponse')" />                   
				</xl:linkToSheet>
				
				<xsl:if test="count(/ePASSResponse/RFxResponse/RFx/Questionnaire/Question[@QuestionResponseType=$XADDataType.Matrix]) > 0">            
				 <xl:linkToSheet horizontalAlignment="right">
				        <xsl:attribute name="writeContentToCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions'),',14,1')" />	            
				     <xsl:attribute name="targetCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.tableresponse'),',1,1')" />
				        <xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.tableresponse')" />	                   
				 </xl:linkToSheet>
				</xsl:if>            
		</xsl:element>
		
		<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx"/>

      <xsl:apply-templates select="Logs" mode="standalone"/>
    </book>  
  </xsl:template>
 -->	   
	    
	<!-- *******************Process RFx node******************************************************* -->
  <xsl:template match="RFx" mode="RFI">
    <!--  If there are any Matrix type questions, then write them out in the separate matrix question sheet -->
    <xsl:variable name="matrixQuestions" select="Questionnaire/Question[@QuestionResponseType= $XADDataType.Matrix]" />
    <xsl:if test="count($matrixQuestions) > 0">
      <xl:sheet>
        <xsl:attribute name="name"><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.tableresponse')"/></xsl:attribute>
        <xsl:attribute name="type"><xsl:value-of select="'RFI_TABLE_RESPONSE'"/></xsl:attribute>
        <xsl:attribute name="rfxDecimalPlaces"><xsl:value-of select="@RFxDecimalPlaces"/></xsl:attribute>
        
        <xl:row>
		      <xl:linkToSheet>
		      	<xsl:attribute name="targetCellByPosition" select="concat(localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.questionresponse'),',6,1')" />
	            <xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.hyperlink.backtoresponse')" />
	        </xl:linkToSheet>
        </xl:row>
        <xl:skip numberOfRows="1"/>
		    <xsl:for-each select="$matrixQuestions" >
		        <xsl:call-template name="MatrixQuestionResponse">
		            <xsl:with-param name="question" select="."/>
		        </xsl:call-template>
	          <xsl:if test="position() != last()" >
	            <xl:skip numberOfRows="1"/>
	          </xsl:if>
		    </xsl:for-each>
      </xl:sheet>
    </xsl:if>
    
    <xl:sheet>
      <xsl:attribute name="name"><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.sheet.name.questionresponse')"/></xsl:attribute>
      <xsl:attribute name="type"><xsl:value-of select="'RFI_QUESTION_RESPONSE'"/></xsl:attribute>
      <xsl:attribute name="rfxDecimalPlaces"><xsl:value-of select="@RFxDecimalPlaces"/></xsl:attribute>
      <xsl:attribute name="validationLimit"><xsl:value-of select="$validationLimit"/></xsl:attribute>
        <xsl:call-template name="RFxInformation"/>
				<xl:skip numberOfRows="1"/>
		
				<xl:row header="true"  font="questionheader">
         <xl:cell name="questionResponseSectionHead"><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.question.response.section')"/></xl:cell>
         <xsl:if test="$totalNumberOfQuestions > 0 ">
         	<xl:formula><xsl:value-of select="$allQuestionsStatusFormula" /></xl:formula>
         </xsl:if>
         </xl:row>

		    <xl:row header="true" font="questionsubheader">
		      <xl:cell>
		        <xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.questionnaires.questions.ResponseQuestion')"/>
		      </xl:cell>
		      <xl:cell ><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.ResponseValue')"/></xl:cell>
		      <xl:cell ><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.ResponseComments')"/></xl:cell>
		    </xl:row>

	    	<!--  Process each Questionnaire -->
        <xsl:for-each select="Questionnaire">
        
          <!--  Write Questionnaire section header -->
          <xsl:variable name="questionnaireName" select="@QuestionnaireName"/>
          <xsl:variable name="questionnaireCanRespond" select="@QuestionnaireCanRespond"/>
          <xsl:variable name="isFirstQuestionnaire" select="position()"/>
          	
          <xl:row header="true" font="questionnaireheader">
            <xl:cell><xsl:value-of select="@QuestionnaireName"/></xl:cell>
            <xl:cell><xsl:value-of select="''"/></xl:cell>
            <xl:cell><xsl:value-of select="''"/></xl:cell>
          </xl:row>
					
          <!-- Process each question -->
          <xsl:for-each select="Question">
            <xsl:variable name="questionText" select="@QuestionText"/>
			<xsl:variable name="isFirstQuestion" select="position()"/>
    		<!--  FIXME: It might be a good idea to key the response by the QuestionnaireCode and QuestionText -->
            <xsl:variable name="response" select="key('responseByQuestionnaireAndQuestion',concat($questionnaireName,$questionText))[1]" />
            <xl:row>
            	<xsl:variable name="xadType" select="@QuestionResponseType"/>
					<xsl:choose>
						<xsl:when test="$xadType = $XADDataType.Spacer">
							<xl:cell spacer="true">
								<xsl:value-of select="concat(if(@QuestionIsResponseRequired=$trueValue) then '*' else '',@QuestionText)"/>
							</xl:cell>	
						</xsl:when>
						<xsl:otherwise>
							<xl:cell name="questionName" font="questioninfo">
								<xsl:value-of select="concat(if(@QuestionIsResponseRequired=$trueValue) then '*' else '', @QuestionText)"/>				
							</xl:cell>	
						</xsl:otherwise>
					</xsl:choose>
	              <xsl:choose>
	                <xsl:when test="$questionnaireCanRespond = $trueValue ">
	                  <xsl:call-template name="ResponseAndComments">
	                    <xsl:with-param name="xadType" select="$xadType"/>
	                    <xsl:with-param name="question" select="."/>
	                    <xsl:with-param name="response" select="$response"/>
	                    <xsl:with-param name="isFirstQuestion" select="
	                    					if($isFirstQuestionnaire = 1 and $isFirstQuestion = 1)
	                    						then 'true'
	                    					else 'false'
	                    	"/>
	             		</xsl:call-template>
	                </xsl:when>
	                <xsl:otherwise>
	                  <xl:cell> <xsl:value-of select="''"/> </xl:cell>                    
	                  <xl:cell> <xsl:value-of select="''"/> </xl:cell>
	                </xsl:otherwise>
	              </xsl:choose>
            </xl:row>
          </xsl:for-each> <!--  All Questions of a Questionnaire -->
        </xsl:for-each> <!--  All Questionnaires -->
	</xl:sheet>
  </xsl:template>
	
  <!--code to create header section ends here -->
	<!-- *******************************Process Response node as per its data type************************************* -->
  <xsl:template name="ResponseAndComments">
    <xsl:param name="xadType"/>
    <xsl:param name="question"/>
    <xsl:param name="response"/>
    <xsl:param name="isFirstQuestion"/>
    <xsl:param name="RowNo" select="1"/>
    
    <xsl:choose>
      <xsl:when test="$xadType = $XADDataType.SimpleText or $xadType = $XADDataType.String">
        <xsl:call-template name="TextField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="some $XAType in $XADDataType.NumberTypes satisfies $XAType = $xadType">
        <xsl:call-template name="NumberField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$xadType = $XADDataType.Boolean or $xadType = $XADDataType.Boolean_RadioButton
      					or $xadType = $XADDataType.Boolean_CheckBox">
        <xsl:call-template name="BooleanField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$xadType = $XADDataType.Enumeration">
        <xsl:call-template name="EnumerationField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$xadType = $XADDataType.Date">
        <xsl:call-template name="DateField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$xadType = $XADDataType.Spacer">
        <xsl:call-template name="SpacerField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$xadType = $XADDataType.EnumerationMulti">
        <xsl:call-template name="EnumerationMultiField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="$xadType = $XADDataType.Matrix">
        <xsl:call-template name="MatrixField">
          <xsl:with-param name="xadType" select="$xadType"/>
          <xsl:with-param name="question" select="$question"/>
          <xsl:with-param name="response" select="$response"/>
          <xsl:with-param name="isFirstQuestion" select="$isFirstQuestion"/>
          <xsl:with-param name="RowNo" select="$RowNo"/>
        </xsl:call-template>
      </xsl:when>
    </xsl:choose>
  </xsl:template>
	
	<!-- *********************************Process response node of text data type******************************** -->
	<xsl:template name="TextField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>

		<saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />
		<saxon:assign name="defaultvalue" select=" if (empty($question/@QuestionDefaultValue)) then '' else $question/@QuestionDefaultValue " />				
		<saxon:assign name="comment" select="
			if( $xadType = $XADDataType.SimpleText ) then 
				localeHelper:getSimpleTextFieldValidationComment($localeHelper,$question/@QuestionResponseValidation,'255')
			else
				concat($XADDataType.String.ValidationComment,'&#xa;',
					localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.datalimited',$responseMaxChars))
				"/>
    
    	<xsl:variable name="dataType" select="
    		if( $xadType = $XADDataType.SimpleText)
    			then 'SingleText'
    		else 'Text' "/>
		
		<!-- ESP-41503 -->
		<xsl:variable name="textLength">
			<xsl:choose>
				<xsl:when test="$xadType = $XADDataType.SimpleText">
					<xsl:value-of>255</xsl:value-of>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$responseMaxChars"/>
				</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>
    		
    	<xl:cell 
			name="responseToQuestion" 
			header="false" 
			textlength="{$textLength}" 
			editable="true"
			tooltip="{$comment}"
			datatype="{$dataType}">
			<xsl:if test="not($response/@ResponseValue)">
				<xsl:attribute name="defaultvalue" select="$defaultvalue"/>
			</xsl:if>
			<xsl:value-of select="$response/@ResponseValue"/>
		</xl:cell>					

        <!--Single line text questions never have comments so just to make it non-editable-->
    	<xl:cell header="false" editable="false" />
 		<xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
 			<xsl:value-of select="$responseStatusFormula" />
		</xl:formula>
 </xsl:template>	

	<!-- *********************************Process response node of integer data type******************************** -->
	<xsl:template name="NumberField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>
		<xsl:call-template name="GetNumberToolTip" >
		  <xsl:with-param name="question" select="$question" />
		</xsl:call-template>
		<xsl:variable name="dataTypeBasedComment" select="
			if( $xadType = $XADDataType.Integer ) then $XADDataType.Integer.ValidationComment
			else if ( $xadType = $XADDataType.Currency ) then $XADDataType.Currency.ValidationComment
			else $XADDataType.Double.ValidationComment
		" />
		<saxon:assign name="comment" select="if( $comment='' ) then $dataTypeBasedComment else concat($dataTypeBasedComment,'&#xa;', $comment)"/>			
		<xl:cell 
			name="responseToQuestion" 
			datatype="{
				if($xadType = $XADDataType.Integer) then 'Integer' 
				else if ($xadType = $XADDataType.Double) then 'Decimal' 
				else 'Currency'
				}" 
			editable="true" 
			minvalue="{if( empty($question/@QuestionResponseMinValue) ) then '' else $question/@QuestionResponseMinValue}" 
			maxvalue="{if( empty($question/@QuestionResponseMaxValue) ) then '' else $question/@QuestionResponseMaxValue}" 
			minvalueinc="{if ( $question/@ResponseMinValInc = $trueValue or $question/@ResponseMinValInc = 'true'  ) then 'true' else 'false'}" 
			maxvalueinc="{if ( $question/@ResponseMaxValInc = $trueValue or $question/@ResponseMaxValInc = 'true'  ) then 'true' else 'false'}" 
			tooltip="{$comment}" 
			attrDecimalPlaces="{$decimalplaces}">
			<xsl:if test="not($response/@ResponseValue)">
				<xsl:attribute name="defaultvalue" select="$defaultvalue"/>
			</xsl:if>
			<xsl:value-of select="$response/@ResponseValue"/>
		</xl:cell>	
		<xsl:choose>
			<xsl:when test="$allowcomments = $trueValue">
				<xl:cell 
					datatype="Text" 
					editable="true" 
					tooltip="{$limitation}" 
					textlength="255">
					<xsl:value-of select="$response/@ResponseComments"/>				
				</xl:cell>
			</xsl:when>
			<xsl:otherwise>
				<xl:cell header="false" editable="false" />
			</xsl:otherwise>
		</xsl:choose>
    <xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
       <xsl:value-of select="$responseStatusFormula" />
    </xl:formula>
		<saxon:assign name="comment" select="''"/>				
	</xsl:template>

	<xsl:template name="BooleanField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>
		
		<saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />		
		<xsl:variable name="selectionlist" select="concat($pleaseSelectValue,'|',$question/@QuestionResponseSelectionValues)"/>
		<saxon:assign name="defaultvalue" select=" if (empty($question/@QuestionDefaultValue)) then $pleaseSelectValue else $question/@QuestionDefaultValue " />				
		<saxon:assign name="comment" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.dropdown')"/>		

		<xl:cell name="responseToQuestion" selectionlist="{$selectionlist}" editable="true">
			<xsl:attribute name="tooltip"><xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.boolean'), '&#xa;', $comment)"/></xsl:attribute>
			<xsl:if test="not($response/@ResponseValue)">
				<xsl:attribute name="defaultvalue" select="if(empty($defaultvalue) or $defaultvalue = '') then $pleaseSelectValue else $defaultvalue" />					
			</xsl:if>
			<xsl:value-of select="$response/@ResponseValue" />
		</xl:cell>
		<xsl:choose>
			<xsl:when test="$allowcomments = $trueValue">
				<xl:cell>
					<xsl:attribute name="editable">true</xsl:attribute>
					<xsl:attribute name="tooltip"><xsl:value-of select="$limitation"/></xsl:attribute>
					<xsl:attribute name="textlength"><xsl:value-of select="'255'"/></xsl:attribute>
	      		    <xsl:attribute name="editable">true</xsl:attribute>
	      		    <xsl:attribute name="datatype">Text</xsl:attribute>
					<xsl:value-of select="$response/@ResponseComments"/>		
				</xl:cell>
			</xsl:when>
			<xsl:otherwise>
              <xl:cell header="false" editable="false" />
			</xsl:otherwise>
		</xsl:choose>
		<xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
	      <xsl:value-of select="$responseStatusFormula" />
	    </xl:formula>
	</xsl:template>
	
	<!-- *********************************Process response node of Enumeration data type******************************** -->
	<xsl:template name="EnumerationField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>
		
		<saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />		
		<xsl:variable name="selectionlist" select="concat($pleaseSelectValue,'|',$question/@QuestionResponseSelectionValues)"/>
		<saxon:assign name="defaultvalue" select=" if (empty($question/@QuestionDefaultValue)) then $pleaseSelectValue else $question/@QuestionDefaultValue " />		
		<saxon:assign name="comment" select="''"/>
		<saxon:assign name="comment" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.dropdown')"/>
		<xl:cell name="responseToQuestion" selectionlist="{$selectionlist}" editable="true">
			<xsl:attribute name="tooltip"><xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.enumaration'), '&#xa;', $comment)"/></xsl:attribute>
			<xsl:if test="not($response/@ResponseValue)">
				<xsl:attribute name="defaultvalue">
                  <xsl:value-of select="if (not(empty($defaultvalue)) or $defaultvalue != '') then $defaultvalue else $pleaseSelectValue" />        
				</xsl:attribute>
			</xsl:if>
			<xsl:value-of select="$response/@ResponseValue"/>
		</xl:cell>
		<xsl:choose>
			<xsl:when test="$allowcomments = $trueValue">
				<xl:cell>
					<xsl:attribute name="editable">true</xsl:attribute>
					<xsl:attribute name="tooltip"><xsl:value-of select="$limitation"/></xsl:attribute>
					<xsl:attribute name="textlength"><xsl:value-of select="'255'"/></xsl:attribute>
	      		    <xsl:attribute name="editable">true</xsl:attribute>
	      		    <xsl:attribute name="datatype">Text</xsl:attribute>
					<xsl:value-of select="$response/@ResponseComments"/>
				</xl:cell>
			</xsl:when>
			<xsl:otherwise>
              <xl:cell header="false" editable="false" />
			</xsl:otherwise>
		</xsl:choose>
		<xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
			<xsl:value-of select="$responseStatusFormula" />
		</xl:formula>
	</xsl:template>
	
	<!-- *********************************Process response node of multi-select data type******************************** -->
	<xsl:template name="EnumerationMultiField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>
		
		<saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />		
		<xsl:variable name="selectionlist" select="$question/@QuestionResponseSelectionValues"/>
		<saxon:assign name="defaultvalue" select=" if (empty($question/@QuestionDefaultValue)) then '' else $question/@QuestionDefaultValue " />				
		<saxon:assign name="comment" select="''"/>
		<saxon:assign name="comment" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.multiselect')"/>
		<xl:cell name="responseToQuestion" tooltip="{$selectionlist}" editable="true" datatype="SelectionMulti">
			<xsl:if test="not($response/@ResponseValue)">
				<xsl:attribute name="defaultvalue"><xsl:value-of select="$defaultvalue"/></xsl:attribute>
			</xsl:if>
			<xsl:value-of select="$response/@ResponseValue"/>
		</xl:cell>
		<xsl:choose>
			<xsl:when test="$allowcomments = $trueValue">
				<xl:cell>
					<xsl:attribute name="editable">true</xsl:attribute>
					<xsl:attribute name="tooltip"><xsl:value-of select="$limitation"/></xsl:attribute>
					<xsl:attribute name="textlength"><xsl:value-of select="'255'"/></xsl:attribute>
	      		    <xsl:attribute name="editable">true</xsl:attribute>
	      		    <xsl:attribute name="datatype">Text</xsl:attribute>
					<xsl:value-of select="$response/@ResponseComments"/>
				</xl:cell>
			</xsl:when>
			<xsl:otherwise>
              <xl:cell header="false" editable="false" />
			</xsl:otherwise>
		</xsl:choose>
		<xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
			<xsl:value-of select="$responseStatusFormula" />
		</xl:formula>
  </xsl:template>
	


<!-- *********************************Process response node of MATRIX data type******************************** -->
	<xsl:template name="MatrixField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>
        <xsl:param name="RowNo" />
				
		<saxon:assign name="comment" select="''"/>
		<saxon:assign name="comment" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.multiselect')"/>
        <xl:linkToSheet>
            <xsl:attribute name="targetCellByName" select="concat(questionNameHelper:getNiceNameFor($questionNameHelper,$question/../@QuestionnaireName,$question/@QuestionText),'_topLeft')" />
            <xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.hyperlink.clickhere')"/>
        </xl:linkToSheet>

		<saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />		
		<xl:cell>
			<xsl:attribute name="header">false</xsl:attribute>
			<xsl:choose>
				<xsl:when test="($allowcomments=$trueValue)">
					<xsl:attribute name="tooltip"><xsl:value-of select="$limitation"/></xsl:attribute>
					<xsl:attribute name="textlength"><xsl:value-of select="'255'"/></xsl:attribute>
					<xsl:attribute name="editable">true</xsl:attribute>
					<xsl:attribute name="datatype">Text</xsl:attribute>
					<xsl:value-of select="$response/@ResponseComments"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:attribute name="editable"><xsl:value-of select="'false'"/></xsl:attribute>
				</xsl:otherwise>
			</xsl:choose>
		</xl:cell>
		<xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
	       <xsl:value-of select="rfihelper:tableQuestionResponseStatusFormula($rfihelper,$question/../@QuestionnaireName,$question/@QuestionText)" />         
		</xl:formula>
	</xsl:template>



	<!-- *********************************Process response node of date data type******************************** -->
	<xsl:template name="DateField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>
		
		<saxon:assign name="allowcomments" select="if (empty($question/@QuestionAllowComments)) then false else $question/@QuestionAllowComments" />
		<saxon:assign name="defaultvalue" select=" if (empty($question/@QuestionDefaultValue)) then '' else $question/@QuestionDefaultValue " />				
		<saxon:assign name="comment" select="''"/>
		<saxon:assign name="comment" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.date')"/>		
		<xl:cell name="responseToQuestion" datatype="Date" editable="true">
			<xsl:attribute name="tooltip"><xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.date'), '&#xa;', $comment)"/></xsl:attribute>
			<xsl:if test="not($response/@ResponseValue)">
				<xsl:attribute name="defaultvalue"><xsl:value-of select="$defaultvalue"/></xsl:attribute>
			</xsl:if>	
			<xsl:value-of select="$response/@ResponseValue"/>
		</xl:cell>
		<xsl:choose>
			<xsl:when test="$allowcomments = $trueValue">
				<xl:cell> 
					<xsl:attribute name="editable">true</xsl:attribute>
					<xsl:attribute name="tooltip"><xsl:value-of select="$limitation"/></xsl:attribute>
					<xsl:attribute name="textlength"><xsl:value-of select="'255'"/></xsl:attribute>
	      		    <xsl:attribute name="editable">true</xsl:attribute>
	      		    <xsl:attribute name="datatype">Text</xsl:attribute>
					<xsl:value-of select="$response/@ResponseComments"/>
				</xl:cell>
			</xsl:when>
			<xsl:otherwise> 
              <xl:cell header="false" editable="false" />
			</xsl:otherwise>
		</xsl:choose>
		<xl:formula dynamicContent="yes" name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}">
            <xsl:value-of select="$responseStatusFormula" />
        </xl:formula>
	</xsl:template>
	
	
	<xsl:variable name="minInclValue" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.intege.min.inclusive', $minvalue)"/>
	<xsl:variable name="minExclValue" select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.integer.min.exclusive', $minvalue)"/>
	
	<!-- *********************************Process response node of spacer-row data type******************************** -->
	<xsl:template name="SpacerField">
		<xsl:param name="xadType"/>
		<xsl:param name="question"/>
		<xsl:param name="response"/>
		<xsl:param name="isFirstQuestion"/>

		<xl:cell name="responseToQuestion" header="true" font="questionsubheader" editable="false">
			<xsl:attribute name="tooltip"><xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.spacerrow')"/></xsl:attribute>
		</xl:cell>
 		<xl:cell header="true" font="questionsubheader" editable="false" />
		<xl:cell name="{rfi:questionResponseStatusCellName($isFirstQuestion,position(),last())}" writeCellContent="false" />
	</xsl:template>

<!-- *******************************Process Table Response node as per its data type************************************* -->
	<xsl:template name="TableResponse">
		<xsl:param name="xadType"/>
		<xsl:param name="response"/>
		<xsl:param name="selectionlist"/>
		<xsl:param name="pleaseSelectValue" />
		<xsl:param name="isSubTypeRows"/>
		<xsl:if test="some $XAType in $XADDataType.NumberTypes satisfies $XAType = $xadType ">
			<xsl:attribute name="minvalue"><xsl:value-of select="$minvalue"/></xsl:attribute>
			<xsl:attribute name="maxvalue"><xsl:value-of select="$maxvalue"/></xsl:attribute>
			<xsl:attribute name="minvalueinc"><xsl:value-of select="$minvalueinc"/></xsl:attribute>
			<xsl:attribute name="maxvalueinc"><xsl:value-of select="$maxvalueinc"/></xsl:attribute>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="$xadType = $XADDataType.SimpleText">				
				<xsl:attribute name="textlength" select="'80'"/>
				<xsl:value-of select="$response"/>
			</xsl:when>		
			<xsl:when test="$xadType = $XADDataType.Boolean or $xadType = $XADDataType.Enumeration">
				<xsl:attribute name="defaultvalue" select="if(empty($response) or $response = '') then $pleaseSelectValue else $response" />
				<xsl:attribute name="selectionlist" select="$selectionlist"/>
				<xsl:attribute name="isSubTypeRows" select="$isSubTypeRows"/>
				<xsl:value-of select="$response"/>
			</xsl:when>			
			<xsl:when test="some $XAType in $XADDataType.NumberTypes satisfies $XAType = $xadType or $xadType = $XADDataType.Date ">
				<xsl:value-of select="$response"/>
			</xsl:when>
		</xsl:choose>		
	</xsl:template>


	<!-- ***********************process matrix question information**************************** -->
    <xsl:variable name="MatrixQuestionResponse.numEditableResponses" select="0" saxon:assignable="yes" />	
	<xsl:template name="MatrixQuestionResponse">
		<xsl:param name="question"/>
		
        <xsl:variable name="isSubTypeRows" select="@QuestionResponseSubType = localeHelper:getValue( $localeHelper, 'integration.TableSubDataType.MATRIX_TYPE_COLUMNS')" />            
        <xsl:variable name="matrixResponse" select="/ePASSResponse/RFxResponse/RFx/Response[@ResponseQuestion = $question/@QuestionText]" />
        <xsl:variable name="records" select="$question/ExtendedAttributeDefinition[@XADSubDataType = $matrixRecord]" />     
        <xsl:variable name="fields" select="$question/ExtendedAttributeDefinition[@XADSubDataType = $matrixField]" />        

		<xl:row header="true"  font="tablequestionnaireheader">
			<xl:cell><xsl:value-of select="$question/../@QuestionnaireName"/></xl:cell>			
		</xl:row>
		<xl:row header="true"  font="tablequestionheader" >
		    <xl:cell><xsl:value-of select="if ($question/@QuestionIsResponseRequired = $trueValue) then concat('*',$question/@QuestionText) else $question/@QuestionText" /></xl:cell>
		</xl:row>

        <saxon:assign name="maxvalueinc" select="
            if (empty($question/@ResponseMaxValInc)) then '' 
            else if ( $question/@ResponseMaxValInc = $trueValue or $question/@ResponseMaxValInc = 'true'  ) then 'true'
            else 'false'" />

        <saxon:assign name="minvalueinc" select="
            if (empty($question/@ResponseMinValInc)) then '' 
            else if ( $question/@ResponseMinValInc = $trueValue or $question/@ResponseMinValInc = 'true'  ) then 'true'
            else 'false'" />
		
		<xl:row>
            <xl:cell font="questioninfo"><xsl:value-of select="if ($isSubTypeRows) then localeHelper:getValue( $localeHelper,  'integration.MatrixRecordLabel') else localeHelper:getValue( $localeHelper,  'integration.MatrixFieldLabel')" /></xl:cell>
            <xsl:choose>
                <xsl:when test="$isSubTypeRows">                       
                    <xsl:for-each select="$fields">
                        <xl:cell font="questioninfo">                       
                            <xsl:attribute name="font" select="'questioninfo'"/>                            
                            <xsl:call-template name="MatrixQuestionHeaderComment">
                                <xsl:with-param name="XANode" select="."/>
                            </xsl:call-template>
                            <xsl:value-of select="@XADDescription"/>
                        </xl:cell>              
                    </xsl:for-each>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="$records">
                        <xl:cell font="questioninfo"> <xsl:value-of select="@XADName"/> </xl:cell>              
                    </xsl:for-each>
                </xsl:otherwise>
            </xsl:choose>
		</xl:row>
        
        <saxon:assign name="MatrixQuestionResponse.numEditableResponses" select="0" />
		<xsl:choose>
			<xsl:when test="$isSubTypeRows">
				<xsl:for-each select="$records">
					<xsl:variable name="reccode" select="localeHelper:nameToCode(@XADName,false())" />
					<xsl:variable name="recordCode" select="@XADCode" />
					<xsl:variable name="recordname" select="@XADName" />
					<xsl:variable name="rowPosition" select="position()" />
					<xsl:variable name="lastRow" select="last()" />	
					<xl:row>	
						<xl:cell font="questioninfo"> <xsl:value-of select="@XADDescription"/> </xl:cell>	
						<xsl:for-each select="$fields">
			         	   	<xsl:variable name="columnPosition" select="position()" />
			            	<xsl:variable name="lastColumn" select="last()" /> 
							<xsl:variable name="fldcode" select="localeHelper:nameToCode(@XADName,false())"/>
							<xsl:variable name="fieldCode" select="@XADCode" />
							<xsl:variable name="fldname" select="@XADName"/>
							<xsl:variable name="defaultValue" select="@XADDefaultValue"/>
							<xsl:variable name="cName" select="concat($fldcode, $reccode)"/>
							<xsl:variable name="disabledCell" select="$question/ExtendedAttributeDefinition[@XADSubDataType=$matrixChildCell][@XADName=$cName]/@XADName"/>
							<xsl:variable name="cellName" select="concat($fieldCode, $recordCode)"/>
							<xsl:variable name="disabledCellImported" select="$question/ExtendedAttributeDefinition[@XADSubDataType=$matrixChildCell][@XADName=$cellName]/@XADName"/>
							<xsl:variable name="selectionlist" select="if(@XADDataType = $XADDataType.Boolean) then concat($pleaseSelectValue, '|', $yesValue ,'|', $noValue) else  concat($pleaseSelectValue,'|', @XADSelectionList)" />

							<saxon:assign name="minvalueinc" select="if (empty(@XADMinInc)) then '' else if (@XADMinInc = $trueValue or @XADMinInc = 'true') then 'true' else 'false'" />
							<saxon:assign name="maxvalueinc" select="if (empty(@XADMaxInc)) then '' else if (@XADMaxInc = $trueValue or @XADMaxInc = 'true') then 'true' else 'false'" />
							<saxon:assign name="minvalue" select="if (empty(@XADMinimumValue) or @XADMinimumValue = '') then '' else @XADMinimumValue " />
							<saxon:assign name="maxvalue" select="if (empty(@XADMaximumValue) or @XADMaximumValue = '' ) then '' else @XADMaximumValue " />
									
							<xsl:variable name="response" select="$matrixResponse/TableValue/Record[@name=$recordname]/Field[@name=$fldname]/@value"/>
              				<xsl:variable name="niceName" select="questionNameHelper:getNiceNameFor($questionNameHelper,$question/../@QuestionnaireName,$question/@QuestionText)" />
              				<xsl:variable name="comma" select="','" />
              				<xsl:variable name="responseCellName" select="rfi:tableResponseCellName($niceName,$rowPosition,$lastRow,$columnPosition,$lastColumn)" />                                                                
                            
							<!-- PR#44761 : check for cell visibility-->
                    		<xsl:variable name="cellVisibility" select="$question/ExtendedAttributeDefinition[@XADName = $cName]/@XADSubDataType"/> 
						    <xl:cell font="questioninfo" header="true">
                            	<xsl:if test="not(empty($responseCellName))">
                                	<xsl:attribute name="name" select="$responseCellName" />
                                </xsl:if>   
						      							
								<xsl:choose><!-- PR#44761 : check for cell visibility-->
									<xsl:when test="not(($cName = $disabledCell) or ($cellName = $disabledCellImported)) and (empty($cellVisibility) or string-length($cellVisibility) &lt;= 0 or 
                   									not($cellVisibility = 'cell'))">
										<xsl:attribute name="editable"><xsl:value-of select="'true'"/></xsl:attribute>																				
									</xsl:when>
									<xsl:otherwise>
										<xsl:attribute name="editable"><xsl:value-of select="'false'"/></xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>	
								<xsl:attribute name="datatype">
									<xsl:call-template name="DataTypeReverseLocal">
										<xsl:with-param name="dataType" select="@XADDataType"/>
									</xsl:call-template>
								</xsl:attribute>                     
              					<xsl:call-template name="TableResponse">
									<xsl:with-param name="xadType" select="@XADDataType"/>
									<xsl:with-param name="response" select="if ( $response != '') then $response else $defaultValue" />											
                  					<xsl:with-param name="selectionlist" select="$selectionlist"/>
                  					<xsl:with-param name="pleaseSelectValue" select="$pleaseSelectValue" />
                  					<xsl:with-param name="isSubTypeRows" select="$isSubTypeRows"/>
              					</xsl:call-template>                  				
                  				<saxon:assign name="MatrixQuestionResponse.numEditableResponses" select="$MatrixQuestionResponse.numEditableResponses + 1" />
							</xl:cell>						
						</xsl:for-each>
					</xl:row>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>
				<xsl:for-each select="$fields">
          			<xsl:variable name="rowPosition" select="position()" />
          			<xsl:variable name="lastRow" select="last()" /> 
					<xsl:variable name="fldcode" select="localeHelper:nameToCode(@XADName,false())" />
					<xsl:variable name="fieldCode" select="@XADCode" />
					<xsl:variable name="fldname" select="@XADName" />	
					<xsl:variable name="datatype" select="@XADDataType" />
          			<xsl:variable name="selectionlist" select="if(@XADDataType = $XADDataType.Boolean) then concat($pleaseSelectValue, '|', $yesValue ,'|', $noValue) else  concat($pleaseSelectValue,'|', @XADSelectionList)" />
					<xl:row>	
						<xl:cell font="questioninfo">
							<xsl:call-template name="MatrixQuestionHeaderComment">
                                <xsl:with-param name="XANode" select="."/>
                            </xsl:call-template>								
							<xsl:value-of select="@XADDescription"/>
						</xl:cell>										
	                    <saxon:assign name="minvalueinc" select="if (empty(@XADMinInc)) then '' else if (@XADMinInc = $trueValue or @XADMinInc = 'true') then 'true' else 'false'" />
	                    <saxon:assign name="maxvalueinc" select="if (empty(@XADMaxInc)) then '' else if (@XADMaxInc = $trueValue or @XADMaxInc = 'true') then 'true' else 'false'" />
	                    <saxon:assign name="minvalue" select="if (empty(@XADMinimumValue) or @XADMinimumValue = '') then '' else @XADMinimumValue " />
	                    <saxon:assign name="maxvalue" select="if (empty(@XADMaximumValue) or @XADMaximumValue = '' ) then '' else @XADMaximumValue " />
						<xsl:variable name="defaultValue" select="@XADDefaultValue"/>
						
						<xsl:for-each select="$records">
              				<xsl:variable name="columnPosition" select="position()" />
              				<xsl:variable name="lastColumn" select="last()" /> 
							<xsl:variable name="reccode" select="localeHelper:nameToCode(@XADName,false())"/>
							<xsl:variable name="recordname" select="@XADName"/>
							<xsl:variable name="response" select="$matrixResponse/TableValue/Record[@name=$recordname]/Field[@name=$fldname]/@value"/>
							<xsl:variable name="cName" select="concat($fldcode, $reccode)"/>
							<xsl:variable name="disabledCell" select="$question/ExtendedAttributeDefinition[@XADSubDataType=$matrixChildCell][@XADName=$cName]/@XADName"/>
							<xsl:variable name="cellName" select="concat($fieldCode, @XADCode)"/>
							<xsl:variable name="disabledCellImported" select="$question/ExtendedAttributeDefinition[@XADSubDataType=$matrixChildCell][@XADName=$cellName]/@XADName"/>
							
							<!-- PR#44761 : check for cell visibility-->
           					<xsl:variable name="cellVisibility" select="$question/ExtendedAttributeDefinition[@XADName = $cName]/@XADSubDataType"/>
              				<xsl:variable name="niceName" select="questionNameHelper:getNiceNameFor($questionNameHelper,$question/../@QuestionnaireName,$question/@QuestionText)" />
              				<xsl:variable name="comma" select="','" />
              				<xsl:variable name="responseCellName" select="rfi:tableResponseCellName($niceName,$rowPosition,$lastRow,$columnPosition,$lastColumn)" />                                                                
                    					
							<xl:cell font="questioninfo" header="true">
							    <xsl:if test="not(empty($responseCellName))">
							     <xsl:attribute name="name" select="$responseCellName" />
							    </xsl:if>	
								<xsl:choose><!-- PR#44761 : check for cell visibility-->
									<xsl:when test="not(($cName = $disabledCell) or ($cellName = $disabledCellImported)) and (empty($cellVisibility) or string-length($cellVisibility) &lt;= 0 or 
                   									not($cellVisibility = 'cell'))">
										<xsl:attribute name="editable"><xsl:value-of select="'true'"/></xsl:attribute>
									</xsl:when>
									<xsl:otherwise>
											<xsl:attribute name="editable"><xsl:value-of select="'false'"/></xsl:attribute>
									</xsl:otherwise>
								</xsl:choose>	
								<xsl:attribute name="datatype">
									<xsl:call-template name="DataTypeReverseLocal">
										<xsl:with-param name="dataType" select="$datatype"/>
									</xsl:call-template>
								</xsl:attribute>								
              					<xsl:call-template name="TableResponse">
									<xsl:with-param name="xadType" select="$datatype"/>
									<xsl:with-param name="response" select="if ( $response != '') then $response else $defaultValue" />											
                  					<xsl:with-param name="selectionlist" select="$selectionlist"/>
                  					<xsl:with-param name="pleaseSelectValue" select="$pleaseSelectValue"/>
                  					<xsl:with-param name="isSubTypeRows" select="$isSubTypeRows"/>
              					</xsl:call-template>                  				
                  				<saxon:assign name="MatrixQuestionResponse.numEditableResponses" select="$MatrixQuestionResponse.numEditableResponses + 1" />
							</xl:cell>		
						</xsl:for-each>
					</xl:row>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		
		<!--  one way or the other the number of editable responses would have been computed -->
        <saxon:assign name="questionNameHelper" select="questionNameHelper:setNumberOfResponses($questionNameHelper,$question/../@QuestionnaireName,$question/@QuestionText,$MatrixQuestionResponse.numEditableResponses)" />    		
	</xsl:template>
	
	<xsl:template name="MatrixQuestionHeaderComment">
		<xsl:param name="XANode" />
		
		<xsl:variable name="varXAType" select="$XANode/@XADDataType" />		
		<xsl:variable name="varXADescription" select="concat(replace($XANode/@XADDescription,'&amp;#xa;', '&#xA;'), '&#xa;')" /> <!--get description of bid IA-->
		<xsl:variable name="varXARequired"><!--get required status of bid IA-->
			<xsl:if test="$XANode/@XADIsRequired = $trueValue">
				<xsl:value-of select="concat( '(', localeHelper:getValue( $localeHelper,  'EPASSAttributeDefStruct.required') ,')')" />
			</xsl:if>
		</xsl:variable>
		
		<xsl:choose>
			<xsl:when test="$varXAType =  $XADDataType.SimpleText">
				<xsl:variable name="varXAValidation" select="$XANode/@XADValidation" /> <!--get validation set for bid IA such as ZIP,DUNS, E-mail etc-->
				<xsl:variable name="varValidationText">
					<xsl:choose>
						<xsl:when test="$varXAValidation = $XADValidationType.DUNS">
							<xsl:value-of select="concat( $XADValidationType.DUNS.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.EMAIL">
							<xsl:value-of select="concat( $XADValidationType.EMAIL.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.URL">
							<xsl:value-of select="concat( $XADValidationType.URL.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.US_PHONE">
							<xsl:value-of select="concat( $XADValidationType.US_PHONE.ValidationComment, '&#xa;') " />
						</xsl:when>
						<xsl:when test="$varXAValidation = $XADValidationType.ZIPCODE">
							<xsl:value-of select="concat( $XADValidationType.ZIPCODE.ValidationComment, '&#xa;')" />
						</xsl:when>
					</xsl:choose>
				</xsl:variable>
				<xsl:attribute name="tooltip">
					<xsl:variable name="commentVar">
						<xsl:value-of select="localeHelper:getToolTip($localeHelper, 'excelmap.bids.rfi.response.datalimited','80')" />
					</xsl:variable>
					<xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.textsingle'), '&#xa;', $varValidationText, $commentVar)" />
				</xsl:attribute>
			</xsl:when>
			
			<xsl:when test="$varXAType = $XADDataType.Date">
				<xsl:attribute name="tooltip">
                    <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.date'), '&#xa;',
                    									localeHelper:getValue( $localeHelper, 'excelmap.bids.rfi.response.datatype.date'))" />
                </xsl:attribute>
			</xsl:when>			
			<xsl:when test="$varXAType = $XADDataType.Enumeration">
				<xsl:variable name="varXASelectionList" select="$XANode/@XADSelectionList" /> <!--get selection list of bid IA-->
				<xsl:attribute name="tooltip">
                   <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.singleselect'), '&#xa;', $varXASelectionList)" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.EnumerationMulti"><!--for multi select show selection list-->
				<xsl:variable name="varXASelectionList" select="$XANode/@XADSelectionList" /> <!--get selection list of bid IA-->
				<xsl:attribute name="tooltip">
                   <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.multiselect'), '&#xa;', $varXASelectionList)" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.Calculated"> <!--for formula type show formula in comments-->
				<xsl:variable name="varXAFormulaSubType" select="$XANode/@XADSubDataType" /> <!--get formula result type-->
				<xsl:variable name="varXAFormula" select="$XANode/@Formula" /> <!--get formula-->
				<xsl:attribute name="tooltip">
                    <xsl:choose>
                        <xsl:when test="$XANode/@XADFormulaShowSupp = $trueValue">
                            <xsl:value-of select="concat($varXAType,' : ',$varXAFormulaSubType, '  ' , $varXARequired, '&#xa;', $varXADescription, $XADDataType.Calculated, ' : ', $varXAFormula)" />
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:value-of select="concat($varXAType,' : ',$varXAFormulaSubType, '  ' , $varXARequired, '&#xa;', $varXADescription)" />
                        </xsl:otherwise>
                    </xsl:choose>
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="some $x in $XADDataType.NumberTypes satisfies $x = $varXAType">
				<xsl:variable name="varXAMinMessage">
					<xsl:variable name="varXAMinValue" select="$XANode/@XADMinimumValue" />
					<xsl:if test="$varXAMinValue != ''">
						<xsl:if test="$XANode/@XADMinInc = $trueValue">
							<xsl:value-of select="concat('X &gt;= ',$varXAMinValue )" />
						</xsl:if>
						<xsl:if test="$XANode/@XADMinInc != $trueValue">
							<xsl:value-of select="concat('X &gt; ',$varXAMinValue )" />
						</xsl:if>
					</xsl:if>
				</xsl:variable>
				<xsl:variable name="varXAMaxMessage">
					<xsl:variable name="varXAMaxValue" select="$XANode/@XADMaximumValue" />
					<xsl:if test="$varXAMaxValue != ''">
						<xsl:if test="$XANode/@XADMaxInc = $trueValue">
							<xsl:value-of select="concat('X &lt;= ',$varXAMaxValue )" />
						</xsl:if>
						<xsl:if test="$XANode/@XADMaxInc != $trueValue">
							<xsl:value-of select="concat('X &lt; ',$varXAMaxValue )" />
						</xsl:if>
					</xsl:if>
				</xsl:variable>
				<xsl:attribute name="tooltip">
                    <xsl:value-of select="concat($varXAType, '&#xa;', $XADDataType.Double.ValidationComment, '&#xa;', $varXAMinMessage, '  ', $varXAMaxMessage)" />
                </xsl:attribute>
			</xsl:when>
			<xsl:when test="$varXAType = $XADDataType.Boolean">
				<xsl:attribute name="tooltip">
                    <xsl:value-of select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.boolean'), '&#xa;',
                    									localeHelper:getValue( $localeHelper, 'excelmap.bids.rfi.response.datatype.dropdown'))" />
                </xsl:attribute>
			</xsl:when>
			<xsl:otherwise>
				<xsl:attribute name="tooltip">
                   <xsl:value-of select="concat($varXAType, $varXARequired, '&#xa;', $varXADescription)" />
                </xsl:attribute>
			</xsl:otherwise>
		</xsl:choose>
		
	</xsl:template>
	
</xsl:stylesheet>
