<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
	<!--
		This RFQ bidding template has the following rules Simple bids -> import & export both is have to be supported Bundled bids -> import & export both is coded Volume discount bids -> import is
		supported but export is not supported
	-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="2.0" 
	xmlns:saxon="http://saxon.sf.net/" 
	xmlns:localeHelper = "java:com.emptoris.framework.importExport.LocaleHelper"
	xmlns:xsltContext="java:com.emptoris.framework.importExport.service.clientInterface.EPASSXMLBasedXSLTContext"
	xmlns:java="java:com.avinamart.Utility.EPASSIFHelper"
	xmlns:ss="http://www.emptoris.com"
	xmlns:xl="http://www.emptoris.com/if/spreadsheet/saxon/com.emptoris.framework.importExport.service.internal.translate.SpreadSheetXSLTExtensionClassFactory"
	exclude-result-prefixes="saxon localeHelper xsltContext xl ss" extension-element-prefixes="saxon">
	
<!--
	Include these when testing ONLY this template in isolation.
	 	
	<xsl:import href="ePASS2gXML_error_standalone.xsl" />
	<xsl:import href="ePASS2gXML/Common.xsl" />
	<xsl:import href="ePASS2gXML/RFxCommonTemplates.xsl" />
	<xsl:import href="ePASS2gXML/BidCommonTemplates.xsl" />
 -->	
	
	<xsl:variable name="rfq.SubstitutionSet" select="localeHelper:getValue( $localeHelper,  'integration.ItemType.Substitution')" />

	<xsl:variable name="rfq.rfx" select="/ePASSResponse/RFxResponse/RFx" />

    <!--it store the value of RFxUseBundleBid attribute of RFx element. If it contain true then display "Bundled Bids" section-->
	<xsl:variable name="rfq.bundleBidEnabled" select="if( $rfq.rfx/GeneralRFxBiddingRules/@RFxUseBundleBid = $trueValue ) then true() else false()" />

    <!--it store the value of RFxVolumeDiscount attribute of RFx element. If it contain true then display "Volume Discount Bids" section-->
	<xsl:variable name="rfq.volumeBidEnabled" select="if( $rfq.rfx/RFQBiddingRules/@RFxUseVolumeBid = $trueValue ) then true() else false()" />

	<!--it is used to store col. no. for "Volume Discount Bids" section as it depends on RFxUseBundleBid attribute of RFx element-->
	

	<xsl:variable name="bidSellerProductCode" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.BidSellerProductCode')"/>
	<xsl:variable name="XADDomainScope.BidItem" select="localeHelper:getValue( $localeHelper,  'integration.AttributeDefScope.BidStruct.bid_item')" />

	<xsl:variable name="dataLimited" select="localeHelper:getToolTip( $localeHelper,  'excelmap.bids.rfi.response.datalimited','80','')" />
	<xsl:variable name="decimal" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.decimal')" />
	<xsl:variable name="dropdown" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.dropdown')" />
	<xsl:variable name="date" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfi.response.datatype.date')" />

	<xsl:variable name="update" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.update')" />
	<xsl:variable name="new" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.new')" />
	
	<xsl:variable name="ItemXADMap" select="localeHelper:createMap('ItemXADMap')" />
	<xsl:variable name="bidNode" saxon:assignable="yes" />

	<xsl:variable name="bidIACount">
		<xsl:if test="$isBidTemplate">
			<xsl:value-of select="count($bidXAsVisible) + 2" /><!-- Added 2 for action and currency code columns which are not bid IAs -->
		</xsl:if>
	</xsl:variable>
	<xsl:variable name="adjustedIACount">
		<xsl:if test="$isBidTemplate">
			<xsl:choose>
				<xsl:when test="$rfq.bundleBidEnabled and $rfq.volumeBidEnabled">
					<xsl:value-of select="$bidIACount + 6" />
				</xsl:when>
				<xsl:when test="$rfq.bundleBidEnabled or $rfq.volumeBidEnabled">
					<xsl:value-of select="$bidIACount + 3" />
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$bidIACount" />
				</xsl:otherwise>
			</xsl:choose>
		</xsl:if>
	</xsl:variable>
	<xsl:variable name="validationLimitBids" select="if($isBidTemplate) then ( 
		count( $rfx/Bid[@BidType != $bid.Type.Bundle and @Status=$bid.Status.Valid]) + count($rfx/Bid/Bid[@Status=$bid.Status.Valid]) ) * 
		$adjustedIACount else 0" />
	<xsl:variable name="validationLimitItems" select="if($isBidTemplate) then 
		( count($rfx/Requisition/LineItem[@LineItemType != $rfq.SubstitutionSet ]) +  count($rfx/Requisition/LineItem/LineItem ) ) * $adjustedIACount else 0" />
	<xsl:variable name="allowcomments" select="false()" saxon:assignable="yes" />
	<xsl:variable name="defaultvalue" select="''" saxon:assignable="yes" />
	<xsl:variable name="decimalplaces" select="2" saxon:assignable="yes" />
	<xsl:variable name="number" select="0" saxon:assignable="yes" />
	
	<xsl:key match="/ePASSResponse/RFxResponse/RFx/Bid[@BidType=$bid.Type.Simple and @Status=$bid.Status.Valid]" name="validSimpleBids" use="@BidLineItemCode" />
	<xsl:key 
		match="/ePASSResponse/RFxResponse/RFx/Requisition/LineItem|/ePASSResponse/RFxResponse/RFx/Requisition/LineItem/LineItem"
		name="lineItemByCode" use="@LineItemCode" /> 
	<xsl:key match="/ePASSResponse/RFxResponse/RFx/Bid/Bid[@BidType=$bid.Type.Simple and @Status=$bid.Status.Valid]" name="validBidsInBundle" use="../@BundleName" />
	
	<!-- ************************************************************** -->
	<!-- RFx section specific for converting from ePASS RFxResponse XML -->
	<!-- ************************************************************** -->
	<xsl:variable name="rfqSheetName" select="localeHelper:getValue( $localeHelper, 'excelmap.bids.rfq.sheet.name.bid')" /> 
	<xsl:variable name="rfpSheetName" select="localeHelper:getValue( $localeHelper, 'excelmap.bids.rfp.sheet.name')" />
	
	<!--
		Variables used to debug. 

	<xsl:variable name="callCount.RFx.RFQ" select="0" saxon:assignable="yes"/> 
	<xsl:variable name="callCount.LineItem.rfq.bidtemplate" select="0" saxon:assignable="yes"/>
	<xsl:variable name="callCount.rfq.BidItem" select="0" saxon:assignable="yes"/>
	<xsl:variable name="callCount.LineItem.rfq.Item" select="0" saxon:assignable="yes" />
	<xsl:variable name="callCount.rfq.ProcessBidsAndItemsSupplier" select="0" saxon:assignable="yes" />
	<xsl:variable name="callSequence" select="()" saxon:assignable="yes" />
	 -->	
<!--
	<xsl:variable name="instructionsSheetName" select="localeHelper:getValue( $localeHelper,  'excelmap.bids.auction.sheet.name.instructions')" />

	Use this part to test just RFQ.  	
	
	<xsl:template match="/">
		
		<book doctype="RFxResponse" language="{$language}" workbook="{Options/Option[@OptionKey='WorkbookBase']/@OptionValue}" rowColumnNumbersMode="mixed">
			<xl:sheet type="INSTRUCTIONS" name="{$instructionsSheetName}">
				<xl:linkToSheet horizontalAlignment="right">
					<xsl:attribute name="writeContentToCellByPosition" select="concat($instructionsSheetName,',12,1')" /> 
					<xsl:attribute name="targetCellByPosition" select="concat($rfqSheetName,',1,1')" />
					<xsl:value-of select="$rfqSheetName" />
				</xl:linkToSheet>
			</xl:sheet>

			<xsl:call-template name="SetupBidKeys" />

			<xsl:apply-templates select="ePASSResponse/RFxResponse/RFx" mode="RFQ"/>
		</book>
	</xsl:template>
-->

	<!-- ***************************** -->
	<!-- Handle the RFx Header section -->
	<!-- ***************************** -->
	<xsl:template match="RFx" mode="RFQ">
<!--	
		<saxon:assign name="callCount.RFx.RFQ" select="$callCount.RFx.RFQ + 1" />
		<saxon:assign name="callSequence" select="($callSequence,'RFx.RFQ[',$callCount.RFx.RFQ,']')" />
			<xsl:message><xsl:value-of select="data($callSequence)" /></xsl:message>	-->
		<xl:sheet>
			<xsl:attribute name="name" select="if ($bid.rfxtype='sealed') then $rfqSheetName else $rfpSheetName">
			</xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="'BID_RFQ'" /></xsl:attribute>
			<xsl:attribute name="rfxDecimalPlaces"><xsl:value-of select="@RFxDecimalPlaces" /></xsl:attribute>
			<xsl:attribute name="validationLimit"><xsl:value-of select="if( $isBidTemplate) then max(($validationLimitBids,$validationLimitItems)) else 0" /></xsl:attribute>
			<xsl:attribute name="rfxCurrencyCodes"><xsl:value-of select="@RFxCurrencyCodes" /></xsl:attribute>
			<xsl:attribute name="rfxAllowSingleBidPerItem"><xsl:value-of select="./RFQBiddingRules/@RFxAllowSingleBidPerItem"/></xsl:attribute>
			<xsl:call-template name="RFxInformation" />
			<xl:row />
			<xsl:variable name="currExchangeNodes" select="$rfx//CurrencyExchange"/>
			<xsl:if test="count($currExchangeNodes) &gt; 0 and java:canBidderViewExchangeRate()">
				<xsl:call-template name="CurrencyExchangeRates">
					<xsl:with-param name="currExchangeNodes" select="$currExchangeNodes"></xsl:with-param>
				</xsl:call-template>
				<xl:row/>
			</xsl:if>
			
      		<!--It creates the column headers-->
			<xsl:call-template name="rfq.bid.headers" />
			
			<xsl:apply-templates select="$rfx/Requisition/LineItem" mode="rfq.bidtemplate"/>
			<xl:skip numberOfRows="1" />
			<!--Process the bundle bids-->
			<xsl:if test="$rfq.bundleBidEnabled">
				<xsl:for-each select="$rfx/Bid[@BidType = $bid.Type.Bundle]">
					<xsl:for-each select="Bid">
						<xsl:sort select="@BidCode" data-type="number" order="ascending" />				
						<xl:row font="iteminfo">
							<xsl:variable name="lineitem" select="key('lineItemByCode',@BidLineItemCode)[1]" />
							<xsl:apply-templates select="$lineitem" mode="rfq.Item">
								<xsl:with-param name="atleastOneSimpleBidPresent" select="true()" />
								<xsl:with-param name="selectedCurrencyCode" select="@BidCurrencyCode" />
								<xsl:with-param name="bidCode" select="@BidCode"/>
							</xsl:apply-templates>
							<xsl:call-template name="ProcessBid">
								<xsl:with-param name="lineitem" select="$lineitem"/>
								<xsl:with-param name="bidNode" select="."/>
							</xsl:call-template>
							<xl:cell header="false" editable="true">
								<xsl:value-of select="@BundleName" />
							</xl:cell>
							<xl:cell header="false" editable="true" datatype="Decimal" minvalue="0" maxvalue="100" minvalueinc="true" maxvalueinc="true">
								<xsl:value-of select="@PPUPercentDiscount" />
							</xl:cell>
							<xl:cell header="false" editable="true" datatype="Decimal" minvalue="0" maxvalue="100" minvalueinc="true" maxvalueinc="true">
								<xsl:value-of select="@OTCPercentDiscount" />
							</xl:cell>
							<xsl:if test="$rfq.volumeBidEnabled ">
								<xl:cell editable="true">
									<xsl:value-of select="''" />
								</xl:cell>
								<xl:cell editable="true" datatype="Decimal" minvalue="0" minvalueinc="true">
									<xsl:value-of select="''" />
								</xl:cell>
								<xl:cell editable="true" datatype="Decimal" minvalue="0" minvalueinc="true">
									<xsl:value-of select="''" />
								</xl:cell>
							</xsl:if>
						</xl:row>
					</xsl:for-each>
				</xsl:for-each>
			</xsl:if>
		</xl:sheet>
		<!-- <saxon:assign name="callSequence" select="subsequence($callSequence,0,count($callSequence)-3)" /> -->		
	</xsl:template>

	<!-- ********************** -->
	<!-- Create the bid headers -->
	<!-- ********************** -->
	<xsl:template name="rfq.bid.headers">
		<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
		<xsl:if test="$UOMColumnPresent">
			<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
		</xsl:if>
		<xsl:if test="$descriptionPresent">
			<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
		</xsl:if>
		<xsl:if test="$includeItemDefs">
			<xsl:if test="$specificationPresent">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
				<xsl:if test="$specificationURLPresent">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
			<xsl:if test="$maxDesiredQuantityPresent">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
			<xsl:if test="$showDeliveryDate">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
			<xsl:if test="$showLeadDays">
				<saxon:assign name="visibleItemIACount" select="$visibleItemIACount + 1"/>
			</xsl:if>
		</xsl:if>
		
		<xsl:variable name="numEmptyCells" select="3+ $visibleItemIACount"/>
		<xsl:variable name="itemDefEmptyCells">
	    		<xsl:value-of select="
	    			if($includeItemDefs)
    				then
    					if($itemSetEnabled=$trueValue)
   						then $userDefinedItemIACount + 3
    					else 
    						$userDefinedItemIACount + 2
	    			else 0
	    		"/>
	    </xsl:variable>
				
		<xl:row header="true" font="rfxheader">
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.rfq.headers.itembids.section')" />
			</xl:cell>
	    	<xl:skip numberOfColumns="{$numEmptyCells+ $itemDefEmptyCells}" />
			<xl:cell font="itemheader">
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.section.simplebids')" />
			</xl:cell>
			<xsl:if test="$rfq.bundleBidEnabled">
			    <xl:skip>
			    	<xsl:attribute name="numberOfColumns" select="count($bidXAsVisible)+1" />
			    </xl:skip>			
				<xl:cell font="itemheader">
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bundle.bundlebids')" />
				</xl:cell>
			</xsl:if>
			<xsl:if test="$rfq.volumeBidEnabled">
		    	<xl:skip numberOfColumns="2" />
				<xl:cell font="itemheader">
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.section.volumediscountbids')" />
				</xl:cell>
			</xsl:if>
		</xl:row>
		<xl:row header="true" font="itemheader">
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.item.info')" />
			</xl:cell>
	    <xl:skip>
	    	<xsl:attribute name="numberOfColumns" select="$numEmptyCells+$itemDefEmptyCells" />
	    </xl:skip>
			<xl:cell>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.bid.info')" /> 
			</xl:cell>
		</xl:row>
		<xl:row header="true" font="itemcolumnheader">
			<xl:cell>
				<xsl:attribute name="tooltip" select="$itemXACodes[@XADName=localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.xad.Name')]/@XADDescription"/>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'name', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			<xl:cell>
				<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName=$XADName.UniqueId]/@XADDescription"/>
				<xsl:if test="not($uniqueIdColumnPresent)">
					<xsl:attribute name="hideColumn" select="'true'"/>
				</xsl:if>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'code', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			<xl:cell>
				<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LotDesc')"/>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.line_items.LineItemLotName')" />
			</xl:cell>
			<xsl:if test="$descriptionPresent">
				<xl:cell>
					<xsl:attribute name="tooltip" select="$itemXACodes[@XADName=localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.xad.Description')]/@XADDescription"/>
					<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'description', @OrganizationCode, @RFxCode)" />
				</xl:cell>
			</xsl:if>
			<xl:cell freezeColumn="true">
				<xsl:attribute name="tooltip" select="$itemXACodes[@XADName=$XADName.MinDesiredQuantity]/@XADDescription"/>
				<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'minQuantity', @OrganizationCode, @RFxCode)" />
			</xl:cell>
			
			<xsl:if test="$includeItemDefs">
				<xsl:if test="$specificationPresent">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName=$XADName.Specification]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'specification', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
				<xsl:if test="$specificationURLPresent">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName=$XADName.SpecificationURL]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'specificationURL', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
			</xsl:if>
			<xsl:if test="$UOMColumnPresent">
				<xl:cell>
					<xsl:attribute name="tooltip" select="$itemXACodes[@XADCode='unitOfMeasure']/@XADDescription"/>
					<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'unitOfMeasure', @OrganizationCode, @RFxCode)" />
				</xl:cell>
			</xsl:if>
			<xsl:if test="$includeItemDefs">
				<xl:cell>
					<xsl:attribute name="tooltip" select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.CategoryDesc')"/>
					<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.LineItemCategory')" />
				</xl:cell>
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.ItemType')" />
				</xl:cell>
				<xsl:if test="$itemSetEnabled=$trueValue">
					<xl:cell>
						<xsl:value-of select="localeHelper:getValue($localeHelper, 'excelmap.bids.line_items.ParentItemUniqueID')" />
					</xl:cell>
				</xsl:if>
				<xsl:if test="$maxDesiredQuantityPresent">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
								$itemXACodes[@XADName=$XADName.MaxDesiredQuantity]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'maxQuantity', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
				<xsl:if test="$showDeliveryDate">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName=localeHelper:getValue($localeHelper, 'excelmap.bids.simple.BidDeliveryDate')]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'dueDate', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
				<xsl:if test="$showLeadDays">
					<xl:cell>
						<xsl:attribute name="tooltip" select="
							$itemXACodes[@XADName=localeHelper:getValue($localeHelper, 'excelmap.bids.simple.BidLeadDays')]/@XADDescription"/>
						<xsl:value-of select="java:getPredefinedItemIATranslationValue($language, 'udaDouble2', @OrganizationCode, @RFxCode)" />
					</xl:cell>
				</xsl:if>
				<xsl:call-template name="ItemIAsHeader"/>
			</xsl:if>
			
			
			
			<xl:cell>
				<xsl:attribute name="tooltip">
					<xsl:value-of
					select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.singleselect'), '  ' , '(', localeHelper:getValue( $localeHelper,  'EPASSAttributeDefStruct.required'), ')','&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.action.new'),'&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.action.update'),'&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.action.cancel'),'&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.action.no_bid'))" />
				</xsl:attribute>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bids.BidAction')" />
			</xl:cell>
			<xl:cell>
				<xsl:attribute name="tooltip">
					<xsl:value-of
					select="concat(localeHelper:getValue( $localeHelper, 'excelmap.bid.attribute.singleselect'),'  ' , '(', localeHelper:getValue( $localeHelper,  'EPASSAttributeDefStruct.required'), ')','&#xa;',
												localeHelper:getValue( $localeHelper, 'excelmap.bids.comment.currency'),'&#xa;',
												$rfxcurrencycodes)" />
				</xsl:attribute>
				<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bids.BidCurrencyCode')" />
			</xl:cell>
			
      <!-- iterate over extended attributes having XADDomain="bid" to get names -->
			<xsl:for-each select="$bidXAsVisible">
				<xsl:if test="@XADName != $XADName.BidDiscountCode "><!--If XADName is not 'PPU Discount Amount in %' then only process it-->
					<xl:cell>
						<xsl:call-template name="XADHeaderComment"><!--it creates the tooltip for bid IA-->
							<xsl:with-param name="XANode" select="." />
						</xsl:call-template>
						<xsl:variable name="isRequired" select="@XADIsRequired = $trueValue or translate(@XADIsRequired, 'truefals', 'TRUEFALS')='TRUE'" />
						<xsl:value-of
							select="
								if( $isRequired ) 
									then concat('*',@XADName)
								else if ( @XADName= $XADName.BidMinimum 
										and /ePASSResponse/RFxResponse/RFx/RFQBiddingRules/@RFxAllowOptimizationFeedback = $trueValue) 
									then concat('*',@XADName) 
								else 
									@XADName " />
					</xl:cell>
				</xsl:if>
			</xsl:for-each>
			<xsl:if test="$rfq.bundleBidEnabled">
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.rfx.bid.BundleName')" />
				</xl:cell>
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bundle.priceperunitpercentdiscount')" />
				</xl:cell>
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bundle.onetimechargepercentdiscount')" />
				</xl:cell>
			</xsl:if>
			<xsl:if test="$rfq.volumeBidEnabled">
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.headers.section.stepvolumediscount')" />
				</xl:cell>
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.volume.minimumquantity')" />
				</xl:cell>
				<xl:cell>
					<xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.volume.maximumquantity')" />
				</xl:cell>
			</xsl:if>
			<xl:cell hideColumn="true">
			    <xsl:value-of select="localeHelper:getValue( $localeHelper,  'excelmap.bids.bids.BidCode')" />
			</xl:cell>
		</xl:row>
	</xsl:template>

    <!-- **************************************************************************************************************** -->
	<!-- It is the template to process RFx/Requisition/LineItem element -->
	<!-- **************************************************************************************************************** -->
	<xsl:template match="LineItem" mode="rfq.bidtemplate">
<!--		<saxon:assign name="callCount.LineItem.rfq.bidtemplate" select="$callCount.LineItem.rfq.bidtemplate + 1" />
		<saxon:assign name="callSequence" select="($callSequence,'LineItem.rfq.bidtemplate[',$callCount.LineItem.rfq.bidtemplate,']')" />
 		<xsl:message><xsl:value-of select="data($callSequence)" /></xsl:message> -->
	
		<xsl:variable name="lineitemcode" select="@LineItemCode" /><!--Stores the name of LineItem-->
		<xsl:variable name="lineitemtype" select="@LineItemType" /><!--Stores the type of lineitem.  Possible values are single, substitution or all_or_none -->

		<!--count the number of valid simple bids for the given line item-->
		<xsl:variable name="lineitem" select="." /><!--stores the current LineItem node for further processing-->
		<xsl:choose>
			<xsl:when test="$lineitem/@LineItemType = $rfq.SubstitutionSet"><!--Handle LineItem of type substitution -->
				<xsl:for-each select="$lineitem/LineItem">
					<xsl:variable name="substitionSetMemberLineItemCode" select="@LineItemCode" />
					<!--Count the number of valid bids for child of substitution type lineitem-->
					<xsl:call-template name="rfq.BidItem">
						<xsl:with-param name="lineitem" select="." />
						<xsl:with-param name="bids" select="key('validSimpleBids',$substitionSetMemberLineItemCode)" />
					</xsl:call-template>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise><!-- It is used to handle the LineItem of type 'Simple' and 'All OR None' set-->
				<xsl:call-template name="rfq.BidItem">
					<xsl:with-param name="lineitem" select="$lineitem" />
					<xsl:with-param name="bids" select="key('validSimpleBids',@LineItemCode)" />
				</xsl:call-template>
			</xsl:otherwise>
		</xsl:choose>
		<!-- <saxon:assign name="callSequence" select="subsequence($callSequence,0,count($callSequence)-3)" /> -->		
	</xsl:template>

	<!-- **************************************** -->
	<!-- Process an item and its bids -->
	<!-- **************************************** -->
	<xsl:template name="rfq.BidItem">
		<xsl:param name="lineitem" />
		<xsl:param name="bids" select="()" />
<!--		
		<saxon:assign name="callCount.rfq.BidItem" select="$callCount.rfq.BidItem + 1" />
		<saxon:assign name="callSequence" select="($callSequence,'rfq.BidItem[',$callCount.rfq.BidItem,']')" />
 		<xsl:message><xsl:value-of select="data($callSequence)" /></xsl:message> -->
		
	
		<xsl:variable name="bidCount" select="count($bids)"/>
<!-- 		<xsl:message select="concat('bidCount is ',$bidCount)" /> -->
		<xsl:choose>
			<xsl:when test="$bidCount &lt; 1"><!--if there are no bids on item-->
				<xl:row font="iteminfo">
                    <!--It populates the first 8 columns upto 'Currency Code' column-->
					<xsl:apply-templates select="$lineitem" mode="rfq.Item">
						<xsl:with-param name="atleastOneSimpleBidPresent" select="false()" /><!--It is passed to decide the value for "Action" column-->
						<xsl:with-param name="bidCode" select="@BidCode"/>
					</xsl:apply-templates>
					<xsl:call-template name="ProcessBid">
						<xsl:with-param name="lineitem" select="$lineitem"/>
					</xsl:call-template>
					<xsl:if test="$rfq.bundleBidEnabled"><!-- -if bundle bidding is true set empty cells as there are o bids-->
						<xl:cell editable="true">
							<xsl:value-of select="''" />
						</xl:cell>
						<xl:cell editable="true" datatype="Decimal" minvalue="0" maxvalue="100" minvalueinc="true" maxvalueinc="true">
							<xsl:value-of select="''" />
						</xl:cell>
						<xl:cell editable="true" datatype="Decimal" minvalue="0" maxvalue="100" minvalueinc="true" maxvalueinc="true">
							<xsl:value-of select="''" />
						</xl:cell>
					</xsl:if>
					<xsl:if test="$rfq.volumeBidEnabled"><!-- if volume bidding is true set empty cells as there are o bids -->
						<xl:cell editable="true">
							<xsl:value-of select="''" />
						</xl:cell>
						<xl:cell editable="true" datatype="Decimal" minvalue="0" minvalueinc="true">
							<xsl:value-of select="''" />
						</xl:cell>
						<xl:cell editable="true" datatype="Decimal" minvalue="0" minvalueinc="true">
							<xsl:value-of select="''" />
						</xl:cell>
					</xsl:if>
				</xl:row>
			</xsl:when>
			<xsl:otherwise> <!--if there are one or more bids on item -->
				<xsl:for-each select="$bids">
					<xsl:sort select="@BidCode" data-type="number" order="ascending" />				
					<xl:row font="iteminfo"> 
						<xsl:apply-templates select="$lineitem" mode="rfq.Item">
							<xsl:with-param name="atleastOneSimpleBidPresent" select="true()" />
							<xsl:with-param name="selectedCurrencyCode" select="@BidCurrencyCode" />
							<xsl:with-param name="bidCode" select="@BidCode"/>
						</xsl:apply-templates>
						<xsl:call-template name="ProcessBid">
							<xsl:with-param name="lineitem" select="$lineitem"/>
							<xsl:with-param name="bidNode" select="."/>
						</xsl:call-template>
						<xsl:if test="$rfq.bundleBidEnabled">
							<xl:cell editable="true">
								<xsl:value-of select="''" />
							</xl:cell>
							<xl:cell editable="true" datatype="Decimal" minvalue="0" maxvalue="100" minvalueinc="true" maxvalueinc="true">
								<xsl:value-of select="''" />
							</xl:cell>
							<xl:cell editable="true" datatype="Decimal" minvalue="0" maxvalue="100" minvalueinc="true" maxvalueinc="true">
								<xsl:value-of select="''" />
							</xl:cell>
						</xsl:if>
						<xsl:if test="$rfq.volumeBidEnabled">
							<xl:cell editable="true">
								<xsl:value-of select="''" />
							</xl:cell>
							<xl:cell editable="true" datatype="Decimal" minvalue="0" minvalueinc="true">
								<xsl:value-of select="''" />
							</xl:cell>
							<xl:cell editable="true" datatype="Decimal" minvalue="0" minvalueinc="true">
								<xsl:value-of select="''" />
							</xl:cell>
						</xsl:if>
						<xl:cell datatype="Integer" editable="false" hideColumn="true" textlength="0">
						    <xsl:value-of select="@BidCode"/>
						</xl:cell>
					</xl:row>
				</xsl:for-each>
			</xsl:otherwise>
		</xsl:choose>
		<!-- <saxon:assign name="callSequence" select="subsequence($callSequence,0,count($callSequence)-3)" /> -->		
	</xsl:template>

	<!-- **************************************************************************************************************** -->
	<!-- Template for populating first 8 columns with line item information -->
	<!-- **************************************************************************************************************** -->
	<xsl:template match="LineItem" mode="rfq.Item">
		<xsl:param name="atleastOneSimpleBidPresent" select="false()"/><!--it is used to decide the value of "Action" column-->
		<xsl:param name="selectedCurrencyCode" select="''" />
		<xsl:param name="bidCode" />
		
		<xsl:variable name="lineitemcode" select="@LineItemCode" />
		<xl:cell> <xsl:value-of select="@LineItemName" /> </xl:cell>
		<xl:cell>
			<xsl:if test="not($uniqueIdColumnPresent)">
				<xsl:attribute name="hideColumn" select="'true'"/>
			</xsl:if>
			<xsl:value-of select="@LineItemCode" />
		</xl:cell>
		<xl:cell> <xsl:value-of select="@LineItemLotName" /> </xl:cell>
		<xsl:if test="$descriptionPresent">
			<xl:cell> <xsl:value-of select="@LineItemDescription" /> </xl:cell>
		</xsl:if>
		<xl:cell datatype="Integer"> <xsl:value-of select="@LineItemMinimumDesiredQuantity" /> </xl:cell>  
		
		
		<xsl:if test="$includeItemDefs">
			<xsl:if test="$specificationPresent">
				<xl:cell>
					<xsl:value-of select="ExtendedAttribute[@ExtendedAttributeCode = $XADName.Specification]/@ExtendedAttributeValue"/>
				</xl:cell>
			</xsl:if>
			<xsl:if test="$specificationURLPresent">
				<xl:cell>
					<xsl:value-of select="ExtendedAttribute[@ExtendedAttributeCode = $XADName.SpecificationURL]/@ExtendedAttributeValue"/>
				</xl:cell>
			</xsl:if>
		</xsl:if>		
		<xsl:if test="$UOMColumnPresent">
			<xl:cell><xsl:value-of select="@LineItemUnitOfMeasure" /></xl:cell>
		</xsl:if>
		<xsl:if test="$includeItemDefs">
			<xl:cell>
				<xsl:value-of select="./@LineItemCategoryCode"/>
			</xl:cell>
			<xl:cell>
				<xsl:value-of select="./@LineItemType"/>
			</xl:cell>
			<xsl:if test="$itemSetEnabled=$trueValue">
				<xl:cell>
					<xsl:value-of select="../@LineItemCode"/>
				</xl:cell>
			</xsl:if>
			<xsl:if test="$maxDesiredQuantityPresent">
				<xl:cell datatype="Integer">
					<xsl:value-of select="./@LineItemMaximumDesiredQuantity"/>
				</xl:cell>
			</xsl:if>
			
			<xsl:if test="$showDeliveryDate">
				<xl:cell>
					<xsl:value-of select="./@LineItemDeliveryDateTime"/>
				</xl:cell>
			</xsl:if>
			<xsl:if test="$showLeadDays">
				<xl:cell datatype="Integer">
					<xsl:value-of select="./@LineItemLeadDays"/>
				</xl:cell>
			</xsl:if>
		</xsl:if>
		
		 <xsl:if test="$includeItemDefs">     
			 <xsl:call-template name="ItemIAValues">
				<xsl:with-param name="extendedattribute" select="./ExtendedAttribute"/>
			 </xsl:call-template>
         </xsl:if>
		
		
		
		<xl:cell editable="true">
			<xsl:attribute name="defaultvalue" select="if($atleastOneSimpleBidPresent) then $update else $new" />
			<xsl:attribute name="selectionlist" select="concat($new,'|',$update,'|',localeHelper:getValue( $localeHelper,  'excelmap.bids.simple.cancel'),'|',$noBid,'|')" />
			<!--
				As this tooltip is common for all cell under header 'Action' so display it at header level instead of each cell <xsl:attribute name="tooltip"> <xsl:value-of select="$dropdown"/> </xsl:attribute>
			-->
		</xl:cell>

    <!--Calculates the value of 'Currency Codes' Column-->
		<xsl:variable name="restrictedcurrency" select="./@LineItemRestrictedCurrency" />
		<xsl:variable name="currencylist" select="localeHelper:removeRestrictedCurrency($rfxcurrencycodes, $restrictedcurrency )" />
		<xsl:variable name="singleCurrency" select="substring-after($currencylist,$DefaultStringDelimiter)" />
		<xsl:variable name="isMultiCurr" select="if($singleCurrency='') then false() else true()" />
		
		<xl:cell editable="true" isCurrencyList="true">
			<xsl:attribute name="defaultvalue" select="
				if( $selectedCurrencyCode ) then $selectedCurrencyCode
				else if( $supplierPrefferedCurrency!= '' and contains($currencylist, $supplierPrefferedCurrency) ) then $supplierPrefferedCurrency
				else if( contains($currencylist, $rfxPrimaryCurrency) ) then $rfxPrimaryCurrency
				else if( $isMultiCurr ) then $pleaseSelectValue
				else $currencylist
			" />
			<xsl:attribute name="selectionlist" select="$currencylist " />
		</xl:cell>
		<!-- <saxon:assign name="callSequence" select="subsequence($callSequence,0,count($callSequence)-3)" /> -->		
	</xsl:template>
	
    <!-- ************************************************************** -->
	<!-- Create comment based on xad datatype-->
	<!-- ************************************************************** -->
	<xsl:template name="getComment">
		<xsl:param name="datatype" />
		<xsl:choose>
			<xsl:when test="$datatype = $XADDataType.SimpleText">
				<xsl:value-of select="localeHelper:getToolTip( $localeHelper,  'excelmap.bids.rfi.response.datalimited','255')" />
			</xsl:when>
			<xsl:when test="$datatype = $XADDataType.String">
				<xsl:value-of select="localeHelper:getToolTip( $localeHelper,  'excelmap.bids.rfi.response.datalimited','2000')" />
			</xsl:when>
			<xsl:when test="$datatype = $XADDataType.Integer or $datatype = $XADDataType.Currency or $datatype = $XADDataType.Double ">
				<saxon:assign name="comment" select="''" />
				<xsl:call-template name="GetNumberToolTip" />
				<xsl:if test="$comment = ''">
					<saxon:assign name="comment" select="$decimal" />
				</xsl:if>
				<xsl:value-of select="$comment" />
			</xsl:when>
			<xsl:when test="$datatype = $XADDataType.Boolean or $datatype = $XADDataType.Enumeration">
				<xsl:value-of select="$dropdown" />
			</xsl:when>
			<xsl:when test="$datatype = $XADDataType.Date">
				<xsl:value-of select="$date" />
			</xsl:when>
		</xsl:choose>
	</xsl:template>

    <!-- ************************************************************** -->
	<!-- Create comment based on xad datatype-->
	<!-- ************************************************************** -->
	<xsl:template name="getXADComment">
		<xsl:param name="xadNode" />
		<xsl:variable name="varXadDatatype" select="$xadNode/@XADDataType" />
		<xsl:variable name="varXadName" select="$xadNode/@XADName" />
		<xsl:choose>
			<!--if IA type is Text_Single then comment of maximum 255 chars-->
			<xsl:when test="$varXadDatatype = $XADDataType.SimpleText">
				<xsl:choose>
					<xsl:when test="$varXadName = $supplierItemCode"><!--Exceptional: same type but max length is 80 chars-->
						<xsl:value-of select="localeHelper:getToolTip( $localeHelper,  'excelmap.bids.rfi.response.datalimited','80')" />
					</xsl:when>
					<xsl:otherwise>
						<xsl:value-of select="localeHelper:getToolTip( $localeHelper,  'excelmap.bids.rfi.response.datalimited','255')" />
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>

            <!--if IA type is Text_Multi then comment of maximum 2000 chars-->
			<xsl:when test="$varXadDatatype = $XADDataType.String">
				<xsl:value-of select="localeHelper:getToolTip( $localeHelper,  'excelmap.bids.rfi.response.datalimited','2000')" />
			</xsl:when>

            <!--if IA type is Decimal or Integer or Currency then comment of min max-->
			<xsl:when test="$varXadDatatype = $XADDataType.Integer or $varXadDatatype = $XADDataType.Currency or $varXadDatatype = $XADDataType.Double ">
				<saxon:assign name="comment" select="''" /> <!--set to empty so that first bid ia comment should not used by second-->
				<xsl:call-template name="GetNumberToolTip" />
				<xsl:if test="$comment = ''">
					<saxon:assign name="comment" select="$decimal" />
				</xsl:if>
				<xsl:value-of select="$comment" />
			</xsl:when>

            <!--if IA type is Boolean or Selection(Single or Multiple) then comment of select from list-->
			<xsl:when test="$varXadDatatype = $XADDataType.Boolean or $varXadDatatype = $XADDataType.Enumeration">
				<xsl:value-of select="$dropdown" />
			</xsl:when>

            <!--if IA type is Date then comment showing the valid date format of YYYY-MM-DD HH:MM:SS -->
			<xsl:when test="$varXadDatatype = $XADDataType.Date">
				<xsl:value-of select="$date" />
			</xsl:when>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
