<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	version="2.0" xmlns:saxon="http://saxon.sf.net/" xmlns:emptoris-ojeu="http://www.emptoris.com/sourcing/ojeu" extension-element-prefixes="saxon">
	
	<xsl:template name="Section_AnnexA_PRIOR_INFORMATION">
		<xsl:param name="noticeRoot" />
		<xsl:variable name="sectionRoot" select="$noticeRoot/AUTHORITY_PRIOR_INFORMATION" />
		<fo:block xsl:use-attribute-sets="h1">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_AnnexA')" />
		</fo:block>

		<xsl:if test="$noticeRoot/@HAS_A1='Yes'">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a1.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_PRIOR_INFORMATION/FURTHER_INFORMATION/CONTACT_DATA" />
					<xsl:with-param name="displayURL" select="true()"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>

		<xsl:variable name="regulatoryInfo" select="$noticeRoot/OTH_INFO_PRIOR_INFORMATION/INFORMATION_REGULATORY_FRAMEWORK" />
		
		<xsl:if test="$regulatoryInfo/*/CONTACT_DATA">
			<xsl:if test="$regulatoryInfo/TAX_LEGISLATION/CONTACT_DATA">
				<fo:block-container keep-together.within-page="auto">
					<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_pin_notice_annexa.header.notice.a2.title')" />
					</fo:block>
					<xsl:call-template name="writeContactDetails">
						<xsl:with-param name="contextNode" select="$regulatoryInfo/TAX_LEGISLATION/CONTACT_DATA" />
						<xsl:with-param name="displayURL" select="true()"/>
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
	
			<xsl:if test="$regulatoryInfo/ENVIRONMENTAL_PROTECTION_LEGISLATION/CONTACT_DATA">
				<fo:block-container keep-together.within-page="auto">
					<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_pin_notice_annexa.header.notice.a3.title')" />
					</fo:block>
					<xsl:call-template name="writeContactDetails">
						<xsl:with-param name="contextNode" select="$regulatoryInfo/ENVIRONMENTAL_PROTECTION_LEGISLATION/CONTACT_DATA" />
						<xsl:with-param name="displayURL" select="true()"/>
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
	
			<xsl:if test="$regulatoryInfo/EMPLOYMENT_PROTECTION_WORKING_CONDITIONS/CONTACT_DATA">
				<fo:block-container keep-together.within-page="auto">
					<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_pin_notice_annexa.header.notice.a4.title')" />
					</fo:block>
					<xsl:call-template name="writeContactDetails">
						<xsl:with-param name="contextNode" select="$regulatoryInfo/EMPLOYMENT_PROTECTION_WORKING_CONDITIONS/CONTACT_DATA" />
						<xsl:with-param name="displayURL" select="true()"/>
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	
	<xsl:template name="Section_AnnexA_CONTRACT_AWARD">
		<xsl:param name="noticeRoot" />
		<xsl:variable name="sectionRoot" select="$noticeRoot/CONTRACTING_AUTHORITY_INFORMATION_CONTRACT_AWARD" />
		<fo:block xsl:use-attribute-sets="h1">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_AnnexA')" />
		</fo:block>

		<xsl:if test="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/FURTHER_INFORMATION/CONTACT_DATA">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a1.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/FURTHER_INFORMATION/CONTACT_DATA" />
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>

		<xsl:if test="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/SPECIFICATIONS_AND_ADDITIONAL_DOCUMENTS/CONTACT_DATA">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a2.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/SPECIFICATIONS_AND_ADDITIONAL_DOCUMENTS/CONTACT_DATA" />
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>

		<xsl:if test="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/TENDERS_REQUESTS_APPLICATIONS_MUST_BE_SENT_TO/CONTACT_DATA">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a3.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/TENDERS_REQUESTS_APPLICATIONS_MUST_BE_SENT_TO/CONTACT_DATA" />
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
	</xsl:template>	
	
	<xsl:template name="Section_AnnexA_CONTRACT">
		<xsl:param name="noticeRoot" />
		<xsl:variable name="sectionRoot" select="$noticeRoot/CONTRACTING_AUTHORITY_INFORMATION" />
		<fo:block xsl:use-attribute-sets="h1">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_AnnexA')" />
		</fo:block>

		<xsl:if test="$noticeRoot/@HAS_A1='Yes'">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a1.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/FURTHER_INFORMATION/CONTACT_DATA" />
					<xsl:with-param name="displayURL" select="true()"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>

		<xsl:if test="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/SPECIFICATIONS_AND_ADDITIONAL_DOCUMENTS/CONTACT_DATA">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a2.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/SPECIFICATIONS_AND_ADDITIONAL_DOCUMENTS/CONTACT_DATA" />
					<xsl:with-param name="displayURL" select="true()"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>

		<xsl:if test="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/TENDERS_REQUESTS_APPLICATIONS_MUST_BE_SENT_TO/CONTACT_DATA">
			<fo:block-container keep-together.within-page="auto">
				<fo:block xsl:use-attribute-sets="h2" margin-top="5mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.a3.title')" />
				</fo:block>
				<xsl:call-template name="writeContactDetails">
					<xsl:with-param name="contextNode" select="$sectionRoot/NAME_ADDRESSES_CONTACT_CONTRACT/TENDERS_REQUESTS_APPLICATIONS_MUST_BE_SENT_TO/CONTACT_DATA" />
					<xsl:with-param name="displayURL" select="true()"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
