<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:n2016="ted/2016/nuts" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	version="2.0" xmlns:saxon="http://saxon.sf.net/" xmlns:emptoris-ojeu="http://www.emptoris.com/sourcing/ojeu" extension-element-prefixes="saxon">
	<!--
		In SAXON 8.3, only global variables can be marked as assignable. It'd be nice if local variables as assignable. Need to investigate further with SAXON.
	-->
	<xsl:template name="Section_AnnexB">
		<xsl:param name="objectOfContract" />
		<xsl:param name="PinType" />
		<xsl:param name="noticeType" />
		<xsl:param name="contractType" />
		<xsl:param name="procedureType" />
		<xsl:param name="lotSection" />
		<!--<xsl:param name="lotPosition" select="1" />	-->
		
		<!--<xsl:variable name="noticeType" select="$noticeRoot/@CTYPE" />-->
		<!-- If the notice type is supplies or services, the lot section could have
			multiple nodes ( sequence of nodes, one for lot of each object of contract for which there are lots ). 
		 -->
		<xsl:for-each select="($lotSection)"> 
			<xsl:if test="$objectOfContract/p:LOT_DIVISION">
				<fo:block xsl:use-attribute-sets="h1" margin-top="3mm">
							<xsl:value-of select="if( last() > 1 ) then concat(messageLocalizer:convertLiteral($locale,'form.noticetree.object_of_contract.info_abt_lots'), ' : ',
						messageLocalizer:convertLiteral($locale,'ojeu.form.lot.no.hdr'),' (', position() ,') ')
						else messageLocalizer:convertLiteral($locale,'form.noticetree.object_of_contract.info_abt_lots')" />					
				</fo:block>
				
				<fo:block xsl:use-attribute-sets="h2">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.lot.hdr.title')" />
				</fo:block>
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<xsl:if test="p:TITLE">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.title')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="p:TITLE" />
					</xsl:call-template>
				</xsl:if>	
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.lot_no')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="p:LOT_NO" />
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
			<xsl:if test="$objectOfContract/p:NO_LOT_DIVISION">
				<fo:block xsl:use-attribute-sets="h1" margin-top="3mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.object_of_contract.description')" />					
				</fo:block>
			</xsl:if>

			<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.additionl_object')" />
			</fo:block>	

			<xsl:call-template name="writeAdditionalCPVAndVOCTable">
				<xsl:with-param name="cpvNode" select="." />
			</xsl:call-template>

			
			<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.placeOfPerformance')" />
			</fo:block>
	
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3" margin-top="3mm" >
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.nutsCodeAndName')" />
				</fo:block>	
				<xsl:for-each select="n2016:NUTS/@DESCRIPTION">
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="data(.)" />
					</xsl:call-template>
				</xsl:for-each>
							
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.placeOfPerformance')" />
				</fo:block>
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="p:MAIN_SITE" />
					<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			</fo:block-container>
			
			
			<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.quantity_or_scope')" />
			</fo:block>
			
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.quanorscope_desc')" />
				</fo:block>
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="p:SHORT_DESCR" />
					<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			</fo:block-container>
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT') or ($noticeType='CONTRACT_AWARD')">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.award_criteria')" />
				</fo:block>
			</xsl:if>	
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="if( p:AC_PROCUREMENT_DOC ) then messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.criteria.procurement.documents')
								else if (p:AC_QUALITY or p:AC_COST or p:AC_PRICE) then messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.criteria.below')
								else ''" />
				</fo:block>
			</fo:block-container>
			</xsl:if>
			
			<xsl:variable name="qualityCriterion" select="p:AC_QUALITY" />
			<xsl:variable name="costCriterion" select="p:AC_COST" />
			<xsl:variable name="priceCriterion" select="p:AC_PRICE" />
			<xsl:if test="($qualityCriterion) or ($costCriterion) or ($priceCriterion)">
				<xsl:call-template name="writeAwardCriterionTable">
					<xsl:with-param name="awardCriterionNode" select="." />
				</xsl:call-template>
			</xsl:if>
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
				<xsl:if test="(p:VAL_OBJECT)">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.value_excluding_vat')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.value_excluding_vat')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="concat(p:VAL_OBJECT, ' ', p:VAL_OBJECT/@CURRENCY)" />
					</xsl:call-template>
				</fo:block-container>
				</xsl:if>
			</xsl:if>
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.duration_of_contract')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<xsl:if test="(p:DURATION)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.duration')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="concat(p:DURATION, ' ', p:DURATION/@TYPE)" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="(p:DATE_START)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.period')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="concat(messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.starting'), ' ', p:DATE_START, ' ', 
							messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.completion'), ' ', p:DATE_END)" />
						</xsl:call-template>
					</xsl:if>
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.contract.renewal')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( p:RENEWAL ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
					<xsl:if test="(p:RENEWAL)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.desc.renewals')" />
						</fo:block>
						<xsl:call-template name="writeMultiLineData">
							<xsl:with-param name="multiLineData" select="p:RENEWAL_DESCR" />
							<xsl:with-param name="marginLeft" select="'0mm'" />
						</xsl:call-template>
					</xsl:if>
				</fo:block-container>
			</xsl:if>
			
			<xsl:if test="($noticeType='CONTRACT') and ($procedureType != 'OPEN')">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.number_of_candidates')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<xsl:if test="(p:NB_ENVISAGED_CANDIDATE)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.envisaged.number_of_candidates')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NB_ENVISAGED_CANDIDATE" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="(p:NB_MIN_LIMIT_CANDIDATE)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.range')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="concat(messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.envisaged.minimum.number'), ' ', p:NB_MIN_LIMIT_CANDIDATE, ' ', 
							messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.envisaged.maximum.number'), ' ', p:NB_MAX_LIMIT_CANDIDATE)" />
						</xsl:call-template>
					</xsl:if>
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.criteria.for.choosing.number_of_candidates')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="p:CRITERIA_CANDIDATE" />
						<xsl:with-param name="marginLeft" select="'0mm'" />
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">			
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.variants')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.variants')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( p:ACCEPTED_VARIANTS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT') or ($noticeType='CONTRACT_AWARD')">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.options')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.options')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( p:OPTIONS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
					<xsl:if test="(p:OPTIONS)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.desc.options')" />
						</fo:block>
						<xsl:call-template name="writeMultiLineData">
							<xsl:with-param name="multiLineData" select="p:OPTIONS_DESCR" />
							<xsl:with-param name="marginLeft" select="'0mm'" />
						</xsl:call-template>
					</xsl:if>
				</fo:block-container>
			</xsl:if>
			
			<xsl:if test="($noticeType='CONTRACT')">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.electronic.catalogues')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.electronic.catalogues')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( p:ECATALOGUE_REQUIRED ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
			
			<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT') or ($noticeType='CONTRACT_AWARD')">
				<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.Info.eu.funds')" />
				</fo:block>
				
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.procurement.eu.funds')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( p:EU_PROGR_RELATED ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else if (p:NO_EU_PROGR_RELATED) then messageLocalizer:convertLiteral($locale,'form.terminology.button.no')
								else ''" />
					</xsl:call-template>
					<xsl:if test="(p:EU_PROGR_RELATED)">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.identification.of.project')" />
						</fo:block>
						<xsl:call-template name="writeMultiLineData">
							<xsl:with-param name="multiLineData" select="p:EU_PROGR_RELATED" />
							<xsl:with-param name="marginLeft" select="'0mm'" />
						</xsl:call-template>
					</xsl:if>
				</fo:block-container>
			</xsl:if>
			
			<fo:block xsl:use-attribute-sets="h2" margin-top="3mm" >
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.title.add_info_abt_lots_hdr')" />
			</fo:block>
			
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="p:INFO_ADD" />
					<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			</fo:block-container>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>
