<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2015. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	version="2.0" xmlns:saxon="http://saxon.sf.net/" xmlns:emptoris-ojeu="http://www.emptoris.com/sourcing/ojeu"  extension-element-prefixes="saxon">
	<!--
		In SAXON 8.3, only global variables can be marked as assignable. It'd be nice if local variables as assignable. Need to investigate further with SAXON.
	-->
	<xsl:template name="Section_Changes">
		<xsl:param name="sectionRoot" />
		<fo:block xsl:use-attribute-sets="h1">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.corrigendum_changes')" />
		</fo:block>
		

	
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.header.information')" />
		</fo:block>
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.header.reason.for.change')" />
		</fo:block>
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">	
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:MODIFICATION_ORIGINAL ) then messageLocalizer:convertLiteral($locale,'corrigendum.changes.reason_for_change.option1')
						else if ($sectionRoot/p:PUBLICATION_TED)then messageLocalizer:convertLiteral($locale,'corrigendum.changes.reason_for_change.option2')
						else ''" />
			</xsl:call-template>
			</fo:block>
		</fo:block-container>
		
		
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.header.text_to_be_corrected')" />
		</fo:block>
		
		<xsl:variable name="changes" select="$sectionRoot/p:CHANGE" />
		
		<xsl:for-each select="$changes">
			<xsl:variable name="change" select="." />
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.section_number')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="p:WHERE/p:SECTION" />
				</xsl:call-template>
				<xsl:if test="p:WHERE/p:LOT_NO">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.lot_no')" />
					</fo:block>
		
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="p:WHERE/p:LOT_NO" />
					</xsl:call-template>
				</xsl:if>
				<xsl:if test="p:WHERE/p:LABEL">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.Place_of_text_to_be_modified')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="p:WHERE/p:LABEL" />
					</xsl:call-template>
				</xsl:if>
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.instead_of')" />
				</fo:block>
				<xsl:if test="(p:OLD_VALUE/p:TEXT) or (p:NEW_VALUE/p:TEXT)">
					<xsl:if test="(p:OLD_VALUE/p:TEXT)">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:OLD_VALUE/p:TEXT" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="p:NOTHING">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NOTHING" />
						</xsl:call-template>
					</xsl:if>
					
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.read')" />
					</fo:block>
					<xsl:if test="(p:NEW_VALUE/p:TEXT)">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NEW_VALUE/p:TEXT" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="p:NOTHING">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NOTHING" />
						</xsl:call-template>
					</xsl:if>
				</xsl:if>
				<xsl:if test="(p:OLD_VALUE/p:DATE) or (p:NEW_VALUE/p:DATE)">
					<xsl:if test="(p:OLD_VALUE/p:DATE)">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="concat(p:OLD_VALUE/p:DATE, ' ', p:OLD_VALUE/p:TIME)" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="p:NOTHING">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NOTHING" />
						</xsl:call-template>
					</xsl:if>
					
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.read')" />
					</fo:block>
					<xsl:if test="(p:NEW_VALUE/p:DATE)">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="concat(p:NEW_VALUE/p:DATE, ' ', p:NEW_VALUE/p:TIME)" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="p:NOTHING">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NOTHING" />
						</xsl:call-template>
					</xsl:if>
				</xsl:if>
				<xsl:if test="(p:OLD_VALUE/p:CPV_MAIN) and (p:NEW_VALUE/p:CPV_MAIN)">
					<xsl:call-template name="writeMainCPVAndVOCTable">
						<xsl:with-param name="cpvNode" select="p:OLD_VALUE/p:CPV_MAIN" />
					</xsl:call-template>
					
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.read')" />
					</fo:block>
					
					<xsl:call-template name="writeMainCPVAndVOCTable">
						<xsl:with-param name="cpvNode" select="p:NEW_VALUE/p:CPV_MAIN" />
					</xsl:call-template>
				</xsl:if>
				<xsl:if test="(p:OLD_VALUE/p:CPV_ADDITIONAL) or (p:NEW_VALUE/p:CPV_ADDITIONAL)">
					<xsl:if test="(p:OLD_VALUE/p:CPV_ADDITIONAL)">
						<xsl:call-template name="writeAdditionalCPVAndVOCTable">
							<xsl:with-param name="cpvNode" select="p:OLD_VALUE" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="p:NOTHING">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NOTHING" />
						</xsl:call-template>
					</xsl:if>				
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.lable.read')" />
					</fo:block>
					<xsl:if test="(p:NEW_VALUE/p:CPV_ADDITIONAL)">
						<xsl:call-template name="writeAdditionalCPVAndVOCTable">
							<xsl:with-param name="cpvNode" select="p:NEW_VALUE" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="p:NOTHING">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="p:NOTHING" />
						</xsl:call-template>
					</xsl:if>					
				</xsl:if>
			</fo:block-container>
		</xsl:for-each>	

		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'corrigendum.changes.field.header.other_additional_information')" />
		</fo:block>
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">	
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:INFO_ADD" />
			</xsl:call-template>
			</fo:block>
		</fo:block-container>
		
		
		<fo:block>
 			<fo:footnote>
				<fo:inline></fo:inline>
				<fo:footnote-body>
					<fo:block text-align="center" font-size="12pt" font-style="italic">
						It is the contracting authority's/contracting entity's responsibility to ensure compliance with European Union law and any applicable laws.
					</fo:block>
				</fo:footnote-body>
			</fo:footnote>
 		</fo:block>

	</xsl:template>
</xsl:stylesheet>
