<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	version="2.0" xmlns:saxon="http://saxon.sf.net/" xmlns:emptoris-ojeu="http://www.emptoris.com/sourcing/ojeu"  extension-element-prefixes="saxon">
	<!--
		In SAXON 8.3, only global variables can be marked as assignable. It'd be nice if local variables as assignable. Need to investigate further with SAXON.
	-->
	<xsl:template name="Section_ComplementaryInfo">
		<xsl:param name="sectionRoot" />
		<xsl:param name="PinType" />
		<xsl:param name="noticeType" />
		<xsl:if test="($noticeType !='CORRIGENDUM')">
			<xsl:call-template name="Section_ComplementaryInfo_NOT_CORRIGENDUM" >
				<xsl:with-param name="sectionRoot" select="$sectionRoot" />
				<xsl:with-param name="PinType" select="$PinType" />
				<xsl:with-param name="noticeType" select="$noticeType" />
			</xsl:call-template>	
		</xsl:if>
		<xsl:if test="($noticeType ='CORRIGENDUM')">
			<xsl:call-template name="Section_ComplementaryInfo_CORRIGENDUM" >
				<xsl:with-param name="sectionRoot" select="$sectionRoot" />
			</xsl:call-template>	
		</xsl:if>
	</xsl:template>		
	
	<xsl:template name="Section_ComplementaryInfo_NOT_CORRIGENDUM">
		<xsl:param name="sectionRoot" />
		<xsl:param name="PinType" />
		<xsl:param name="noticeType" />
		<!--<xsl:variable name="PinType" select="$noticeRoot/p:NOTICE/@TYPE" />-->
		<fo:block xsl:use-attribute-sets="h1">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.complementry_information.tooltip')" />
		</fo:block>
		
		<xsl:if test="$sectionRoot/p:RECURRENT_PROCUREMENT|$sectionRoot/p:NO_RECURRENT_PROCUREMENT">
		<fo:block-container keep-together.within-page="auto">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.rc.separator')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.recurrent.procurement')" />
				</fo:block>
				<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">	
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:RECURRENT_PROCUREMENT ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
							else if ($sectionRoot/p:NO_RECURRENT_PROCUREMENT)then messageLocalizer:convertLiteral($locale,'form.terminology.button.no')
							else ''" />
				</xsl:call-template>
				</fo:block>
				<xsl:if test="$sectionRoot/p:RECURRENT_PROCUREMENT">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.estimated.timing')" />
					</fo:block>
					<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$sectionRoot/p:ESTIMATED_TIMING" /></xsl:call-template>	
					</fo:block>	
				</xsl:if>
			</fo:block-container>
		</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
		<fo:block-container keep-together.within-page="auto">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.electronic.workflow.separator')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.electronic.ordering')" />
				</fo:block>
				<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">	
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:EORDERING ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
				</fo:block>
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.electronic.invoicing')" />
				</fo:block>
				<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">
					<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="if( $sectionRoot/p:EINVOICING ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" /></xsl:call-template>	
				</fo:block>	
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.electronic.payment')" />
				</fo:block>
				<fo:block xsl:use-attribute-sets="h3" font-weight="normal"  margin-top="2mm">
					<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="if( $sectionRoot/p:EPAYMENT ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" /></xsl:call-template>	
				</fo:block>
			</fo:block-container>
		</fo:block-container>
		</xsl:if>
		
		<fo:block-container keep-together.within-page="auto">
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.additional.info')" />
		</fo:block>
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.additional.info.field')" />
			</fo:block>
			<xsl:call-template name="writeMultiLineData">
				<xsl:with-param name="multiLineData" select="$sectionRoot/p:INFO_ADD" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>
		</fo:block-container>
		</fo:block-container>
		
		<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS') or ($PinType='PRI_CALL_COMPETITION') or ($noticeType='CONTRACT') or ($noticeType='CONTRACT_AWARD')">
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.procedures.for.review')" />
		</fo:block>
		
		<fo:block-container keep-together.within-page="auto" margin-left="0mm" border-style="none">
			<fo:block xsl:use-attribute-sets="h3" margin-left="3mm" font-weight="bold" text-transform="none" margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.body.responsible.for.review')" />
			</fo:block>
			<xsl:call-template name="writeContactDetails">
				<xsl:with-param name="contextNode" select="$sectionRoot/p:ADDRESS_REVIEW_BODY" />
				<xsl:with-param name="displayContactPoints" select="false()" />
				<xsl:with-param name="displayURL" select="true()" />
				<xsl:with-param name="nationalId" select="false()"/>
				<xsl:with-param name="nutsCode" select="false()"/>
				<xsl:with-param name="marginLeft" select="'3mm'" />						
			</xsl:call-template>
		</fo:block-container>
		
		<fo:block-container keep-together.within-page="auto" margin-left="0mm" border-style="none">						
			<fo:block xsl:use-attribute-sets="h3" margin-left="3mm" font-weight="bold" text-transform="none" margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.body.mediation.procedures')" />
			</fo:block>
			<xsl:call-template name="writeContactDetails">
				<xsl:with-param name="contextNode" select="$sectionRoot/p:ADDRESS_MEDIATION_BODY" />
				<xsl:with-param name="displayContactPoints" select="false()" />
				<xsl:with-param name="displayURL" select="true()" />
				<xsl:with-param name="nationalId" select="false()"/>
				<xsl:with-param name="nutsCode" select="false()"/>		
				<xsl:with-param name="marginLeft" select="'3mm'" />						
			</xsl:call-template>
		</fo:block-container>	
		
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.rp.separator')" />
			</fo:block>
		
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.review.procedures')" />
			</fo:block>
			<xsl:call-template name="writeMultiLineData">
				<xsl:with-param name="multiLineData" select="$sectionRoot/p:REVIEW_PROCEDURE" />
			</xsl:call-template>
		</fo:block-container>
		
		<fo:block-container keep-together.within-page="auto" margin-left="0mm" border-style="none">			
			<fo:block xsl:use-attribute-sets="h3" margin-left="3mm" font-weight="bold" text-transform="none" margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.service')" />
			</fo:block>
			<xsl:call-template name="writeContactDetails">
				<xsl:with-param name="contextNode" select="$sectionRoot/p:ADDRESS_REVIEW_INFO" />
				<xsl:with-param name="displayContactPoints" select="false()" />
				<xsl:with-param name="displayURL" select="true()" />
				<xsl:with-param name="nationalId" select="false()"/>
				<xsl:with-param name="nutsCode" select="false()"/>			
				<xsl:with-param name="marginLeft" select="'3mm'" />
			</xsl:call-template>
		</fo:block-container>
		</xsl:if>

		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.date.dispatch')" />
		</fo:block>
	
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.date.of.dispatch')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:DATE_DISPATCH_NOTICE" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>
		</fo:block-container>
	</xsl:template>
	
	<xsl:template name="Section_ComplementaryInfo_CORRIGENDUM">
		<xsl:param name="sectionRoot" />
		<fo:block xsl:use-attribute-sets="h1">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.complementry_information.tooltip')" />
		</fo:block>
		
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.date.dispatch')" />
		</fo:block>
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.date.of.dispatch')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:DATE_DISPATCH_NOTICE" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>
		</fo:block-container>
		
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.onr.separator')" />
		</fo:block>
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.original_notice_sent_via')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.ted_esender')" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>

			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.ted_esender_login')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:ESENDER_LOGIN" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>
			<xsl:if test="$sectionRoot/p:CUSTOMER_LOGIN">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.ted_esnder_customer_login')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:CUSTOMER_LOGIN" />
					<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			</xsl:if>
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.original_notice_reference')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:NO_DOC_EXT" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>
			<xsl:if test="$sectionRoot/p:NOTICE_NUMBER_OJ">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.original_notice_number')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:NOTICE_NUMBER_OJ" />
					<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			</xsl:if>
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.original_notice_dispatch_date')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:DATE_DISPATCH_ORIGINAL" />
				<xsl:with-param name="marginLeft" select="'0mm'" />
			</xsl:call-template>
		</fo:block-container>
	</xsl:template>
</xsl:stylesheet>
