<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	version="2.0" xmlns:saxon="http://saxon.sf.net/" extension-element-prefixes="saxon">
	<!--
		In SAXON 8.3, only global variables can be marked as assignable. It'd be nice if local variables as assignable. Need to investigate further with SAXON.
	-->
	<xsl:template name="Section_LEFTI">
		<xsl:param name="sectionRoot" />
		<xsl:param name="PinType" />
		<xsl:param name="noticeType" />
		<xsl:param name="contractType" />
		
		<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">		
			<fo:block xsl:use-attribute-sets="h1">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_information.tooltip')" />
			</fo:block>
			<!--<xsl:if test="$noticeRoot/@CTYPE='WORKS'"> -->		
				<fo:block xsl:use-attribute-sets="h2">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation')" />
				</fo:block>
				<fo:block xsl:use-attribute-sets="h2">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.suitability.professional.activity')" />
					</fo:block>
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.list.brief.description.conditions')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:SUITABILITY" />
						<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
					</xsl:call-template>
				</fo:block-container>
			
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.economic.and.financial.standing')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.selection.criteria.procurement.documents')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:ECONOMIC_CRITERIA_DOC ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
																  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
				<xsl:if test="$sectionRoot/p:ECONOMIC_FINANCIAL_INFO|$sectionRoot/p:ECONOMIC_FINANCIAL_MIN_LEVEL">
					<fo:block xsl:use-attribute-sets="h3">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.Economic.financial.standing.list.brief.description.selection.criteria')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:ECONOMIC_FINANCIAL_INFO" />
						<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
					</xsl:call-template>
					<fo:block xsl:use-attribute-sets="h3">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.minimum.level.of.standards')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:ECONOMIC_FINANCIAL_MIN_LEVEL" />
						<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
					</xsl:call-template>
				</xsl:if>
			</fo:block-container>
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.technical.professional.ability')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.selection.criteria.procurement.documents')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:TECHNICAL_CRITERIA_DOC ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
																  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
				<xsl:if test="$sectionRoot/p:TECHNICAL_PROFESSIONAL_INFO|$sectionRoot/p:TECHNICAL_PROFESSIONAL_MIN_LEVEL">
					<fo:block xsl:use-attribute-sets="h3">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.Economic.financial.standing.list.brief.description.selection.criteria')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:TECHNICAL_PROFESSIONAL_INFO" />
						<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
					</xsl:call-template>
					<fo:block xsl:use-attribute-sets="h3">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.minimum.level.of.standards')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:TECHNICAL_PROFESSIONAL_MIN_LEVEL" />
						<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
					</xsl:call-template>
				</xsl:if>
			</fo:block-container>
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.information.reserved.contracts')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.the.contract.is.restricted')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:RESTRICTED_SHELTERED_WORKSHOP ) then 													messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
					else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
				<fo:block xsl:use-attribute-sets="h3">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.the.execution.of.the.contract')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:RESTRICTED_SHELTERED_PROGRAM ) then 													messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
					else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
			</fo:block-container>
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.relating.to.contract')" />
			</fo:block>
			<xsl:if test="$contractType = 'SERVICES'">
				<fo:block xsl:use-attribute-sets="h2">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.information.particular.profession')" />
				</fo:block>
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.execution.particular.profession')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PARTICULAR_PROFESSION ) then 													messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
						else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
					</xsl:call-template>
					<xsl:if test="$sectionRoot/p:PARTICULAR_PROFESSION">
						<fo:block xsl:use-attribute-sets="h3">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.main.financing.conditions')" />
						</fo:block>
						<xsl:call-template name="writeMultiLineData">
							<xsl:with-param name="multiLineData" select="$sectionRoot/p:REFERENCE_TO_LAW" />
							<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
						</xsl:call-template>
					</xsl:if>
				</fo:block-container>
			</xsl:if>
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.contract.performance.conditions', 'III.2.2')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.contract.performance.conditions', '')" />
				</fo:block>
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="$sectionRoot/p:PERFORMANCE_CONDITIONS" />
					<xsl:with-param name="numEmptyLinesIfBlank" select="3" />
				</xsl:call-template>
			</fo:block-container>
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.information.responsible.performance.contract')" />
			</fo:block>
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.lefti.conditions.for.participation.professional.qualifications.performing.contract')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PERFORMANCE_STAFF_QUALIFICATION ) then 													messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
					else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>
