<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	version="2.0" xmlns:saxon="http://saxon.sf.net/" xmlns:emptoris-ojeu="http://www.emptoris.com/sourcing/ojeu"  extension-element-prefixes="saxon">
	<!--
		In SAXON 8.3, only global variables can be marked as assignable. It'd be nice if local variables as assignable. Need to investigate further with SAXON.
	-->
	<xsl:template name="Section_Procedure_PRIOR_INFORMATION">
		<xsl:param name="sectionRoot" />
		<xsl:param name="PinType" />	
		<xsl:param name="noticeType" />
		<xsl:param name="contractType" />		
		<xsl:call-template name="Section_Procedure_CONTRACT" >
			<xsl:with-param name="sectionRoot" select="$sectionRoot" />
			<xsl:with-param name="PinType" select="$PinType" />
			<xsl:with-param name="noticeType" select="$noticeType" />	
			<xsl:with-param name="contractType" select="$contractType" />		
		</xsl:call-template>			
	</xsl:template> 
	
	<xsl:template name="Section_Procedure_CONTRACT">
		<xsl:param name="sectionRoot" />
		<xsl:param name="PinType" />	
		<xsl:param name="noticeType" />
		<xsl:param name="contractType" />	

			<fo:block xsl:use-attribute-sets="h1">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_procedure')" />
			</fo:block>		

		<xsl:if test="($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.procedure.types')" />
			</fo:block>		

			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.type_of_procedure')" />
				</fo:block>

				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_RESTRICTED ) then messageLocalizer:convertLiteral($locale,'ProcedureType.restricted')
								else if ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION)then messageLocalizer:convertLiteral($locale,'ProcedureType.competitiveProcedureWithNegotiation')
								else if ($sectionRoot/p:PT_OPEN)then messageLocalizer:convertLiteral($locale,'ProcedureType.open')
								else if ($sectionRoot/p:PT_COMPETITIVE_DIALOGUE)then messageLocalizer:convertLiteral($locale,'ProcedureType.competitiveDialogue')
								else if ($sectionRoot/p:PT_INNOVATION_PARTNERSHIP)then messageLocalizer:convertLiteral($locale,'ProcedureType.innovationPartnership')
								else ''" />
				</xsl:call-template>
			<xsl:if test="($noticeType='CONTRACT') and (($sectionRoot/p:PT_OPEN) or ($sectionRoot/p:PT_RESTRICTED)or ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION))">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.contract_award.label.accelarated_procedure')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:ACCELERATED_PROC ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
														  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
				</xsl:call-template>
				<xsl:if test="$sectionRoot/p:ACCELERATED_PROC">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.contract_award.label.accelarated_procedure.justification')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:ACCELERATED_PROC" />
						<xsl:with-param name="marginLeft" select="'0mm'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:if>
			</fo:block-container>	
		</xsl:if>
		
		<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.framework.agreement')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
			
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.framework.agreement.establishment')" />
				</fo:block>

				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:FRAMEWORK ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
				</xsl:call-template>
			<xsl:if test="$sectionRoot/p:FRAMEWORK">
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:FRAMEWORK/p:SINGLE_OPERATOR ) then messageLocalizer:convertLiteral($locale,'form.terminology.procedure.framework.agreement.singleOperator')
								else if ($sectionRoot/p:FRAMEWORK/p:SEVERAL_OPERATORS)then messageLocalizer:convertLiteral($locale,'form.terminology.procedure.framework.agreement.multiOperator')
								else ''" />
				</xsl:call-template>
				<xsl:if test="$sectionRoot/p:FRAMEWORK/p:SEVERAL_OPERATORS">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.framework.agreement.maxNumberofParticipient')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="$sectionRoot/p:FRAMEWORK/p:NB_PARTICIPANTS" />
					</xsl:call-template>
				</xsl:if>
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.framework.agreement.justification.exceedfouryears')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:FRAMEWORK/p:JUSTIFICATION" />
				</xsl:call-template>
			</xsl:if>
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.dynamic.purchasing')" />
			</fo:block>

			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:DPS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
							else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
			</xsl:call-template>
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.dynamic.additional.purchasers')" />
			</fo:block>

			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:DPS_ADDITIONAL_PURCHASERS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
							else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
			</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($noticeType='CONTRACT') and (($sectionRoot/p:PT_COMPETITIVE_DIALOGUE) or ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION) or ($sectionRoot/p:PT_INNOVATION_PARTNERSHIP))">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.reduction.solution')" />
			</fo:block>	
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.detail.info.reduction.solution')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:REDUCTION_RECOURSE ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
							else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($noticeType='CONTRACT') and ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION)">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.negotiation')" />
			</fo:block>	
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.detail.reserve.right.negotiation')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:RIGHT_CONTRACT_INITIAL_TENDERS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
							else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.electronic.auction')" />
			</fo:block>		

			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.selection.electronic.auction')" />
				</fo:block>

				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:EAUCTION_USED ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
																  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
				</xsl:call-template>
				<xsl:if test="$sectionRoot/p:EAUCTION_USED">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.label.electronic_auction_addl_info')" />
					</fo:block>

					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:INFO_ADD_EAUCTION" />
						<xsl:with-param name="marginLeft" select="'0mm'" />
					</xsl:call-template>
				</xsl:if>
			</fo:block-container>
		</xsl:if>
		
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.info.gpa')" />
		</fo:block>		

		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.info.gpa.label')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:CONTRACT_COVERED_GPA ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
												  else if ($sectionRoot/p:NO_CONTRACT_COVERED_GPA)then messageLocalizer:convertLiteral($locale,'form.terminology.button.no')
												  else ''" />
			</xsl:call-template>
		</fo:block-container>
		
		
		<xsl:if test="($noticeType='CONTRACT')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="concat( 'IV.2 ', messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.administrative_info') )" />
			</fo:block>	
						
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'IV.2.1) Previous publication concerning this procedure')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.contract_award.header.notice.number.ojs')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:NOTICE_NUMBER_OJ"/>
				</xsl:call-template>
			</fo:block-container>
			
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.receipt.tender.participate')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.receipt.tender.participate.label')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="concat($sectionRoot/p:DATE_RECEIPT_TENDERS, ' ', $sectionRoot/p:TIME_RECEIPT_TENDERS)"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		
		<xsl:if test="($PinType='PRI_CALL_COMPETITION')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="concat( 'IV.2 ', messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.administrative_info') )" />
			</fo:block>	
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.receipt.expressionof.interest')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.receipt.expressionof.interest.label')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="concat($sectionRoot/p:DATE_RECEIPT_TENDERS, ' ', $sectionRoot/p:TIME_RECEIPT_TENDERS)"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($noticeType='CONTRACT') and (($sectionRoot/p:PT_RESTRICTED)or ($sectionRoot/p:PT_COMPETITIVE_DIALOGUE) or ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION) or ($sectionRoot/p:PT_INNOVATION_PARTNERSHIP))">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.estimateddate.dispatch')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.detail.estimateddate.dispatch')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:DATE_DISPATCH_INVITATIONS"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($PinType='PRI_CALL_COMPETITION')or ($noticeType='CONTRACT')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.tender_languages')" />
			</fo:block>	
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.tender_languages_label')" />
				</fo:block>
				<xsl:variable name="languages" select="$sectionRoot/p:LANGUAGES/p:LANGUAGE/@DESCRIPTION" />
				<xsl:if test="$languages">
					<xsl:for-each select="$languages">
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="data(.)" />
						</xsl:call-template>
					</xsl:for-each>
				</xsl:if>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($PinType='PRI_REDUCING_TIME_LIMITS')or ($PinType='PRI_CALL_COMPETITION')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.schedule.startdate')" />
			</fo:block>	
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.schedule.startdate_label')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:DATE_AWARD_SCHEDULED"/>
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($noticeType='CONTRACT')">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.label.Minimum_term_duration')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<xsl:if test="$sectionRoot/p:DATE_TENDER_VALID">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.label.tender_valid_untill')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="$sectionRoot/p:DATE_TENDER_VALID"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:if test="$sectionRoot/p:DURATION_TENDER_VALID">			
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.label.tender_time_duration.inmonths')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="concat($sectionRoot/p:DURATION_TENDER_VALID, 'Months')"/>
				</xsl:call-template>
			</xsl:if>
			<fo:block xsl:use-attribute-sets="h3" >
					<xsl:value-of select="''" />
			</fo:block>
			</fo:block-container>
		</xsl:if>
		
		<xsl:if test="($noticeType='CONTRACT') and ($sectionRoot/p:PT_OPEN)">
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.conditions_for_open_tenders')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.label.tender_open_date')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="concat($sectionRoot/p:OPENING_CONDITION/p:DATE_OPENING_TENDERS, ' ', $sectionRoot/p:OPENING_CONDITION/p:TIME_OPENING_TENDERS)"/>
				</xsl:call-template>
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.label.tender_open_place')" />
				</fo:block>
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="$sectionRoot/p:OPENING_CONDITION/p:PLACE"/>
				<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.conditions_for_open_tenders.authorised.person')" />
				</fo:block>
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="$sectionRoot/p:OPENING_CONDITION/p:INFO_ADD"/>
				<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			</fo:block-container>
		</xsl:if>
	</xsl:template>	

	<xsl:template name="Section_Procedure_CONTRACT_AWARD">
		<xsl:param name="sectionRoot" />
		<xsl:param name="PinType" />	
		<xsl:param name="noticeType" />
		<xsl:param name="contractType" />		

			<fo:block xsl:use-attribute-sets="h1">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_procedure')" />
			</fo:block>
			
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.procedure.types')" />
			</fo:block>		

			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.type_of_procedure')" />
				</fo:block>

				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_RESTRICTED ) then messageLocalizer:convertLiteral($locale,'ProcedureType.restricted')
								else if ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION)then messageLocalizer:convertLiteral($locale,'ProcedureType.competitiveProcedureWithNegotiation')
								else if ($sectionRoot/p:PT_OPEN)then messageLocalizer:convertLiteral($locale,'ProcedureType.open')
								else if ($sectionRoot/p:PT_COMPETITIVE_DIALOGUE)then messageLocalizer:convertLiteral($locale,'ProcedureType.competitiveDialogue')
								else if ($sectionRoot/p:PT_INNOVATION_PARTNERSHIP)then messageLocalizer:convertLiteral($locale,'ProcedureType.innovationPartnership')
								else if ($sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL)then messageLocalizer:convertLiteral($locale,'ProcedureType.contractAwardWithoutPriorPublication')
								else ''" />
				</xsl:call-template>
			<xsl:if test="($sectionRoot/p:PT_OPEN) or ($sectionRoot/p:PT_RESTRICTED)or ($sectionRoot/p:PT_COMPETITIVE_NEGOTIATION)">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.contract_award.label.accelarated_procedure')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:ACCELERATED_PROC ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
														  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
				</xsl:call-template>
				<xsl:if test="$sectionRoot/p:ACCELERATED_PROC">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.contract_award.label.accelarated_procedure.justification')" />
					</fo:block>
					<xsl:call-template name="writeMultiLineData">
						<xsl:with-param name="multiLineData" select="$sectionRoot/p:ACCELERATED_PROC" />
						<xsl:with-param name="marginLeft" select="'0mm'" />
					</xsl:call-template>
				</xsl:if>
			</xsl:if>
			</fo:block-container>	

		
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.framework.agreement')" />
			</fo:block>		
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.framework.agreement.establishment')" />
				</fo:block>

				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:FRAMEWORK ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
								else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
				</xsl:call-template>
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.header.dynamic.purchasing')" />
			</fo:block>

			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:DPS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
							else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
			</xsl:call-template>
			</fo:block-container>

			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.electronic.auction')" />
			</fo:block>		

			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.selection.electronic.auction')" />
				</fo:block>

				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:EAUCTION_USED ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
																  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
				</xsl:call-template>
			</fo:block-container>

			
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.info.gpa')" />
		</fo:block>		

		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.procedure.header.info.gpa.label')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:CONTRACT_COVERED_GPA ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
												  else if ($sectionRoot/p:NO_CONTRACT_COVERED_GPA)then messageLocalizer:convertLiteral($locale,'form.terminology.button.no')
												  else ''" />
			</xsl:call-template>
		</fo:block-container>

		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="concat( 'IV.2 ', messageLocalizer:convertLiteral($locale,'form.WizNoticeProcudure.header.administrative_info') )" />
		</fo:block>	
					
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="messageLocalizer:convertLiteral($locale,'IV.2.1) Previous publication concerning this procedure')" />
		</fo:block>		
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.contract_award.header.notice.number.ojs')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="$sectionRoot/p:NOTICE_NUMBER_OJ"/>
			</xsl:call-template>
		</fo:block-container>
		
		

		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="concat( 'IV.2 ', messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.contract_award.header.info.termination.dynamic.purchase') )" />
		</fo:block>	
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.contract_award.detail.info.termination.dynamic.purchase')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:TERMINATION_DPS ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
																  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
			</xsl:call-template>
		</fo:block-container>
		
		<fo:block xsl:use-attribute-sets="h2">
			<xsl:value-of select="concat( 'IV.2 ', messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.contract_award.header.info.termination.cfc.pin') )" />
		</fo:block>	
		<fo:block-container xsl:use-attribute-sets="subSectionBox">
			<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_procedure.contract_award.detail.ca.award.basedonpin')" />
			</fo:block>
			<xsl:call-template name="writeSingleLineData">
				<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:TERMINATION_PIN ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
																  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')"/>
			</xsl:call-template>
		</fo:block-container>
	</xsl:template>
	
	
	<xsl:template name="Section_Procedure_AnnexD1">
		<xsl:param name="sectionRoot" />
		<xsl:param name="contractType" />
		
			<fo:block xsl:use-attribute-sets="h1">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.noticetree.notice_AnnexD')" />
			</fo:block>
			
			<fo:block xsl:use-attribute-sets="h2" font-weight="bold">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.justification')" />
			</fo:block>	
			<xsl:if test="$sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE">
				<fo:block xsl:use-attribute-sets="h2">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.reason.for.choice')" />
				</fo:block>				

				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.reason.for.choice1')" />
					</fo:block>

					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
															  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.no.tenders')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_PROC_OPEN ) then messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.open.procedure')
															  else if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_PROC_RESTRICTED ) then  messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.restricted.procedure')
															  else ''" />
					</xsl:call-template>
					<xsl:if test="($contractType='SUPPLIES')">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.products.involved')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_MANUF_FOR_RESEARCH ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
															  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
						</xsl:call-template>
					</xsl:if>
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.works.goods.services')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_TECHNICAL ) then messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.technical')
															  else if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_ARTISTIC ) then  messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.artistic')
															  else if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_PROTECT_RIGHTS ) then  messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.connected')
															  else ''" />
					</xsl:call-template>
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.extreme.urgency')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_EXTREME_URGENCY ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
														  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.additional.works')" />
					</fo:block>
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_ADD_DELIVERIES_ORDERED ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
														  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
					<xsl:if test="($contractType='WORKS') or ($contractType='SERVICES') ">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.new.works.services')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_REPETITION_EXISTING ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
															  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="($contractType='SERVICES') ">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.service.contract.awarded')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_CONTRACT_AWARDED_DESIGN_CONTEST ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
															  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="($contractType='SUPPLIES') ">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.supplies.from.commodity.market')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_COMMODITY_MARKET ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
															  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
						</xsl:call-template>
					</xsl:if>
					<xsl:if test="($contractType='SUPPLIES') or ($contractType='SERVICES') ">
						<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
							<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.advantangeous.purchase.term')" />
						</fo:block>
						<xsl:call-template name="writeSingleLineData">
							<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_FROM_WINDING_PROVIDER ) then messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.supplier.winding.up')
																  else if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_ACCORDANCE_ARTICLE/p:D_FROM_LIQUIDATOR_CREDITOR ) then  messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.arrangement.with.creditors')
																  else ''" />
						</xsl:call-template>
					</xsl:if>
				</fo:block-container>
			</xsl:if>
			
			<xsl:if test="$sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_OUTSIDE_SCOPE">
				<fo:block xsl:use-attribute-sets="h2">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.order.justification')" />
				</fo:block>	
			
				<fo:block-container xsl:use-attribute-sets="subSectionBox">
					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.order.justification1')" />
					</fo:block>

					<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.contract.ouside.directive')" />
					</fo:block>
					
					<xsl:call-template name="writeSingleLineData">
						<xsl:with-param name="singleLineData" select="if( $sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_OUTSIDE_SCOPE ) then messageLocalizer:convertLiteral($locale,'form.terminology.button.yes')
															  else messageLocalizer:convertLiteral($locale,'form.terminology.button.no')" />
					</xsl:call-template>
				</fo:block-container>
			</xsl:if>
			<fo:block xsl:use-attribute-sets="h2">
				<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.explaination')" />
			</fo:block>	
			<fo:block-container xsl:use-attribute-sets="subSectionBox">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
					<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.annexd.reason.contract.lawful')" />
				</fo:block>
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="$sectionRoot/p:PT_AWARD_CONTRACT_WITHOUT_CALL/p:D_JUSTIFICATION" />
					<xsl:with-param name="marginLeft" select="'0mm'" />
				</xsl:call-template>
			
			</fo:block-container>
	</xsl:template>
</xsl:stylesheet>
