<!--
 (C) COPYRIGHT International Business Machines Corp. 2012, 2016. All Rights Reserved
  US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
-->
<xsl:stylesheet xmlns:p="ted/R2.0.9.S02/reception" xmlns:n2016="ted/2016/nuts" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:messageLocalizer="java:com.emptoris.app.ojeu.integration.PDFMessageLocalizer"
	xmlns:xs="http://www.w3.org/2001/XMLSchema" xmlns:emptoris-ojeu="http://www.emptoris.com/sourcing/ojeu" version="2.0" xmlns:saxon="http://saxon.sf.net/"
	extension-element-prefixes="saxon" >
	<xsl:output method="xml" encoding="UTF-8" />
	<xsl:param name="locale" />

	<!--
		FO Style for top level header. 
	 -->
	<xsl:attribute-set name="standard-border">
		<xsl:attribute name="border-style" select="'solid'" />
	</xsl:attribute-set>
	
	<xsl:attribute-set name="border-bottom">
		<xsl:attribute name="border-bottom-style" select="'solid'" />
	</xsl:attribute-set>	

	<xsl:attribute-set name="border-top">
		<xsl:attribute name="border-top-style" select="'solid'" />
	</xsl:attribute-set>	
	
	<xsl:attribute-set name="fontSize1">
		<xsl:attribute name="font-size" select="'13pt'" />
	</xsl:attribute-set>

	<xsl:attribute-set name="fontSize2">
		<xsl:attribute name="font-size" select="'12pt'" />
	</xsl:attribute-set>

	<xsl:attribute-set name="fontSize3">
		<xsl:attribute name="font-size" select="'11pt'" />
	</xsl:attribute-set>

	<xsl:attribute-set name="fontSize4">
		<xsl:attribute name="font-size" select="'10pt'" />
	</xsl:attribute-set>

	<xsl:attribute-set name="fontSize5">
		<xsl:attribute name="font-size" select="'9pt'" />
	</xsl:attribute-set>

	<xsl:attribute-set name="h1" use-attribute-sets="fontSize1">
		<xsl:attribute name="margin-left" select="'3mm'" />
		<xsl:attribute name="font-weight" select="'bold'" />
		<xsl:attribute name="text-transform" select="'uppercase'" />
		<xsl:attribute name="border-style" select="'none'" />
		<xsl:attribute name="font-family" select="'LinLibertine_RB'" />				
	</xsl:attribute-set>

	<xsl:attribute-set name="h2" use-attribute-sets="h1 fontSize2">
		<xsl:attribute name="margin-top" select="'3mm'" />
		<xsl:attribute name="margin-left" select="'3mm'" />
		<xsl:attribute name="font-weight" select="'normal'" />
		<xsl:attribute name="border-style" select="'none'" />		
	</xsl:attribute-set>

	<xsl:attribute-set name="h3" use-attribute-sets="h2 fontSize2">
		<xsl:attribute name="margin-left" select="'0mm'" />
		<xsl:attribute name="text-transform" select="'none'" />
		<xsl:attribute name="font-weight" select="'bold'" />
		<xsl:attribute name="border-style" select="'none'" />		
	</xsl:attribute-set>

	<xsl:attribute-set name="h4" use-attribute-sets="h3 fontSize4">
		<xsl:attribute name="margin-left" select="'12mm'" />
		<xsl:attribute name="text-transform" select="'none'" />
		<xsl:attribute name="border-style" select="'none'" />		
	</xsl:attribute-set>

	<xsl:attribute-set name="nonBold" use-attribute-sets="h3">
		<xsl:attribute name="font-weight" select="'normal'" />
		<xsl:attribute name="margin-top" select="'1mm'" />
		<xsl:attribute name="font-family" select="'LinLibertine_R'" />
	</xsl:attribute-set>

	<xsl:attribute-set name="subSectionBox" use-attribute-sets="h2 standard-border">
		<xsl:attribute name="text-transform" select="'none'" />
		<xsl:attribute name="keep-together.within-page" select="'auto'" />
		<xsl:attribute name="margin-bottom" select="'3mm'" />
		<xsl:attribute name="margin-top" select="'3mm'" />
	</xsl:attribute-set>

	<xsl:variable name="relativeXPaths" select="()" saxon:assignable="yes" />
	<xsl:variable name="resourceBundleKeys" select="()" saxon:assignable="yes" />

	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-ContractingAuthority.xsl" />
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-ObjectOfContract.xsl" />
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-LEFTI.xsl" />
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-Procedure.xsl" />
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-ComplementaryInfo.xsl" />
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-AnnexA.xsl" />	
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-AwardOfContract.xsl" />
	<xsl:include href="com/emptoris/app/ojeu/integration/NoticeToPDF-fop-Changes.xsl" />

	<!--
		In SAXON 8.3, only global variables can be marked as assignable. It'd be nice if local variables as assignable. Need to investigate further with SAXON.
	-->
	<xsl:template match="/">
		<xsl:variable name="dispatchDate" select="//NOTICE_DISPATCH_DATE" />
		<fo:root>
			<fo:layout-master-set>
				<!-- This page master is for first page only which contains header -->
				<fo:simple-page-master master-name="A4" page-width="210mm" page-height="297mm" margin="5mm">
					<fo:region-body margin-top="40mm" margin-left="5mm" margin-right="5mm" margin-bottom="20mm" />
					<fo:region-before region-name="header-first-page" extent="20mm" />
					<fo:region-after extent="10mm" />
					<fo:region-start extent="10mm" />
					<fo:region-end extent="10mm" />
				</fo:simple-page-master>
				<!-- This page master is for rest of the pages which does not contain header -->
				<fo:simple-page-master master-name="A4-without-header" page-width="210mm" page-height="297mm" margin="5mm">
					<fo:region-body margin-top="10mm" margin-left="5mm" margin-right="5mm" margin-bottom="20mm" />
					<fo:region-before region-name="header-rest-pages" extent="30mm" />
					<fo:region-after extent="10mm" />
					<fo:region-start extent="10mm" />
					<fo:region-end extent="10mm" />
				</fo:simple-page-master>	
				<!-- This master tells when to use which page master -->
			    <fo:page-sequence-master master-name="document">
			      <fo:repeatable-page-master-alternatives>
			        <fo:conditional-page-master-reference page-position="first" master-reference="A4"/>
			        <fo:conditional-page-master-reference page-position="rest" master-reference="A4-without-header"/>
			      </fo:repeatable-page-master-alternatives>
			    </fo:page-sequence-master>							
			</fo:layout-master-set>
			
			<!-- master-referece is set to page-sequence-master which has setting of conditional master-referece -->
			<fo:page-sequence master-reference="document" initial-page-number="1" id="page-sequence-1">
				<!--
					<fo:flow flow-name="xsl-region-before"> <fo:block font-size="16pt" font-family="sans-serif" line-height="normal" text-align="start" color="blue"> This is a
					place holder for the header of the page. This will be like a letter head may be an image or some text with the image in the background. </fo:block>
					</fo:flow>
					This is the header which is used only for first page
				-->
				<fo:static-content flow-name="header-first-page">
					<fo:block>
						<fo:external-graphic src="{p:TED_ESENDERS/p:ICON_FILE_PATH}" content-width="80px" content-height="35px" />
					</fo:block>
					<fo:block margin-left="30mm" font-size="9pt" text-transform="uppercase">european union</fo:block>
					<fo:block margin-left="30mm" font-size="9pt">Publication of Supplement to the Official Journal of European Union</fo:block>
					<fo:table table-layout="fixed" width="140mm" margin-left="30mm">
						<fo:table-column column-width="60mm" />
						<fo:table-column column-width="80mm" />
						<fo:table-body font-size="9pt">
							<fo:table-row>
								<fo:table-cell margin-left="0mm">
									<fo:block>2, rue Mercier, L-2985 Luxembourg</fo:block>
								</fo:table-cell>
								<fo:table-cell margin-left="0mm">
									<fo:block>Fax: (352) 29 29 42 670</fo:block>
								</fo:table-cell>
							</fo:table-row>
							<fo:table-row>
								<fo:table-cell margin-left="0mm">
									<fo:block>Email: sourcing@emptoris.com </fo:block>
								</fo:table-cell>
								<fo:table-cell margin-left="0mm">
									<fo:block>Info &amp; online forms: http://sourcing.emptoris.com</fo:block></fo:table-cell>
							</fo:table-row>							
						</fo:table-body>
					</fo:table>
				</fo:static-content>
				<!-- This is the header having no data, used for rest of the pages -->
				<fo:static-content flow-name="header-rest-pages">
					<fo:block text-align-last="center"></fo:block>
				</fo:static-content>
				<fo:static-content flow-name="xsl-region-after">
					<fo:block font-size="8pt" text-align="center">
						<fo:page-number /> / <fo:page-number-citation-last ref-id="page-sequence-1" />
					</fo:block>
				</fo:static-content>
				<fo:flow flow-name="xsl-region-body">
					<xsl:variable name="xmlRoot" select="/" /> <!-- document -->
					<xsl:variable name="firstLevelNodes" select="/*" /><!-- result ted senders -->
					<xsl:variable name="childrenOfFirstNodeInFirstLevel" select="$firstLevelNodes[1]/*" /> <!--result sender and  form section  -->
					<xsl:variable name="formSection" select="$childrenOfFirstNodeInFirstLevel[2]" /> <!-- gets formsection element -->
					<xsl:variable name="noticeRoot" select="$formSection/*" /> <!-- F01_2014, F02_2014, F03_2014  -->
					
					<!--<xsl:variable name="sections" select="$noticeRoot/*" /> -->
					<!--<xsl:variable name="noticeRoot" select="$noticeRoot[1]" /> -->
					<fo:block text-align="center" font-size="14pt" font-weight="bold" text-transform="uppercase">
						<xsl:value-of
							select="
	  						if (/p:TED_ESENDERS/p:FORM_SECTION/p:F02_2014) then messageLocalizer:convertLiteral($locale,'NoticeType.contractNotice') 
	  						else if (/p:TED_ESENDERS/p:FORM_SECTION/p:F01_2014) then messageLocalizer:convertLiteral($locale,'NoticeType.priorInformationNotice')
	  						else if (/p:TED_ESENDERS/p:FORM_SECTION/p:F03_2014) then messageLocalizer:convertLiteral($locale,'NoticeType.contractAwardNotice')
							else messageLocalizer:convertLiteral($locale,'NoticeType.corrigendumNotice')" />
					</fo:block>
					<fo:block text-align="center" font-size="14pt" font-weight="bold" >
						<xsl:value-of
							select="
	  						if ($noticeRoot/p:NOTICE/@TYPE = 'PRI_ONLY') then messageLocalizer:convertLiteral($locale,'PriorInformationNoticeType.noticeForPriorInfo') 
	  						else if ($noticeRoot/p:NOTICE/@TYPE = 'PRI_REDUCING_TIME_LIMITS') then messageLocalizer:convertLiteral($locale,'PriorInformationNoticeType.noticeForReducingLimits')
							else if ($noticeRoot/p:NOTICE/@TYPE = 'PRI_CALL_COMPETITION') then messageLocalizer:convertLiteral($locale,'PriorInformationNoticeType.noticeForCompetition')
	  						else ''" />
					</fo:block>
					<fo:block text-align="center" font-size="12pt" font-weight="bold" >
						<xsl:value-of
							select="
	  						if (/p:TED_ESENDERS/p:FORM_SECTION/p:F14_2014) then messageLocalizer:convertLiteral($locale,'corrigendum.changes.pdf.header') 
	  						else ''" />
					</fo:block>
					<fo:block text-align="center" font-size="12pt" font-weight="bold" >
						 <xsl:value-of select="$noticeRoot/@NAME" />
					</fo:block>
					<fo:block text-align="center" font-size="12pt">
						<xsl:value-of
							select="messageLocalizer:convertLiteral($locale,'ojeu.notice.pdf.common.directive')" />
					</fo:block>
					<fo:block text-align="left" margin-left="3mm" margin-right="3mm" font-size="11pt" font-style="italic" margin-top="3mm">
						<xsl:value-of
							select="if (/p:TED_ESENDERS/p:FORM_SECTION/p:F14_2014) then messageLocalizer:convertLiteral($locale,'corrigendum.changes.pdf.header.reminder') 
	  						else ''" />
					</fo:block>
					
					<fo:block text-align="center" font-size="12pt" font-weight="bold" text-transform="capitalize" margin-top="3mm"
						margin-bottom="3mm">
						<!-- <xsl:value-of
							select="
	  						if ( $noticeRoot/@CTYPE = 'WORKS' ) then messageLocalizer:convertLiteral($locale,'ContractType.works')
	  						else if ( $noticeRoot/@CTYPE = 'SERVICES' ) then messageLocalizer:convertLiteral($locale,'ContractType.services')
	  						else messageLocalizer:convertLiteral($locale,'ContractType.supplies')" /> -->
					</fo:block>
					
						<!--  Get all the nodes in their respective order -->
					<xsl:variable name="sections" select="$noticeRoot/*" />	
										
					<!--<xsl:variable name="noticeType" select="substring(local-name($noticeRoot),4)" /> -->
					<xsl:variable name="noticeType" select="if ( /p:TED_ESENDERS/p:FORM_SECTION/p:F01_2014 ) then 'PRIOR_INFORMATION'
															else if ( /p:TED_ESENDERS/p:FORM_SECTION/p:F02_2014 ) then 'CONTRACT' 
															else if ( /p:TED_ESENDERS/p:FORM_SECTION/p:F03_2014 ) then 'CONTRACT_AWARD'
															else 'CORRIGENDUM'" />
					
					<xsl:variable name="contractingAuthority" select="$noticeRoot/p:CONTRACTING_BODY" />	
					<xsl:variable name="objectOfContract" select="$noticeRoot/p:OBJECT_CONTRACT" />					
					<xsl:variable name="lefti" select="$noticeRoot/p:LEFTI" />
					<xsl:variable name="procedure" select="$noticeRoot/p:PROCEDURE" />
					<xsl:variable name="complementaryInfo" select="$noticeRoot/p:COMPLEMENTARY_INFO" />
					<xsl:variable name="contractsAwarded" select="$noticeRoot/p:AWARD_CONTRACT" />
					<xsl:variable name="changes" select="$noticeRoot/p:CHANGES" />
					
					<xsl:variable name="procedureType" select="if ( $procedure/PT_OPEN ) then 'OPEN'
															else if ( $procedure/PT_RESTRICTED ) then 'RESTRICTED'
															else if ( $procedure/PT_COMPETITIVE_DIALOGUE ) then 'COMPETITIVE_DIALOGUE'		
															else if ( $procedure/PT_COMPETITIVE_NEGOTIATION ) then 'COMPETITIVE_NEGOTIATION'
															else if ( $procedure/PT_INNOVATION_PARTNERSHIP ) then 'INNOVATION_PARTNERSHIP'
															else if ( $procedure/PT_AWARD_CONTRACT_WITHOUT_CALL ) then 'AWARD_CONTRACT_WITHOUT_CALL'
															else ''" />
					
					<fo:block-container break-after="page"> 
						<saxon:call-template name="Section_ContractingAuthority" >
							<xsl:with-param name="sectionRoot" select="$contractingAuthority" />
							<xsl:with-param name="PinType" select="$noticeRoot/p:NOTICE/@TYPE" />
							<xsl:with-param name="noticeType" select="$noticeType" />
							<xsl:with-param name="noticeRoot" select="$noticeRoot" />								
						</saxon:call-template>
					</fo:block-container>
					
					<xsl:if test="$objectOfContract" >
					<!--<fo:block-container break-after="page"> -->
					<saxon:call-template name="Section_ObjectOfContract" >
						<xsl:with-param name="sectionRoot" select="$objectOfContract" />
						<xsl:with-param name="PinType" select="$noticeRoot/p:NOTICE/@TYPE" />
						<xsl:with-param name="noticeType" select="$noticeType" />
						<xsl:with-param name="contractType" select="$noticeRoot/p:OBJECT_CONTRACT/p:TYPE_CONTRACT/@CTYPE" />	
						<xsl:with-param name="procedureType" select="$procedureType" />						
					</saxon:call-template> 
					<!--</fo:block-container> -->
					</xsl:if>
					
					<xsl:if test="$lefti" >
						<fo:block-container break-after="page">								
							<saxon:call-template name="Section_LEFTI" >
								<xsl:with-param name="sectionRoot" select="$lefti" />
								<xsl:with-param name="PinType" select="$noticeRoot/p:NOTICE/@TYPE" />
								<xsl:with-param name="noticeType" select="$noticeType" />
								<xsl:with-param name="contractType" select="$noticeRoot/p:OBJECT_CONTRACT/p:TYPE_CONTRACT/@CTYPE" />
							</saxon:call-template>
						</fo:block-container>
					</xsl:if>
					
					<xsl:if test="$procedure" >
						<fo:block-container break-after="page">								
							<saxon:call-template name="{concat('Section_Procedure_',$noticeType)}" >
								<xsl:with-param name="sectionRoot" select="$procedure" />
								<xsl:with-param name="PinType" select="$noticeRoot/p:NOTICE/@TYPE" />
								<xsl:with-param name="noticeType" select="$noticeType" />
								<xsl:with-param name="contractType" select="$noticeRoot/p:OBJECT_CONTRACT/p:TYPE_CONTRACT/@CTYPE" />
							</saxon:call-template>
						</fo:block-container>	
					</xsl:if> 								
					
					<xsl:if test="$contractsAwarded">
						<fo:block-container break-after="page">
							<saxon:call-template name="Section_AwardOfContract_CONTRACT_AWARD">
								<xsl:with-param name="noticeRoot" select="$noticeRoot"/>
								<xsl:with-param name="contractsAwarded" select="$contractsAwarded"/>
							</saxon:call-template>
						</fo:block-container>
					</xsl:if>
					
					 <xsl:if test="$complementaryInfo" >
						<fo:block-container break-after="page">								
							<saxon:call-template name="Section_ComplementaryInfo" >
								<xsl:with-param name="sectionRoot" select="$complementaryInfo" />
								<xsl:with-param name="PinType" select="$noticeRoot/p:NOTICE/@TYPE" />
								<xsl:with-param name="noticeType" select="$noticeType" />
							</saxon:call-template>
						</fo:block-container>	
					</xsl:if> 	

					<xsl:if test="$procedure/p:PT_AWARD_CONTRACT_WITHOUT_CALL" >
						<fo:block-container break-after="page">								
							<saxon:call-template name="Section_Procedure_AnnexD1" >
								<xsl:with-param name="sectionRoot" select="$procedure" />
								<xsl:with-param name="contractType" select="$noticeRoot/p:OBJECT_CONTRACT/p:TYPE_CONTRACT/@CTYPE" />
							</saxon:call-template>
						</fo:block-container>	
					</xsl:if>

					<xsl:if test="$changes" >
						<fo:block-container break-after="page">								
							<saxon:call-template name="Section_Changes" >
								<xsl:with-param name="sectionRoot" select="$changes" />
							</saxon:call-template>
						</fo:block-container>	
					</xsl:if>					
				</fo:flow>
			</fo:page-sequence>
		</fo:root>
	</xsl:template>
	
	<xsl:template name="writeSingleLineData" >
		<xsl:param name="singleLineData"/>
		<xsl:param name="marginTop" select="'1mm'" />
		<xsl:param name="marginBottom" select="'1mm'" />		
		<xsl:param name="marginLeft" />
		<xsl:param name="font" select="'LinLibertine_R'" />
		
		<xsl:variable name="nonEmptyData" select="$singleLineData and string-length($singleLineData) > 0" />		
		<xsl:if test="$nonEmptyData">
			<fo:block xsl:use-attribute-sets="nonBold" margin-top="{$marginTop}" margin-bottom="{$marginBottom}" font-family="{$font}">
				<xsl:if test="$marginLeft">
					<xsl:attribute name="margin-left" select="$marginLeft" />
				</xsl:if>
				<xsl:value-of select="$singleLineData" />
			</fo:block>
		</xsl:if>
		
		<xsl:if test="not($nonEmptyData)">
			<fo:block xsl:use-attribute-sets="nonBold" margin-top="{$marginTop}" margin-bottom="{$marginBottom}">
				<xsl:if test="$marginLeft">
					<xsl:attribute name="margin-left" select="$marginLeft" />
				</xsl:if>
				<fo:leader leader-length.minimum="100%" leader-pattern="use-content">_</fo:leader>
			</fo:block>
		</xsl:if>	
	</xsl:template>	
	
	<xsl:template name="writeMultiLineData" >
		<xsl:param name="multiLineData" />
		<xsl:param name="marginTopFirstLine" select="'1mm'" />
		<xsl:param name="marginTopOtherLines" select="'1mm'" />
		<xsl:param name="numEmptyLinesIfBlank" select="3" as="xs:integer"/>
		<xsl:param name="marginLeft" />
		
		
		<xsl:variable name="nonEmptyData" select="$multiLineData and (count($multiLineData/P) > 0 or string-length($multiLineData) > 0 )" />
		<xsl:if test="$nonEmptyData">
			<xsl:variable name="lines" select="
				if( count($multiLineData/P) > 0 ) then $multiLineData/P 
				else $multiLineData
			" />
			<xsl:for-each select="$lines">
				<fo:block xsl:use-attribute-sets="nonBold" margin-top="{if( position()=1 ) then $marginTopFirstLine else $marginTopOtherLines}">
					<xsl:if test="$marginLeft">
						<xsl:attribute name="margin-left" select="$marginLeft" />
					</xsl:if>
					<xsl:value-of select="data(.)" />
				</fo:block>
			</xsl:for-each>
		</xsl:if>
		
		<xsl:if test="not($nonEmptyData)">
			<xsl:for-each select="(1 to $numEmptyLinesIfBlank)" >
				<fo:block margin-top="{if( position()=1 ) then $marginTopFirstLine else $marginTopOtherLines}" margin-bottom="{if( position()=1 ) then $marginTopFirstLine else $marginTopOtherLines}">
					<xsl:if test="$marginLeft">
						<xsl:attribute name="margin-left" select="$marginLeft" />
					</xsl:if>
					<fo:leader leader-length.minimum="100%" leader-pattern="use-content">_</fo:leader>
				</fo:block>
			</xsl:for-each>	
		</xsl:if>	
	</xsl:template>
	
	<xsl:variable name="writeSimpleFieldsLabelAboveValueBelow.LoopIndex" select="1" saxon:assignable="yes" />
	<xsl:template name="writeSimpleFieldsLabelAboveValueBelow" >
		<xsl:param name="contextNode" />
		<xsl:param name="relativeXPaths" />
		<xsl:param name="resourceBundleKeys" />
		<xsl:param name="numEmptyLinesIfBlank" as="xs:integer*"/>
		<xsl:param name="marginLeft" />
		<xsl:param name="translateLabels" select="true()" />
		
		<xsl:for-each select="$relativeXPaths">
			<xsl:variable name="valueExpression" select="saxon:expression(concat('$p1/',data(.)))" />
			<xsl:variable name="value" select="saxon:eval($valueExpression,$contextNode)" />
			<xsl:variable name="position" select="position()" />
			<fo:block xsl:use-attribute-sets="h3" >
				<xsl:if test="$marginLeft">
					<xsl:attribute name="margin-left" select="$marginLeft" />
				</xsl:if>
				<xsl:value-of select="if( $translateLabels) then messageLocalizer:convertLiteral($locale,$resourceBundleKeys[$writeSimpleFieldsLabelAboveValueBelow.LoopIndex]) else $resourceBundleKeys[$writeSimpleFieldsLabelAboveValueBelow.LoopIndex]" />
			</fo:block>
			<xsl:if test="$marginLeft">
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="$value" />
					<xsl:with-param name="marginLeft" select="$marginLeft" />
					<xsl:with-param name="numEmptyLinesIfBlank" select="if($numEmptyLinesIfBlank[$position]) then $numEmptyLinesIfBlank[$position] else 3" />
				</xsl:call-template>
			</xsl:if>
			<xsl:if test="not($marginLeft)" >
				<xsl:call-template name="writeMultiLineData">
					<xsl:with-param name="multiLineData" select="$value" />
					<xsl:with-param name="numEmptyLinesIfBlank" select="if($numEmptyLinesIfBlank[$position]) then $numEmptyLinesIfBlank[$position] else 3" />					
				</xsl:call-template>
			</xsl:if>
			<saxon:assign name="writeSimpleFieldsLabelAboveValueBelow.LoopIndex" select="$writeSimpleFieldsLabelAboveValueBelow.LoopIndex + 1" />
		</xsl:for-each>
		<saxon:assign name="writeSimpleFieldsLabelAboveValueBelow.LoopIndex" select="1" />		
	</xsl:template> 
	
	<xsl:variable name="writeSimpleFieldsInTable.LoopIndex" select="1" saxon:assignable="yes" />
	<xsl:template name="writeSimpleFieldsInTable" >
		<xsl:param name="contextNode" />
		<xsl:param name="relativeXPaths" />
		<xsl:param name="resourceBundleKeys" />
		<xsl:param name="tableWidth" select="'180mm'" />
		<xsl:param name="tableMarginLeft" select="'10mm'" />
		<xsl:param name="tableMarginTop" select="'5mm'" />
		<xsl:param name="labelColumnWidth" select="'50mm'" />
		<xsl:param name="valueColumnWidth" select="'130mm'" />
		<xsl:param name="borderStyle" select="'none'" />
		<xsl:param name="borderColor" select="'grey'" />
		<xsl:param name="borderWidth" select="'0.2pt'" />
		
    <xsl:variable name="rowsPresent" select="some $x in $relativeXPaths satisfies saxon:eval(saxon:expression(concat('$p1/',$x)),$contextNode)" />
    <xsl:if test="$rowsPresent">
			<fo:table table-layout="fixed" width="{$tableWidth}" margin-left="{$tableMarginLeft}" margin-top="{$tableMarginTop}" border-style="{$borderStyle}" border-width="{$borderWidth}" border-color="{$borderColor}">
	      <fo:table-column column-width="{$labelColumnWidth}"/>
	      <fo:table-column column-width="{$valueColumnWidth}"/>
				<fo:table-body font-size="10pt">
				<xsl:for-each select="$relativeXPaths">
					<xsl:variable name="valueExpression" select="saxon:expression(concat('$p1/',data(.)))" />
					<xsl:if test="saxon:eval($valueExpression,$contextNode)" >
						<fo:table-row border-style="{$borderStyle}"  border-width="{$borderWidth}" border-color="{$borderColor}" margin-bottom="1mm" margin-right="0mm">
							<fo:table-cell border-style="{$borderStyle}"  border-width="{$borderWidth}"  border-color="{$borderColor}" text-align="justify" margin-right="1mm" padding-right="1mm" display-align="center" >
								<fo:block text-align="end" right="0mm" font-weight="bold" margin-top="1mm" margin-bottom="1mm"><xsl:value-of select="messageLocalizer:convertLiteral($locale,$resourceBundleKeys[$writeSimpleFieldsInTable.LoopIndex])" /></fo:block>
							</fo:table-cell>
							<fo:table-cell border-style="{$borderStyle}"  border-width="{$borderWidth}"  border-color="{$borderColor}" >
								<fo:block text-align="start" left="0mm" display-align="center" margin-top="1mm" margin-bottom="1mm"><xsl:value-of select="saxon:eval($valueExpression,$contextNode)" /></fo:block>
							</fo:table-cell>		
						</fo:table-row>
					</xsl:if>
					<saxon:assign name="writeSimpleFieldsInTable.LoopIndex" select="$writeSimpleFieldsInTable.LoopIndex + 1" />
				</xsl:for-each>
				</fo:table-body>
			</fo:table>
		</xsl:if>	
		<saxon:assign name="writeSimpleFieldsInTable.LoopIndex" select="1" />	
	</xsl:template>
	
	<xsl:template name="writeContactDetails"> 
		<xsl:param name="contextNode" />
		<xsl:param name="displayContactPoints" select="true()" />
		<xsl:param name="displayURL" select="false()"/>
		<xsl:param name="nationalId" select="true()"/>
		<xsl:param name="nutsCode" select="true()"/>
		<xsl:param name="showSME" select="false()"/>
		<xsl:param name="isSME" select="No"/>
		<xsl:param name="marginLeft" />
		<fo:table table-layout="fixed" xsl:use-attribute-sets="h2 fontSize3 standard-border" text-transform="none">
			<xsl:if test="$marginLeft">
				<xsl:attribute name="margin-left" select="$marginLeft" />
			</xsl:if>	
			<fo:table-column column-width="47mm"/>
			<fo:table-column column-width="47mm"/> 
			<fo:table-column column-width="47mm"/>
			<fo:table-column column-width="47mm"/>
			<fo:table-body>
				<fo:table-row xsl:use-attribute-sets="border-bottom">
					<fo:table-cell number-columns-spanned="{if($nationalId) then '3' else '4'}" padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.official.name')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:OFFICIALNAME" /></xsl:call-template>
					</fo:table-cell>
					<xsl:if test="$nationalId">	
						<fo:table-cell number-columns-spanned="1" padding-top="1mm" padding-bottom="1mm">
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.national.registration.number')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:NATIONALID" /></xsl:call-template>
						</fo:table-cell>
					</xsl:if>
				</fo:table-row>
				<fo:table-row xsl:use-attribute-sets="border-bottom">
					<fo:table-cell number-columns-spanned="4" padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.postal.address')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:ADDRESS" /></xsl:call-template>
					</fo:table-cell>
				</fo:table-row>				
				<fo:table-row xsl:use-attribute-sets="border-bottom">
					<fo:table-cell number-columns-spanned="{if($nutsCode) then '1' else '2'}" padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.town')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:TOWN" /></xsl:call-template>
					</fo:table-cell>
					<xsl:if test="$nutsCode">
						<fo:table-cell padding-top="1mm" padding-bottom="1mm">
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.nuts.code')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/n2016:NUTS/@CODE" /></xsl:call-template>
						</fo:table-cell>
					</xsl:if>	
					<fo:table-cell padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.postal.code')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:POSTAL_CODE" /></xsl:call-template>
					</fo:table-cell>
					<fo:table-cell padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.country')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:COUNTRY/@COUNTRY-NAME" /></xsl:call-template>
					</fo:table-cell>
				</fo:table-row>
				<fo:table-row xsl:use-attribute-sets="border-bottom">
					<xsl:if test="$displayContactPoints">
						<fo:table-cell number-columns-spanned="3" padding-top="1mm" padding-bottom="1mm">
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.contact.points')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:CONTACT_POINT" /></xsl:call-template>
						</fo:table-cell>
					</xsl:if>	
					<xsl:if test="not($displayContactPoints)">
						<fo:table-cell number-columns-spanned="3" padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.email')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:E_MAIL" /></xsl:call-template>
						</fo:table-cell>
					</xsl:if>
					<fo:table-cell number-columns-spanned="1" padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.telephone')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:PHONE" /></xsl:call-template>
					</fo:table-cell>
					
				</fo:table-row>								
				<fo:table-row xsl:use-attribute-sets="border-bottom">
					<fo:table-cell number-columns-spanned="3" padding-top="1mm" padding-bottom="1mm">
						<xsl:if test="$displayContactPoints">
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.email')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:E_MAIL" /></xsl:call-template>
						</xsl:if>
						<xsl:if test="$displayURL">
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz.ojeu.compinfo.ia')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:URL" /></xsl:call-template>
						</xsl:if>
					</fo:table-cell>
					<fo:table-cell number-columns-spanned="1" padding-top="1mm" padding-bottom="1mm">
						<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.fax')" /></fo:block>
						<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:FAX" /></xsl:call-template>
					</fo:table-cell>
				</fo:table-row>	
				<xsl:if test="not($displayURL)">
					<fo:table-row>
						<fo:table-cell number-columns-spanned="4" padding-top="1mm" padding-bottom="1mm">
							<fo:block font-size="13pt" font-weight="bold" ><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.internet.address')" /></fo:block>
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.url')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:URL_GENERAL" /></xsl:call-template>
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.wiz_notice_annexa.header.notice.buyer.url')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$contextNode/p:URL_BUYER" /></xsl:call-template>
						</fo:table-cell>
					</fo:table-row>		
				</xsl:if>
				<xsl:if test="$showSME">
					<fo:table-row>
						<fo:table-cell number-columns-spanned="4" padding-top="1mm" padding-bottom="1mm">
							<fo:block font-weight="bold"><xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.contract_award.hdr.contractor.is.an.sme')" /></fo:block>
							<xsl:call-template name="writeSingleLineData"><xsl:with-param name="singleLineData" select="$isSME" /></xsl:call-template>
						</fo:table-cell>
					</fo:table-row>	
				</xsl:if>				
			</fo:table-body>
		</fo:table>
	</xsl:template>
	
	
	<xsl:function name="emptoris-ojeu:amount" as="xs:string">
		<xsl:param name="amountNode" />
		<xsl:variable name="returnValue" select="if( $amountNode/RANGE_VALUE_COST ) then
				messageLocalizer:convertLiteral($locale,'pdf.notice.amount.minMax.range.Closed',($amountNode/RANGE_VALUE_COST/LOW_VALUE,$amountNode/RANGE_VALUE_COST/HIGH_VALUE,$amountNode/@CURRENCY))
			else if ( $amountNode/VALUE_COST ) then 
				concat($amountNode/VALUE_COST,' ', $amountNode/@CURRENCY )
			else 
				''																			 
				" />
		<xsl:sequence select="$returnValue" />
	</xsl:function>
	
	<xsl:function name="emptoris-ojeu:amountIncludesVat" as="xs:string">
		<xsl:param name="amountNode" />
		<xsl:variable name="returnValue" select="emptoris-ojeu:amount($amountNode)"/>
		<xsl:variable name="includesVatStr" select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.contract_award.hdr.ini_esti_value_of_contract_includes_vat')"/>
		<xsl:variable name="excludesVatStr" select="messageLocalizer:convertLiteral($locale,'SubContractType.excludingVat')"/>
		<xsl:variable name="returnValueIncludesVat" select="(
			if( $amountNode/INCLUDING_VAT ) then
				concat( $returnValue, ' ', $includesVatStr, ' ', $amountNode/INCLUDING_VAT/VAT_PRCT, ' %')
			else
			if($returnValue != '' ) then
				concat( $returnValue, ' ',  $excludesVatStr)
			else
				''
		)"/>		
		
		<xsl:sequence select="$returnValueIncludesVat" />
	</xsl:function>			
	
	<xsl:template name="writeMainCPVAndVOCTable">
		<xsl:param name="cpvNode" />
		<!--<xsl:param name="headerTitle" select="messageLocalizer:convertLiteral($locale,'form.wiz_object_of_contract.cpv.value.header.pdf')"/> -->
		<!--<xsl:param name="mainCPVNode" select="$cpvNode" />-->

		<xsl:param name="tableWidth" select="'170mm'" />
		<xsl:param name="tableMarginLeft" select="'3mm'" />
		<xsl:param name="tableMarginTop" select="'0mm'" />
		<xsl:param name="labelColumnWidth" select="'20mm'" />
		<xsl:param name="cpvCodeColumnWidth" select="'30mm'" />
		<xsl:param name="cpvDescriptionColumnWidth" select="'45mm'" />
		<xsl:param name="vocCodeColumnWidth" select="'50mm'" />
		<xsl:param name="vocDescriptionColumnWidth" select="'55mm'" />
		<xsl:param name="borderStyle" select="'solid'" />
		<xsl:param name="borderColor" select="'black'" />
		<xsl:param name="borderWidth" select="'0.2pt'" />

	<fo:block-container xsl:use-attribute-sets="subSectionBox" padding-left="0mm" keep-together.within-page="auto">
		<!--<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
			<xsl:value-of select="$headerTitle" />
		</fo:block>-->

		<!--<xsl:if test="$cpvNode/p:CPV_CODE">-->
			<fo:table table-layout="fixed" margin-top="{$tableMarginTop}"  margin-left="0mm" left="0mm" >
				<fo:table-column column-width="15%"/>
				<fo:table-column column-width="35%"/>
				<fo:table-column column-width="15%"/>
				<fo:table-column column-width="35%"/>
				<fo:table-header>
					<fo:table-row display-align="center" margin-left="0mm" >
						<fo:table-cell number-columns-spanned="4" margin-left="0mm" left="0mm">
							<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm" margin-bottom="2mm" text-align="left" left="0mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.main_obj')" />
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
						<fo:table-cell left="0mm" number-columns-spanned="2">
							<fo:block text-align="left" margin-left="10mm" padding-bottom="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.main_vocabulary')" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell number-columns-spanned="2">
							<fo:block text-align="left" margin-left="5mm" padding-bottom="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.supp_vocabulary')" />
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row>
						<fo:table-cell><fo:block /></fo:table-cell>
					</fo:table-row>
					<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
						<fo:table-cell  left="0mm">
							<fo:block text-align="left" padding-left="0mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.unique_id')" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block>
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.description')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block text-align="left">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.unique_id')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block text-align="left">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.description')" />							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-header>
				<fo:table-body font-size="9pt" border-color="{$borderColor}">
					<fo:table-row text-align="left">
						<fo:table-cell display-align="center"  left="0mm">
							<fo:block text-align="left" >
								<xsl:value-of select="$cpvNode/p:CPV_CODE/@CODE" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell display-align="center" >
							<fo:block text-align="left" margin-top="1mm" margin-bottom="1mm">
								<xsl:value-of select="$cpvNode/p:CPV_CODE/@DESCRIPTION" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell display-align="center" >
							<fo:block text-align="left">
								<xsl:for-each select="$cpvNode/p:CPV_SUPPLEMENTARY_CODE">
									<fo:inline>
										<xsl:value-of select="@CODE" />
										<xsl:value-of select="if(position() != last()) then ', ' else '' " />
									</fo:inline>
								</xsl:for-each>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell display-align="center">
							<fo:block text-align="left" >
								<xsl:for-each select="$cpvNode/p:CPV_SUPPLEMENTARY_CODE">
									<fo:inline>
										<xsl:value-of select="@DESCRIPTION" />
										<xsl:value-of select="if(position() != last()) then ', ' else '' " />
									</fo:inline>
								</xsl:for-each>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
		<!--</xsl:if>-->

	</fo:block-container>					
	</xsl:template>
	
	<xsl:template name="writeCPVAndVOCTable">
		<xsl:param name="cpvNode" />
		<xsl:param name="headerTitle" select="messageLocalizer:convertLiteral($locale,'form.wiz_object_of_contract.cpv.value.header.pdf')"/>
		<!--<xsl:param name="mainCPVNode" select="$cpvNode" />-->

		<xsl:param name="tableWidth" select="'170mm'" />
		<xsl:param name="tableMarginLeft" select="'3mm'" />
		<xsl:param name="tableMarginTop" select="'0mm'" />
		<xsl:param name="labelColumnWidth" select="'20mm'" />
		<xsl:param name="cpvCodeColumnWidth" select="'30mm'" />
		<xsl:param name="cpvDescriptionColumnWidth" select="'45mm'" />
		<xsl:param name="vocCodeColumnWidth" select="'50mm'" />
		<xsl:param name="vocDescriptionColumnWidth" select="'55mm'" />
		<xsl:param name="borderStyle" select="'solid'" />
		<xsl:param name="borderColor" select="'black'" />
		<xsl:param name="borderWidth" select="'0.2pt'" />

	<fo:block-container xsl:use-attribute-sets="subSectionBox" padding-left="0mm" keep-together.within-page="auto">
		<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
			<xsl:value-of select="$headerTitle" />
		</fo:block>

		<xsl:if test="$cpvNode/p:CPV_CODE">
			<fo:table table-layout="fixed" margin-top="{$tableMarginTop}"  margin-left="0mm" left="0mm" >
				<fo:table-column column-width="15%"/>
				<fo:table-column column-width="35%"/>
				<fo:table-column column-width="15%"/>
				<fo:table-column column-width="35%"/>
				<fo:table-header>
					<fo:table-row display-align="center" margin-left="0mm" >
						<fo:table-cell number-columns-spanned="4" margin-left="0mm" left="0mm">
							<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm" margin-bottom="2mm" text-align="left" left="0mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.main_obj')" />
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
						<fo:table-cell left="0mm" number-columns-spanned="2">
							<fo:block text-align="left" margin-left="10mm" padding-bottom="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.main_vocabulary')" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell number-columns-spanned="2">
							<fo:block text-align="left" margin-left="5mm" padding-bottom="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.supp_vocabulary')" />
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row>
						<fo:table-cell><fo:block /></fo:table-cell>
					</fo:table-row>
					<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
						<fo:table-cell  left="0mm">
							<fo:block text-align="left" padding-left="0mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.unique_id')" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block>
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.description')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block text-align="left">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.unique_id')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block text-align="left">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.description')" />							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-header>
				<fo:table-body font-size="9pt" border-color="{$borderColor}">
					<fo:table-row text-align="left">
						<fo:table-cell display-align="center"  left="0mm">
							<fo:block text-align="left" >
								<xsl:value-of select="$cpvNode/p:CPV_CODE/@CODE" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell display-align="center" >
							<fo:block text-align="left" margin-top="1mm" margin-bottom="1mm">
								<xsl:value-of select="$cpvNode/p:CPV_CODE/@DESCRIPTION" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell display-align="center" >
							<fo:block text-align="left">
								<xsl:for-each select="$cpvNode/p:CPV_SUPPLEMENTARY_CODE">
									<fo:inline>
										<xsl:value-of select="@CODE" />
										<xsl:value-of select="if(position() != last()) then ', ' else '' " />
									</fo:inline>
								</xsl:for-each>
							</fo:block>
						</fo:table-cell>
						<fo:table-cell display-align="center">
							<fo:block text-align="left" >
								<xsl:for-each select="$cpvNode/p:CPV_SUPPLEMENTARY_CODE">
									<fo:inline>
										<xsl:value-of select="@DESCRIPTION" />
										<xsl:value-of select="if(position() != last()) then ', ' else '' " />
									</fo:inline>
								</xsl:for-each>
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
		</xsl:if>

	</fo:block-container>					
	</xsl:template>
	
	<xsl:template name="writeAdditionalCPVAndVOCTable">
		<xsl:param name="cpvNode" />
		<xsl:param name="additionalCPVNodes" select="$cpvNode/p:CPV_ADDITIONAL" /> 
		
		<xsl:param name="tableWidth" select="'170mm'" />
		<xsl:param name="tableMarginLeft" select="'3mm'" />
		<xsl:param name="tableMarginTop" select="'0mm'" />
		<xsl:param name="labelColumnWidth" select="'20mm'" />
		<xsl:param name="cpvCodeColumnWidth" select="'30mm'" />
		<xsl:param name="cpvDescriptionColumnWidth" select="'45mm'" />
		<xsl:param name="vocCodeColumnWidth" select="'50mm'" />
		<xsl:param name="vocDescriptionColumnWidth" select="'55mm'" />
		<xsl:param name="borderStyle" select="'solid'" />
		<xsl:param name="borderColor" select="'black'" />
		<xsl:param name="borderWidth" select="'0.2pt'" />
		
	<fo:block-container xsl:use-attribute-sets="subSectionBox" padding-left="0mm" keep-together.within-page="auto">
			<fo:table table-layout="fixed" margin-top="{$tableMarginTop}">
				<fo:table-column column-width="15%"/>
				<fo:table-column column-width="35%"/>
				<fo:table-column column-width="15%"/>
				<fo:table-column column-width="35%"/>
				<fo:table-header>
					<fo:table-row display-align="center" margin-left="0mm" >
						<fo:table-cell number-columns-spanned="4" margin-left="0mm" left="0mm">
							<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm" margin-bottom="2mm" text-align="left" left="0mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.additionl_object.pdf')" />
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					
					<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
						<fo:table-cell left="0mm" number-columns-spanned="2">
							<fo:block text-align="left" margin-left="10mm"  padding-bottom="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.main_vocabulary')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell number-columns-spanned="2">
							<fo:block text-align="left" margin-left="5mm" padding-bottom="2mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.hdr.supp_vocabulary')" />							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
					<fo:table-row>
						<fo:table-cell><fo:block /></fo:table-cell>
					</fo:table-row>
					
					<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
						<fo:table-cell  left="0mm">
							<fo:block text-align="left" padding-left="0mm">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.unique_id')" />
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block>
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.description')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block text-align="left">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.unique_id')" />							
							</fo:block>
						</fo:table-cell>
						<fo:table-cell text-align="left" >
							<fo:block text-align="left">
								<xsl:value-of select="messageLocalizer:convertLiteral($locale,'form.detailBidManualAward.header.description')" />							
							</fo:block>
						</fo:table-cell>
					</fo:table-row>
				</fo:table-header>
				<fo:table-body font-size="10pt" border-color="{$borderColor}">
					<xsl:for-each select="$additionalCPVNodes">
						<fo:table-row text-align="left">
							<fo:table-cell display-align="center"  left="0mm">
								<fo:block text-align="left" >
									<xsl:value-of select="p:CPV_CODE/@CODE" />
								</fo:block>
							</fo:table-cell>
							<fo:table-cell display-align="center">
								<fo:block text-align="left" margin-top="1mm" margin-bottom="1mm">
									<xsl:value-of select="p:CPV_CODE/@DESCRIPTION" />
								</fo:block>
							</fo:table-cell>
							<fo:table-cell display-align="center">
								<fo:block text-align="left">
									<xsl:for-each select="p:CPV_SUPPLEMENTARY_CODE">
										<fo:inline>
											<xsl:value-of select="@CODE" />
											<xsl:value-of select="if(position() != last()) then ', ' else '' " />
										</fo:inline>
									</xsl:for-each>
								</fo:block>
							</fo:table-cell>
							<fo:table-cell display-align="center">
								<fo:block text-align="left" margin-top="1mm" margin-bottom="1mm">
									<xsl:for-each select="p:CPV_SUPPLEMENTARY_CODE">
										<fo:inline>
											<xsl:value-of select="@DESCRIPTION" />
											<xsl:value-of select="if(position() != last()) then ', ' else '' " />
										</fo:inline>
									</xsl:for-each>
								</fo:block>
							</fo:table-cell>
						</fo:table-row>
					</xsl:for-each>
					<fo:table-row>
						<fo:table-cell><fo:block /></fo:table-cell>
					</fo:table-row>
				</fo:table-body>
			</fo:table>
	</fo:block-container>	
	</xsl:template>
	
	<xsl:template name="writeAwardCriterionTable">
		<xsl:param name="awardCriterionNode" />
		<xsl:param name="qualityCriterion" select="$awardCriterionNode/p:AC_QUALITY" />
		<xsl:param name="costCriterion" select="$awardCriterionNode/p:AC_COST" />
		<xsl:param name="priceCriterion" select="$awardCriterionNode/p:AC_PRICE" />  		
		
		<xsl:param name="tableWidth" select="'170mm'" />
		<xsl:param name="tableMarginLeft" select="'3mm'" />
		<xsl:param name="tableMarginTop" select="'0mm'" />
		<xsl:param name="labelColumnWidth" select="'20mm'" />
		<xsl:param name="cpvCodeColumnWidth" select="'30mm'" />
		<xsl:param name="cpvDescriptionColumnWidth" select="'45mm'" />
		<xsl:param name="vocCodeColumnWidth" select="'50mm'" />
		<xsl:param name="vocDescriptionColumnWidth" select="'55mm'" />
		<xsl:param name="borderStyle" select="'solid'" />
		<xsl:param name="borderColor" select="'black'" />
		<xsl:param name="borderWidth" select="'0.2pt'" />
		
	<fo:block-container xsl:use-attribute-sets="subSectionBox" padding-left="0mm" keep-together.within-page="auto">
			<xsl:if test="$qualityCriterion">
				<fo:table table-layout="fixed" margin-top="{$tableMarginTop}">
					<fo:table-column column-width="3%"/>
					<fo:table-column column-width="82%"/>
					<fo:table-column column-width="15%"/>
					<fo:table-header>
						<fo:table-row display-align="center" margin-left="0mm" >
							<fo:table-cell number-columns-spanned="3" margin-left="0mm" left="0mm">
								<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm" margin-bottom="2mm" text-align="left" left="0mm">
									<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.quality.criterion')" />
								</fo:block>
							</fo:table-cell>
						</fo:table-row>
						
						<fo:table-row>
							<fo:table-cell><fo:block /></fo:table-cell>
						</fo:table-row>
						
						<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
							<fo:table-cell  left="0mm">
								<fo:block text-align="left" padding-left="0mm">
									<xsl:value-of select="''" />
								</fo:block>
							</fo:table-cell>
							<fo:table-cell  left="0mm">
								<fo:block text-align="left" padding-left="0mm">
									<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.criterion')" />
								</fo:block>
							</fo:table-cell>
							<fo:table-cell text-align="left" >
								<fo:block>
									<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.price.weight.criterion')" />							
								</fo:block>
							</fo:table-cell>
						</fo:table-row>
					</fo:table-header>
					<fo:table-body font-size="10pt" border-color="{$borderColor}">
						<xsl:for-each select="$qualityCriterion">
							<fo:table-row text-align="left">
								<fo:table-cell display-align="center"  left="0mm">
									<fo:block text-align="left" >
										<xsl:value-of select="position()" />
									</fo:block>
								</fo:table-cell>
								<fo:table-cell display-align="center"  left="0mm">
									<fo:block text-align="left" >
										<xsl:value-of select="p:AC_CRITERION" />
									</fo:block>
								</fo:table-cell>
								<fo:table-cell display-align="center">
									<fo:block text-align="left" margin-top="1mm" margin-bottom="1mm">
										<xsl:value-of select="p:AC_WEIGHTING" />
									</fo:block>
								</fo:table-cell>
							</fo:table-row>
						</xsl:for-each>
						<fo:table-row>
							<fo:table-cell><fo:block /></fo:table-cell>
						</fo:table-row>
					</fo:table-body>
				</fo:table>
			</xsl:if>
			
			<xsl:if test="$costCriterion">
				<fo:table table-layout="fixed" margin-top="{$tableMarginTop}">
					<fo:table-column column-width="3%"/>
					<fo:table-column column-width="82%"/>
					<fo:table-column column-width="15%"/>
					<fo:table-header>
						<fo:table-row display-align="center" margin-left="0mm" >
							<fo:table-cell number-columns-spanned="3" margin-left="0mm" left="0mm">
								<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm" margin-bottom="2mm" text-align="left" left="0mm">
									<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.cost.criterion')" />
								</fo:block>
							</fo:table-cell>
						</fo:table-row>
						
						<fo:table-row>
							<fo:table-cell><fo:block /></fo:table-cell>
						</fo:table-row>
						
						<fo:table-row display-align="center" margin-top="2mm" font-weight="bold">
							<fo:table-cell  left="0mm">
								<fo:block text-align="left" padding-left="0mm">
									<xsl:value-of select="''" />
								</fo:block>
							</fo:table-cell>
							<fo:table-cell  left="0mm">
								<fo:block text-align="left" padding-left="0mm">
									<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.criterion')" />
								</fo:block>
							</fo:table-cell>
							<fo:table-cell text-align="left" >
								<fo:block>
									<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.price.weight.criterion')" />							
								</fo:block>
							</fo:table-cell>
						</fo:table-row>
					</fo:table-header>
					<fo:table-body font-size="10pt" border-color="{$borderColor}">
						<xsl:for-each select="$costCriterion">
							<fo:table-row text-align="left">
								<fo:table-cell display-align="center"  left="0mm">
									<fo:block text-align="left" >
										<xsl:value-of select="position()" />
									</fo:block>
								</fo:table-cell>
								<fo:table-cell display-align="center"  left="0mm">
									<fo:block text-align="left" >
										<xsl:value-of select="p:AC_CRITERION" />
									</fo:block>
								</fo:table-cell>
								<fo:table-cell display-align="center">
									<fo:block text-align="left" margin-top="1mm" margin-bottom="1mm">
										<xsl:value-of select="p:AC_WEIGHTING" />
									</fo:block>
								</fo:table-cell>
							</fo:table-row>
						</xsl:for-each>
						<fo:table-row>
							<fo:table-cell><fo:block /></fo:table-cell>
						</fo:table-row>
					</fo:table-body>
				</fo:table>
			</xsl:if>
			
			<xsl:if test="$priceCriterion">
				<fo:block xsl:use-attribute-sets="h3"  margin-top="2mm">
						<xsl:value-of select="messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.price.criterion')" />
				</fo:block>
				<xsl:call-template name="writeSingleLineData">
					<xsl:with-param name="singleLineData" select="concat(messageLocalizer:convertLiteral($locale,'ojeu.form.detail.lot.price.weight.criterion'), ' - ' , $priceCriterion/p:AC_WEIGHTING)" />
				</xsl:call-template>
			</xsl:if>
	</fo:block-container>	
	</xsl:template>
	
</xsl:stylesheet>
